/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/


#ifndef	__ALD_DLG_H__
#define	__ALD_DLG_H__    1

#ifndef __APPXBASE_H__
#include "appXbase.h"
#endif

#include "tfontwin.h"
#include "tlineedit.h"


// ********************** TMsgBox ************************************
#define msgOK		1
#define msgOKALL	(1 << 1)
#define msgABORT	(1 << 2)
#define msgRETRY	(1 << 3)
#define msgIGNORE	(1 << 4)
#define msgYES		(1 << 5)
#define msgYESALL	(1 << 6)
#define msgNO		(1 << 7)
#define msgSKIP		(1 << 8)
#define msgSKIPALL	(1 << 9)
#define msgREPEAT	(1 << 10)
#define msgFORCE	(1 << 11)
#define msgCANCEL	(1 << 15)
// use icon info.png or info.xpm
#define msgIcoINFO	(1 << 24)
// use icon warning.png or warning.xpm
#define msgIcoWARNING	(1 << 25)
// use icon error.png or error.xpm
#define msgIcoERROR	(3 << 24)

#define msgFontFixed	(1 << 28)
#define msgBell		(1 << 29)

#define msgbuWidth	64
#define msgbuHeight	24

#define TCSelf TMsgBox
typedef struct TMsgBox {
  AlgTForm

  int RetCode;
  int buCount;
  const char *Msg;

  int intern_approc_count;

  TButton *buN[5];

  void (*OnButton)(struct TMsgBox *mb);
  int OnButton_UserMk;

  TPic *pic;
  int y_off;

} TMsgBox;
#undef TCSelf

#define mbpakt_x_y		1
#define mbpakt_scr		(1<<1)
#define mbpakt_FocusButton	(1<<2)
#define mbpakt_Caption		(1<<4)
#define mbpakt_IconName		(1<<5)
#define mbpakt_OnButton		(1<<6)
#define mbpakt_UTF8		(1<<7)
typedef struct {
  dword akt;
  int left, top;
  int scrwidth, scrheight;
  dword FocusButton;
  const char *Caption;
  char *IconName;
  void (*OnButton)(TMsgBox *mb);
  bool UTF8on;
} TMsgBoxParam;

extern TMsgBox *TMsgBox_Create(TWins *parent, const char *Msg, dword fu, 
				TMsgBoxParam *mbp);

extern int MsgBox_Show(TWins *parent, const char *Caption, const char *Msg, 
			dword fu, dword foc);
extern int MsgBox_Show_mbp(TWins *parent, const char *Msg, dword fu, 
				TMsgBoxParam *mbp);
extern void Copyright_MsgBox_Show(TWins *parent, const char *Caption);

/* ErrType = EMSG_INFO,EMSG_WARN,EMSG_ERR,.. in sysbase.h */
extern int MsgBox_Show_Error(TWins *parent, const char *Caption, dword fu, 
				dword foc, int ErrType, const char *msg, ...);
extern int MsgBox_Error(TWins *parent, const char *msg, ...);

extern int MsgBox_Show_Warning(TWins *parent, const char *Caption, dword fu, 
				dword foc, int ErrType, const char *msg, ...);
extern int MsgBox_Warning(TWins *parent, const char *msg, ...);

extern int NetError_Dlg(TWins *owner, TglobPath *gp, int button, 
			const char *bef, TNetErrRet *ErrRet);

// ********************** TNewFile_Dlg **********************************

#define ffnNewDirectory   1
#define ffnNewTxtFile     2

#define TCSelf TNewFile_Dlg
typedef struct TNewFile_Dlg {
  AlgTForm

  int RetCode;
  int fu;
  TglobPath *gp;

  TWins *lblNew;
  TWins *lblNewPath;

  TEdit *edFile;

  TButton *buOk;
  TButton *buCancel;

} TNewFile_Dlg;
#undef TCSelf

extern TNewFile_Dlg *Create_NewFile_Dlg(TWins *parent, int fu);
extern bool NewFile_Dlg_Execute(TNewFile_Dlg *fw);

// ********************** TFile_Dlg **********************************

#define fwdret_False	0
#define fwdret_True	1
#define fwdret_OnlyDir	2

#define TCSelf TFile_Dlg
typedef struct TFile_Dlg {
  AlgTForm

  int RetCode;
  int RetName_gp_fu;
  bool DirMode, DirModeMix, fdlg_b2, fdlg_b3;
  char *path;

  TWins *PanelTop;

  TMenuButton *mbuSettings;
  TMenu *menuSetting;
    TMenuItem *miCaseSort;
    TMenuItem *miItemDblClick;
    TMenuItem *miPathDblClick;
  TComboBox *edPath;
  TMenuButton *mbuPathRet;
  TMenuButton *mbuAzArt;
  TMenuButton *mbuNewPath;

  struct TFileWin *FileWin;

  TWins *PanelBottom;
  TEdit *edFile;
  TComboBox *cobPattern;
  TChkBox *cbHiddenFiles;
  TButton *buOk;
  TButton *buCancel;
  TWins *lblFile;
  TWins *lblPattern;
  TglobPath *last_gp;

  TNewFile_Dlg *NewFile_Dlg;
} TFile_Dlg;
#undef TCSelf

extern TFile_Dlg *Create_FileAlg_Dlg(TWins *parent);
extern TFile_Dlg *Create_File_Dlg(TWins *parent);
extern TFile_Dlg *Create_FileSave_Dlg(TWins *parent);

extern void file_dlg_InitAzPic(TFile_Dlg *fwd);

extern void File_Dlg_SetPath(TFile_Dlg *fw, const char *s);
extern void File_Dlg_SetName(TFile_Dlg *fw, const char *fn);
extern void File_Dlg_SetNamePath(TFile_Dlg *fw, const char *fn);
extern void File_Dlg_AddPattern(TFile_Dlg *fw, const char *pattern, unsigned short *ftyp);
extern TPattern *File_Dlg_Get_Patter(TFile_Dlg *fw);
extern bool File_Dlg_Execute(TFile_Dlg *fwd);
extern bool File_Dlg_GetEdFileName(TFile_Dlg *fwd, char **s);

// ********************** TFind_Dlg **********************************
#define TCSelf TFind_Dlg
typedef struct TFind_Dlg {
  AlgTForm

  int RetCode;

  TWins *lbl1;
  TComboBox *edFind;
  TChkBox *cbCase;
  TChkBox *cbBack;
  TChkBox *cbBegin;
  TButton *buOk;
  TButton *buCancel;

} TFind_Dlg;
#undef TCSelf

extern TFind_Dlg *Create_Find_Dlg(TWins *parent);
extern bool Find_Dlg_Execute(TFind_Dlg *self, const char *s);
extern void Find_Dlg_SetUTF8(TFind_Dlg *self, bool UTF8);

// ********************** TReplace_Dlg **********************************
#define TCSelf TReplace_Dlg
typedef struct TReplace_Dlg {
  AlgTForm

  int RetCode;

  TWins *lbl1;
  TComboBox *edFind;
  TWins *lbl2;
  TComboBox *edRepl;
  TChkBox *cbCase;
  TChkBox *cbBack;
  TChkBox *cbBegin;
  TButton *buOk;
  TButton *buCancel;
} TReplace_Dlg;
#undef TCSelf

extern TReplace_Dlg *Create_Replace_Dlg(TWins *parent);
extern bool Replace_Dlg_Execute(TReplace_Dlg *self, const char *s);
extern void Replace_Dlg_SetUTF8(TReplace_Dlg *self, bool UTF8);

// ********************** TReplace_Dlg **********************************
#define TCSelf TLogin_Dlg
typedef struct TLogin_Dlg {
  AlgTForm

  int RetCode;
  TWins *lblHost;
  TWins *lblHostName;

  TWins *lblUser;
  TEdit *edUser;

  TWins *lblPasswd;
  TEdit *edPasswd;
  TButton *buOk;
  TButton *buCancel;
} TLogin_Dlg;
#undef TCSelf

extern TLogin_Dlg *Create_Login_Dlg(TWins *parent);
extern bool Login_Dlg_Execute(TLogin_Dlg *dlgw, TglobPath *gp);
extern bool Login_Dlg_Create_Execute(TWins *parent, TglobPath *gp);

// ********************** TFomt_Dlg **********************************
#define TCSelf TFont_Dlg
typedef struct TFont_Dlg {
  AlgTForm

  int RetCode;
  

  TWins *pnlTop;
  TWins *pnlMiddle;

  TMenuButton *mbCharset;
    TMenu *menuCharset;
      TMenu *menuIso8859;

  TMenuButton *mbHelp;
    TMenu *menuHelp;

  TComboBox *cobDPI;
  TEdit *edTop;

  TTreeVFont *tv;
  TWins *pnlRight;
  TWins *pnlRightTop;
  TLineEdit *le;
  TWins *pnlRightBottom;

  TComboBox *cobSIZE;
  TChkBox *cbUTF8;

  TEdit *edResult;
  TWins *CharAzBox;
  TChkBox *cbN;
  TChkBox *cbNK;
  TChkBox *cbB;
  TChkBox *cbBK;
  TButton *buCancel;
  TButton *buOK;

  TMenuItem *defmi_x, *defmi_scale, *defmi_75x, *defmi_100;
} TFont_Dlg;
#undef TCSelf

extern void Init_FontAlg_Dlg(TFont_Dlg *mf, const char *fontname);
extern TFont_Dlg *Create_Font_Dlg(TWins *parent, const char *fontname);
extern bool Font_Dlg_Create_Execute(TWins *parent, char **ret_fontname);

#ifdef _OS_WIN32
extern bool font_dlg_W32(TWins *parent, LOGFONTW *lf, char **ret_fontname);
#endif  /* _OS_WIN32 */

#endif /* __ALD_DLG_H__ */

