/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#ifndef	__ELF_INFO_H__
#define	__ELF_INFO_H__    1

#ifndef _OS_WIN32
#include <elf.h>
#endif /* _OS_WIN32 */

#define USE_ELFx64 1

/* TELF_InfoItem.fkt */
#define ELF_SONEEDED	1
#define ELF_SELF_NAME	(1<<1)
#define ELF_PROVIDES	(1<<2)

#define TAlgItem TELF_InfoItem

typedef struct TELF_InfoItem {
  AlgTItem
  dword fkt;
  char *so_name;
  char *verneed;
  char *verdef;
} TELF_InfoItem;

#undef TAlgItem

typedef struct {
  TELF_InfoItem *InfoItem;
//  Tstat64 *st;
  byte isElf64;
  byte e_encoding;	//ELFDATA2LSB,ELFDATA2MSB,...
  byte e_osabi;		//ELFOSABI_NONE,ELFOSABI_LINUX,ELFOSABI_ARM,...
  byte isSO;
  byte gnuHASH;
  byte ncb5,ncb6, ncb7;
  int e_type;		//ET_REL,ET_EXEC,...
  int e_machine;	//EM_386,EM_ARM,...
} TELF_Info;

#ifndef _OS_WIN32
#define ELFfkt_ALL	0
#define ELFfkt_SONEED	1
#define ELFfkt_VERNEED	(1<<1)
#define ELFfkt_PROVIDES	(1<<2)

extern TELF_Info *elf_getinfo(const char *fn, TNetErrRet *ErrRet, int fkt);
extern void elf_info_free(TELF_Info *elf_info);
#endif /* _OS_WIN32 */

#endif /* __ELF_INFO_H__ */
