/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__FONT_XFT_H__
#define	__FONT_XFT_H__    1


/* TFontS->flags */
#define FONTFG_UTF8		1
#define FONTFG_ImageString	(1<<1)
#define FONTFG_AuoClrOrigin	(1<<2)

#define FONT_WCBUF_MAX	200


#define AlgTFontPvBase dword Color, BackColor; \
  dword flags; \
  int wcChars; \
  word wcbuf[FONT_WCBUF_MAX];


#define AlgTFontBase  AlgTTC0 \
  long PaintToObj; \
  FONT_HANDLE; \
  FONT_PV; \
  bool (*SetColor)(struct TCSelf *self, dword Color); \
  bool (*SetBackColor)(struct TCSelf *self, dword Color); \
  bool (*SetFlags)(struct TCSelf *self, dword flags); \
  int  (*GetWidth)(struct TCSelf *self, const char *s, int len); \
  bool (*GetMetrics)(struct TCSelf *self, int *height, int *ascent); \
  bool (*PaintTo)(struct TCSelf *self, int x, int y, const char *s, int len);

//  bool (*PaintToWinID)(struct TCSelf *self, long WinID, const char *s, int len); 
//  bool (*PaintToImg)(struct TCSelf *self, struct TImage *img, const char *s, int len);

typedef struct TFont_pv {
  AlgTFontPvBase
} TFont_pv;

#define FONT_HANDLE	void *fh
#define FONT_PV		TFont_pv *fpv
#define TCSelf		TFontS
typedef struct TFontS {
  AlgTFontBase
} TFontS;
#undef FONT_HANDLE
#undef FONT_PV
#undef TCSelf

/* ____________________________ Font X11 _______________________________ */
#ifdef	__APPXBASE_H__

#ifndef TFontX_handle
#define TFontX_handle void *fh
#endif
#ifndef TFontX_pv
#define TFontX_pv void *fpv
#endif

#define FONT_HANDLE	TFontX_handle
#define FONT_PV		TFontX_pv
#define TCSelf		TFontX
//  font_handle		//XFontStruct *xfont;	Create(xfont)
//  font_pv		//gc,Color,BackColor,UTF8on
typedef struct TFontX {
  AlgTFontBase
} TFontX;
#undef FONT_HANDLE
#undef FONT_PV
#undef TCSelf


extern TFontS *TFontX_Create(TFont *font);

/* ____________________________ Font X11 Freetype ______________________ */
#ifdef	__FONT_FT_H__

#ifndef TFontX_FT_handle
#define TFontX_FT_handle void *fh
#endif
#ifndef TFontX_FT_pv
#define TFontX_FT_pv void *fpv
#endif

#define FONT_HANDLE	TFontX_FT_handle
#define FONT_PV		TFontX_FT_pv
#define TCSelf		TFontX_FT
//  font_handle		//FT_Library,Face,fcache,..	Create(fontft)
//  font_pv		//Color,BackColor,UTF8on,..
typedef struct TFontX_FT {
  AlgTFontBase
} TFontX_FT;
#undef FONT_HANDLE
#undef FONT_PV
#undef TCSelf

extern TFontS *TFontX_FT_Create(struct TFont_FT *font);
#endif /* __FONT_FT_H__ */
#endif /* __APPXBASE_H__ */

/* ____________________________ Font Image Freetype ____________________ */
#ifdef	__FONT_FT_H__
#ifndef TFontImg_FT_handle
#define TFontImg_FT_handle void *fh
#endif
#ifndef TFontImg_FT_pv
#define TFontImg_FT_pv void *fpv
#endif

#define FONT_HANDLE	TFontImg_FT_handle
#define FONT_PV		TFontImg_FT_pv
#define TCSelf		TFontImg_FT
//  font_handle		//FT_Library,Face,fcache,..	Create(fontft)
//  font_pv		//Color,BackColor,UTF8on,..
typedef struct TFontImg_FT {
  AlgTFontBase
} TFontImg_FT;
#undef FONT_HANDLE
#undef FONT_PV
#undef TCSelf

extern TFontS *TFontImg_FT_Create(struct TFont_FT *font);
#endif /* __FONT_FT_H__ */

extern TFontS *GetFontX(const char *FontName);
extern TFontS *GetFontX_FT(const char *FontFileName, int font_height, int font_dpi);
extern TFontS *GetFontImg_FT(const char *FontFileName, int font_height, int font_dpi);

extern bool TFont_SetFlags(TFontS *self, dword flags);
extern bool TFont_SetColor(TFontS *self, dword Color);
extern bool TFont_SetBackColor(TFontS *self, dword Color);
extern int  TFont_GetWidth(TFontS *self, const char *s, int len);
extern bool Font_GetMetrics(TFontS *self, int *height, int *ascent);
extern bool TFont_PaintTo(TFontS *self, int x, int y, const char *s, int len);

#endif /* __FONT_XFT_H__ */
