/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__FONT_FT_H__
#define	__FONT_FT_H__    1


#define AlgTFont_FT  AlgTTC \
  bool (*SetColor)(struct TCSelf *self, dword Color); \
  bool (*SetBackColor)(struct TCSelf *self, dword Color); \
  bool (*SetUTF8)(struct TCSelf *self, bool UTF8on); \
  bool (*SetAngle)(struct TCSelf *self, float angle); \
  bool (*ClrOrigin)(struct TCSelf *self); \
  bool (*SetOrigin)(struct TCSelf *self, float x, float y); \
  bool (*GetOrigin)(struct TCSelf *self, float *x, float *y); \
  int  (*GetWidth)(struct TCSelf *self, const char *s, int slen); \
  bool (*GetVector)(struct TCSelf *self, float *x, float *y, const char *s, int slen); \
  bool (*GetMetrics)(struct TCSelf *self, int *height, int *ascent); \
  long (*GetGlyphs)(struct TCSelf *self); \
  bool (*ToImage)(struct TCSelf *self, struct TImage *img, int x, int y, const char *s, int slen);

#define TCSelf TFont_FT
typedef struct TFont_FT {
  AlgTFont_FT
} TFont_FT;
#undef TCSelf

extern TFont_FT *TFont_FT_Create(const char *FontFileName, int font_height, int font_dpi);
#ifdef HAVE_FT
extern void *TFont_FT_pv_Create(const char *FontFileName, int font_height, int font_dpi);
#endif
extern bool Font_FT_ToImage(TFont_FT *self, TImage *img, int x, int y, 
				const char *s, int slen);
extern bool Font_FT_StrToImage(TFont_FT *self, TImage *img, int x, int y, 
				const char *s);

extern bool Font_FT_SetAngle(TFont_FT *self, float angle);
extern bool Font_FT_ClrOrigin(TFont_FT *self);
extern bool Font_FT_SetOrigin(TFont_FT *self, float x, float y);
extern bool Font_FT_GetOrigin(TFont_FT *self, float *x, float *y);
extern bool Font_FT_GetVector(TFont_FT *self, float *x, float *y, 
				const char *s, int slen);
extern bool Font_FT_StrGetVector(TFont_FT *self, float *x, float *y, 
				const char *s);
extern int  Font_FT_GetWidth(TFont_FT *self, const char *s, int slen);

extern bool Font_FT_SetColor(TFont_FT *self, dword Color);
extern bool Font_FT_SetBackColor(TFont_FT *self, dword Color);
extern bool Font_FT_SetUTF8(TFont_FT *self, bool UTF8on);

extern bool Font_FT_GetMetrics(TFont_FT *self, int *height, int *ascent);
extern long Font_FT_GetGlyphs(TFont_FT *self);

#endif /* __FONT_FT_H__ */
