/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#ifndef	__FTPIO_H__
#define	__FTPIO_H__    1

/* ftpio.c */
#define TYPE_A	1	//ASCII
#define TYPE_I	2	//binary
#define TYPE_E	3	//EBCDIC
#define TYPE_L	4	//local byte size


#define ftpSchr_Connect		1
#define ftpSchr_USER		2
#define ftpSchr_PASS		3
#define ftpSchr_SYST		4
#define ftpSchr_TYPE_I		5
#define ftpSchr_CWD		6
#define ftpSchr_InitConn	7
#define ftpSchr_LIST		9
#define ftpSchr_MLST		10
#define ftpSchr_MLSD		11
#define ftpSchr_RETR		12
#define ftpSchr_STOR		15
#define ftpSchr_SIZE		16
#define ftpSchr_STAT		22
#define ftpSchr_QUIT		99

#define ftpSh_Mask_BefStart	0x00ffffff
#define ftpSh_Connect		1
#define ftpSh_USER		(1<<1)
#define ftpSh_PASS		(1<<2)
#define ftpSh_SYST		(1<<3)
#define ftpSh_TYPE_I		(1<<4)
#define ftpSh_CWD		(1<<5)
#define ftpSh_InitConn		(1<<6)
#define ftpSh_LIST		(1<<8)
#define ftpSh_MLST		(1<<9)
#define ftpSh_MLSD		(1<<10)
#define ftpSh_SIZE		(1<<11)
#define ftpSh_RETR		(1<<14)
#define ftpSh_STOR		(1<<15)
#define ftpSh_STAT		(1<<22)
//#define ftpSh_ReplyEnd		(1<<24)
#define ftpSh_Mask_BefEnd	0xff000000
#define ftpSh_QUIT		(1<<24)

typedef struct TEvReplyBuf {
  struct TEvReplyBuf *next;
  int code;
  char *msg;
  bool last;
} TEvReplyBuf;

typedef struct TFtp {
  AlgTTC
  int ftpSchr;
  int ftpSh;
  char *cmd_LS;
  char *srcFile, *destFile;
  TdServFile *srcFileStat;
  void *owner;
  TglobPath gp;
  char *AktPath;

  int port;
  bool sendport;
  bool isConnect;
  bool ReplyBufAkt;
  bool passivemode;
  bool FtpStop;
  bool ncb1, ncb2, ncb3;
  struct sockaddr_in hisctladdr;
  struct sockaddr_in data_addr;
  struct sockaddr_in myctladdr;
  int sock;
  int data;
  FILE *pin;
  FILE *pout;
  int file_fd;
  TEvReplyBuf *ReplyBuf;
  uint64_t TransfStart_us;
  uint64_t TransfDatLg;
  uint64_t TransfDatLg_Last_MSG;
  uint64_t TransfNxEv_us;
  int curtype, newtype, transtype;
  void (*DoError)(struct TFtp*, int ErrNr, const char *msg);
  void (*DoStrgMSG)(struct TFtp*, int strg);
  void (*OnLineRecv)(struct TFtp*, int code, char *msg, bool last);
  void (*OnRecvData)(struct TFtp*, int fd, Tfd_list *fdl, int *fu);
  void (*OnFtpDataRecv)(struct TFtp*);
  void (*OnFtpDataSend)(struct TFtp*);
  int rpCode, rpIdx, rpOrgCode, rpOcode, rpConti, rpPflag, rpPx, rpD, prCpend;
  int rpHCode;
  int rpMsg;
  char *pcSTAT;
  TLineBuf RdDataBuf;
  TLineBuf *WrDataBuf;
  char reply_str[BUFSIZ];
  char pasv[64];
  char *CurrentDir;
  char *lastErrStr;
  int lastErrCode;
} TFtp;

extern TFtp *TFtp_Create();
extern bool TFtp_Open(TFtp *ftp);
extern void TFtp_Close(TFtp *ftp);
extern void TFtp_Error(TFtp *ftp, int ErrNr, const char *msg, ...);

extern bool TFtp_Command(TFtp *ftp, const char *fmt, ...);
//extern void TFtp_USER(TFtp *ftp, char *s);
//extern void TFtp_PASS(TFtp *ftp, char *s);
//extern void TFtp_QUIT(TFtp *ftp);
extern int TFtp_changetype(TFtp *ftp, int newtype); //0=err 1=ok 2=akt
extern bool TFtp_initconn(TFtp *ftp);
extern bool TFtp_initconn_pasv(TFtp *ftp);
extern void TFtp_closeconn(TFtp *ftp);
extern bool TFtp_dataconn(TFtp *ftp);

/* ftpbasebef.c */
extern bool TFtp_BaseBefSend(TFtp *ftp);
extern bool TFtp_BaseBefRecv(TFtp *ftp, int code, char *msg);


/* ftptoServFile.c */
#define ftptsf_RootPath		1

#define ftptsf_isDotFile	(1<<8)

extern TdServFile *ftptoServFile(const char *ls, int *tsf);

/* ftpreplybuf.c */
extern void AddToReplyBuf(TFtp *ftp, int code, char *msg, bool last);
extern void DelFirstReplyBuf(TFtp *ftp);
extern void ClrReplyBuf(TFtp *ftp);
extern bool ReplyBuf_Line(TFtp *ftp);



#endif /* __FTPIO_H__ */
