/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#define LZ_MAX_CODE         4095
#define LZ_BITS             12

#define FLUSH_OUTPUT        4096    
#define FIRST_CODE          4097
#define NO_CODE             4098

#define LZW_ERR_EOF		1
#define LZW_ERR_DEFECT		2

typedef struct TLzw {
  AlgTTC
  void *owner;
  bool (*Lzw_rd)(struct TLzw *lzw, void *data, int lg);
  bool lzwEOF;
  bool nc1, nc2, nc3;
  int Error;
  int ResLg;
  dword GesDataLg;
  dword ZDataLg;

  int LastCode;
  int StackIdx;

  int Bits;
  int CodeBits;
  int ClearCode;
  int EOFCode;
  int CodeIdx;
  int CodeIdxMask;


  int BufCount;
  int BufIdx;
  TBitsIO BitsIO;

  byte buf[256];
  byte Stack[LZ_MAX_CODE + 1];
  byte Suffix[LZ_MAX_CODE + 1];
  int Prefix[LZ_MAX_CODE + 1];
} TLzw;

extern TLzw *TLzw_Create();
extern bool TLzw_Setup_rd(TLzw *self);
extern bool TLzw_Decompress(TLzw *self, byte *buf, int lg);
