/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#ifndef	__STDWIN_H__
#define	__STDWIN_H__    1

//***** BorderFu
#define  mBorder		1
#define  mBorder2D		(1<<1)
#define  mBorderL		(1<<2)
#define  mBorderW2		(1<<3)
#define  mBorderBu		(1<<4)

#define  mBorderNoLeft		(1<<8)
#define  mBorderNoRigth		(1<<9)
#define  mBorderNoTop		(1<<10)
#define  mBorderNoBottom	(1<<11)


//***** CaptionFu
#define mCaptionPaint	1
#define mCaptionSolid	(1<<1)
#define mCaptionLeft	(1<<2)
#define mCaptionRigth	(1<<3)
#define mCaptionTop	(1<<4)
#define mCaptionBottom	(1<<5)
#define mCaptionNoAutoXY	(1<<6)
#define mCaptionAutoUtf8	(1<<7)
#define mCaptionUseRepaint	(1<<8)

#define mCaptionRePaint		(1<<12)
#define mFocusRecIsPaint	(1<<13)

//***** CaptionFu used in TWins_Ctl
#define CtlCaptionFu_Update	0
#define CtlCaptionFu_Set	1
#define CtlCaptionFu_Clr	2

//***** KeyFu
#define mCanFocus	1
#define mHasFocus	(1<<1)
#define mNoKeyFocus	(1<<2)
//#define mHasRepTimer	(1<<3)

#define mK_Right	(1<<8)
#define mK_Down		(1<<9)
#define mK_Left		(1<<10)
#define mK_Up		(1<<11)
#define mK_Tab		(1<<12)
#define mK_ReturnTab	(1<<13)
#define mK_Ev_OnDisWins	(1<<15)

//***** Align
#define alNone		0
#define alTop		(1<<0)
#define alBottom	(1<<1)
#define alLeft		(1<<2)
#define alRight		(1<<3)
#define alClient	(1<<4)
// #define alMask		0x001f

//***** RunStatus **************************
#define runst_Paint1		1
#define runst_Activate1		(1<<1)
#define runst_Activate		(1<<2)
#define runst_GoDestroy		(1<<3)
/* RunStatus used in ALDesk */
#define runst_RestackMk		(1<<4)
#define runst_OnTop		(1<<5)

//#define runst_FREE_LOCK		(1<<8)
//#define runst_FREE_LOCK_Destroy	(1<<9)

//------------------------------------------
#define wtyp_WinsBaseMask	0x1700ff
#define wtyp_ChkWinsMask	0x070000

#define wtyp_Wins		0x01
#define wtyp_Form		0x100000
#define wtyp_Button		0x03
#define wtyp_ButtonPic		0x103
#define wtyp_Edit		0x04
#define wtyp_TDVal		0x104
#define wtyp_ChkBox		0x05
#define wtyp_ScrollBar		0x06
#define wtyp_MenuButton		0x07
#define wtyp_Menu		0x08
#define wtyp_MenuFile		0x108
#define wtyp_ScrollWin		0x09
#define wtyp_LineEdit		0x0A
#define wtyp_Grid		0x0B
#define wtyp_FileWin		0x0C
#define wtyp_TPageControl	0x0D
#define wtyp_TPage		0x0E
#define wtyp_TreeV		0x0F
#define wtyp_TTreeVFile		0x10F
#define wtyp_TTreeVFont		0x20F
#define wtyp_ProgressBar	0x10
#define wtyp_SplitterV		0x011
#define wtyp_SplitterH		0x111
#define wtyp_SysTrayWin		(wtyp_Form | 0x012)
#define wtyp_RepButton		0x13
#define wtyp_LabelMultiLine	0x14


#define wtyp_TwmRoot		(wtyp_Form | 0x0f002)
#define wtyp_TwmWin		0x0f001
#define wtyp_TwmFrame		(wtyp_Form | 0x0f101)
#define wtyp_TwmTitle		0x0f201
#define wtyp_TTaskbar		0x0f301
#define wtyp_TTaskbarApplet	0x0f401
#define wtyp_TwmDeskIcon	0x0f501


#define wtyp_TTreeVNode		0x10200
#define wtyp_TTreeVFileNode	0x10201
//#define wtyp_TTreeVRootFileNode	0x10202
//#define wtyp_TTreeVNode_Mask	0xffffff00
/*	wtyp_TNode 0x10100-0x103ff
	wtyp_TTreeVNode		0x10200-0x102ff */



/* ab 0xnnn1nnnn - 0xnnn7nnnn no Wins Typen
	wtyp_TLines	0x10000    in sysbase.h
	wtyp_Thighlight 0x11000-0x11fff
	wtyp_TClassGC   0x12000-0x12fff
	wtyp_SubType    0x14000-0x14fff
	wtyp_Plugin	0x20000-0x2ffff


	wtyp_USER_Form	0x8nn02-0x8nn02
	wtyp_USER_Wins	0x8nn01-0x8nn01
	wtyp_USER	0x90000-0xfffff
*/
#define wtyp_TClassGC		0x12000
#define wtyp_TAHimg		0x12001
#define wtyp_TimgBorder		0x12002
#define wtyp_TGetFilePic	0x12004
#define wtyp_TFileIcons		0x12005

// #define wtyp_TImage		0x12010  in sysbase.h
#define wtyp_TPixMap		0x12011

#define wtyp_TXPM_LD_struct	0x12020
#define wtyp_TPNG_LD_struct	0x12021
#define wtyp_TJPEG_LD_struct	0x12022
// #define wtyp_Tpxm_load_struct	0x12023  in sysbase.h

//#define wtyp_TColMap		0x12030  in sysbase.h


#define wtyp_MenuItem		0x14000
#define wtyp_MenuFileItem	0x14001

#define wtyp_TDecor		0x15000
#define wtyp_TDecorDup		0x15001
#define wtyp_TDecorDat		0x15002
#define wtyp_TButton_Decor	0x15003

#define wtyp_LineEditKeyPlugin	0x2000A

#define wtyp_USER_Wins	0x80001
#define wtyp_USER_Form	(wtyp_Form | 0x80000)

typedef struct TWRect {
  int left;
  int top;
  int width;
  int height;
} TWRect;

typedef struct TMouseDown {
  struct TWins *apph;
  struct TWins *oldapph;
  int x;
  int y;
  int x_root;
  int y_root;
  int button;
  int state;
  int obj_left;
  int obj_top;
  int obj_width;
  int obj_height;
  Time time_ev;
  bool DblClickAkt;
  bool WinIsEnabled;
  bool nc2;
  bool nc3;
} TMouseDown;

/* ________________________ Decor _______________________________________ */ 
#define decor_Destroy		0x0001
#define decor_ClrAndFree	0x0002
#define decor_NewSize		0x0003
#define decor_Border		0x0004
#define decor_FocusIn		0x0005
#define decor_FocusOut		0x0006

#define Deco_SizeOk		1
#define Deco_MaskAkt		(1<<1)
#define Deco_imgB_Free		(1<<8)

#define AlgTDecor    AlgTTC \
  int stat; \
  bool (*DoDecor)(struct TWins*, int bef, int, void*); \
  struct TDecor *(*CreateDup)(struct TDecor**); \
  struct TDecor *(*Create_dup)(struct TDecor*); \
  struct TDecor **DecorDup; \
  struct TDecor *DecorLastDup; \
  void *DecorDat; \
  struct TAHimg *backimg; \
  struct TPixMap *backpxm; \
  struct TimgBorder *imgB;


typedef struct TDecor {
  AlgTDecor
} TDecor;
/* ________________________ SetUp Ctl ___________________________________ */ 
#define wctlb_SetFont		1
#define wctlb_SetFontTf		2
#define wctlb_SetUTF8		3
#define wctlb_CaptionFu		4
#define wctlb_AtExit		5

#define wctlf_SelfFree	1
#define wctlf_ptrFree	(1<<1)

typedef struct {
  int bef;
  dword flag;
  union {
    void *ptr;
    char *ptr_s;
    const char *ptr_s_const;
  };
  ic64 ic;
  int data_lg;
  char data[];
} TWinsCtl;

/* ________________________ dnd _________________________________________ */ 
typedef int (*TOndndMouseMove)(struct TWins*, XMotionEvent* ev);
typedef int (*TOndndDrop)(struct TWins*);

typedef void (*TWinsEv)(struct TWins *self);
typedef void (*TSetVisibleEv)(struct TWins *self, bool Value);
typedef void (*TSetCaptionEv)(struct TWins *self, const char *s);
typedef void (*TFocusEv)(struct TWins *self, int Change);

typedef void (*TClickEv)(struct TWins *self, long KeyState, bool DblClick);
//typedef void (*TMmoveEv)(struct TWins *self, XMotionEvent *ev);
//typedef void (*TMupdownEv)(struct TWins *self, XButtonEvent *ev);
//typedef void (*TMoverEv)(struct TWins *self, XCrossingEvent *ev, bool Leave);

typedef void (*TMouseMoveEv)(struct TWins *self, XMotionEvent *ev);
typedef void (*TMouseButtonEv)(struct TWins *self, XButtonEvent *ev);
typedef void (*TMouseOverEv)(struct TWins *self, XCrossingEvent *ev, bool Leave);

typedef void (*TOnKeyEv)(struct TWins *self, TKeyEvent *KeyEv);
typedef int (*TKeyEv)(struct TWins *self, TKeyEvent *KeyEv);

typedef bool (*WinsCtlEv)(struct TWins *self, TWinsCtl *wctl);
typedef void (*TClientRectEv)(struct TWins *self, TWRect *rc);


#ifdef _OS_WIN32
typedef struct {
  HBRUSH background_pixmap;
  bool OverrideRedirect;
  bool nc1_OS, nc2_OS, nc3_OS;
} T_OS_var;
#else
typedef struct {
  int nc_OS;
} T_OS_var;
#endif

typedef struct {
  TOndndMouseMove OndndMouseMove; 
  TOndndDrop OndndDrop; 
  int (*OndndEnter)(struct TWins*, XClientMessageEvent *ev); 
  int (*OndndStatus)(struct TWins*, XClientMessageEvent *ev); 
  bool (*DodndSelectionReq)(XSelectionRequestEvent *ev, char **ppc, int *lg, int *iss); \
} THdnd;


#define TCSelf TWins

#define AlgTWins    AlgTTC \
  struct TWins *prev; \
  struct TWins *next; \
  struct TWins *prev_child; \
  struct TWins *next_child; \
  struct TWins **pproot; \
  int left; \
  int top; \
  int width; \
  int height; \
  word min_width; \
  word max_width; \
  word min_height; \
  word max_height; \
  dword Color; \
  word BorderFu; \
  word CaptionFu; \
  word KeyFu; \
  word Align; \
  byte BorderOffLeft; \
  byte BorderOffRigth; \
  byte BorderOffTop; \
  byte BorderOffBottom; \
  bool Enabled; \
  bool Visible; \
  bool IsParent; \
  bool PaintOnEvEndMk; \
  bool ResizeStartMk; \
  bool MouseClickStop; \
  bool nc6; \
  bool nc7; \
  Window WinID; \
  struct TWins *FormStruct; \
  void *subClass; \
  struct TWins *owner; \
  TVDrawString vds; \
  struct TMenu *PopupMenu; \
  struct TWins *InfoWin; \
  int16_t CaptionOffX; \
  int16_t CaptionOffY; \
  int cursor_nr; \
  TEvProc *EvProc; \
  void (*SetParent)(struct TCSelf *self, struct TWins*); \
  bool (*GetIsParent)(struct TCSelf *self); \
  void (*SetCaption)(struct TCSelf *self, const char *s); \
  const char *(*GetCaption)(struct TCSelf *self); \
  void (*SetColor)(struct TCSelf *self, dword Color); \
  void (*SetBorder)(struct TCSelf *self, int BorderFu); \
  void (*SetEnabled)(struct TCSelf *self, bool Value); \
  void (*SetVisible)(struct TCSelf *self, bool); \
  void (*SetRC)(struct TCSelf *self, int left, int top, int width, int height); \
  void (*Refresh)(struct TCSelf *self); \
  bool (*WinsCtl)(struct TCSelf *self, TWinsCtl *wctl); \
  void (*OnDestroy)(struct TCSelf *self); \
  void (*OnPaint)(struct TCSelf *self); \
  bool (*OnPaintCaption)(struct TCSelf *self, bool enabled); \
  void (*OnResize)(struct TCSelf *self); \
  void (*OnClick)(struct TCSelf *self, long KeyState, bool DblClick); \
  void (*OnMouseDown)(struct TCSelf *self, XButtonEvent *ev); \
  void (*OnMouseUp)(struct TCSelf *self, XButtonEvent *ev); \
  void (*OnMouseMove)(struct TCSelf *self, XMotionEvent *ev); \
  void (*OnMouseOver)(struct TCSelf *self, XCrossingEvent *ev, bool Leave); \
  void (*OnKeyDown)(struct TCSelf* self, TKeyEvent *KeyEv); \
  void (*OnKeyUp)(struct TCSelf *self, TKeyEvent *KeyEv); \
  void (*OnFocus)(struct TCSelf *self, int Change); \
  void (*OnActivate)(struct TCSelf *self); \
  void (*OnVisible)(struct TCSelf *self, bool Visible); \
  void (*OnSetCaption)(struct TCSelf *self, const char *s); \
  void (*Resize)(struct TCSelf *self); \
  void (*GetClientRect)(struct TCSelf *self, TWRect *rc); \
  void (*GetAlignClientRect)(struct TCSelf *self, TWRect *rc); \
  bool (*AdjustSize)(struct TCSelf *self); \
  void (*Paint)(struct TCSelf *self); \
  void (*RePaint)(struct TCSelf *self); \
  void (*DoPaint)(struct TCSelf *self); \
  void (*DoClick)(struct TCSelf *self, long KeyState, bool DblClick); \
  void (*DoMouseDown)(struct TCSelf *self, XButtonEvent *ev); \
  void (*DoMouseUp)(struct TCSelf *self, XButtonEvent *ev); \
  void (*DoMouseMove)(struct TCSelf *self, XMotionEvent *ev); \
  void (*DoMouseOver)(struct TCSelf *self, XCrossingEvent *ev, bool Leave); \
  int (*DoKeyDown)(struct TCSelf *self, TKeyEvent *KeyEv); \
  int (*DoKeyUp)(struct TCSelf *self, TKeyEvent *KeyEv); \
  void (*DoFocus)(struct TCSelf *self, int Change); \
  bool (*DoActivate)(struct TCSelf *self); \
  THdnd *Hdnd; \
  struct TgTimer *RepTimer; \
  byte RepTimerStartCount; \
  byte nc_b_001, nc_b_002, nc_b_003; \
  dword LastPaintTime_us; \
  int RunStatus; \
  TWRect xwc; \
  T_OS_var OS_var; \
  TDecor *Decor;

typedef struct TWins {
  AlgTWins
} TWins;

#undef TCSelf

#define WCSfkt_OverrideRedirect 1

typedef struct TWins_Create_struct {
  void *wins;
  TWins *Parent;
  Window ParentWinID;
  void (*CreateParams)(struct TWins_Create_struct *wcs);
  void (*CreateXWin)(struct TWins_Create_struct *wcs);
  long XMask;
  XSetWindowAttributes XAttr;
  void *SubP; //used in TMenuButton; TForm Parent
  dword WCSfkt;
} TWins_Create_struct;

extern void TWins_Create_struct_init(TWins_Create_struct *wcs, int tcsize, int wtyp);

extern void REGP3 SelfCreateS(TWins *self, int Left, int Top, int Width, int Height, const char *s);

extern TWins *TWins_CreateB(TWins *Parent, int Left, int Top, int Width, int Height, int BorderFu);
extern TWins *TWins_CreateBA(TWins *Parent, int Left, int Top, int Width, int Height, int BorderFu, int Align);
extern TWins *TWins_CreateLabel(TWins *Parent, int Left, int Top, int Width, int Height, const char *s, int CaptionFu, int BorderFu);
extern TWins *TWins_CreateLabelA(TWins *Parent, int Left, int Top, int Width, int Height, const char *s, int CaptionFu, int BorderFu, int Align);

extern void TWins_SetBorderWidth(TWins *self, int BorderWidth);
extern void TWins_SetDefaultBorderWidth(TWins *self);

extern void Set_Parent(TWins *self, TWins *Parent);
extern bool Get_IsParent(TWins *self);
extern void SetCaption(TWins *self, const char *s);
extern const char *GetCaption_pc(TWins *self);
extern void SetColor(TWins *self, dword col);
extern void SetBorder(TWins *self, int BorderFu);
extern void SetFont(TWins *self, const char *name);
extern bool SetFontTf(TWins *self, TFont *font);
extern void Set_Focus(TWins *self);
extern void SetEnabled(TWins *self, bool Value);
extern void SetVisible(TWins *self, bool Value);
extern void Set_Cursor(TWins *self, int Value);

extern void SetLeft(TWins *self, int left);
extern void SetTop(TWins *self, int top);
extern void SetPosition(TWins *self, int left, int top);
extern void SetWidth(TWins *self, int Width);
extern void SetHeight(TWins *self, int Height);
extern void SetWinSize(TWins *self, int Width, int Height);
extern void SetRC(TWins *self, int Left, int Top, int Width, int Height);
extern void Paint(TWins *self);
extern void RePaint(TWins *self);
//void PaintOnEvEnd(TWins *self);  //use Refresh
extern void Refresh(TWins *self);

extern void SetFontForeColor(TWins *self, int col);
extern void SetFontDefaultForeColor(TWins *self);
extern void SetFontBackColor(TWins *self, int col);
extern void SetFontDefaultBackColor(TWins *self);

extern bool WinsCtl(TWins *self, TWinsCtl *wctl);

extern void Resize(TWins *self);
extern void Get_ClientRect(TWins *self, TWRect *rc);
extern void GetAlignClientRect(TWins *self, TWRect *rc);
extern void AdjustSize(TWins *self);
extern void *GetParentWins(TWins *self);
extern void *GetParentWins_wtyp(TWins *self, int wtyp);
extern void *GetParentForm(TWins *self);
extern bool TestWinIsEnabled(TWins *self);
extern bool TestWinIsVisible(TWins *self);
extern bool TestWinIsAktiv(TWins *self);  //Enabled + Visible
extern bool TestWinCanFocus(TWins *self);

//******************* TWins
extern TWins *TWins_Create(TWins *Parent);
extern void TWins_DefaultConf(TWins_Create_struct *wcs);
extern void TWins_CreateXWin(TWins_Create_struct *wcs);
extern bool TWins__Destroy (TWins *self);
extern void TWins_Add(TWins *self, TWins *Parent);
extern void TWins_SetParent(TWins *self, TWins *Parent);
extern void TWins_ReParent(TWins *self, TWins *Parent, int left, int top);
#ifdef USE_DECOR
extern bool TWins_Decor(TWins *self, int bef, int mk, void *p);
#endif
extern void TWins_GetAlignClientRect(TWins *self, TWRect *rc);
extern void TWins_GetClientRect(TWins *self, TWRect *rc);
extern void TWins_SetSize(TWins *self);
extern bool TWins_AdjustSize(TWins *self); //true = new size
extern void TWins_Resize(TWins *self);
extern bool TWins_Ctl(TWins *self, TWinsCtl *wctl);

extern void TWins_PaintEnCaption(TWins *self, bool En);
extern void TWins_Paint(TWins *self);
extern void TWins_RePaint(TWins *self);
extern void TWins_Refresh(TWins *self);

extern void vds_SetStr(TVDrawString *vds, const char *s);
extern void TWins_SetCaption(TWins *self, const char *s);
extern void TWins_SetUTF8(TWins *self, bool UTF8);
extern void TWins_SetUTF8Auto(TWins *self, bool UTF8Auto);
extern void TWins_SetColor(TWins *self, dword Color);
extern void TWins_SetBorder(TWins *self, int BorderFu);
extern void TWins_SetEnabled(TWins *self, bool Value);
extern void TWins_SetVisible(TWins *self, bool Value);

extern void TWins_SetRC(TWins *self, int Left, int Top, int Width, int Height);

#define cWinsMinWidth  1
#define cWinsMaxWidth  (1<<1)
#define cWinsMinHeight (1<<2)
#define cWinsMaxHeight (1<<3)
extern int TWins_ChkWinSizeMinMax(TWins *self, int *w, int *h);


extern void TWins_DoPaint(TWins *self);
extern void TWins_DoClick(TWins *self, long KeyState, bool DblClick);
extern void TWins_DoMouseDown(TWins *self, XButtonEvent *ev);
extern void TWins_DoMouseUp(TWins *self, XButtonEvent *ev);
extern void TWins_DoMouseMove(TWins *self, XMotionEvent *ev);
extern void TWins_DoMouseOver(TWins *self, XCrossingEvent *ev, bool Leave);

extern int TWins_DoKeyDown(TWins *self, TKeyEvent *KeyEv);
extern int TWins_DoKeyUp(TWins *self, TKeyEvent *KeyEv);

//#define WinsFocusOut	0
#define WinsFocusIN	1
#define WinsFocusChange (1<<1)

extern void TWins_DoFocus(TWins *self, int Change);
extern bool TWins_DoActivate(TWins *self);
#ifdef DRAG_AND_DROP
extern int TWins_DodndMouseMove(TWins *self, XMotionEvent* ev);
extern int TWins_DodndDrop(TWins *self);
extern int TWins_DodndStatus(TWins *self, XClientMessageEvent* ev);
#endif

typedef bool (*TKeyDownPlugIn)(TWins* self, TKeyEvent *KeyEv, int *res);
typedef bool (*TKeyUnRedoPlugIn)(TWins* self, TUnRedoLine *url);

typedef struct TPlugIn_KeyDown {
  AlgTTC
  struct TPlugIn_KeyDown *next;
  TKeyDownPlugIn KeyDownPlugIn;
  TKeyUnRedoPlugIn ReUndo;
} TPlugIn_KeyDown;

struct TForm;
//******************* TForm
//typedef void (*TFormOnShow)(struct TForm *self);

/* form.FormZStyle */
#define fzsNormal       0
#define fzsOnTop        (1<<1)
#define fszTransient    (1<<1)
#define fszNoResize     (1<<2)
/* form.FormZStyle + USE_MWMHINTS in form.c */
#define fszNoTitle      (1<<4)
#define fszNoBorder     (1<<5)
#define fszNoInput      (1<<6)
#define fszFullSize     (1<<7)

/* form.FormPosition */
#define poDefault       0
#define poDesigned      1
#define poCenter        (1<<1)
/* TForm.OnCanClose (bool *CanClose) */
#define FormClose		1
#define FormCloseAndFree	(1<<1)

#define TCSelf TForm

#define AlgTForm AlgTWins \
  TWins *FocusWin; \
  TWins *Parent; \
  int FormZStyle; \
  int FormPosition; \
  int Gravity; \
  const char *IconName; \
  TPic *Icon; \
  XClassHint XFormClass; \
  void (*OnMove)(struct TCSelf *self); \
  void (*OnCanClose)(struct TCSelf *self, int *CanClose); \
  void (*OnShow)(struct TCSelf *self); \
  void (*Show)(struct TCSelf *self); \
  void (*Close)(struct TCSelf *self); \
  TWins *LastNoMenuFocusWin; \
  struct TMenuButton *Root_MenuButton; \
  void (*DoMenuButtonExec)(struct TCSelf *self); \
  bool CloseIsWM_DELETE; \
  bool CloseIsVisibleFalse; \
  bool dnd_isEnable; \
  bool nc3_form;

typedef struct TForm {
  AlgTForm
} TForm;
#undef TCSelf

//typedef void (*TOnCanClose)(TForm *self, int *CanClose);

extern void *TForm_CreatParamAlg_WCSfkt(TWins *Parent, int FormMemSize, dword WCSfkt);
extern void *TForm_CreatParamAlg(TWins *Parent, int FormMemSize);
extern TForm *TForm_Create(TWins *Parent);
extern bool TForm__Destroy(TForm *self);
extern void TForm_CreateParams(TWins_Create_struct *wcs);
extern void TForm_CreateXWin(TWins_Create_struct *wcs);

extern void TForm_Close(TForm *self);
extern void TForm_Show(TForm *self);
extern void TForm_SetVisible(TForm *self, bool Value);

//******************* TSysTrayWin
#define TCSelf TSysTrayWin
typedef struct TSysTrayWin {
  AlgTForm
  Window SysTrayWin;
  TWRect SysTrayWin_rc;
} TSysTrayWin;
#undef TCSelf

TSysTrayWin *TSysTrayWin_Create();


//******************* TButton
#define TCSelf TButton
typedef struct TButton {
  AlgTWins
} TButton;
#undef TCSelf

extern TButton *TButton_Create(TWins *Parent);
extern void TButton_CreateParams(TWins_Create_struct *wcs);
extern TButton *TButton_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s);

extern void TButton_DoPaint(TButton *self);
extern int TButton_DoKeyDown(TButton *self, TKeyEvent *KeyEv);
extern int TButton_DoKeyUp(TButton *self, TKeyEvent *KeyEv);
extern void TButton_DoMouseDown(TButton *self, XButtonEvent *ev);
extern void TButton_DoMouseUp(TButton *self, XButtonEvent *ev);
extern void TButton_DoFocus(TButton *self, int Change);

#ifdef USE_DECOR
extern TDecor *TButton_Decor_Create(char *upIco, char *downIco, int BorderWidth);
#endif

//******************* TButtonPic
/* pic_fu */
#define mBuPicLeft	(1<<2)
#define mBuPicRigth	(1<<3)
#define mBuPicTop	(1<<4)
#define mBuPicBottom	(1<<5)

#define TCSelf TButtonPic
typedef struct TButtonPic {
  AlgTWins
  int pic_fu;
  int pic_offX;
  int pic_offY;
  TPic *pic;		//Enabled Pic
  TPic *dispic;		//Disabled Pic
} TButtonPic;
#undef TCSelf
extern TButtonPic *TButtonPic_Create(TWins *ws);
extern TButtonPic *TButtonPic_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s);
extern void TButtonPic_DoPaint(TButtonPic *self);

//******************* TRepButton
#define AlgTRepButton AlgTWins \
  void (*OnMouseDownRep)(struct TCSelf *self); 

#define TCSelf TRepButton
typedef struct TRepButton {
  AlgTRepButton
} TRepButton;
#undef TCSelf

extern TDecor *DefaultRepButtonDecor;

extern TRepButton *TRepButton_Create(TWins *Parent);
extern void TRepButton_CreateParams(TWins_Create_struct *wcs);
extern TRepButton *TRepButton_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s);

//******************* TEdit

#define AlgTEdit AlgTWins \
  int CaretCharIdx; \
  void (*OnChange)(struct TCSelf *self); \
  bool (*DoCharAllow)(struct TCSelf *self, TKeyEvent *KeyEv, int idx); \
  dword ColorReadOnlyOffset; \
  bool AutoSel; \
  bool ReadOnly; \
  byte Passwd; \
  bool ed_nc3;


#define TCSelf TEdit
typedef struct TEdit {
  AlgTEdit
} TEdit;
#undef TCSelf

extern TEdit *TEdit_Create(TWins *ws);
extern void TEdit_CreateParams(TWins_Create_struct *wcs);
extern TEdit *TEdit_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s);
extern bool TEdit__Destroy(TEdit *self);
extern void TEdit_DoPaint(TEdit *self);
extern int TEdit_DoKeyDown(TEdit *self, TKeyEvent *KeyEv);
extern void TEdit_DoMouseDown(TEdit *self, XButtonEvent *ev);
extern void TEdit_DoMouseUp(TEdit *self, XButtonEvent *ev);
extern void TEdit_DoMouseMove(TEdit *self, XMotionEvent *ev);
extern void TEdit_DoClick(TEdit *self, long KeyState, bool DblClick);
extern void TEdit_DoFocus(TEdit *self, int Change);

extern void TEdit_SetCaption(TEdit *self, const char *s);
extern void TEdit_SetSelAll(TEdit *ed);
extern void TEdit_SetReadOnly(TEdit *self, bool ReadOnly);

#define ed_passwd_akt 0x01
#define ed_passwd_akt_NULL 0x02

extern TEdit *TEdit_passwd_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s);

//******************* TDVal **************************************
 /* dv_fu */
#define tdv_fu_LostFocusEnter	1
#define tdv_fu_KorrOn		(1<<1)
#define tdv_fu_MouseMove_add	(1<<2)

#define AlgTDVal AlgTEdit \
  double dval; \
  double min; \
  double max; \
  double korr; \
  double MouseMove_add_dval; \
  int nk; \
  int korr_nk; \
  int dv_fu; \
  void (*OnValChange)(struct TDVal *self, double dval); \
  double MouseDown_dval; \
  bool Change_mk; \
  byte MouseMove_Sel_mk; \
  bool ForceChange_mk;

#define TCSelf TDVal

typedef struct TDVal {
  AlgTDVal
} TDVal;
#undef TCSelf

extern TDVal *TDVal_Create(TWins *ws);
extern TDVal *TDVal_CreateS(TWins *Parent, int Left, int Top, int Width, int Height);
extern TDVal *TDVal_CreateSV4(TWins *Parent, int Left, int Top, int Width, int Height, 
			double val, double min, double max, int nk);

extern void TDVal_Set_Value(TDVal *dv, double dval);
extern void TDVal_Set_Value_ev(TDVal *dv, double dval);
extern void TDVal_Set_Min(TDVal *dv, double dval);
extern void TDVal_Set_Max(TDVal *dv, double dval);
extern void TDVal_KorrOnOff(TDVal *dv, int OnOff);
extern void TDVal_SetUpKorr(TDVal *dv, double korr, int nk, int OnOff);
#define tdvfu_ChangeEv		(1<<16)
extern void TDVal_DoValChange(TDVal *dv, double val, int fu);

extern int TDVal_GetIntegerMult(TDVal *self, double multfakt);
extern int TDVal_GetInteger(TDVal *self);

//******************* TChkBox

#define TCSelf TChkBox

#define AlgChkBox AlgTWins \
  bool Checked; \
  bool OnlyInBoxCheck; \
  bool AutoToggle; \
  bool cb_nc3;


typedef struct TChkBox {
  AlgChkBox
} TChkBox;
#undef TCSelf

extern TChkBox *TChkBox_Create(TWins *Parent);
extern TChkBox *TChkBox_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s);
extern void TChkBox_SetChecked(TChkBox *self, bool Value);
extern void TChkBox_SetChecked_ev(TChkBox *self, bool Value);

//******************* TScrollBar ***************************
#define sbfu_inv	1

#define TCSelf TScrollBar

#define AlgScrollBar AlgTWins \
  int Count; \
  int ButtonCountSize; \
  int MaxCount; \
  int OffCount; \
  int sbfu; \
  int SmallChange; \
  int LargeChange; \
  int MouseZ_Wheel; \
  void (*OnCount)(struct TCSelf *self, int Count); \
  bool (*OnSmallChange)(struct TCSelf *self, int *NewCount, bool Neg); \
  bool (*OnLargeChange)(struct TCSelf *self, int *NewCount, bool Neg); \
  int scLg; \
  int scPos; \
  int MouseDownSeg; \
  int MouseDownPos; \
  int MDscPos; \
  int bulg; \
  bool Hsc; \
  bool scPaint;

typedef struct TScrollBar {
  AlgScrollBar
} TScrollBar;
#undef TCSelf

extern TScrollBar *TScrollBar_Create(TWins *Parent);
extern TScrollBar *TScrollBarHorz_CreateP(TWins *Parent);
extern TScrollBar *TScrollBarVert_CreateP(TWins *Parent);

extern void TScrollBar_SetCount(TScrollBar *sb, int Count);
extern void TScrollBar_SetCount_ev(TScrollBar *sb, int Count);
extern int TScrollBar_GetCount(TScrollBar *sb);
extern void TScrollBar_SetButtonCountSize(TScrollBar *sb, int ButtonCountSize);
extern void TScrollBar_SetMaxCount(TScrollBar *sb, int MaxCount);
extern void TScrollBar_SetMaxCount_ButtonSize(TScrollBar *sb, int MaxCount, int ButtonCountSize);
extern void TScrollBar_Refresh(TScrollBar *self);
extern void TScrollBar_SetCountParam(TScrollBar *sb, int Count, int buCount, 
			      int MaxCount, int OffCount, int sbfu);

extern void TScrollBar_DoCount(TScrollBar *sb, int Count);
extern bool TScrollBar_MouseZ_Wheel(TScrollBar *self, XButtonEvent *ev);

//******************* TSplitter ****************************
#define TCSelf TSplitterV
typedef struct TSplitterV {
  AlgTWins
  TWins	*leftwin;	//or top
  int	md_left;	//or top
  TWins	*rightwin;	//or bottom
  int	rightwin_right;	//or bottom
  int	rmk;
} TSplitterV;
#undef TCSelf

TSplitterV *TSplitterV_CreateP(TWins *Parent);

#define TCSelf TSplitterH
typedef struct TSplitterH {
  AlgTWins
  TWins	*topwin;
  int	md_top;
  TWins	*bottomwin;
  int	bottomwin_bottom;
  int	rmk;
} TSplitterH;
#undef TCSelf

extern TSplitterH *TSplitterH_CreateP(TWins *Parent);

//******************* TClassGC *****************************


#define AlgClassGC AlgTTC \
  int Width; \
  int Height; \
  int Top; \
  int Left; \
  int XOrigin; \
  int YOrigin; \
  int ForeColor; \
  int BackColor; \
  struct TWins *owner; \
  GC gc; \
  XRectangle ClipRc; \
  TVDrawString vds; \
  XGCValues gcv;

typedef struct TClassGC {
  AlgClassGC
} TClassGC;

extern TClassGC *TClassGC_Create(TWins *owner);

extern void TClassGC_SetForeGround(TClassGC *self, int Color);
extern void TClassGC_SetBackGround(TClassGC *self, int Color);
extern void TClassGC_SetClipRc(TClassGC *self, TWRect *rc);

extern void TClassGC_DrawLine(TClassGC *self, int x1, int y1, int x2, int y2);
extern void TClassGC_DrawRect(TClassGC *self, int x, int y, int w, int h);
extern void TClassGC_DrawFocusRect_rc(TClassGC *self, TWRect *rc);

extern void TClassGC_FillRect(TClassGC *self, int x, int y, int w, int h);
extern void TClassGC_FillRect_rc(TClassGC *self, TWRect *rc);
extern void TClassGC_FillSelectRect_rc(TClassGC *self, TWRect *rc);

extern void TClassGC_BorderPaint(TClassGC *self, int BorderFu, int x, int y, int w, int h);
extern void TClassGC_BorderPaint_rc(TClassGC *self, int BorderFu, TWRect *rc);
extern int TClassGC_DrawColorString(TClassGC *self, int x, int y);
//********** TClassGC_DrawColorStringFu.fu *****
// #define mStrSolid	(1<<1)
#define mStrLeft	(1<<2)
#define mStrRigth	(1<<3)
#define mStrTop 	(1<<4)
#define mStrBottom	(1<<5)
extern int TClassGC_DrawColorStringFu(TClassGC *self, int x, int y, int fu);

extern void TClassGC_DrawPic(TClassGC *self, TPic *pic, int x, int y);

//******************* TScrollWin ***************************

#define TCSelf TScrollWin

#define AlgScrollWin AlgTWins \
  struct TWins *pw; \
  struct TWins *pws; \
  struct TScrollBar *HSB; \
  struct TScrollBar *VSB;
//  int MouseZ_Wheel;

typedef struct TScrollWin {
  AlgScrollWin
} TScrollWin;
#undef TCSelf

extern TScrollWin *TScrollWin_CreateU(TWins *Parent, int Left, int Top, int Width, int Height, int BorderFu, int Align, bool mParent);
extern TScrollWin *TScrollWin_Create(TWins *Parent);
extern void TScrollWin_DefaultConf(TWins_Create_struct *wcs);
extern void TScrollWin_CreateParams(TWins_Create_struct *wcs);
extern void TScrollWin_SetParent(TScrollWin *self, TWins *Parent);
extern void TScrollWin_SetMouseZ_Wheel(TScrollWin *self, int Value);


//******************* TGrid ******************************************
#define grFixNoBorder		1
//#define grFixNoDefaultCol	(1<<1)
#define grFixResize		(1<<2)
/* FixedColsFu */
// #define grCol_alloc_objs	(1<<8)

/* SelectFu */
#define grSelFu_Row		1
#define grSelFu_NoAutoHSB	(1<<1)

struct TGrid;

typedef struct TcrDat {
  union {
    int w;
    int h;
  };
  int min, max;
  int Color;		//$80000000 = no Color
  int tag;
  const char *name;
  bool Visible;
  bool nc1, nc2, nc3;
  void *obj;
} TcrDat;

#define TcrDat_Row TcrDat

typedef struct TMouseCell {
  int Col;
  int Row;
  int x;
  int y;
  int XOrigin;
  int YOrigin;
  TWRect rc;
  bool InCell;
  bool fixCol;
  bool fixRow;
  bool nc3;
} TMouseCell;

typedef struct {
  int xa, xe;	//xa=-1 no data cell paint
  int ya, ye;	//ya=-1 no data cell paint
} TPaintCellDat;

// #define FixedCanResize	1
/* DoPaintCell fu */
#define GrDPC_DrawFocusRc	1
#define GrDPC_DrawSelect	(1<<1)

#define TCSelf TGrid

#define AlgGrid AlgScrollWin \
  int FixedCols; \
  int FixedColsFu; \
  int FixedColsColor; \
  int FixedRows; \
  int FixedRowsFu; \
  int FixedRowsColor; \
  int DefaultColWidth; \
  int DefaultRowHeight; \
  int RowCount; \
  int ColCount; \
  int SelectFu; \
  int SelectIdxCol; \
  int SelectIdxRow; \
  TMouseCell MouseCell; \
  TClassGC *CellGC; \
  TClassGC *PaintGC; \
  TcrDat *ColDat; \
  TcrDat_Row *RowDat; \
  TWRect rcPaint; \
  bool (*DoPaintCell)(struct TCSelf *self, int ACol, int ARow, TWRect *rc, int *fu); \
  void (*DoSelect)(struct TCSelf* self, int fu); \
  void (*DocrResize)(struct TCSelf *self, int idx, bool isCol); \
  void (*DoEditEnd)(struct TCSelf* self); \
  void (*DoSetUp_VHSB)(struct TCSelf *self); \
  bool (*OnSelect)(struct TCSelf* self, int ACol, int ARow, int fu); \
  void (*OnRowFree)(struct TCSelf* self, TcrDat_Row *cr); \
  void (*OnEditEnd)(struct TCSelf* self); \
  void (*OncrResize)(struct TCSelf *self, int idx, bool isCol); \
  void (*OnPaintCellEnd)(struct TCSelf *self, TPaintCellDat *pcd); \
  int MoveX; \
  int MoveY; \
  TWins *EditWins; \
  int EditWinsCol; \
  int EditWinsRow; \
  bool RowColResize; \
  bool ag_nc1; \
  bool ag_nc2; \
  bool ag_nc3;

typedef struct TGrid {
  AlgGrid
} TGrid;
#undef TCSelf

//typedef bool (*TDoPaintCell)(TGrid *self, int ACol, int ARow, TWRect *rc, int *fu);
//typedef void (*TGridDoSelect)(TGrid *self, int fu);
//typedef void (*TOncrResize)(TGrid *self, int idx, bool isCol);

extern TGrid *TGrid_Create(TWins *Parent);
extern void TGrid_DefaultConf(TWins_Create_struct *wcs);
extern void TGrid_CreateParams(TWins_Create_struct *wcs);
extern bool TGrid__Destroy(TGrid *self);
//extern TGrid *TGrid_CreateU(TWins *Parent, int Left, int Top, int Width, int Height, int BorderFu, int Align, bool mParent);
extern TGrid *TGrid_Create_alClient(TWins *Parent, int BorderFu);

extern void TGrid_Chk_VHSB(TGrid *gr);
extern void TGrid_EditEnd(TGrid *gr);
extern void TGrid_Resize(TGrid *self);
extern void TGrid_DoPaint(TGrid *self);
extern void TGrid_ChkSelect_RC(TGrid *gr, int ACol, int ARow);

extern void TGrid_SetMouseZ_Wheel(TGrid *self, int Value);

#define grBefFu_Mask		0x0f
#define grBefFu_Select		0
#define grBefFu_Deselect	1
#define grBefFu_DelRow		2
#define grBefFu_Deselect_DelRow	3
#define grBefFu_ctrl		0x10
#define grBefFu_strg		0x20

#define grBefFu_Select_Idx	0x100
#define grBefFu_Repaint		0x400


//fu 0=Select 1=Deselect 2=Del 3=Deselect+Del
extern void TGrid_Select(TGrid *gr, int Col, int Row, int fu);
extern void TGrid_DoSelect(TGrid *gr, int fu);
extern void TGrid_Deselect(TGrid *gr);

extern void TGrid_DoMouseDown(TGrid *self, XButtonEvent *ev);
extern void TGrid_DoMouseUp(TGrid *self, XButtonEvent *ev);
extern void TGrid_DoMouseMove(TGrid *self, XMotionEvent *ev);
extern void TGrid_DocrResize(TGrid *self, int idx, bool isCol);

extern bool TGrid_DoPaintCell(TGrid *self, int ACol, int ARow, TWRect *rc, int *fu);
extern void TGrid_DoSetUp_VHSB(TGrid *self);

extern bool TGrid_GetCell_AbsRC(TGrid *gr, int ACol, int ARow, TWRect *rc);
extern bool TGrid_GetCell_RC(TGrid *gr, int ACol, int ARow, TWRect *rc);
extern void TGrid_PaintCell(TGrid *gr, int ACol, int ARow, int *fu);

extern void TGrid_SetColCount(TGrid *self, int Value);
extern void TGrid_SetRowCount(TGrid *self, int Value);

extern TcrDat_Row* TGrid_AddRow(TGrid *gr);
extern TcrDat_Row* TGrid_InsRow(TGrid *gr, int Idx);
extern void TGrid_DelRow(TGrid *gr, int Idx);

extern void TGrid_SetColWidth(TGrid *gr, int Col, int Width);
extern void TGrid_SetRowHeight(TGrid *gr, int Row, int Height);

extern void TGrid_SetColVisible(TGrid *gr, int Col, bool Visible);
extern void TGrid_SetRowVisible(TGrid *gr, int Row, bool Visible);

extern void TGrid_Set_crMinMax(TGrid *self, int idx, bool isCol, int min, int max);
extern void TGrid_Set_crSize  (TGrid *self, int idx, bool isCol, int wh);

//******************* TMenuButton **************************
#define TCSelf TMenuButton

#define AlgMenuButton AlgTWins \
  struct TMenuButton *mbuRoot; \
  TPic *pic; \
  TPic *dis_pic; \
  struct TMenu *menu; \
  int mbuStat; \
  bool AutoSize; \
  bool mbu_ncb1; \
  bool mbu_ncb2; \
  bool mbu_ncb3;

typedef struct TMenuButton {
  AlgMenuButton
} TMenuButton;
#undef TCSelf

extern TMenuButton *TMenuButton_Create(TWins *ws, TMenuButton *mbuRoot);
extern TMenuButton *TMenuButton_CreateS(TWins *Parent, TMenuButton *mbuRoot, const char *s);
extern void TMenuButton_SetAsRoot(TForm *Form, TMenuButton *mbu);
extern void TMenuButton_SetPosition(TMenuButton *mb);

extern void TMenuEdit_DoPaint(TWins *self);
extern void TMenuButton_DoMouseDown(TMenuButton *self, XButtonEvent *ev);
extern void TMenuButton_DoMouseUp(TMenuButton *self, XButtonEvent *ev);
extern void TMenuButton_DoClick(TMenuButton *self, long KeyState, bool DblClick);
extern int TMenuButton_DoKeyDown(TMenuButton *self, TKeyEvent *KeyEv);
extern int TMenuButton_DoKeyUp(TMenuButton *self, TKeyEvent *KeyEv);


//******************* TMenu
#define miNotVisible	1
#define miNotEnabled	(1 << 1)
#define miChecked	(1 << 2)
#define miCanNotSelect	(1 << 3)
#define miHead		(1 << 4)
#define miDisable_s2	(1 << 5)
#define miSeparator	(1 << 16)
#define miCanCheck	(1 << 17)
#define miAutoToggle	(3 << 17)
/* add,ins,... b24..b31 */
#define miAddInv	(1 << 24)
#define miAdd_setSel	(1 << 25)

#define AlgMenuItem AlgTTC \
  struct TCMenuItem *next; \
  struct TCMenuItem *prev; \
  struct TCMenu *next_menu; \
  char *s; \
  char *s2; \
  int lg; \
  dword fu; \
  int y1; \
  int y2; \
  void *obj; \
  TPic *pic; \
  void (*OnClick)(struct TCMenu *menu, long KeyState, struct TCMenuItem* mi); 

#define TCMenu TMenu
#define TCMenuItem TMenuItem
typedef struct TMenuItem {
  AlgMenuItem
} TMenuItem;
#undef TCMenuItem
#undef TCMenu

extern bool TMenuItem__Destroy(TMenuItem *self);
extern void TMenuItem_SetCaption(TMenuItem *mi, const char *s);

#define mioXK_Right	1
#define mioXK_XK_Left	2
#define mioClose	3
/* OnMenuClose stat */
//#define me_stClose		0
//#define me_stClose_mouse_anf	1

/* TMenu->RunStat */
#define meRS_OPEN	1
#define meRS_SubLeft	(1<<1)
#define meRS_ParentCanDestroy	(1<<8)

#define AlgMenu AlgTWins \
  struct TMenuButton *MenuButton; \
  TCMenuItem *MenuItem; \
  TCMenuItem *SelItem; \
  struct TCSelf *next_tmp_menu; \
  struct TCSelf *prev_tmp_menu; \
  int TopItemIdx; \
  int ItemMinHeight; \
  int SideXOff; \
  int s2_XOff; \
  int pic_OffX; \
  int ItemYOff; \
  char Gravity; \
  char bu_c1, bu_c2, bu_c3; \
  dword RunStat; \
  TPic *side_pic; \
  void (*OnMenuOpen)(struct TCSelf *self); \
  void (*OnMenuClose)(struct TCSelf *self); \
  TCMenuItem *(*DoMenuItemCreate)(struct TCSelf *self); \
  void (*DoShow)(struct TCSelf *self, int, int); \
  void (*DoMenuOpen)(struct TCSelf *self); \
  void (*DoMenuClose)(struct TCSelf *self); \
  void (*DoOwner)(struct TWins *owner, int); 

#define TCSelf TMenu
#define TCMenuItem TMenuItem
typedef struct TMenu {  
  AlgMenu
} TMenu;
#undef TCMenuItem
#undef TCSelf

typedef void (*TMenuEv)(TMenu *self);
typedef void (*TMenuClickEv)(TMenu *self, long KeyState, TMenuItem* mi);

extern TMenu *TMenu_Create(TWins *Form);
extern void TMenu_CreateParams(TWins_Create_struct *wcs);
extern bool TMenu__Destroy(TMenu *self);
extern void TMenu_DoPaint(TMenu *self);

extern void TMenu_Show(TMenu *self, TWins *owner, int Left, int Top);
extern void TMenu_Close(TMenu *self);
extern void TMenu_DoClose(TMenu *self);

extern TMenuItem *TMenu_InsItem(TMenu *me, const char *s, int idx);
extern TMenuItem *TMenu_AddItem(TMenu *me, const char *s, long fu, void (*OnClick)(struct TMenu*, long, struct TMenuItem*));
extern TMenuItem *TMenu_GetItemI(TMenu *self, int idx);
extern TMenuItem *TMenu_GetItemS(TMenu *self, const char *s);
extern void TMenu_DelItem(TMenu *self, TMenuItem *mi);
extern void TMenu_DelItemS(TMenu *self, const char *s);

extern void TMenu_Cls(TMenu *me);
extern TMenu *GetAktMenueWin();

extern void TMenu_DoMenuOpen(TMenu *me);
extern void TMenu_DoShow(TMenu *me, int Left, int Top);
extern void TMenu_DoClick(TMenu *self, long KeyState, bool DblClick);

/* tmenu_push.c */
extern bool TMenu_DelItemI(TMenu *self, int idx);  //Result hasNext
extern TMenuItem *TMenu_PushS(TMenu *self, const char *s, int maxItem);


/* TMenuFileItem.mfik */
#define mfik_sort_ok	(1<<16)

#define TCMenu TMenuFile
#define TCMenuItem TMenuFileItem
typedef struct TMenuFileItem {
  AlgMenuItem
  int mfik;
  char *filename;
  char *itemname;
} TMenuFileItem;
#undef TCMenuItem
#undef TCMenu

/* TMenuFile.mfk */
#define mfk_init_ok	1
#define mfk_sort_inv	(1<<2)
#define mfk_AddDirHead	(1<<3)
#define mfk_AutoFree	(1<<4)

#define AlgTMenuFile AlgMenu \
  void (*OnInitDat)(struct TCSelf *self, bool iniEnd); \
  bool (*OnAddFilter)(struct TCSelf *self, struct TDirFileList *dfl, TDesktopHead *ddkh); \
  struct TCSelf *(*OnNextMenuCreate)(struct TCSelf *owner); \
  char *path; \
  int mfk; \
  int icon_size;

#define TCSelf TMenuFile
#define TCMenuItem TMenuFileItem
typedef struct TMenuFile {
  AlgTMenuFile
} TMenuFile;
#undef TCMenuItem
#undef TCSelf

extern TMenuFile *TMenuFile_Create(TWins *Form);
extern void TMenuFile_CreateParams(TWins_Create_struct *wcs);
extern bool TMenuFile__Destroy(TMenuFile *self);
extern void TMenuFile_DoPaint(TMenuFile *self);
extern void TMenuFile_Show(TWins *self, int Left, int Top);

//******************* TComboBox

#define AlgComboBox AlgTEdit \
  struct TWins *button; \
  void (*OnPopUp)(struct TComboBox*, TMenu *me); \
  void (*OnItemSel)(struct TComboBox*, TMenuItem *SelItem); \
  TMenu *popup; \
  TMenuItem *SelItem; 

#define TCSelf TComboBox
typedef struct TComboBox {
  AlgComboBox
} TComboBox;
#undef TCSelf

extern TComboBox *TComboBox_Create(TWins *Parent);
extern TComboBox *TComboBox_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s);
extern void TComboBox_GetClientRect(TWins *self, TWRect *rc);
extern void TComboBox_Resize(TComboBox *self);
extern TMenuItem *TComboBox_AddItem(TComboBox *cb, const char *s, long fu, void (*OnClick)(struct TMenu*, long KeyState, struct TMenuItem*));
extern TMenuItem *TComboBox_GetItemI(TComboBox *self, int idx);
extern void TComboBox_DelItem(TComboBox *cb, TMenuItem *mi);
extern void TComboBox_DelItemS(TComboBox *cb, const char *s);
//extern bool TComboBox_DelItemI(TComboBox *self, int idx);  //Result hasNext
extern TMenuItem *TComboBox_Push(TComboBox *self, int maxItem);

extern void TComboBox_SetItem_mi(TComboBox *cb, TMenuItem *mi);
extern void TComboBox_SetItem(TComboBox *cb, int idx);
extern void TComboBox_SetNextItem(TComboBox *cb);
extern void TComboBox_SetPrevItem(TComboBox *cb);
extern void TComboBox_ClsMenu(TComboBox *cb);

//******************* TProgressBar

#define TCSelf TProgressBar
typedef struct TProgressBar {
  AlgTWins
  int nk; 
  int Proz;	//0..1000  (1000=100%)
} TProgressBar;
#undef TCSelf

extern TProgressBar *TProgressBar_Create(TWins *Parent);
extern TProgressBar *TProgressBar_CreateU(TWins *Parent, int Left, int Top, int Width, int Height);
extern void TProgressBar_DoPaint(TProgressBar *self);
extern void TProgressBar_SetProz(TProgressBar *pb, int Value);

//******************* TPageControl
#define pgNotChange	1

// struct TPage *Page0; 

#define TCSelf TPageControl

#define AlgTPageControl AlgTWins \
  struct TPage *AktPage; \
  int MinTabWidth; \
  int TabTxtOff; \
  int TabsHeight, TabsGesHeight; \
  int AktYnr; \
  int xv1, xv2; \
  int Ynr; \
  int TabMaxX[16]; \
  void (*PaintTabs)(struct TPageControl*, int y0, int Ynr); \
  void (*OnChangeTab)(struct TPageControl *self, struct TPage *fromPage, struct TPage *toPage, int *fu); \
  void (*OnPageActivate)(struct TPageControl *self, struct TPage *AktPage); 

typedef struct TPageControl {
  AlgTPageControl
} TPageControl;
#undef TCSelf

extern TPageControl *TPageControl_Create(TWins *Parent);
extern TPageControl *TPageControl_CreateA(TWins *Parent);
extern bool TPageControl_ClrPageFromList(TPageControl *pagc, struct TPage *pag);
extern void TPageControl_InsPageToList(TPageControl *pagc, struct TPage *pag, struct TPage *insto_pag);
extern void TPage_SetPageAktiv(struct TPage *self);

//******************* TPage
#define TCSelf TPage

#define AlgTPage AlgTWins \
  struct TPageControl *PageControl; \
  bool PageVisible; \
  bool page_nc1, page_nc2, page_nc3; \
  TWins *FocusWin; \
  int TabXa, TabXe; \
  int TabYo, TabYu, TabYnr; \
  int Wtxt;

typedef struct TPage {
  AlgTPage
} TPage;
#undef TCSelf

extern TPage *GetParentPage(TWins* ws);
//extern void TPageControl_FreePage(TPageControl *pagc, TPage *pag);

extern TPage *TPageControl_AddNewPage(TPageControl *pagc, const char *Caption);

extern TPage *TPageControl_GetFirstPage(TPageControl *self, bool ChkVisible);
extern TPage *TPageControl_GetLastPage(TPageControl *self, bool ChkVisible);
extern TPage *TPage_GetNext(TPage *pg, bool ChkVisible);
extern TPage *TPage_GetPrev(TPage *pg, bool ChkVisible);

#define pgMove_ChkVisible	0x01
#define pgMove_Prev		0x02
extern void TPage_Move(TPage *self, TPage *to, int fu);

extern TPageControl *TPage_GetTPageControl(TPage *pg);

extern int TPageControl_GetPageCount(TPageControl *self, bool ChkVisible);

extern void *TPage_CreateParamAlg(TPageControl *Parent, int PageMemSize);
extern TPage *TPageControl_AddNewUserPage(TPageControl *pagc, const char *Caption, 
			struct TPage* (*DoTPageCreate)(struct TPageControl *Parent));

//******************* TTreeVNode
#define TVN_CHK_EXPAND 0


#define tvnfu_CalcSizeOnly	1
#define tvnfu_PaintNew		(1<<1)
#if TVN_CHK_EXPAND
#define tvnfu_TestExpand	(1<<2)
#endif

#define tvnSt_Expanded		1
#define tvnSt_SizeOk		(1<<1)
#define tvnSt_ForceCanExp	(1<<2)
#define tvnSt_NotVisible	(1<<3)

#define AlgTreeVNode int st; \
  int left; \
  int top; \
  int width; \
  int height; \
  int abs_top; \
  char *s; \
  int lg; \
  TFont *Font; \
  unsigned int ForeColor, BackColor; \
  void (*get_s_lg)(struct TTreeVNode *tvn, const char **s, int *lg); \
  TPic *pic; \
  TTC0 *ttc; 

#define TAlgNode TTreeVNode

typedef struct TTreeVNode {
  AlgTNode
/*
  AlgTTC				//--+
  struct TTreeVNode *prev;		//  |
  struct TTreeVNode *next;		//  |
  struct TTreeVNode *prev_child;	//  |--TNode Head
  struct TTreeVNode *next_child;	//  |
  struct TTreeVNode **root_node;	//--|
*/
  struct TTreeV *tv;

  AlgTreeVNode

} TTreeVNode;

#undef TAlgNode

extern void TTreeVNode_Param(TTreeVNode *self, struct TTreeV *tv, const char *s);
extern bool TTreeVNode__Destroy(TTreeVNode *self);

extern TTreeVNode* TTreeVNode_get_prev(TTreeVNode *tvn);
extern TTreeVNode* TTreeVNode_get_next(TTreeVNode *tvn);
extern TTreeVNode* TTreeVNode_get_prev_child(TTreeVNode *tvn);
extern TTreeVNode* TTreeVNode_get_next_child(TTreeVNode *tvn);

extern const char *TTreeVNode_GetCaption(TTreeVNode *tvn);
extern void TTreeVNode_GetCaption_s_lg(TTreeVNode *tvn, const char **s, int *lg);

extern TTreeVNode* TTreeVNode_get_node0(TTreeVNode *tvn, bool all);
extern TTreeVNode* TTreeVNode_get_by_name(TTreeVNode *tvn, const char *name, 
					bool all);
extern TTreeVNode* TTreeVNode_get_by_name_lg(TTreeVNode *tvn, const char *name, 
					int lg, bool all);

#define tvExpEv_KeyDown 2
#define tvExpEv_MouseDown 4
#define tvExpEv_Software 1

#define TCSelf TTreeV

#define AlgTreeV AlgScrollWin \
  int DefaultWidth; \
  int DefaultHeight; \
  unsigned int DefaultForeColor; \
  unsigned int DefaultBackColor; \
  TTreeVNode *SelectNode; \
  void (*DoPaintNode)(struct TTreeV *tv, struct TTreeVNode *tvn, int fu); \
  void (*DoExpandChange)(struct TTreeV *tv, TTreeVNode *tvn, int ExpEv); \
  void (*DoExpand)(struct TTreeV *tv, TTreeVNode *tvn); \
  void (*DoCollaps)(struct TTreeV *tv, TTreeVNode *tvn); \
  void (*DoNodeClick)(struct TTreeV *tv, TTreeVNode *tvn, bool DblClick); \
  void (*OnPaintNode)(struct TTreeV *tv, struct TTreeVNode *tvn, int fu); \
  bool (*OnExpandChange)(struct TTreeV *tv, TTreeVNode *tvn, int ExpEv); \
  void (*OnExpand)(struct TTreeV *tv, TTreeVNode *tvn); \
  void (*OnCollaps)(struct TTreeV *tv, TTreeVNode *tvn); \
  void (*OnNodeClick)(struct TTreeV *tv, TTreeVNode *tvn, bool DblClick); \
  void (*OnNodeSelect)(struct TTreeV *tv, TTreeVNode *tvn); \
  int max_node_X; \
  TTreeVNode *ClickNode;

typedef struct TTreeV {
  AlgTreeV
  TTreeVNode *Nodes;
} TTreeV;
#undef TCSelf

typedef void (*TtvNodeEv)(TTreeV *tv, TTreeVNode *tvn);
typedef void (*TtvNodeClick)(TTreeV *tv, TTreeVNode *tvn, bool DblClick);
typedef bool (*TOnExpandChange)(TTreeV *tv, TTreeVNode *tvn, int ExpEv);

extern TTreeV *TTreeV_Create(TWins *Parent);
extern bool TTreeV__Destroy(TTreeV *self);
extern void TTreeV_CreateParams(TWins_Create_struct *wcs);
extern TTreeV *TTreeV_CreateA(TWins *Parent, int Left, int Top, int Width, int Height, int Align);
extern void TTreeV_Cls(TTreeV *self);
extern void TTreeVNode_Del(TTreeVNode *self);

extern void TTreeV_NodeExpand(TTreeV *self, TTreeVNode *tvn);
extern void TTreeV_NodeCollaps(TTreeV *self, TTreeVNode *tvn);

extern void TTreeV_SetMouseZ_Wheel(TTreeV *self, int Value);

#define tvnCF_Self	0
#define tvnCF_Child	1
#define tvnCF_ALLChild	2
extern bool TTreeVNode_TestNodeIsExpand(TTreeVNode *tvn, int CF);

//char *TTreeV_GetNodeCaption(TTreeV *self, TTreeVNode *tvn);
extern void TTreeV_SetNodeVisible(TTreeV *self, TTreeVNode *tvn, bool Value);
extern void TTreeV_SetSelNode(TTreeV *self, TTreeVNode *tvn);
extern TTreeVNode *TTreeV_GetSelNode(TTreeV *self);

extern void TTreeV_Update_ScrollBar(TTreeV *self, int *ppmxh);

extern void TTreeV_Resize(TTreeV *self);
extern void TTreeV_DoPaint(TTreeV *self);
extern void TTreeV_DoPaintNode(TTreeV *tv, TTreeVNode *tvn, int fu);
extern void TTreeV_DoExpandChange(TTreeV *self, TTreeVNode *tvn, int ExpEv);
extern void TTreeV_DoExpand(TTreeV *self, TTreeVNode *tvn);
extern void TTreeV_DoCollaps(TTreeV *self, TTreeVNode *tvn);
extern void TTreeV_DoNodeClick(TTreeV *self, TTreeVNode *tvn, bool DblClick);

extern TTreeVNode *TTreeV_AddNode(TTreeV *tv, TTreeVNode *prev_child, TTreeVNode *prev, const char *s);
extern TTreeVNode *TTreeV_AddNextNode(TTreeV *tv, TTreeVNode *prev_child, const char *s);
extern TTreeVNode *TTreeV_Get_prev_child(TTreeV *tv, TTreeVNode *tvn);

//******************* Default msg
extern int default_Error_ev(int ErrType, const char *err);
extern void default_Global_OnFileMsg(TFileMsg *fmsg);

#endif /* __STDWIN_H__ */
