/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

char *NT4_GetLongPathName(char *fn) {
  HANDLE dh;
  WIN32_FIND_DATAW fid;
  char *pc, *pca;
  char *res = NULL;
  char *tspn;

	if (!fn || (WinVERSIONINFO.dwMajorVersion > 4)) return NULL;
	pc = fn;
	while (*pc && (*pc != '~')) pc++;
	if (*pc != '~') return NULL;
	tspn = pcdup(fn);

	pca = pc = tspn;
	while (*pc) {
	    while (*pc && (*pc != '~')) {
		if ((*pc == '\\') || (*pc == '/')) {
		    pc++;
		    ppcnadd(&res, pca, pc-pca);
		    pca = pc;
		} else pc++;
	    }
	    if (*pc == '~') {
	        while (*pc && (*pc != '\\') && (*pc != '/')) pc++;
		char tc = *pc;
		*pc = 0;
		word *pwc = UTF8topwc(tspn);
		dh = FindFirstFileW(pwc, &fid);
		xfree(pwc);
		if (dh != INVALID_HANDLE_VALUE) {
		    FindClose(dh);
		    char *tmp = pwctoUTF8(fid.cFileName);
		    ppcadd(&res, tmp);
		    xfree(tmp);
		} else {
		    ppcadd(&res, pca);
		}
		*pc = tc;
		pca = pc;
	    }
	}
	ppcadd(&res, pca);
	xfree(tspn);
	return res;
}

