/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

int XDrawLine (Display *dpy, Drawable d, GC gc, int x1, int y1, int x2, int y2) {
  int w, h, isTempDC;
  HDC hDC;
	if (gc->gcv.tile) {

  TBITMAP_Dat *bmDat;
  RECT rc;
  HBRUSH hOldBrush;
  HBRUSH hBrush = 0;
  int bw, bw1, bw2;

	    bmDat = Get_BITMAP_Dat(gc->gcv.tile);
	    if (!bmDat || (bmDat->ui_type != sizeof(DIBSECTION))) return 0;

	    bw = bmDat->ui.DIBS.dsBm.bmHeight;
	    if (y1 != y2) bw = bmDat->ui.DIBS.dsBm.bmWidth;
	    bw1 = bw >> 1;
	    bw2 = bw - bw1;

	    hDC = GetTmpPaintDC(d, &isTempDC, gc, 0);
	    SetBrushOrgEx(hDC, gc->gcv.ts_x_origin, gc->gcv.ts_y_origin, NULL);
	    hBrush = CreatePatternBrush(gc->gcv.tile);
	    hOldBrush = SelectObject(hDC, hBrush);

	    rc.left = x1;
	    rc.top = y1;
	    rc.right = x2;
	    rc.bottom = y2;
	    if (x1 == x2) {
		rc.left -= bw1;
		rc.right += bw2;
	    } else if (y1 == y2) {
		rc.top -= bw1;
		rc.bottom += bw2;
	    }
	    FillRect(hDC, &rc, hBrush);
	    SelectObject(hDC, hOldBrush);
	    DeleteObject(hBrush);
	    SetBrushOrgEx(hDC, 0, 0, NULL);

	} else {	//if (gc->gcv.tile)
	    hDC = GetTmpPaintDC(d, &isTempDC, gc, gcdc_hpen);
	    w = abs(x1-x2);
	    h = abs(y1-y2);
	    if (w > h) {
		if (x1>x2) x2--; else x2++;
	    } else {
		if (y1>y2) y2--; else y2++;
	    }
	    MoveToEx(hDC, x1, y1, NULL);
	    LineTo(hDC, x2, y2);
	}
	ReleaseTmpPaintDC(d, hDC, isTempDC);

	return 0;
}
