/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

static void AddRegion(HRGN *Rgn, int xa, int ya, int w, int h) {
  HRGN tmpRgn;

	if (*Rgn) {
	    tmpRgn = CreateRectRgn(xa, ya, xa+w, ya+h);
	    CombineRgn(*Rgn, *Rgn, tmpRgn, RGN_XOR);
	    DeleteObject(tmpRgn);

	} else {
	    *Rgn = CreateRectRgn(xa, ya, xa+w, ya+h);
	}
}

void XShapeCombineMask(Display *dpy, XID dest, int destKind, int xOff, int yOff,
		  Pixmap src, int op) {

	if (!src) {
	    SetWindowRgn(dest, NULL, True);

	} else if (op == ShapeSubtract) {

  TBITMAP_Dat *bmDat;
  HRGN Rgn;
  RECT rc;
  int ix, iy;
  int mz, md, xa;
  byte *imgdat;
  byte *sb;
  bool mk;

	    bmDat = Get_BITMAP_Dat(src);
	    if (!bmDat || (bmDat->ui_type != sizeof(DIBSECTION)) || !dest) return;

	    GetClientRect (dest, &rc);
	    Rgn = CreateRectRgn(0, 0, rc.right-rc.left, rc.bottom-rc.top);
	    GetWindowRgn(dest, Rgn);

	    imgdat = bmDat->ui.DIBS.dsBm.bmBits;
	    imgdat += bmDat->bytes_per_line * (bmDat->ui.DIBS.dsBm.bmHeight - 1);

	    iy = md = xa = 0;
	    while (iy < bmDat->ui.DIBS.dsBm.bmHeight) {
		sb = imgdat; ix = 0; mz = 0; mk = False;
		while (ix < bmDat->ui.DIBS.dsBm.bmWidth) {
		    if (!mz) { md = *sb; mz = 8; sb++; }
		    if (md & 0x80) {	//no mask bit
			if (mk) AddRegion(&Rgn, xOff+xa, yOff+iy, ix-xa, 1);
			mk = False;
		    } else {		//mask bit
			if (!mk) xa = ix;
			mk = True;
		    }
		    md <<= 1; ix++;
		}
		if (mk) AddRegion(&Rgn, xOff+xa, yOff+iy, ix-xa, 1);
		imgdat -= bmDat->bytes_per_line;
		iy++;
	    }

	    if (Rgn) {
		SetWindowRgn(dest, Rgn, True);
		DeleteObject(Rgn);
	    }

	} else { //if (op == ShapeSubtract)
    printf("%s(%d): XShapeCombineMask: \n", FL);
	}
}
