/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/


#include "appXbase.h"

#ifdef DRAG_AND_DROP

//bool dnd_ClientMessage(XClientMessageEvent *ev);
//void dndM_MoveSet(int sch, XID destWinID, int x, int y);
//void dnd_SetSelection(TWins *ws, Atom *nAtom, int nAtomCount);



void Tdnd_Create() {
  Tdnd *dnd = appXDat.dnd;

	if (!dnd) {
		dnd = Tdnd_Atoms_Create();
		appXDat.dnd = dnd;
	}
	dnd->dnd_Message = dnd_ClientMessage;
}

void TWins_dnd(TWins *self, TOndndMouseMove OndndMouseMove, TOndndDrop OndndDrop) {
  int m;
  TForm *form = GetParentForm(self);
  THdnd *Hdnd;

	Tdnd_Create();
	Hdnd = self->Hdnd;
	if (!Hdnd) Hdnd = xcalloc(sizeof(THdnd));

	Hdnd->OndndMouseMove = OndndMouseMove;
	Hdnd->OndndDrop = OndndDrop;

// printf("%s(%d): w=0x%x\n", FL, (int)form->WinID);

	m = dnd_version;       // 4;
	XChangeProperty (appXDat.dpy, form->WinID,
		appXDat.dnd->XA_XdndAware, XA_ATOM,
		32, PropModeReplace,
		(unsigned char*)&m, 1);
}

static void GetXPointer(XMotionEvent *XMev){
  XID cw, cr;

	XMev->type = MotionNotify;
	XMev->serial = 0;
	XMev->send_event = 0;
	XMev->display = appXDat.dpy;
	XMev->subwindow = 0;
	XMev->time = 0;
	XMev->is_hint = 0;
	XMev->same_screen = 0;

	cw = appXDat.RootW;
	cr = appXDat.RootW;
	while (cr != 0) {
	    if (XQueryPointer(XMev->display, cw, &XMev->root,
	                 &cr, &XMev->x_root, &XMev->y_root, &XMev->x, &XMev->y,
	                 &XMev->state) != 0) {
		if (cr != 0) {
			XMev->subwindow = cw;
			cw = cr;
		} 
	    } else cr = 0;
	} 
	XMev->window = cw;
} 

bool dnd_ClientMessage(XClientMessageEvent *ev) {
  int i, dndOk;
  Tobjmsg msg;
  XClientMessageEvent xcm;

  Atom ActualTypeRet;
  int ActualFormatRet;
  unsigned long NItemsRet;
  unsigned long BytesAfterRet;
  unsigned char *PropRet;

  XMotionEvent Xm_Ev;

  int *pA;
  Tdnd *dnd = appXDat.dnd;

//	if ((ev->type != ClientMessage) || (!dnd)) return False;

	Fill0(&xcm, sizeof(XClientMessageEvent));

	if (ev->message_type == dnd->XA_XdndEnter) {
		dnd->dndSel_SrcWin = ev->data.l[0];
		dnd->dndSel_SrcVer = ev->data.l[1];
		msg.msg = msg_dnd;
		msg.f = msgf_dndEnter;
		msg.p = (void*)ev;
		dnd->dnd_Schr = Exec_Win_Ev(&msg, ev->window);
// printf("XdndEnter w=0x%x sw=0x%x sv=%x schr=%d\n", (int)ev->xany.window, (int)ev->xclient.data.l[0], (int)ev->xclient.data.l[1], dnd->dnd_Schr);
// fflush(stdout);

	} else if (ev->message_type == dnd->XA_XdndLeave) {
		dnd->dnd_Schr = 0;
// printf("XdndLeave w=0x%x sw=0x%x schr=%d\n", (int)ev->xclient.window, (int)ev->xclient.data.l[0], dnd->dnd_Schr);
// fflush(stdout);

	} else if (ev->message_type == dnd->XA_XdndPosition) {

		if (dnd->dnd_Schr == 0) return True;

		dnd->dndSel_LastX = ev->data.s[5];
		dnd->dndSel_LastY = ev->data.s[4];

		if ((dnd->dnd_Schr < 2) || (dnd->dndSel_SrcWin != ev->data.l[0])) {

// printf("XdndPosition w=0x%x sw=0x%x x=%d y=%d t=%d act=%d=%s\n", (int)ev->xclient.window,
//         (int)ev->xclient.data.l[0], ev->xclient.data.s[5], ev->xclient.data.s[4],
//         (int)ev->xclient.data.l[3], (int)ev->xclient.data.l[4], XGetAtomName(appXDat.dpy, ev->xclient.data.l[4]));
// fflush(stdout);

		  dnd->dnd_Schr = 2;
		  dnd->dndSel_SrcWin = ev->data.l[0];
		  dnd->dndSel_rAtomsCount = 0;
		  if (XGetWindowProperty (appXDat.dpy, ev->data.l[0],
		                          dnd->XA_XdndTypeList, 0, 65536, 0, XA_ATOM,
		                          &ActualTypeRet, &ActualFormatRet, &NItemsRet,
		                          &BytesAfterRet, &PropRet) == Success) {
		    if ((NItemsRet > 0) && (ActualTypeRet == XA_ATOM) && (ActualFormatRet == 32)) {
		      if (NItemsRet > 16) NItemsRet = 16;
		      dnd->dndSel_rAtomsCount = NItemsRet;
		      pA = (int*)PropRet;
		      for (i=0; i<NItemsRet; i++) {
// AzAtom(FL, "Sel-Atoms", *pA);
		        dnd->dndSel_rAtoms[i] = *pA; pA++;
		      } 
		      XFree(PropRet);
// fflush(stdout);
		    } 
		  } 
		} 

		GetXPointer(&Xm_Ev);

		msg.msg = msg_dnd;
		msg.f = msgf_dndPosition;
		msg.p = (int*)&Xm_Ev;
//		dndOk = Exec_WinsX_Ev_msg0(Xm_Ev.xwindow, msg);
		dndOk = Exec_Win_Ev(&msg, Xm_Ev.window);
//        if (dndOk < 0) dndOk = 0;
		dnd->dndSel_DestWin = Xm_Ev.window;

//  printf('Xm_Ev win=%d x=%d y=%d m=%x ok=%d A=%d'#10,
//          Xm_Ev.xwindow, Xm_Ev.x, Xm_Ev.y, Xm_Ev.state, dndOk, appDat.dndSel_rAtomsCount);

		xcm.type = ClientMessage;
		xcm.message_type = dnd->XA_XdndStatus;
		xcm.format = 32;
		xcm.window = ev->data.l[0]; //WinID;
		xcm.data.l[0] = ev->window; //Xm_Ev.xwindow; //ChildWin; //WinID;
		xcm.data.l[1] = dndOk;
//		xev.xclient.data.l[2] = 0x00;
//		xev.xclient.data.l[3] = 0;
		xcm.data.l[4] = ev->data.l[4];
		XSendEvent(appXDat.dpy, ev->data.l[0], 0, NoEventMask, (XEvent*)&xcm);


	} else if (ev->message_type == dnd->XA_XdndDrop) {
// printf("XdndDrop w=0x%x sw=0x%x\n", (int)ev->xclient.window, (int)ev->xclient.data.l[0]);
// fflush(stdout);

		msg.msg = msg_dnd;
		msg.f = msgf_dndDrop;
		msg.p = (int*)ev;
		Exec_Win_Ev(&msg, dnd->dndSel_DestWin);

		xcm.type = ClientMessage;
		xcm.message_type = dnd->XA_XdndFinished;
		xcm.format = 32;
		xcm.window = ev->data.l[0]; //WinID;
		xcm.data.l[0] = ev->window;
//		xev.xclient.data.l[1] = 0;
//		xev.xclient.data.l[2] = 0;
//		xev.xclient.data.l[3] = 0;
//		xev.xclient.data.l[4] = 0;
		XSendEvent(appXDat.dpy, ev->data.l[0], 0, NoEventMask, (XEvent*)&xcm);

		dnd->dnd_Schr = 0;
/*	} else if (ev->xclient.message_type == dnd->XA_XdndStatus) {
 printf("XA_XdndStatus w=0x%x sw=0x%x 0x%x\n", (int)ev->xclient.window, (int)ev->xclient.data.l[0], (int)ev->xclient.data.l[1]);
		if (dnd->dndM_SrcWin > 0) {
		  msg.msg = msg_dnd;
		  msg.f = msgf_dndStatus;
		  msg.p = (int*)ev;
		  if (ev->xclient.data.l[1] == 0) i = 0; else i = dnd->dndM_WinOkNr;
		  dnd_IconWinMap(i, dnd->dndM_WinX, dnd->dndM_WinY, True);
		} */
	} else return False;
	return True;
} 



Atom dnd_AisText() {
  int i;
  Tdnd *dnd = appXDat.dnd;

	if (dnd->dndSel_rAtomsCount == 0) return XA_STRING; else {
	  for (i=0;i<dnd->dndSel_rAtomsCount;i++) {
	    if (dnd->dndSel_rAtoms[i] == appXDat.XA_TEXT_PLAIN) {
	      return appXDat.XA_TEXT_PLAIN;
	    } 
	  } 
	}
	return 0;
} 

#endif  /* DRAG_AND_DROP */
