/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

//#include "appXbase.h"
//#include <math.h>
//#include "tpixmap.h"
#include "appbase.h"
#include "image.h"
#include "font_FT.h"

bool Font_FT_ToImage(TFont_FT *self, TImage *img, int x, int y, 
				const char *s, int slen) 
{
	if (!self || !self->ToImage) return false;
	return self->ToImage(self, img, x, y, s, slen);
}


bool Font_FT_StrToImage(TFont_FT *self, TImage *img, int x, int y, 
				const char *s)
{
	if (!self || !self->ToImage) return false;
	return self->ToImage(self, img, x, y, s, pclen(s));
}

bool Font_FT_SetAngle(TFont_FT *self, float angle) {
	if (!self || !self->SetAngle) return false;
	return self->SetAngle(self, angle);
}

bool Font_FT_ClrOrigin(TFont_FT *self) {
	if (!self || !self->ClrOrigin) return false;
	return self->ClrOrigin(self);
}

bool Font_FT_SetOrigin(TFont_FT *self, float x, float y) {
	if (!self || !self->SetOrigin) return false;
	return self->SetOrigin(self, x, y);
}

bool Font_FT_GetOrigin(TFont_FT *self, float *x, float *y) {
	if (!self || !self->GetOrigin) return false;
	return self->GetOrigin(self, x, y);
}

bool Font_FT_GetVector(TFont_FT *self, float *x, float *y, const char *s, int slen) {
	if (!self || !self->GetVector) return false;
	return self->GetVector(self, x, y, s, slen);
}

bool Font_FT_StrGetVector(TFont_FT *self, float *x, float *y, const char *s) {
	if (x) *x = 0;
	if (y) *y = 0;
	if (!self || !self->GetVector) return false;
	return self->GetVector(self, x, y, s, pclen(s));
}

int  Font_FT_GetWidth(TFont_FT *self, const char *s, int slen) {
  float x;
	if (!self) return 0;
	if (self->GetWidth) return self->GetWidth(self, s, slen);
	if (!self->GetVector) return 0;
	if (!self->GetVector(self, &x, NULL, s, slen)) return 0;
	return (int) x;
}

bool Font_FT_SetColor(TFont_FT *self, dword Color) {
	if (!self || !self->SetColor) return false;
	return self->SetColor(self, Color);
}

bool Font_FT_SetBackColor(TFont_FT *self, dword Color) {
	if (!self || !self->SetBackColor) return false;
	return self->SetBackColor(self, Color);
}

bool Font_FT_SetUTF8(TFont_FT *self, bool UTF8on) {
	if (!self || !self->SetUTF8) return false;
	return self->SetUTF8(self, UTF8on);
}

bool Font_FT_GetMetrics(TFont_FT *self, int *height, int *ascent) {
	if (height) *height = 0;
	if (ascent) *ascent = 0;
	if (!self || !self->GetMetrics) return false;
	return self->GetMetrics(self, height, ascent);
}

long Font_FT_GetGlyphs(TFont_FT *self) {
	if (!self || !self->GetGlyphs) return 0;
	return self->GetGlyphs(self);
}
/*____________________________ Create ___________________________________*/
TFont_FT *TFont_FT_Create(const char *FontFileName, int font_height, int font_dpi) {
#ifdef HAVE_FT
	return TFont_FT_pv_Create(FontFileName, font_height, font_dpi);
#else
 printf("%s(%d): ERROR: no freetype support (no ft2build.h !!!)\n", FL);
	return NULL;
#endif
}
