/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public License
 as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version. 

 This library is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of 
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 See the GNU Lesser General Public License for more details. 

 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA
*/

#include "font_FT.h"
#include <ft2build.h>
#include FT_FREETYPE_H
//#include FT_CACHE_H

#define TFCACHE_MAX 256
typedef struct {
  int advance;
  int bitmap_width, bitmap_rows, bitmap_left, bitmap_top;
  byte *data;
} TFCache;

#define TCSelf TFont_FT_pv
typedef struct TFont_FT_pv {
  AlgTFont_FT
  dword Color, BackColor;
  dword col, R, G, B;
  int xo, yo;
  FT_Library    library;
  FT_Face       face;
  FT_Matrix     matrix;                 /* transformation matrix */
  FT_Vector     pen;                    /* untransformed origin  */
  float angle;
  int	metrics_height;
  int	metrics_ascent;
  int	font_dpi;
  int	font_height;
  long	glyphs;
  void REGP3 (*to_img)(struct TCSelf *self, TImage *img);
  int fcache_max;
  TFCache *fcache;
  TFCache *fcache_glyph;
  TImage *paint_img;
  int sbpl;
  byte *sb0;
  int fixes_o;
  dword fixes_o_shift;
  bool use_angle;
  bool fixes_size;
  bool UTF8on;
} TFont_FT_pv;
#undef TCSelf

/*
extern TFont_FT *TFont_FT_Create(const char *FontFileName, int height, int dpi);

extern bool TFont_FT_to_TPixMap(TFont_FT *self, TImage *img, int x, int y, 
				const char *s, int slen);

extern bool TFont_FT_SetAngle(TFont_FT *self, float angle);
extern bool TFont_FT_SetOrigin(TFont_FT *self, float x, float y);
extern bool TFont_FT_GetOrigin(TFont_FT *self, float *x, float *y);
*/
