/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"

static bool ChkFocEl(TWins *wins) {
	return (TestWinCanFocus(wins) && 
		(wins->wtyp != wtyp_MenuButton) &&
		!(wins->KeyFu & mNoKeyFocus));
}

static TWins *NextFocEl(TWins *wins) {
  while (wins && !ChkFocEl(wins)) wins = wins->next;
  return wins;
}

static void Form_NextFocEl_Scan(TWins *wins, TWins **org_ap, TWins **apa, TWins **apn) {
	while (wins && !*apn) {
	    if (wins->next_child) Form_NextFocEl_Scan(wins->next_child, org_ap, apa, apn);
	    if (!*apn) {
		if (ChkFocEl(wins) && (wins != *org_ap)) {
		    if (*org_ap) {
			if (!*apa) *apa = wins; 
		    } else *apn = wins;
		}
		if (wins == *org_ap) *org_ap = NULL;
	    }
	    wins = wins->next;
	}
}

static TWins *PrevFocEl(TWins *wins) {
  while (wins && !ChkFocEl(wins)) wins = wins->prev;
  return wins;
}

TWins *GetNextFocEl(TWins *wins, bool ret, bool over) {
  TWins *nap, *napc;
  TForm *Form;

	if (!wins) return NULL;
	if (ret) {
	    nap = PrevFocEl(wins->prev);
	    if (nap) return nap;
	    nap = wins;
	    while (nap->next) nap = nap->next;
	    nap = PrevFocEl(nap);
	    if (nap && (nap != wins)) return nap;

	} else if (over) {
	    nap = NextFocEl(wins->next);
	    if (nap && (nap->wtyp != wtyp_MenuButton)) return nap;
	    Form = GetParentForm(wins);
	    nap = napc = NULL;
	    Form_NextFocEl_Scan((TWins*)Form, &wins, &nap, &napc);
	    if (napc) return napc;
	    if (nap) return nap;

	} else {
	    nap = NextFocEl(wins->next);
	    if (nap) return nap; 
	    nap = wins;
	    while (nap->prev) nap = nap->prev;
	    nap = NextFocEl(nap);
	    if (nap && (nap != wins)) return nap;
	}
	return NULL;
}
