/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"

TPic *pic_load(const char *FileName, TPic *pic_mem) {
  TPixMap *pxm;
  TPic *pic = pic_mem;
  char *fn = path_rel2abs(FileName, NULL);

	pxm = TPixMap_Loader(fn, NULL, 0);
	xfree (fn);
	if (!pxm) return NULL;
	TPixMap_XPutImage(pxm);

	if (!pic) pic = xcalloc(sizeof(TPic));
	pic->width = pxm->width;
	pic->height = pxm->height;
	pic->pic = pxm->pmxID;
	pic->mask = pxm->maskID;
	pxm->pmxID = pxm->maskID = 0;
	Tfree(pxm);
	return pic;
}
