/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"

void SetSelection_TPixMap(TPixMap *pxm) {
  TPixMap *selpxm = NULL;

	SelClr();
	SelRetClr();
	appXDat.SELECT_AtomsCount = 0;
	if (!pxm) return;

	TPixMap_XGetImage(pxm);
	if ((appXDat.RootW_depth == 16) && 
	    ((pxm->pxm_LD & pxmLD_bppMask) != pxm_2b_16bpp)) {
	    selpxm = (TPixMap*)TImage_rgb888to565((TImage*)pxm);
	} else if ((appXDat.RootW_depth > 16) && 
	    ((pxm->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp)) {
	    selpxm = (TPixMap*)TImage_rgb565to888((TImage*)pxm);
	} else {
	    selpxm = (TPixMap*)TImage_Create_dup_struct((TImage*)pxm, 
			dupfu_init_imgmem|dupfu_copy_img);  
	}
	TPixMap_XPutImage(selpxm);
	appXDat.Selpxm = selpxm;

#if 1 /* USE_PNG */
	char *bp = NULL;
	if (pxm->stat & pmxStat_ckh_alpha) {
	    size_t size = 0;
	    if ((pxm->width * pxm->height) > 60000) appSetCursorWait(NULL, True);
	    pxm->out_fp = open_memstream(&bp, &size);
	    if (pxm->out_fp) {
		pxm->out_fu = 0;
		write_png((TImage*)pxm);
		fflush (pxm->out_fp);
		fclose(pxm->out_fp);
		pxm->out_fp = NULL;
		appXDat.SelTxt.s = bp;
		appXDat.SelTxt.lg = size;
#ifdef MEM_CHK
 MEM_CHK_ADD(bp, size);
#endif
	    }
	    appSetCursorWait(NULL, False);
	}

	if (bp) {
	    SetSelection(2, XA_PIXMAP, appXDat.XA_IMAGE_PNG);
	} else {
	    SetSelection(1, XA_PIXMAP);
	}
#else
	SetSelection(1, XA_PIXMAP);
#endif
}

TPixMap *GetSelection_TPixMap() {
#if 1 /* USE_PNG */
  TPixMap *pxm = NULL;
  Atom at_PIXMAP = 0;
  Atom at_IMAGE_PNG = 0;
  Pixmap pmxID = 0;
  TGeometry gm;

	Fill0(&gm, sizeof(TGeometry));

	if (!Get_XA_TARGETS()) return NULL;
	at_PIXMAP = get_nSelAtom(XA_PIXMAP);
	at_IMAGE_PNG = get_nSelAtom(appXDat.XA_IMAGE_PNG);

	if (at_IMAGE_PNG) {
	    if (GetPasteDaten(appXDat.CLIPBOARD_ATOM, at_IMAGE_PNG)) {
		pxm = TPixMap_Create_depth(0, 0, 32);
		pxm->in_fp = fmemopen(appXDat.SelRet_lgs.s, appXDat.SelRet_lgs.lg, "rb");
		if (pxm->in_fp) {
		    bool ok = read_png((TImage*)pxm);
		    fclose(pxm->in_fp);
		    pxm->in_fp = NULL;
		    if (!ok) {
			Tfree(pxm);
			pxm = NULL;
		    }
		}
	    }

	} else if (at_PIXMAP) {
	    if (GetPasteDaten(appXDat.CLIPBOARD_ATOM, at_PIXMAP)) {
		if (appXDat.SelRet_lgs.lg >= 4) {
		    pmxID = *((int*)appXDat.SelRet_lgs.s);
		    if (get_geometry((Drawable)pmxID, &gm) && gm.depth) {
			pxm = TPixMap_Create_XID(pmxID, 0);
			TPixMap_XGetImage(pxm);
			pxm->stat &= ~pmxStat_XPixAkt;
			pxm->pmxID = 0;
		    }
		}
	    }
	} else return NULL;

	SelRetClr();
#else
  TPixMap *pxm = NULL;
  Atom at_PIXMAP = 0;
  Pixmap pmxID;

	if (!Get_XA_TARGETS()) return NULL;
	at_PIXMAP = get_nSelAtom(XA_PIXMAP);

	if (at_PIXMAP && GetPasteDaten(appXDat.CLIPBOARD_ATOM, at_PIXMAP)) {
	    if (appXDat.SelRet_lgs.lg >= 4) {
		pmxID = *((int*)appXDat.SelRet_lgs.s);
		pxm = TPixMap_Create_XID(pmxID, 0);
		TPixMap_XGetImage(pxm);
		pxm->stat &= ~pmxStat_XPixAkt;
		pxm->pmxID = 0;
	    }
	    SelRetClr();
	}

#endif
	return pxm;
}
