/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#ifndef _OS_WIN32
#include <X11/extensions/XTest.h>
#endif

int SendKeyCode(dword keycode, bool is_press) {
#ifdef _OS_WIN32
  SHORT kc;
  BYTE bVk;
  DWORD dwFlags;

	if (keycode > 0xff) return 0;
	kc = VkKeyScan(keycode);
//  printf("%s(%d): 0x%03x %d\n", FL, kc, kc);
	bVk = kc;
	if (!bVk || bVk > 254) return 0;
	dwFlags = 0;
	if (!is_press) dwFlags = KEYEVENTF_KEYUP;
	keybd_event(bVk, 0, dwFlags, 0);
	return 0;
#else
	return XTestFakeKeyEvent(appXDat.dpy, keycode, is_press, 0);
#endif
}

int SendKeySym(KeySym keysym, bool is_press) {
#ifdef _OS_WIN32
  DWORD dwFlags;
  BYTE bVk;
// ??????????????????????????????????????????????????????????
//  printf("%s(%d): keysym = 0x%04x\n", FL, keysym);
	if (keysym > 0xff) {
	    switch (keysym) {
	    case XK_BackSpace:	bVk = 0x08; break;
	    case XK_Tab:	bVk = 0x09; break;
	    case XK_Clear:	bVk = 0x0c; break;
	    case XK_Return:	bVk = 0x0d; break;
	    case XK_Home:	bVk = 0x24; break;
	    case XK_Left:	bVk = 0x25; break;
	    case XK_Up:		bVk = 0x26; break;
	    case XK_Right:	bVk = 0x27; break;
	    case XK_Down:	bVk = 0x28; break;
	    case XK_Insert:	bVk = 0x2d; break;
	    case XK_Delete:	bVk = 0x2e; break;
	    case XK_KP_Subtract:	bVk = VkKeyScan(0x2d); break;
	    default: 
		printf("%s(%d): keysym = 0x%04x  TODO\n", FL, keysym);
		return 0;
	    }
	    dwFlags = 0;
	    if (!is_press) dwFlags = KEYEVENTF_KEYUP;
//  printf("%s(%d): bVk = 0x%02x\n", FL, bVk);
	    keybd_event(bVk, 0, dwFlags, 0);
	    return 0;
	}
	return SendKeyCode(keysym, is_press);
#else
  dword keycode;
	keycode = XKeysymToKeycode(appXDat.dpy, keysym);
	return SendKeyCode(keycode, is_press);
#endif
}
