/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

#define SYSTEM_TRAY_REQUEST_DOCK   0
//#define SYSTEM_TRAY_BEGIN_MESSAGE  1
//#define SYSTEM_TRAY_CANCEL_MESSAGE 2

bool GetSysTrayWin(Window *ret_SysTrayWin, TWRect *ret_rc) {
  Atom SysTrayAtom;
  TWRect rc;
  char buf[32];

	if (!ret_SysTrayWin) return False;
	sprintf(buf, "_NET_SYSTEM_TRAY_S%u", DefaultScreen(appXDat.dpy));
	SysTrayAtom = XInternAtom(appXDat.dpy, buf, 1);
	if (!SysTrayAtom) return False;
	*ret_SysTrayWin = XGetSelectionOwner(appXDat.dpy, SysTrayAtom);
	if (!*ret_SysTrayWin) return False;
	if (!ret_rc) ret_rc = &rc;
	return GetXWinAbs_rc(*ret_SysTrayWin, ret_rc);
}

void SendSysTrayWin(Window SysTrayWin, Window WinID) {
  XClientMessageEvent ev;

	Fill0(&ev, sizeof(ev));
	ev.type = ClientMessage;
	ev.window = SysTrayWin;
	ev.message_type = XInternAtom(appXDat.dpy, "_NET_SYSTEM_TRAY_OPCODE", False);
	ev.format = 32;
	ev.data.l[0] = CurrentTime;
	ev.data.l[1] = SYSTEM_TRAY_REQUEST_DOCK;
	ev.data.l[2] = WinID;
	XSendEvent(appXDat.dpy, SysTrayWin, 0, NoEventMask, (XEvent*)&ev);
}
