/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

void alpha2bitmask(TImage *self) {
	if (!(self->stat & pmxStat_has_alpha_tgl)) return;
	if (!self->rgb565_alpha_data &&
	    ((self->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp)) return;

	self->stat &= ~pmxStat_XMaskPixAkt;
	self->stat |= (pmxStat_HandleMask | pmxStat_MaskImgAkt);
	xfree(self->mask_data);
	self->mask_data = xmalloc(((self->width+7) >> 3) * self->height);
	
  byte *sb0 = self->rgb565_alpha_data;
  byte *dbm = self->mask_data;
  dword Mask, MaskZ;
  int sboff = 1;
  int linlg = self->width;

	if (!self->rgb565_alpha_data) {
	    sb0 = self->data + 3;
	    sboff = 4;
	    linlg = self->bytes_per_line;
	}
	for (int y=self->height; y; y--) {
	    Mask = 0; MaskZ = 8;
	    byte *sb = sb0;
	    for (int x=self->width; x; x--) {
		Mask >>= 1;
		if (*sb & 0x80) Mask |= 0x80;
		sb += sboff;
		MaskZ--;
		if (!MaskZ) {
		    *dbm++ = Mask;
		    MaskZ = 8;
		} 
	    }
	    if (MaskZ != 8) {
		Mask >>= MaskZ;
		*dbm++ = Mask;
	    }
	    sb0 += linlg;
	}
}

