/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

bool alpha_chk_mask(TImage *self, int alpha_mask) {
	if (!self->rgb565_alpha_data &&
	    ((self->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp)) return False;

  byte *sb0 = self->rgb565_alpha_data;
  int sboff = 1;
  int linlg = self->width;

	if (!self->rgb565_alpha_data) {
	    sb0 = self->data + 3;
	    sboff = 4;
	    linlg = self->bytes_per_line;
	}
  dword Mask = *sb0 & alpha_mask;
	for (int y=self->height; y; y--) {
	    byte *sb = sb0;
	    for (int x=self->width; x; x--) {
		if ((*sb & alpha_mask) != Mask) return True;
		sb += sboff;
	    }
	    sb0 += linlg;
	}
	return False;
}

bool alpha_chk_tgl(TImage *self) {
	return alpha_chk_mask(self, 0x80);
}

void alpha_bm_stat(TImage *self) {
	self->stat &= ~pmxStat_has_alpha_tgl;
	if (alpha_chk_tgl(self)) {
	    self->stat |= pmxStat_has_alpha_tgl;
	}
}
