/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

static void _imgmask_copy(Timg_rsz *rsz) {
	if (rsz->dest_mask && rsz->src_mask)
//	    memmove(rsz->dest_mask, rsz->src_mask, 
//		    ((rsz->src_w + 7) >> 3) * rsz->src_h);
	    pnmove(rsz->dest_mask, rsz->src_mask, 
		    ((rsz->src_w + 7) >> 3) * rsz->src_h);
}

static int _imgdat16_copy(Timg_rsz *rsz) {
//	memmove(rsz->dest_dat, rsz->src_dat, rsz->src_w * rsz->src_h * 2);
	pnmove(rsz->dest_dat, rsz->src_dat, rsz->src_w * rsz->src_h * 2);
	_imgmask_copy(rsz);
	return 0;
}

static int _imgdat24_copy(Timg_rsz *rsz) {
//	memmove(rsz->dest_dat, rsz->src_dat, rsz->src_w * rsz->src_h * 4);
	pnmove(rsz->dest_dat, rsz->src_dat, rsz->src_w * rsz->src_h * 4);
	_imgmask_copy(rsz);
	return 0;
}

int ImgDat_Copy(Timg_rsz *rsz) {
	if (rsz->src_typ == pxm_2b_16bpp) {
		return _imgdat16_copy(rsz);
	} else if ((rsz->src_typ == pxm_4b_24bpp) || 
		   (rsz->src_typ == pxm_4b_24bpp8a)) {
		return _imgdat24_copy(rsz);
	}
	return rszERR_Zoom;
}
