/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

/* ************ Zoom 16bpp 1:2 ************ */

static int _rsz16_22_11(Timg_rsz *rsz) {
  word *pws = rsz->src_dat;
  word *pwd = rsz->dest_dat;
  dword org_w = rsz->src_w;
//  dword org_h = rsz->src_h;
  dword new_w = rsz->to_w;
  dword new_h = rsz->to_h;

  word *pws0, *pws1, cw;
  dword r, g, b;
  int x;

	while (new_h) {
	    pws0 = pws;
	    pws1 = pws0 + org_w;
	    x = new_w;
	    while (x) {
		cw = *pws0; pws0++;
		b = cw & 0x1f;  g = cw & 0x7e0;  r = cw & 0xf800;
		cw = *pws0; pws0++;
		b += cw & 0x1f; g += cw & 0x7e0; r += cw & 0xf800;
		cw = *pws1; pws1++;
		b += cw & 0x1f; g += cw & 0x7e0; r += cw & 0xf800;
		cw = *pws1; pws1++;
		b += cw & 0x1f; g += cw & 0x7e0; r += cw & 0xf800;
		*pwd = ((r >> 2) & 0xf800) | ((g >> 2) & 0x7e0) | ((b >> 2) & 0x1f);
		pwd++; x--;
	    }
	    pws += org_w + org_w; new_h--;
	  }
	return 0;
}

/* ************ Zoom 16bpp + mask 1:2 ************ */

static int _rsz16m_22_11(Timg_rsz *rsz) {
  word *pws = rsz->src_dat;
  word *pwd = rsz->dest_dat;
  dword org_w = rsz->src_w;
//  dword org_h = rsz->src_h;
  dword new_w = rsz->to_w;
  dword new_h = rsz->to_h;
  byte *pms = rsz->src_mask;
  byte *pmd = rsz->dest_mask;

  word *pws0, *pws1, cw;
  dword r, g, b;
  int x;
  int kms, kmd, ms0, ms1, md, mzs, mzd, km;
  byte *pms0, *pms1, *pmd0;

	kms = (org_w+7) / 8;
	kmd = (new_w+7) / 8;
	while (new_h) {
	    mzs = ms0 = ms1 = mzd = md = 0;
	    pws0 = pws;
	    pws1 = pws0 + org_w;

	    pms0 = pms;
	    pms1 = pms0 + kms;
	    pmd0 = pmd;

	    x = new_w;
	    while (x) {
		if (!mzs) {mzs = 4; ms0 = *pms0; pms0++; ms1 = *pms1; pms1++;}
		km = b = g = r = 0;

		cw = *pws0; pws0++;
		if (ms0 & 1) {
		  b = cw & 0x1f;  g = cw & 0x7e0;  r = cw & 0xf800;
		  km++;
		}
		cw = *pws0; pws0++;
		if (ms0 & 2) {
		  b += cw & 0x1f; g += cw & 0x7e0; r += cw & 0xf800;
		  km++;
		}
		cw = *pws1; pws1++;
		if (ms1 & 1) {
		  b += cw & 0x1f; g += cw & 0x7e0; r += cw & 0xf800;
		  km++;
		}
		cw = *pws1; pws1++;
		if (ms1 & 2) {
		  b += cw & 0x1f; g += cw & 0x7e0; r += cw & 0xf800;
		  km++;
		}
		if (km > 1) {
		  if (km > 3) {
		    *pwd = ((r >> 2) & 0xf800) | ((g >> 2) & 0x7e0) | ((b >> 2) & 0x1f);
		  } else if (km == 3) {
		    *pwd = ((r / 3) & 0xf800) | ((g / 3) & 0x7e0) | ((b / 3) & 0x1f);
		  } else if (km == 2) {
		    *pwd = ((r >> 1) & 0xf800) | ((g >> 1) & 0x7e0) | ((b >> 1) & 0x1f);
		  }
		  md |= (1 << mzd);
		} else {
		  *pwd = 0;
		}
		ms0 >>= 2;
		ms1 >>= 2;
		mzs--;
		mzd++;
		if (mzd > 7) {*pmd0 = md; mzd = md = 0; pmd0++;}
		pwd++; x--;
	    }
	    pws += org_w + org_w; new_h--;
	    pms += kms + kms;
	    pmd += kmd;
	  }
	return 0;
}


/* ************ Zoom 24bpp 1:2 ************ */

static int _rsz24_22_11(Timg_rsz *rsz) {
  dword *pws = rsz->src_dat;
  dword *pwd = rsz->dest_dat;
  dword org_w = rsz->src_w;
//  dword org_h = rsz->src_h;
  dword new_w = rsz->to_w;
  dword new_h = rsz->to_h;

  dword *pws0, *pws1, cw;
  dword r, g, b;
  int x;

	while (new_h) {
	    pws0 = pws;
	    pws1 = pws0 + org_w;
	    x = new_w;
	    while (x) {
		cw = *pws0; pws0++;
		b = cw & 0xff;  g = cw & 0xff00;  r = cw & 0xff0000;
		cw = *pws0; pws0++;
		b += cw & 0xff; g += cw & 0xff00; r += cw & 0xff0000;
		cw = *pws1; pws1++;
		b += cw & 0xff; g += cw & 0xff00; r += cw & 0xff0000;
		cw = *pws1; pws1++;
		b += cw & 0xff; g += cw & 0xff00; r += cw & 0xff0000;
		*pwd = ((r >> 2) & 0xff0000) | ((g >> 2) & 0xff00) | ((b >> 2) & 0xff);
		pwd++; x--;
	    }
	    pws += org_w + org_w; new_h--;
	}
	return 0;

}


/* ************ Zoom 24bpp + mask 1:2 ************ */

static int _rsz24m_22_11(Timg_rsz *rsz) {
  dword *pws = rsz->src_dat;
  dword *pwd = rsz->dest_dat;
  dword org_w = rsz->src_w;
//  dword org_h = rsz->src_h;
  dword new_w = rsz->to_w;
  dword new_h = rsz->to_h;
  byte *pms = rsz->src_mask;
  byte *pmd = rsz->dest_mask;

  dword *pws0, *pws1, cw;
  dword r, g, b;
  int x;
  int kms, kmd, ms0, ms1, md, mzs, mzd, km;
  byte *pms0, *pms1, *pmd0;

	kms = (org_w+7) / 8;
	kmd = (new_w+7) / 8;
	while (new_h) {
	    mzs = ms0 = ms1 = mzd = md = 0;
	    pws0 = pws;
	    pws1 = pws0 + org_w;

	    pms0 = pms;
	    pms1 = pms0 + kms;
	    pmd0 = pmd;

	    x = new_w;
	    while (x) {
		if (!mzs) {mzs = 4; ms0 = *pms0; pms0++; ms1 = *pms1; pms1++;}
		km = b = g = r = 0;

		cw = *pws0; pws0++;
		if (ms0 & 1) {
		  b = cw & 0xff;  g = cw & 0xff00;  r = cw & 0xff0000;
		  km++;
		}
		cw = *pws0; pws0++;
		if (ms0 & 2) {
		  b += cw & 0xff; g += cw & 0xff00; r += cw & 0xff0000;
		  km++;
		}
		cw = *pws1; pws1++;
		if (ms1 & 1) {
		  b += cw & 0xff; g += cw & 0xff00; r += cw & 0xff0000;
		  km++;
		}
		cw = *pws1; pws1++;
		if (ms1 & 2) {
		  b += cw & 0xff; g += cw & 0xff00; r += cw & 0xff0000;
		  km++;
		}
		if (km > 1) {
		  if (km > 3) {
		    *pwd = ((r >> 2) & 0xff0000) | ((g >> 2) & 0xff00) | ((b >> 2) & 0xff);
		  } else if (km == 3) {
		    *pwd = ((r / 3) & 0xff0000) | ((g / 3) & 0xff00) | ((b / 3) & 0xff);
		  } else if (km == 2) {
		    *pwd = ((r >> 1) & 0xff0000) | ((g >> 1) & 0xff00) | ((b >> 1) & 0xff);
		  }
		  md |= (1 << mzd);
		} else {
		  *pwd = 0;
		}
		ms0 >>= 2;
		ms1 >>= 2;
		mzs--;
		mzd++;
		if (mzd > 7) {*pmd0 = md; mzd = md = 0; pmd0++;}
		pwd++; x--;
	    }
	    pws += org_w + org_w; new_h--;
	    pms += kms + kms;
	    pmd += kmd;
	  }
	return 0;
}

int ImgDat_Resize_22_11(Timg_rsz *rsz) {
	if (rsz->src_mask && rsz->dest_mask) {
	    if (rsz->src_typ == pxm_2b_16bpp) {
		return _rsz16m_22_11(rsz);
	    } else if (rsz->src_typ == pxm_4b_24bpp) {
		return _rsz24m_22_11(rsz);
	    }

	} else {
	    if (rsz->src_typ == pxm_2b_16bpp) {
		return _rsz16_22_11(rsz);
	    } else if (rsz->src_typ == pxm_4b_24bpp) {
		return _rsz24_22_11(rsz);
	    }
	}
	return rszERR_Zoom;
}
