/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

// ARMv5

// ----------------------- 32Bit ARGB 8 --------------------------------
#define RSZ_ARM_W0_4b_24bpp8a \
 __asm__ volatile( \
		"uxtb	%0, %4\n" \
		"uxtb	%1, %4, ROR #8\n" \
		"uxtb	%2, %4, ROR #16\n" \
		"uxtb	%3, %4, ROR #24\n" \
		"mul	%0, %5\n" \
		"mul	%1, %5\n" \
		"mul	%2, %5\n" \
		"mul	%3, %5\n" \
		: "=r"(b), "=r"(g), "=r"(r), "=r"(a), "+r"(rgb), "+r"(cx));

#define RSZ_ARM_N_4b_24bpp8a \
 __asm__ volatile( \
		"uxtb	%6, %4\n" \
		"mla	%0, %5, %6, %0\n" \
		"uxtb	%6, %4, ROR #8\n" \
		"mla	%1, %5, %6, %1\n" \
		"uxtb	%6, %4, ROR #16\n" \
		"mla	%2, %5, %6, %2\n" \
		"uxtb	%6, %4, ROR #24\n" \
		"mla	%3, %5, %6, %3\n" \
		: "+r"(b), "+r"(g), "+r"(r), "+r"(a), "+r"(rgb), "+r"(cx), "=r"(m));


static void ATR_INLINE rszcpu32_XN0(Tzx *zx) {
  dword *src, rgb, cx;
  dword b, g, r, a, m, lgx;

	src = zx->src32;
	rgb = *src; src++;
	cx = zx->ca;

	RSZ_ARM_W0_4b_24bpp8a

	lgx = zx->lgx;
	while (lgx > 0) {
	    rgb = *src;  src++;
	    cx = zx->cn;
	    RSZ_ARM_N_4b_24bpp8a
	    lgx--;
	}

	rgb = *src;
	cx = zx->ce;
	RSZ_ARM_N_4b_24bpp8a

	zx->b = b;
	zx->g = g;
	zx->r = r;
	zx->a = a;
}

static void ATR_INLINE rszcpu32_XN(Tzx *zx) {
  dword *src, rgb, cx;
  dword b, g, r, a, m, lgx;

	src = zx->src32;
	rgb = *src; src++;
	cx = zx->ca;

	RSZ_ARM_W0_4b_24bpp8a

	lgx = zx->lgx;
	while (lgx > 0) {
	    rgb = *src;  src++;
	    cx = zx->cn;
	    RSZ_ARM_N_4b_24bpp8a
	    lgx--;
	}

	rgb = *src;
	cx = zx->ce;
	RSZ_ARM_N_4b_24bpp8a

	zx->b += b;
	zx->g += g;
	zx->r += r;
	zx->a += a;
}

#define RSZ_zxToResult_32 \
	z->dest32[pxTab->dox] = ((zx.a >> 16) << 24) | ((zx.r >> 16) << 16) | ((zx.g >> 16) << 8) | (zx.b >> 16);

static void ATR_INLINE rszcpu32_X20(Tzx *zx) {
  byte *rgb = zx->src8;
  dword ca = zx->ca;
  dword ce = zx->ce;

	zx->b = (rgb[0] * ca) + (rgb[4] * ce);
	zx->g = (rgb[1] * ca) + (rgb[5] * ce);
	zx->r = (rgb[2] * ca) + (rgb[6] * ce);
	zx->a = (rgb[3] * ca) + (rgb[7] * ce);
}

static void ATR_INLINE rszcpu32_X2(Tzx *zx) {
  byte *rgb = zx->src8;
  dword ca = zx->ca;
  dword ce = zx->ce;

	zx->b += (rgb[0] * ca) + (rgb[4] * ce);
	zx->g += (rgb[1] * ca) + (rgb[5] * ce);
	zx->r += (rgb[2] * ca) + (rgb[6] * ce);
	zx->a += (rgb[3] * ca) + (rgb[7] * ce);
}

static void __attribute__ ((noinline)) rszcpu32_X2Y1(Tz *z, int lx) {
  dword *src, *dest;
  TpxTab *pxTab;

	if (lx <= 0) return;
	src = z->src32;
	dest = z->dest32;

	pxTab = z->pxTab;
	while (lx > 0) {
	    byte *rgb = (byte*)(src + pxTab->ox);
	    dword ca = pxTab->cxa;
	    dword ce = pxTab->cxe;

	    dest[pxTab->dox] =  (((rgb[0] * ca) + (rgb[4] * ce)) >> 16) |
			       ((((rgb[1] * ca) + (rgb[5] * ce)) >> 16) << 8) |
			       ((((rgb[2] * ca) + (rgb[6] * ce)) >> 16) << 16) |
			       ((((rgb[3] * ca) + (rgb[7] * ce)) >> 16) << 24);

	    pxTab++;
	    lx--;
	}
	z->pxTab = pxTab;
}

static void __attribute__ ((noinline)) rszcpu32_X1Y2(Tz *z, int lx) {
  dword *src, *srcy, *dest, ca, ce;
  TpxTab *pxTab;

	if (lx <= 0) return;
	src = z->src32;
	srcy = src + z->loff_x;
	dest = z->dest32;

	pxTab = z->pxTab;
	ca = z->ca;
	ce = z->ce;
	while (lx > 0) {
	    byte *rgb = (byte*)(src + pxTab->ox);
	    byte *rgby = (byte*)(srcy + pxTab->ox);

	    dest[pxTab->dox] =  (((rgb[0] * ca) + (rgby[0] * ce)) >> 16) |
			       ((((rgb[1] * ca) + (rgby[1] * ce)) >> 16) << 8) |
			       ((((rgb[2] * ca) + (rgby[2] * ce)) >> 16) << 16) |
			       ((((rgb[3] * ca) + (rgby[3] * ce)) >> 16) << 24);

	    pxTab++;
	    lx--;
	}
	z->pxTab = pxTab;
}

// ----------------------- 24Bit RGB 8 ---------------------------------

#define RSZ_ARM_W0_4b_24bpp \
 __asm__ volatile( \
		"uxtb	%0, %3\n" \
		"uxtb	%1, %3, ROR #8\n" \
		"uxtb	%2, %3, ROR #16\n" \
		"mul	%0, %4\n" \
		"mul	%1, %4\n" \
		"mul	%2, %4\n" \
		: "=r"(b), "=r"(g), "=r"(r), "+r"(rgb), "+r"(cx));

#if 1
#define RSZ_ARM_N_4b_24bpp \
 __asm__ volatile( \
		"uxtb	%5, %3\n" \
		"mla	%0, %4, %5, %0\n" \
		"uxtb	%5, %3, ROR #8\n" \
		"mla	%1, %4, %5, %1\n" \
		"uxtb	%5, %3, ROR #16\n" \
		"mla	%2, %4, %5, %2\n" \
		: "+r"(b), "+r"(g), "+r"(r), "+r"(rgb), "+r"(cx), "=r"(m));
#else
#define RSZ_ARM_N_4b_24bpp \
 __asm__ volatile( \
		"uxtb	%%r5, %3\n" \
		"mla	%0, %4, %%r5, %0\n" \
		"uxtb	%%r5, %3, ROR #8\n" \
		"mla	%1, %4, %%r5, %1\n" \
		"uxtb	%%r5, %3, ROR #16\n" \
		"mla	%2, %4, %%r5, %2\n" \
		: "+r"(b), "+r"(g), "+r"(r), "+r"(rgb), "+r"(cx) ::"r5");
#endif

static void ATR_INLINE rszcpu24_XN0(Tzx *zx) {
  dword *src, rgb, cx;
  dword b, g, r, m;

	src = zx->src32;
	rgb = *src; src++;
	cx = zx->ca;

	RSZ_ARM_W0_4b_24bpp

	int lgx = zx->lgx;
	while (lgx > 0) {
	    rgb = *src;  src++;
	    cx = zx->cn;
	    RSZ_ARM_N_4b_24bpp
	    lgx--;
	}

	rgb = *src;
	cx = zx->ce;
	RSZ_ARM_N_4b_24bpp

	zx->b = b;
	zx->g = g;
	zx->r = r;
}

static void ATR_INLINE rszcpu24_XN(Tzx *zx) {
  dword *src, rgb, cx;
  dword b, g, r, m;

	src = zx->src32;
	rgb = *src; src++;
	cx = zx->ca;

	RSZ_ARM_W0_4b_24bpp

	int lgx = zx->lgx;
	while (lgx > 0) {
	    rgb = *src;  src++;
	    cx = zx->cn;
	    RSZ_ARM_N_4b_24bpp
	    lgx--;
	}

	rgb = *src;
	cx = zx->ce;
	RSZ_ARM_N_4b_24bpp

	zx->b += b;
	zx->g += g;
	zx->r += r;
}

#define RSZ_zxToResult_24 \
	z->dest32[pxTab->dox] = ((zx.r >> 16) << 16) | ((zx.g >> 16) << 8) | (zx.b >> 16);

static void ATR_INLINE rszcpu24_X20(Tzx *zx) {
  dword rgb, cx, b, g, r, m;

	rgb = zx->src32[0];
	cx = zx->ca;
	RSZ_ARM_W0_4b_24bpp

	rgb = zx->src32[1];
	cx = zx->ce;
	RSZ_ARM_N_4b_24bpp

	zx->b = b;
	zx->g = g;
	zx->r = r;
}

static void ATR_INLINE rszcpu24_X2(Tzx *zx) {
  dword rgb, cx, b, g, r, m;

	rgb = zx->src32[0];
	cx = zx->ca;
	RSZ_ARM_W0_4b_24bpp

	rgb = zx->src32[1];
	cx = zx->ce;
	RSZ_ARM_N_4b_24bpp

	zx->b += b;
	zx->g += g;
	zx->r += r;
}

static void __attribute__ ((noinline)) rszcpu24_X2Y1(Tz *z, int lx) {
  TpxTab *pxTab;
  dword *src, *dest;

	if (lx <= 0) return;
	pxTab = z->pxTab;
	dest = z->dest32;
	src = z->src32;
	while (lx > 0) {
	    dword rgb, cx, b, g, r, m;

	    rgb = src[pxTab->ox];
	    cx = pxTab->cxa;
	    RSZ_ARM_W0_4b_24bpp

	    rgb = src[pxTab->ox + 1];
	    cx = pxTab->cxe;
	    RSZ_ARM_N_4b_24bpp
#if 0
	    dest[pxTab->dox] = (b >> 16) | ((r >> 16) << 16) | ((g >> 16) << 8);
#else
 __asm__ volatile( \
		"uxtb	%0, %0, ROR #16\n" \
		"uxtb	%1, %1, ROR #16\n" \
		"uxtb	%2, %2, ROR #16\n" \
		"orr	%0, %1, LSL #8\n" \
		"orr	%0, %2, LSL #16\n" \
		: "+r"(b), "+r"(g), "+r"(r));
	    dest[pxTab->dox] = b;
#endif
	    pxTab++;
	    lx--;
	}
	z->pxTab = pxTab;
}

static void __attribute__ ((noinline)) rszcpu24_X1Y2(Tz *z, int lx) {
  TpxTab *pxTab;

	if (lx <= 0) return;

	pxTab = z->pxTab;
	while (lx > 0) {
	    dword rgb, cx, b, g, r, m;

	    rgb = z->src32[pxTab->ox];
	    cx = z->ca;
	    RSZ_ARM_W0_4b_24bpp

	    rgb = z->src32[pxTab->ox + z->loff_x];
	    cx = z->ce;
	    RSZ_ARM_N_4b_24bpp
#if 0
	    z->dest32[pxTab->dox] = ((r >> 16) << 16) | ((g >> 16) << 8) | (b >> 16);
#else
 __asm__ volatile( \
		"uxtb	%0, %0, ROR #16\n" \
		"uxtb	%1, %1, ROR #16\n" \
		"uxtb	%2, %2, ROR #16\n" \
		"orr	%0, %1, LSL #8\n" \
		"orr	%0, %2, LSL #16\n" \
		: "+r"(b), "+r"(g), "+r"(r));
	    z->dest32[pxTab->dox] = b;
#endif
	    pxTab++;
	    lx--;
	}
	z->pxTab = pxTab;
}
