/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

// i386

#define RSZ_i386_W0_4b_24bpp8a \
	b = rgb[0] * cx; \
	g = rgb[1] * cx; \
	r = rgb[2] * cx; \
	a = rgb[3] * cx; 

#define RSZ_i386_N_4b_24bpp8a \
	b += rgb[0] * cx; \
	g += rgb[1] * cx; \
	r += rgb[2] * cx; \
	a += rgb[3] * cx; 

static void ATR_INLINE rszcpu32_XN0(Tzx *zx) {
  byte *rgb;
  dword cx;
  dword b, g, r, a;

	rgb = zx->src8;
	cx = zx->ca;
	RSZ_i386_W0_4b_24bpp8a
	rgb += 4;

	int lgx = zx->lgx;
	while (lgx > 0) {
	    cx = zx->cn;
nx_loop:
	    RSZ_i386_N_4b_24bpp8a
	    rgb += 4;
	    lgx--;
	    if (lgx > 0) goto nx_loop;
	}

	cx = zx->ce;
	RSZ_i386_N_4b_24bpp8a

	zx->b = b;
	zx->g = g;
	zx->r = r;
	zx->a = a;
}

static void ATR_INLINE rszcpu32_XN(Tzx *zx) {
  byte *rgb;
  dword cx;
  dword b, g, r, a;

	rgb = zx->src8;
	cx = zx->ca;
	RSZ_i386_W0_4b_24bpp8a
	rgb += 4;

	int lgx = zx->lgx;
	while (lgx > 0) {
	    cx = zx->cn;
nx_loop:
	    RSZ_i386_N_4b_24bpp8a
	    rgb += 4;
	    lgx--;
	    if (lgx > 0) goto nx_loop;
	}

	cx = zx->ce;
	RSZ_i386_N_4b_24bpp8a

	zx->b += b;
	zx->g += g;
	zx->r += r;
	zx->a += a;
}

#define RSZ_zxToResult_24 \
	z->dest32[pxTab->dox] = ((zx.r >> 16) << 16) | ((zx.g >> 16) << 8) | (zx.b >> 16);

#define RSZ_zxToResult_32 \
	z->dest32[pxTab->dox] = ((zx.a >> 16) << 24) | ((zx.r >> 16) << 16) | ((zx.g >> 16) << 8) | (zx.b >> 16);

static void ATR_INLINE rszcpu24_X20(Tzx *zx) {
  byte *rgb = zx->src8;
  dword ca = zx->ca;
  dword ce = zx->ce;

	zx->b = (rgb[0] * ca) + (rgb[4] * ce);
	zx->g = (rgb[1] * ca) + (rgb[5] * ce);
	zx->r = (rgb[2] * ca) + (rgb[6] * ce);
}

static void ATR_INLINE rszcpu24_X2(Tzx *zx) {
  byte *rgb = zx->src8;
  dword ca = zx->ca;
  dword ce = zx->ce;

	zx->b += (rgb[0] * ca) + (rgb[4] * ce);
	zx->g += (rgb[1] * ca) + (rgb[5] * ce);
	zx->r += (rgb[2] * ca) + (rgb[6] * ce);
}

static void ATR_INLINE rszcpu32_X20(Tzx *zx) {
  byte *rgb = zx->src8;
  dword ca = zx->ca;
  dword ce = zx->ce;

	zx->b = (rgb[0] * ca) + (rgb[4] * ce);
	zx->g = (rgb[1] * ca) + (rgb[5] * ce);
	zx->r = (rgb[2] * ca) + (rgb[6] * ce);
	zx->a = (rgb[3] * ca) + (rgb[7] * ce);
}

static void ATR_INLINE rszcpu32_X2(Tzx *zx) {
  byte *rgb = zx->src8;
  dword ca = zx->ca;
  dword ce = zx->ce;

	zx->b += (rgb[0] * ca) + (rgb[4] * ce);
	zx->g += (rgb[1] * ca) + (rgb[5] * ce);
	zx->r += (rgb[2] * ca) + (rgb[6] * ce);
	zx->a += (rgb[3] * ca) + (rgb[7] * ce);
}

#define RSZ_i386_W0_4b_24 \
	b = rgb[0] * cx; \
	g = rgb[1] * cx; \
	r = rgb[2] * cx; 

#define RSZ_i386_N_4b_24 \
	b += rgb[0] * cx; \
	g += rgb[1] * cx; \
	r += rgb[2] * cx; 

static void ATR_INLINE rszcpu24_XN0(Tzx *zx) {
  byte *rgb;
  dword cx;
  dword b, g, r;

	rgb = zx->src8;
	cx = zx->ca;
	RSZ_i386_W0_4b_24
	rgb += 4;

	int lgx = zx->lgx;
	while (lgx > 0) {
	    cx = zx->cn;
nx_loop:
	    RSZ_i386_N_4b_24
	    rgb += 4;
	    lgx--;
	    if (lgx > 0) goto nx_loop;
	}

	cx = zx->ce;
	RSZ_i386_N_4b_24

	zx->b = b;
	zx->g = g;
	zx->r = r;
}

static void ATR_INLINE rszcpu24_XN(Tzx *zx) {
  byte *rgb;
  dword cx;
  dword b, g, r;

	rgb = zx->src8;
	cx = zx->ca;
	RSZ_i386_W0_4b_24
	rgb += 4;

	int lgx = zx->lgx;
	while (lgx > 0) {
	    cx = zx->cn;
nx_loop:
	    RSZ_i386_N_4b_24
	    rgb += 4;
	    lgx--;
	    if (lgx > 0) goto nx_loop;
	}

	cx = zx->ce;
	RSZ_i386_N_4b_24

	zx->b += b;
	zx->g += g;
	zx->r += r;
}

static void __attribute__ ((noinline)) rszcpu24_X2Y1(Tz *z, int lx) {
  dword *src, *dest;
  TpxTab *pxTab;

	if (lx <= 0) return;
	src = z->src32;
	dest = z->dest32;

	pxTab = z->pxTab;
	while (lx > 0) {
	    byte *rgb = (byte*)(src + pxTab->ox);
	    dword ca = pxTab->cxa;
	    dword ce = pxTab->cxe;

	    dest[pxTab->dox] =  (((rgb[0] * ca) + (rgb[4] * ce)) >> 16) |
			       ((((rgb[1] * ca) + (rgb[5] * ce)) >> 16) << 8) |
			       ((((rgb[2] * ca) + (rgb[6] * ce)) >> 16) << 16);

	    pxTab++;
	    lx--;
	}
	z->pxTab = pxTab;
}

static void __attribute__ ((noinline)) rszcpu32_X2Y1(Tz *z, int lx) {
  dword *src, *dest;
  TpxTab *pxTab;

	if (lx <= 0) return;
	src = z->src32;
	dest = z->dest32;

	pxTab = z->pxTab;
	while (lx > 0) {
	    byte *rgb = (byte*)(src + pxTab->ox);
	    dword ca = pxTab->cxa;
	    dword ce = pxTab->cxe;

	    dest[pxTab->dox] =  (((rgb[0] * ca) + (rgb[4] * ce)) >> 16) |
			       ((((rgb[1] * ca) + (rgb[5] * ce)) >> 16) << 8) |
			       ((((rgb[2] * ca) + (rgb[6] * ce)) >> 16) << 16) |
			       ((((rgb[3] * ca) + (rgb[7] * ce)) >> 16) << 24);

	    pxTab++;
	    lx--;
	}
	z->pxTab = pxTab;
}

static void __attribute__ ((noinline)) rszcpu24_X1Y2(Tz *z, int lx) {
  dword *src, *srcy, *dest, ca, ce;
  TpxTab *pxTab;

	if (lx <= 0) return;
	src = z->src32;
	srcy = src + z->loff_x;
	dest = z->dest32;

	pxTab = z->pxTab;
	ca = z->ca;
	ce = z->ce;
	while (lx > 0) {
	    byte *rgb = (byte*)(src + pxTab->ox);
	    byte *rgby = (byte*)(srcy + pxTab->ox);

	    dest[pxTab->dox] =  (((rgb[0] * ca) + (rgby[0] * ce)) >> 16) |
			       ((((rgb[1] * ca) + (rgby[1] * ce)) >> 16) << 8) |
			       ((((rgb[2] * ca) + (rgby[2] * ce)) >> 16) << 16);

	    pxTab++;
	    lx--;
	}
	z->pxTab = pxTab;
}

static void __attribute__ ((noinline)) rszcpu32_X1Y2(Tz *z, int lx) {
  dword *src, *srcy, *dest, ca, ce;
  TpxTab *pxTab;

	if (lx <= 0) return;
	src = z->src32;
	srcy = src + z->loff_x;
	dest = z->dest32;

	pxTab = z->pxTab;
	ca = z->ca;
	ce = z->ce;
	while (lx > 0) {
	    byte *rgb = (byte*)(src + pxTab->ox);
	    byte *rgby = (byte*)(srcy + pxTab->ox);

	    dest[pxTab->dox] =  (((rgb[0] * ca) + (rgby[0] * ce)) >> 16) |
			       ((((rgb[1] * ca) + (rgby[1] * ce)) >> 16) << 8) |
			       ((((rgb[2] * ca) + (rgby[2] * ce)) >> 16) << 16) |
			       ((((rgb[3] * ca) + (rgby[3] * ce)) >> 16) << 24);

	    pxTab++;
	    lx--;
	}
	z->pxTab = pxTab;
}
