/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "sysbase.h"
#include "image.h"

int CompareColor(ic32 a, ic32 b, dword sortfu) {
  dword m0, m1;
  dword fu;

	if (sortfu & 0x08) {
	    int m = (sortfu & 0xffffff00) >> 8;
	    a.dw &= m;
	    b.dw &= m;
	}

	fu = sortfu & 0x07;
	if (!fu) {
	    m0 = a.b[2] - b.b[2];
	    if (m0) return m0;
	    m0 = a.b[1] - b.b[1];
	    if (m0) return m0;
	    return a.b[0] - b.b[0];
	} else if (fu == 1) {
	    m0 = a.b[0];
	    if (a.b[1] > m0) m0 = a.b[1];
	    if (a.b[2] > m0) m0 = a.b[2];
	    m1 = b.b[0];
	    if (b.b[1] > m1) m1 = b.b[1];
	    if (b.b[2] > m1) m1 = b.b[2];
	    return m0-m1;
	} else { //if (fu == 2) {
	    return (a.b[0]+a.b[1]+a.b[2]) - (b.b[0]+b.b[1]+b.b[2]);
	}
}

void ColorMap_Sort(ic32 *col, int num, dword sortfu) {
	if (col) QuickSort_PL((void*)col, 0, num-1, sortfu, (TCompareFunction)CompareColor);
}
