/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"
#include "tdecor.h"


typedef struct TDecorButton_w3b3 {
  AlgTTC;
  const TBordMaskHead *upDat;
  const TBordMaskHead *downDat;
} TDecorButton_w3b3;

static bool TDecor_button_w3b3_DoDecor(TWins *wins, int bef, int mk, void *p) {
  TRX_Dat rxdat;
  TDecorButton_w3b3 *dat;
  TDecor *Decor = wins->Decor;
  TDecor *deco = Decor;

	if (!deco) return False;
	if (deco->wtyp == wtyp_TDecorDup) {
	  deco = *deco->DecorDup;
	  if (Decor->backpxm != deco->backpxm) {
	    Decor->backpxm = deco->backpxm;
	    Decor->stat &= ~Deco_SizeOk;
	    if (deco->backpxm) {
		TPixMap_XPutImage(deco->backpxm);
		XSetWindowBackgroundPixmap(appXDat.dpy, wins->WinID, deco->backpxm->pmxID);
		XClearWindow(appXDat.dpy, wins->WinID);
		Refresh(wins);
	    } else {
		XSetWindowBackground(appXDat.dpy, wins->WinID, GetColor_RGB(wins->Color));
		XClearWindow(appXDat.dpy, wins->WinID);
		Refresh(wins);
	    }
	    if (wins->KeyFu & mHasFocus)
	      DrawRectFocus(wins->WinID, 3, 3, wins->width-6, wins->height-6);
	    return True;
	  }
	}
	if (!deco || deco->wtyp != wtyp_TDecor) return False;
	dat = deco->DecorDat;
	if (!dat) return False;

	rxdat.WinID = wins->WinID;
	rxdat.Color = wins->Color; // 0xc0c0c0;
	rxdat.org_pxm = deco->backpxm;
	rxdat.width = wins->width;
	rxdat.height = wins->height;
	rxdat.top = 0; //wins->top;
	rxdat.left = 0; //wins->left;
	if (wins->BorderFu & mBorderL) {
	    rxdat.BordMaskHead = dat->downDat;
	} else { 
	    rxdat.BordMaskHead = dat->upDat;
	}

	switch(bef) {
	case decor_NewSize:
	    if (mk & (CWWidth | CWHeight)) {
		decor_RegionBR2_5(&rxdat, &Decor->stat);
	    }
	    return True;

	case decor_Border:
	    if ((Decor->stat & Deco_SizeOk) == 0) {
		decor_RegionBR2_5(&rxdat, &Decor->stat);
	    }
	    decor_paintBR2_5(&rxdat);
	    return True;

	case decor_FocusIn:
	case decor_FocusOut:
	    if (p) *(int*)p = 3;
	    return False;

	case decor_Destroy:
	    if (Decor->wtyp == wtyp_TDecorDup) {
		Tfree(Decor);
	    }
	    return True;

	default:
	    return False;
	}

	return False;
}

TDecor *TDecor_button_w3b3_Create() {
  TDecor *deco;
  TDecorButton_w3b3 *dat;

	dat = ttc_create(sizeof(TDecorButton_w3b3), wtyp_TDecorDat);
	dat->upDat = &TDecoBuW3B3_up_Tab;
	dat->downDat = &TDecoBuW3B3_down_Tab;
	deco = TDecor_Create(dat);
	deco->DoDecor = TDecor_button_w3b3_DoDecor;
	return deco;
}

