
#include "rsz.h"


_imgmask_copy:  /* %ecx = w  %ebx = h */
	mov	src_mask, %esi
	test	%esi, %esi
       jz	_imgmask_copy_end
	mov	dest_mask, %edi
	test	%edi, %edi
       jz	_imgmask_copy_end
	push	%ecx
	add	$7, %ecx
	shr	$3, %ecx
	imul	%ebx, %ecx
	rep
	movsb
	pop	%ecx
_imgmask_copy_end:
       ret

/* ___________________ 16bpp copy _______________________ */
_imgdat16_copy:  /* ecx=new_w ebx=new_h */
	movzwl		src_off_x, %eax
	movzwl		src_off_y, %edx
	or		%edx, %eax
	movzwl		dest_off_x, %edx
	or		%edx, %eax
	movzwl		dest_off_y, %edx
	or		%edx, %eax
       jnz	imgdat16_copy_off
	cmp		src_lg_x, %ecx
       jnz	imgdat16_copy_off

       call	_imgmask_copy
	imul	%ebx, %ecx
	mov	src_dat, %esi
	mov	dest_dat, %edi
	rep
	movsw
	xor	%eax, %eax
       ret


init_copy_off:
	movzbl		src_line_eoff, %ebx
	add		src_w, %ebx
	movzwl		src_off_y, %ecx
	imul		%ebx, %ecx
	movzwl		src_off_x, %ebx
	add		%ebx, %ecx


	movzbl		dest_line_eoff, %ebx
	add		dest_w, %ebx
	movzwl		dest_off_y, %edx
	imul		%ebx, %edx
	movzwl		dest_off_x, %ebx
	add		%ebx, %edx

	movzwl		src_lg_x, %ebx
	movzbl		src_line_eoff, %eax
	add		src_w, %eax
	sub		%ebx, %eax

	movzwl		dest_lg_x, %edi
	movzbl		dest_line_eoff, %ebx
	add		dest_w, %ebx
	sub		%edi, %ebx

	mov		src_dat, %esi
	mov		dest_dat, %edi
       ret

imgdat16_copy_off:
       call	init_copy_off
	lea		(%esi, %ecx, 2), %esi
	lea		(%edi, %edx, 2), %edi
	movzwl		src_lg_y, %edx
imgdat16_copy_off_loop:
	movzwl		src_lg_x, %ecx
	rep
	movsw
	lea		(%esi, %eax, 2), %esi
	lea		(%edi, %ebx, 2), %edi
	dec		%edx
       jnz	imgdat16_copy_off_loop
	xor	%eax, %eax
       ret

/* ___________________ 24bpp copy _______________________ */
_imgdat24_copy:  /* ecx=new_w ebx=new_h */
// call AzAsmReg
	movzwl		src_off_x, %eax
	movzwl		src_off_y, %edx
	or		%edx, %eax
	movzwl		dest_off_x, %edx
	or		%edx, %eax
	movzwl		dest_off_y, %edx
	or		%edx, %eax
       jnz	imgdat24_copy_off
	cmp		src_lg_x, %ecx
       jnz	imgdat24_copy_off

       call	_imgmask_copy
	imul	%ebx, %ecx
	mov	src_dat, %esi
	mov	dest_dat, %edi
	rep
	movsd
	xor	%eax, %eax
       ret

imgdat24_copy_off:
       call	init_copy_off
	lea		(%esi, %ecx, 4), %esi
	lea		(%edi, %edx, 4), %edi
	movzwl		src_lg_y, %edx
imgdat24_copy_off_loop:
	movzwl		src_lg_x, %ecx
	rep
	movsd
	lea		(%esi, %eax, 4), %esi
	lea		(%edi, %ebx, 4), %edi
	dec		%edx
       jnz	imgdat24_copy_off_loop
	xor	%eax, %eax
       ret

.globl _imgdat_copy

_imgdat_copy:
	movzbl	src_typ, %eax
	cmp	rsz_typ_2b_16bpp, %eax
       jz	_imgdat16_copy
	cmp	rsz_typ_4b_24bpp, %eax
       jz	_imgdat24_copy
	cmp	rsz_typ_4b_24bpp8a, %eax
       jz	_imgdat24_copy

	mov	rszERR_Zoom, %eax
       ret


#ifdef _OS_WIN32
.global _ImgDat_Copy
_ImgDat_Copy:
#else
.globl ImgDat_Copy
	.type	 ImgDat_Copy,@function
ImgDat_Copy:
#endif
	push	%ebp
	push	%edi
	push	%esi
	push	%ebx

	mov	%esp, %ebp
	sub	rsz_SIZE+locDat_Size+4, %esp

       call	Set_Resize_head

	mov	to_w, %ecx
	mov	to_h, %ebx
       call	_imgdat_copy

	add	rsz_SIZE+locDat_Size+4, %esp
	pop	%ebx
	pop	%esi
	pop	%edi
	pop	%ebp
       ret
