/*
regparm(3)  arguments in registers EAX, EDX, and ECX

the 8 32-bit registers
%eax (the accumulator)
%ebx, %ecx, %edx, %edi, %esi, %ebp (theframe pointer)
%esp (the stack pointer).

the 8 16-bit 
%ax, %bx, %cx, %dx, %di, %si, %bp, %sp.

the 8 8-bit registers
%ah, %al, %bh, %bl, %ch, %cl, %dh, %dl 
 (the high-bytes and low-bytes %ax, %bx, %cx, %dx)

*/


#include "rsz.h"

#ifndef ONLY_MMX
#define ONLY_MMX 0
#endif

#if ONLY_MMX != 0
#define USE_MMX 1
#endif

#ifndef USE_MMX
#define USE_MMX 1
#endif

#define USE_MMX_Q 1

#define CpxTab_Head	$32

#if USE_MMX_Q != 0
#define pxTab_ox	0
#define pxTab_dox	4
#define pxTab_lgx	8
#define pxTab_dox_1	12
#define pxTab_cxa	16
#define pxTab_cxe	24
#define CpxTab_inc	$32
#else
#define pxTab_cxa	8
#define pxTab_cxe	12
#define pxTab_inc	$16
#endif

#define h_pTap		0
#define h_0_loop	4
#define h_1_loop	8
#define h_N_loop	12

#ifdef _OS_WIN32
#define xmalloc		_xmalloc
#define xfree		_xfree
#endif

#if 0
ValIntPrint:
	.ascii "rsz_XX_11.S: \n  eax=%08x ebx=%08x ecx=%08x edx=%08x\n  edi=%08x esi=%08x ebp=%08x\n"
	.byte	0
.globl AzAsmReg
	.type	 AzAsmReg,@function
AzAsmReg:
	push	%ebp
	push	%esi
	push	%edi
	push	%edx
	push	%ecx
	push	%ebx
	push	%eax
	push	$ValIntPrint
       call	printf
	pop	%eax
	pop	%eax
	pop	%ebx
	pop	%ecx
	pop	%edx
	pop	%edi
	pop	%esi
	pop	%ebp
       ret
#endif

/* ************ Zoom 16bpp XXX:1 ************ */
math_p_kh_kw:
// kh = (org_h << 16) / new_h;
	movzwl		dest_lg_y, %ecx
	movzwl		src_lg_y, %eax
	shl		$0x10, %eax
	xor		%edx, %edx
	divl		%ecx
	mov		%eax, kh
// kmulh   = 0x0080ffff / kh;
	mov		%eax, %ecx
	mov		4(%esp), %eax
	xor		%edx, %edx
	div		%ecx
	mov		%eax, kmulh


// kw = (org_w << 16) / new_w;
	movzwl		dest_lg_x, %ecx
	movzwl		src_lg_x, %eax
	shl		$0x10, %eax
	xor		%edx, %edx
	divl		%ecx
	mov		%eax, kw
// kmulw   = 0x0080ffff / kw;
	mov		%eax, %ecx
	mov		4(%esp), %eax
	xor		%edx, %edx
	div		%ecx
	mov		%eax, kmulw

	movzbl	src_line_eoff, %eax
	add	src_w, %eax
	mov	%eax, loff_x
       ret

#define	loc_K_Off	0x18(%esp)
#define	loc_bix_byte	0x14(%esp)
#define	loc_0_loop	0x00(%esp)
#define	loc_1_loop	0x04(%esp)
#define	loc_N_loop	0x08(%esp)
#define	loc_xdoff	0x0c(%esp)
rsz_p_mem_init:
	sub		$0x10,%esp
	mov		dest_w, %eax
	inc		%eax
	imul		CpxTab_inc, %eax
	add		CpxTab_Head, %eax

	push		%eax
       call	xmalloc
	add		$0x04,%esp
	mov		%eax, rsztemp0
	mov		%eax, %edi
	mov		CpxTab_Head, %edx
	test		$0x04, %eax
       jz	rsz_p_mem_al8
	add		$0x04, %edx
rsz_p_mem_al8:
	add		%eax, %edx
	mov		%edx, h_pTap(%edi)
// call AzReg

	mov		%edx, %edi

	xor		%eax, %eax
	mov		%eax, loc_0_loop
	mov		%eax, loc_1_loop
	mov		%eax, loc_N_loop
	mov		%eax, loc_xdoff
	movzwl		dest_off_x, %ecx

/* Test Fast Zoom */
	movzwl		rsz_fu, %eax
	test		rsz_fu_Fast_rsz, %eax
       jz	rsz_p_mem_loop_0
rsz_p_mem_loop_Fast:
	mov		loc_K_Off, %eax
	push		%eax
       call	math_cxa_cxe
	add		$0x04,%esp
	mov		%edx, pxTab_lgx(%edi)	//lx
	mov		%ecx, %eax
	sub		loc_xdoff, %eax
	mov		%eax, pxTab_dox_1(%edi)	//x diff off
	imul		loc_bix_byte, %eax	//Byte per Pixel
	mov		%eax, pxTab_dox(%edi)	//x diff off * Byte per Pixel
	mov		%ecx, loc_xdoff
	incl		loc_0_loop
	mov		%esi, pxTab_ox(%edi)	//off
	add		CpxTab_inc, %edi
	inc		%ecx
	movzwl		dest_lg_x, %eax
	cmp		%ecx, %eax
       jne	rsz_p_mem_loop_Fast
       jmp	tvcI_p_mem_end


rsz_p_mem_loop_0:
	mov		loc_K_Off, %eax
	push		%eax
       call	math_cxa_cxe
	add		$0x04,%esp
	test		%edx, %edx
       jnz	rsz_p_mem_lxO_0
	mov		%edx, pxTab_lgx(%edi)	//lx
	mov		%ecx, %eax
	sub		loc_xdoff, %eax
	mov		%eax, pxTab_dox_1(%edi)	//x diff off
	imul		loc_bix_byte, %eax	//Byte per Pixel
	mov		%eax, pxTab_dox(%edi)	//x diff off * Byte per Pixel
	mov		%ecx, loc_xdoff
	incl		loc_0_loop
	mov		%esi, pxTab_ox(%edi)	//off
	add		CpxTab_inc, %edi
rsz_p_mem_lxO_0:
	inc		%ecx
	movzwl		dest_lg_x, %eax
	cmp		%ecx, %eax
       jne	rsz_p_mem_loop_0

	movzwl		dest_off_x, %ecx
tvcI_p_mem_loop_1:
	mov		loc_K_Off, %eax
	push		%eax
       call	math_cxa_cxe
	add		$0x04,%esp
	cmp		$1, %edx
       jnz	tvcI_p_mem_lxO_1
	mov		%edx, pxTab_lgx(%edi)	//lx
	mov		%ecx, %eax
	sub		loc_xdoff, %eax
	mov		%eax, pxTab_dox_1(%edi)	//x diff off
	imul		loc_bix_byte, %eax	//Byte per Pixel
	mov		%eax, pxTab_dox(%edi)	
	mov		%ecx, loc_xdoff
	incl		loc_1_loop
	mov		%esi, pxTab_ox(%edi)	//off
	add		CpxTab_inc, %edi
tvcI_p_mem_lxO_1:
	inc		%ecx
	movzwl		dest_lg_x, %eax
	cmp		%ecx, %eax
       jne	tvcI_p_mem_loop_1

	movzwl		dest_lg_x, %eax
	sub		loc_0_loop, %eax
	sub		loc_1_loop, %eax
       jz	tvcI_p_mem_end
	movzwl		dest_off_x, %ecx
tvcI_p_mem_loop_N:
	mov		loc_K_Off, %eax
	push		%eax
       call	math_cxa_cxe
	add		$0x04,%esp
	cmp		$1, %edx
       jle	tvcI_p_mem_lxO_N
	mov		%edx, pxTab_lgx(%edi)	//lx
	mov		%ecx, %eax
	sub		loc_xdoff, %eax
	mov		%eax, pxTab_dox_1(%edi)	//x diff off
	imul		loc_bix_byte, %eax	//Byte per Pixel
	mov		%eax, pxTab_dox(%edi)	
	mov		%ecx, loc_xdoff
	incl		loc_N_loop
	mov		%esi, pxTab_ox(%edi)	//off
	add		CpxTab_inc, %edi
tvcI_p_mem_lxO_N:
	inc		%ecx
	movzwl		dest_lg_x, %eax
	cmp		%ecx, %eax
       jne	tvcI_p_mem_loop_N

tvcI_p_mem_end:
	mov		rsztemp0, %edi
	mov		loc_0_loop, %eax
	mov		%eax, h_0_loop(%edi)
	mov		loc_1_loop, %eax
	mov		%eax, h_1_loop(%edi)
	mov		loc_N_loop, %eax
	mov		%eax, h_N_loop(%edi)
	add		$0x10,%esp
       ret
#undef	loc_bix_byte
#undef	loc_0_loop
#undef	loc_1_loop
#undef	loc_xdoff
#undef	loc_K_Off

#define	loc_K_Off	0x04(%esp)
math_cxa_cxe:			//x=ecx   --> lx=edx xoff=esi
//	mov		loc_K_Off, %ebx
//	mov		kw, %eax
//	shr		$3, %eax
//	cmp		%ebx, %eax
//       jg	math_cxa_cxe_K_Off
//	mov		%eax, loc_K_Off
math_cxa_cxe_K_Off:
// cxa = (kmulw * (0x10000 - (kw0 & 0xffff))) >> 12;
	mov		$0x10000, %ebx

	mov		kw, %eax		//kw
	mov		%eax, %edx
	imul		%ecx, %eax		//x*kw=kw0
	mov		src_off_x, %esi
	shl		$16, %esi
	add		%eax, %esi		//esi = kw0
	add		loc_K_Off, %esi

	movzwl		%si, %eax		//(kw0 & 0xffff)
	sub		%eax, %ebx
	add		loc_K_Off, %ebx
	imul		kmulw, %ebx		//kmulw
	shr		$12, %ebx
	mov		%ebx, %eax
	shl		$16, %eax
	or		%ebx, %eax
	mov		%eax, pxTab_cxa(%edi)	//cxa
	mov		%eax, pxTab_cxa+4(%edi)	//cxa
// cxe = (kmulw * ((kw0+kw) & 0xffff)) >> 12;
	add		%esi, %edx     /* eax = kw0+kw */
	sub		loc_K_Off, %edx
	sub		loc_K_Off, %edx
	movzwl		%dx, %ebx
	add		loc_K_Off, %ebx
	imul		kmulw, %ebx		//kmulw
	shr		$12, %ebx
	mov		%ebx, %eax
	shl		$16, %eax
	or		%ebx, %eax
	mov		%eax, pxTab_cxe(%edi)	//cxe
	mov		%eax, pxTab_cxe+4(%edi)	//cxe
// lx = ((kw0+kw) >> 16) - (kw0 >> 16);
	shr		$16, %esi
	cmp		src_w, %esi
       jge	math_cxa_cxe_w_ov
	shr		$16, %edx
	sub		%esi, %edx

	mov		%esi, %ebx	//chk x+lx > src_w
	add		%edx, %ebx
	cmp		src_w, %ebx
       jge	math_cxa_cxe_w_ov
       ret

math_cxa_cxe_w_ov:
	mov		src_w, %esi
	dec		%esi
	xor		%edx, %edx
       ret

#undef	loc_K_Off

math_cya_cye:    //K_Off_y=%ecx    -> ly = %ecx
	mov		kh, %eax
	shr		$3, %eax
	cmp		%ecx, %eax
       jg	math_cya_cye_K_Off
	mov		%eax, %ecx
math_cya_cye_K_Off:
// cya = (kmulh * (0x10000 - (kh0 & 0xffff))) >> 12;
	mov		kh,%edx
	imul		y, %edx
	mov		src_off_y, %eax
	shl		$16, %eax
	add		%eax, %edx
	add		%ecx, %edx	//+K_Off_y

	mov		$0x10000, %ebx
	movzwl		%dx, %eax
	sub		%eax, %ebx
	add		%ecx, %ebx	//+K_Off_y
	imul		kmulh, %ebx
	shr		$12, %ebx
	mov		%ebx, cya
// cye = (kmulh * ((kh0+kh) & 0xffff)) >> 12;
	mov		kh,%eax
	add		%edx, %eax     /* eax = kw0+kw */
	sub		%ecx, %eax	//-K_Off_y
	sub		%ecx, %eax	//-K_Off_y

	movzwl		%ax, %ebx
	add		%ecx, %ebx	//+K_Off_y
	imul		kmulh, %ebx
	shr		$12, %ebx
	mov		%ebx, cye
// ly = ((kh0+kh-1) >> 16) - (kh0 >> 16);
	shr		$16, %edx
	cmp		src_h, %edx
       jge	math_cya_cye_h_ov
	shr		$16, %eax
	sub		%edx, %eax	//ly

	mov		%edx, %ebx	//chk y+ly > src_h
	add		%eax, %ebx
	cmp		src_h, %ebx
       jge	math_cya_cye_h_ov
math_cya_cye_OV:
//	mov		%eax, ly
	mov		%eax, %ecx	//ly->%ecx

	movzbl		src_line_eoff, %ebx
	add		src_w, %ebx
	imul		%edx, %ebx
	mov		src_dat, %esi

	movzbl		dest_line_eoff, %eax
	add		dest_w, %eax
	imul		y, %eax
	mov		dest_dat, %edi
       ret
math_cya_cye_h_ov:
	mov		src_h, %edx
	dec		%edx
	xor		%eax, %eax
       jmp	math_cya_cye_OV



/* ________________________ Zoom 16bpp ___________________________*/
rsz16_xx_11:
	push		$0x0807ffff
       call	math_p_kh_kw
	add		$0x04,%esp

	mov		rsztemp0, %eax
	test		%eax, %eax
       jnz	rsz16m_anf

	push		$0x0fff		//K_Off
	push		$2		//Byte per Pixel
       call	rsz_p_mem_init
	add		$0x08,%esp
rsz16m_anf:
#if ONLY_MMX != 0
       call	rszmmx16_st

#else /* ONLY_MMX */
#if USE_MMX != 0
	movzwl		rsz_fu, %ecx
	test		rsz_fu_HasMMX, %ecx
       jz	rsz16_cpu
       call	rszmmx16_st
       jmp	rsz16_cpu_mmx_end
rsz16_cpu:
#endif
       call	rszcpu16_st
rsz16_cpu_mmx_end:
#endif /* ONLY_MMX */
       jmp	rsz_end



#if USE_MMX != 0

#include "rsz_mmx.S"
#include "rsz_mmx_m.S"

#endif

#if ONLY_MMX == 0

#include "rsz_cpu.S"
#include "rsz_cpu_m.S"

#endif

/* ________________________ Zoom 24bpp ___________________________*/
rsz24_xx_11:
	push		$0x08000000
       call	math_p_kh_kw
	add		$0x04,%esp

	mov		rsztemp0, %eax
	test		%eax, %eax
       jnz	rsz24p_anf

#if 1
	mov		$0x0fff, %ebx
	mov		kw, %eax
	shr		$3, %eax
	cmp		%ebx, %eax
       jg	K_Off_Ok
	mov		%eax, %ebx
K_Off_Ok:
	push		%ebx
#else
	push		$0x0fff		//K_Off
#endif
	push		$4		//Byte per Pixel
       call	rsz_p_mem_init
	add		$0x08,%esp
rsz24p_anf:
#if ONLY_MMX != 0
       call	rszmmx24_st
#else /* ONLY_MMX */
#if USE_MMX != 0
	movzwl		rsz_fu, %ecx
	test		rsz_fu_HasMMX, %ecx
       jz	rsz24_cpu
       call	rszmmx24_st
       jmp	rsz24_cpu_mmx_end
rsz24_cpu:
#endif
       call	rszcpu24_st
rsz24_cpu_mmx_end:
#endif /* ONLY_MMX */

rsz_end:
	movzwl	rsz_fu, %eax
	and	rsz_fu_TmpNotFree, %eax
       jnz	rsz_NoFree

	mov	rsztemp0, %eax
	push	%eax
       call	xfree
	add	$0x04,%esp
	xor	%eax, %eax
	mov	%eax, rsztemp0
rsz_NoFree:
	mov	rsztemp0, %eax
	mov	Timg_rsz, %edi
	mov	%eax, i_rsztemp0(%edi)

	xor	%eax, %eax
       ret

/* ******************************************* */
.globl _Resize_XX_11

_Resize_XX_11:
	cmp	$0x10000, %esi
       jnz	noK1
	cmp	$0x10000, %edi
       jz	_imgdat_copy
noK1:

	movzbl	src_typ, %eax
	cmp	rsz_typ_2b_16bpp, %eax
       jz	rsz16_xx_11
	cmp	rsz_typ_4b_24bpp, %eax
       jz	rsz24_xx_11
	cmp	rsz_typ_4b_24bpp8a, %eax
       jz	rsz24_xx_11

	mov	rszERR_Zoom, %eax
       ret


#ifdef _OS_WIN32
.global _ImgDat_Resize_XX_11
_ImgDat_Resize_XX_11:
#else
.globl ImgDat_Resize_XX_11
	.type	 ImgDat_Resize_XX_11,@function
ImgDat_Resize_XX_11:
#endif
	push	%ebp
	push	%edi
	push	%esi
	push	%ebx

	mov	%esp, %ebp
	sub	rsz_SIZE+locDat_Size+4, %esp

       call	Set_Resize_head


       call	Chk_Resize_XX_11
	cmp	$0, %eax
       jnz	end_a


       call	_Resize_XX_11
end_a:
	add	rsz_SIZE+locDat_Size+4, %esp
	pop	%ebx
	pop	%esi
	pop	%edi
	pop	%ebp
       ret

