/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

void TImage_ClsRGB(TImage *self, dword RGB) {
  int w, h, x;
  dword bpp, col;
  byte *pb;

	if (!self || !self->data || !self->bytes_per_line) return;

	w = self->width;
	h = self->height;
	if ((w <= 0) || (h <= 0)) return;

	pb = self->data;
	bpp = self->pxm_LD & pxmLD_bppMask;
	if (bpp == pxm_2b_16bpp) {
	    col = RGB24To16(RGB);
	    while (h > 0) {
		word *wx = (word*)pb;
		x = w;
		while (x > 0) {
		    *wx = col;
		    wx++; x--;
		}
		pb += self->bytes_per_line;
		h--;
	    }

	} else if ((bpp == pxm_4b_24bpp) || (bpp == pxm_4b_24bpp8a)) {
	    while (h > 0) {
		dword *wx = (dword*)pb;
		x = w;
		while (x > 0) {
		    *wx = RGB;
		    wx++; x--;
		}
		pb += self->bytes_per_line;
		h--;
	    }
	}
}
