/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

bool TImage_DrawLineChk(TImage *self, int x1, int y1, int x2, int y2) {
  int w, h;

	if (!self || !self->data || !self->bytes_per_line) return false;
	w = self->width;
	h = self->height;
	return  (w > 0) && (h > 0) && 
		((x1 >= 0) || (x2 >= 0)) &&
		((y1 >= 0) || (y2 >= 0)) &&
		((x1 < w) || (x2 < w)) &&
		((y1 < h) || (y2 < h));
}

#if 0
#define printfd printf
#else
#define printfd(a,...)
#endif

static int korr_16k(int val, int k1, int k2) {
 printfd("%s(%d): %d %d %d ", FL, val, k1, k2);
  int result;
	result = val * k1 * 2;
	result /= k2;
 printfd("%d ", result);
	if (result >= 0) result++; else result--;
 printfd("%d -> %d\n", result, result / 2);
	return result / 2;
}


int TImage_pv_DrawLineRGB(TImage *self, dword RGB, int x1, int y1, int x2, int y2) {
  int w, h;
  int x, y, lx, ly, x11, y11, x22, y22, lxg, lyg, max_p, bpl;
  dword col, bpp;

	w = self->width;
	h = self->height;

	bpp = self->pxm_LD & pxmLD_bppMask;
	if (bpp == pxm_2b_16bpp) {
	    bpl = self->bytes_per_line >> 1;
	    col = RGB24To16(RGB);
	} else if ((bpp == pxm_4b_24bpp) || (bpp == pxm_4b_24bpp8a)) {
	    bpl = self->bytes_per_line >> 2;
	    col = RGB;
	} else return 1;

	if (x1 == x2) {
	    if (y1 < 0) y1 = 0;
	    if (y2 < 0) y2 = 0;
	    if (y1 >= h) y1 = h-1;
	    if (y2 >= h) y2 = h-1;
	    if (y1 > y2) SWAP_INT(y1, y2);

	    if (bpp == pxm_2b_16bpp) {
		word *wx = &((word*)self->data)[x1];
		wx += (bpl * y1);
		y = 1 + y2 - y1;
		while (y) {
		    *wx = col;
		    wx += bpl;
		    y--;
		}
	    } else {
		dword *wx = &((dword*)self->data)[x1];
		wx += (bpl * y1);
		y = 1 + y2 - y1;
		while (y) {
		    *wx = col;
		    wx += bpl;
		    y--;
		}
	    }
	    return 0;
	}

	if (y1 == y2) {
	    if (x1 < 0) x1 = 0;
	    if (x2 < 0) x2 = 0;
	    if (x1 >= w) x1 = w-1;
	    if (x2 >= w) x2 = w-1;
	    if (x1 > x2) SWAP_INT(x1, x2);
	    if (bpp == pxm_2b_16bpp) {
		word *wx = &((word*)self->data)[x1];
		wx += bpl * y1;
		x = 1 + x2 - x1;
		while (x) {
		    *wx = col;
		    wx++;
		    x--;
		}
	    } else {
		dword *wx = &((dword*)self->data)[x1];
		wx += bpl * y1;
		x = 1 + x2 - x1;
		while (x) {
		    *wx = col;
		    wx++;
		    x--;
		}
	    }
	    return 0;
	}

//	    return 1;

 printfd("%s(%d): w=%d h=%d  x1=%d y1=%d x2=%d y2=%d\n", FL, w, h, x1, y1, x2, y2);
	if (y1 > y2) {SWAP_INT(y1, y2); SWAP_INT(x1, x2);}

	lxg = x2 - x1;
	lyg = y2 - y1;
	x11 = x1;
	y11 = y1;
	x22 = x2;
	y22 = y2;

	    if (x1 < 0) {
		y11 = y1 - korr_16k(x1, lyg, lxg);
		x11 = 0;
 printfd("%s(%d):  y11=%d\n", FL, y11);
	    }
	    if (y11 < 0) {
		x11 = x1 - korr_16k(y1, lxg, lyg);
		y11 = 0;
 printfd("%s(%d): x11=%d %d %d %d %d\n", FL, x11, y1, lxg, lyg, korr_16k(y1, lxg, lyg));
	    }

	    if (x2 < 0) {
		y22 = y2 - korr_16k(x2, lyg, lxg);
		x22 = 0;
 printfd("%s(%d): y22=%d\n", FL, y22);
	    }
	    if (y22 < 0) {
		x22 = x2 - korr_16k(y2, lxg, lyg);
		y22 = 0;
 printfd("%s(%d): x22=%d\n", FL, x22);
	    }

	    if (x11 >= w) {
		y11 = y1 - korr_16k(x1 - (w - 1), lyg, lxg);
		x11 = w - 1;
 printfd("%s(%d):  y11=%d %d %d %d %d\n", FL, y11, x1 - (w - 1), lxg, lyg, korr_16k(x1 - (w - 1), lyg, lxg));
	    }
	    if (y11 >= h) {
		x11 = x1 - korr_16k(y1 - (h - 1), lxg, lyg);
		y11 = h - 1;
 printfd("%s(%d): x11=%d\n", FL, x11);
	    }

	    if (x22 >= w) {
		y22 = y2 - korr_16k(x2 - (w - 1), lyg, lxg);
		x22 = w - 1;
 printfd("%s(%d): y22=%d\n", FL, y22);
	    }
	    if (y22 >= h) {
		x22 = x2 - korr_16k(y2 - (h - 1), lxg, lyg);
		y22 = h - 1;
 printfd("%s(%d): x22=%d\n", FL, x22);
	    }

 printfd("%s(%d): w=%d h=%d  x1=%d y1=%d x2=%d y2=%d\n", FL, w, h, x11, y11, x22, y22);

	lx = x22 - x11;
	ly = y22 - y11;
	x = lxg;
	if (x < 0) x = -x;
	y = lyg;
	if (y < 0) y = -y;

	if (bpp == pxm_2b_16bpp) {
	    max_p = bpl * h;
	    word *wx0 = (word*)self->data;

	    if (y > x) {
		int ko = (lxg << 16) / lyg;
		int xo = (x1 << 16) + (((y11 - y1) * ko) + 0x8000);
		y = 1 + ly;
		int k0 = y11 * bpl;
		while (y > 0) {
		    int k = k0 + (xo >> 16);
		    if ((k >= 0) && (k < max_p)) wx0[k] =  col;
		    k0 += bpl; xo += ko; y--; 
		}
	    } else {
		int ko = (lyg << 16) / lxg;
		int yo = (y1 << 16) + (((x11 - x1) * ko) + 0x8000);
		if (lx >= 0) {
		    x = 1 + lx;
		    int k0 = x11;
		    while (x > 0) {
			int k = k0 + (bpl * (yo >> 16));
			if ((k >= 0) && (k < max_p)) wx0[k] =  col;
			yo += ko; k0++; x--; 
		    }
		} else {
		    x = 1 - lx;
		    int k0 = x11;
		    while (x > 0) {
			int k = k0 + (bpl * (yo >> 16));
			if ((k >= 0) && (k < max_p)) wx0[k] =  col;
			yo -= ko; k0--; x--; 
		    }
		}
	    }
	} else {
	    max_p = bpl * h;
	    dword *wx0 = (dword*)self->data;

	    if (y > x) {
		int ko = (lxg << 16) / lyg;
		int xo = (x1 << 16) + (((y11 - y1) * ko) + 0x8000);
		y = 1 + ly;
		int k0 = y11 * bpl;
		while (y > 0) {
		    int k = k0 + (xo >> 16);
		    if ((k >= 0) && (k < max_p)) wx0[k] =  col;
		    k0 += bpl; xo += ko; y--; 
		}
	    } else {
		int ko = (lyg << 16) / lxg;
		int yo = (y1 << 16) + (((x11 - x1) * ko) + 0x8000);
		if (lx >= 0) {
		    x = 1 + lx;
		    int k0 = x11;
		    while (x > 0) {
			int k = k0 + (bpl * (yo >> 16));
			if ((k >= 0) && (k < max_p)) wx0[k] =  col;
			yo += ko; k0++; x--; 
		    }
		} else {
		    x = 1 - lx;
		    int k0 = x11;
		    while (x > 0) {
			int k = k0 + (bpl * (yo >> 16));
			if ((k >= 0) && (k < max_p)) wx0[k] =  col;
			yo -= ko; k0--; x--; 
		    }
		}
	    }
	}
	return 0;
}

int TImage_DrawLineRGB(TImage *self, dword RGB, int x1, int y1, int x2, int y2) {
	if (!TImage_DrawLineChk(self, x1, y1, x2, y2)) return 0;
	return TImage_pv_DrawLineRGB(self, RGB, x1, y1, x2, y2);
}
