/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"
#include "image_pv.h"

/* ______________________________________________________________________ */
TImage *TImage_hLoader(const char *fn, TglobPath *gp, dword pxm_LD,
			int type_size, int wtyp, Timg_malloc imal, FILE *F) {
  ThImageLoader *hLD;
  TImage *self;
  TglobPath *gpt;
  FILE *Ft;
  int m;

	hLD = TImage_get_hLoader(fn, gp, pxm_LD, F, False);
	if (!hLD) return NULL;

	self = NULL;
	gpt = gp;
	if (!gpt) gpt = pctogp(fn);

	Ft = F;
	if (!Ft) Ft = TImageIO_OpenStream(gpt, pxm_LD, False);
	if (!Ft) goto err;

	self = TImage_Create(type_size, wtyp);
	rewind(Ft);
	self->in_fp = Ft;
	self->in_gp = gpt;
	self->pxm_LD = pxm_LD;
	self->in_filetyp = hLD->filetyp;
	if (imal) self->img_malloc = imal;

	m = hLD->ioproc(self);

	if (F != Ft) fclose(Ft);
	self->in_gp = NULL;
	self->in_fp = NULL;

	if (m != IMGRD_OK) {
	    if (!(pxm_LD & pxmLD_NoERR) && 
		(!hLD->LibError || !hLD->LibError())) {
		char *tmp = get_DisplayFileStr(fn, gpt);
		appError(EMSG_ERR1 | EMSG_IMAGE_RD, 
			"image readerr=%d \n \"%s\"", m, tmp);
		xfree(tmp);
	    }
	    Tfree(self);
	    self = NULL;
	}
err:
	if (gpt != gp) gpFree(gpt);
	return self;
}

TImage *TImage_Loader(const char *fn, TglobPath *gp, dword pxm_LD) {
	return TImage_hLoader(fn, gp, pxm_LD, 0, 0, NULL, NULL);
}

TImage *TImage_Loader_F(const char *fn, TglobPath *gp, dword pxm_LD, FILE *F) {
	if (!F) return NULL;
	return TImage_hLoader(fn, gp, pxm_LD, 0, 0, NULL, F);
}
