/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"
 
/*____________________________________________________________________________*/
TImage *TImage_dup_new_size_off(TImage *self, int new_width, int new_height, Toff_rsz *srcoff) {
  TImage *rimg = self;
  TImage *nimg = NULL;
  Timg_rsz rsz;

	if (!self || !self->img_malloc) return NULL;
	if ((new_width > 100000)||(new_height > 100000)) return NULL;
	if (new_width < 2) new_width = 2;
	if (new_width > 8000) {
		new_height = new_height * 8000 / new_width;
		new_width = 8000;
	}
	if (new_height < 2) new_height = 2;
	if (new_height > 8000) {
		new_width = new_width * 8000 / new_height;
		new_height = 8000;
	}

	if (((self->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp) &&
	    (self->stat & pmxStat_ckh_alpha)) {
	    rimg = TImage_rgb565to888(self);
	}

	nimg = TImage_Create_dup_struct(rimg, 0);
	nimg->width  = new_width;
	nimg->height = new_height;
	TImage_SetMem(nimg);

	TImage_SetBase_rsz(rimg, &rsz);
	TImage_SetDestBase_rsz(nimg, &rsz);

	if (srcoff) {
	    rsz.src_off_x = srcoff->x;
	    rsz.src_off_y = srcoff->y;
	    rsz.src_lg_x = srcoff->width;
	    rsz.src_lg_y = srcoff->height;
	}

	ImgDat_Resize_XX_11(&rsz);

	if (rimg == self) return nimg;
	Tfree(rimg);
	rimg = TImage_rgb888to565(nimg);
	Tfree(nimg);
	return rimg;
}

TImage *TImage_dup_new_size(TImage *self, int new_width, int new_height) {
	return TImage_dup_new_size_off(self, new_width, new_height, NULL);
}
