/*
 Copyright (C) 2010 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"


TImage *TImage_rgb565to888(TImage *self) {
  TImage *nimg = NULL;
  byte *sb0, *sbA, *db0;

	if (!self || ((self->pxm_LD & pxmLD_bppMask) != pxm_2b_16bpp)) return NULL;
	nimg = TImage_Create(self->wtcsize, self->wtyp);

	nimg->width  = self->width;
	nimg->height = self->height;
	nimg->pxm_LD = (self->pxm_LD & ~pxmLD_bppMask) | pxm_4b_24bpp;
	nimg->stat |= self->stat & pmxStat_ckh_alpha;
	nimg->img_malloc = self->img_malloc;
	nimg->img_malloc(nimg);

	sbA = self->rgb565_alpha_data;
	sb0 = self->data;
	db0 = nimg->data;
//  dword A = 255;
	for (int y=self->height; y; y--) {
	    byte *sb = sb0;
	    byte *db = db0;
	    if (sbA) {
		for (int x=self->width; x; x--) {
		    dword c = *((word*)sb);
		    sb += 2;
		    *((dword*)db) = (*sbA++ << 24)|((c & 0xf800)<<8)|((c & 0x7e0)<<5)|((c & 0x1f)<<3);
		    db += 4;
		}
	    } else {
		for (int x=self->width; x; x--) {
		    dword c = *((word*)sb);
		    sb += 2;
		    *((dword*)db) = 0xff000000|((c & 0xf800)<<8)|((c & 0x7e0)<<5)|((c & 0x1f)<<3);
		    db += 4;
		}
	    }
	    sb0 += self->bytes_per_line;
	    db0 += nimg->bytes_per_line;
	}

	return nimg;
}
