/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"

void TImage_rgb888move565(TImage *img888, TImage *img565) {
  byte *sb0 = img888->data;
  byte *sbA = img565->rgb565_alpha_data;
  byte *db0 = img565->data;
	for (int y=img888->height; y; y--) {
	    byte *sb = sb0;
	    byte *db = db0;
	    if (sbA) {
		for (int x=img888->width; x; x--) {
		    *((word*)db) = ((sb[0]&0xf8)>>3)|((sb[1]&0xfc)<<3)|((sb[2]&0xf8)<<8);
		    *sbA++ = sb[3];
		    sb += 4; db += 2;
		}
	    } else {
		for (int x=img888->width; x; x--) {
		    *((word*)db) = ((sb[0]&0xf8)>>3)|((sb[1]&0xfc)<<3)|((sb[2]&0xf8)<<8);
		    sb += 4; db += 2;
		}
	    }
	    sb0 += img888->bytes_per_line;
	    db0 += img565->bytes_per_line;
	}
	img565->stat &= ~(pmxStat_XPixAkt | pmxStat_XMaskPixAkt);
}

TImage *TImage_rgb888to565(TImage *self) {
  TImage *nimg = NULL;

	if (!self || (((self->pxm_LD & pxmLD_bppMask) != pxm_4b_24bpp)&&
		      ((self->pxm_LD & pxmLD_bppMask) != pxm_4b_24bpp8a))) return NULL;
	nimg = TImage_Create(self->wtcsize, self->wtyp);

	nimg->width  = self->width;
	nimg->height = self->height;
	nimg->pxm_LD = (self->pxm_LD & ~pxmLD_bppMask) | pxm_2b_16bpp;
	nimg->stat |= self->stat & pmxStat_ckh_alpha;
	nimg->img_malloc = self->img_malloc;
	nimg->img_malloc(nimg);
	if (self->stat & pmxStat_ckh_alpha) {
	    nimg->rgb565_alpha_data = xmalloc(self->width * self->height);
	}
	TImage_rgb888move565(self, nimg);

	return nimg;
}
