/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "image.h"
#include "image_pv.h"

//fuWR = fuWR_gray fuWR_NoMask fuWR_use_pallette
//compress_level = 1..10  0=default
int TImage_Write_PNG(TImage *self, const char *fn, int fuWR, dword compress_level) {
  ThImageLoader *hLD;
  FILE *F;
  dword out_fu;
  int result;

	out_fu = fuWR & (fuWR_NoMask|fuWR_gray|fuWR_use_pallette);
	if (compress_level > 10) compress_level = 10;
	if (compress_level > 0) out_fu |= (compress_level << 8);

	hLD = TImage_get_hLoader(fn, NULL, 0, NULL, true);
	if (!hLD || !(hLD->filetyp & filetyp_PNG)) return IMGWR_ERROR;

	F = TImageIO_GetStream(fn, NULL, 0, &hLD, true);
	if (!F) return IMG_ERR_NOSTREAM;

	self->out_gp = pctogp(fn);
	self->out_fu = out_fu;
	self->out_fp = F;
	result = hLD->ioproc(self);

	fclose(self->out_fp);
	self->out_fp = 0;
	gpFree(self->out_gp);
	self->out_gp = NULL;
	return result;
}
