/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"

/*____________________________ Create ________________________________*/
TPixMap *TPixMap_Create_XID(Pixmap pixID, Pixmap maskID) {
  TPixMap *pxm;
  TGeometry gm;

	if (!get_geometry((Drawable)pixID, &gm)) return NULL;
// printf("%s(%d): %d %d %d\n", FL, gm.width, gm.height, gm.depth);
	pxm = TPixMap_Create_depth(gm.width, gm.height, 0);

	if (gm.depth == 1) {
  XImage *Ximg;
	    TPixMap_CreateXimg(pxm);
	    Ximg = XGetImage(pxm->dpy, (Drawable)pixID, 0, 0, 
			  gm.width, gm.height, 0xffffffff, ZPixmap);
	    if (Ximg) {
		byte *ps = (byte*)Ximg->data;
		byte *pd = pxm->data;
		if ((pxm->pxm_LD & pxmLD_bppMask) == pxm_2b_16bpp) {
		    int mdz, md;
		    for (int y=gm.height;y;y--) {
			word *pwd = (word*)pd;
			byte *pbs = ps;
			md = mdz = 0;
			for (int x=gm.width;x;x--) {
			    if (!mdz) {md = *pbs; pbs++; mdz = 8;}
			    if (md & 1) *pwd = 0; else *pwd = 0xffff;
			    md >>= 1; mdz--; pwd++;
			}
			ps += Ximg->bytes_per_line;
			pd += pxm->bytes_per_line;
		    }
		} else {
		    int mdz, md;
		    for (int y=gm.height;y;y--) {
			dword *pwd = (dword*)pd;
			byte *pbs = ps;
			md = mdz = 0;
			for (int x=gm.width;x;x--) {
			    if (!mdz) {md = *pbs; pbs++; mdz = 8;}
			    if (md & 1) *pwd = 0; else *pwd = 0xffffff;
			    md >>= 1; mdz--; pwd++;
			}
			ps += Ximg->bytes_per_line;
			pd += pxm->bytes_per_line;
		    }
		}
		XDestroyImage(Ximg);
	    }
	    pxm->stat = pmxStat_ImgAkt;
	} else {
	    pxm->pmxID = pixID;
	    pxm->stat = pmxStat_XPixAkt;
	}
	pxm->maskID = maskID;


	if (maskID) pxm->stat |= (pmxStat_XMaskPixAkt | pmxStat_HandleMask | pmxStat_has_alpha);
	pxm->gc = appXDat.Default_GC;
	return pxm;
}
