/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"

/*____________________________________________________________________________*/
static TVDrawString *TPixMap_Get_vds(TPixMap *pxm) {
	if (!pxm->vds) {
	    pxm->vds = xcalloc(sizeof(TVDrawString));
	    pxm->vds->Font = appXDat.Default_Font;
	}
	return pxm->vds;
}
/*____________________________________________________________________________*/
void TPixMap_SetFont(TPixMap *pxm, TFont *font) {
  TVDrawString *vds = TPixMap_Get_vds(pxm);
	vds->Font = font;
}

void TPixMap_SetFontName(TPixMap *pxm, const char *name) {
  TFont *font2 = NULL;
  TVDrawString *vds = TPixMap_Get_vds(pxm);

	if (appXDat.Default_Font != vds->Font) font2 = vds->Font;
	vds->Font = MakeFont(name, appXDat.Default_Font->name, font2);
}

/*____________________________________________________________________________*/
void TPixMap_SetFontColor(TPixMap *pxm, dword ForeColor, dword BackColor) {
  TVDrawString *vds = TPixMap_Get_vds(pxm);
	ChangeFontGC(vds->Font, ForeColor, BackColor);
}

/*____________________________________________________________________________*/
void TPixMap_DrawString(TPixMap *pxm, const char *s, int x, int y) {
  TVDrawString *vds = TPixMap_Get_vds(pxm);

	if (!(pxm->stat & pmxStat_NoBixImgSwitch)) TPixMap_XPutImage(pxm);
	vds->s_const = s;
	vds->lg = pclen(s);
	vds->scda = NULL;
	vds->WinID = pxm->pmxID;
	DrawColorString(x, y, vds);
	vds->s_const = NULL;
	vds->lg = 0;
	pxm->stat &= ~pmxStat_ImgAkt;
}
