/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "image.h"
#include "tpixmap.h"

//bool TPixMap__Destroy(TPixMap *pxm);

static TPixMap *pxm_ld(const char *fn, TglobPath *gp, dword pxm_LD, FILE *F) {
  TPixMap *self;

	if (!(pxm_LD & pxmLD_bppMask)) {
	    if (appXDat.RootW_depth == 16) {
		pxm_LD |= pxm_2b_16bpp;
	    } else {
		pxm_LD |= pxm_4b_24bpp;
	    }
	}
	self = (TPixMap*)TImage_hLoader(fn, gp, pxm_LD, sizeof(TPixMap), 
				wtyp_TPixMap, (Timg_malloc)TPixMap_img_malloc, F);

	if (!self) return NULL;
	self->destroy = (TDESTROY)TPixMap__Destroy;
	if (alpha_akt((TImage*)self)) alpha2bitmask((TImage*)self);
	return self;
}



TPixMap *TPixMap_Loader(const char *fn, TglobPath *gp, dword pxm_LD) {
	return pxm_ld(fn, gp, pxm_LD, NULL);
}

TPixMap *TPixMap_Loader_F(const char *fn, TglobPath *gp, dword pxm_LD, FILE *F) {
	if (!F) return NULL;
	return pxm_ld(fn, gp, pxm_LD, F);
}
