/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"
#include "tpixmap_pv.h"


/*____________________________________________________________________________*/
void TPixMap_ToWinBackground(TPixMap *pxm, Window WinID) {
	TPixMap_XPutImage(pxm);
	XSetWindowBackgroundPixmap(appXDat.dpy, WinID, pxm->pmxID);
}

/*____________________________________________________________________________*/
void TPixMap_WinCombineMask(TPixMap *pxm, Window WinID) {
	if (pxm->mask_data) {
	    pxm_create_maskID(pxm);
	    XShapeCombineMask(appXDat.dpy, WinID, ShapeBounding, 
				0, 0, pxm->maskID, ShapeSet);
	}
}
/*____________________________________________________________________________*/
void TPixMap_ClsRGB(TPixMap *pxm, dword Color) {
	if ((pxm->stat & pmxStat_ImgAkt) != 0) {
	    if (!(pxm->stat & pmxStat_NoBixImgSwitch)) TPixMap_XGetImage(pxm);
	    TImage_ClsRGB((TImage*)pxm, Color);
	    pxm->stat &= ~pmxStat_XPixAkt;
	} else {
	    if (!(pxm->stat & pmxStat_NoBixImgSwitch)) TPixMap_XPutImage(pxm);
	    FillRectRGB((Drawable)pxm->pmxID, Color, 0, 0, pxm->width, pxm->height);
	    pxm->stat &= ~pmxStat_ImgAkt;
	}
}

/*____________________________________________________________________________*/
void TPixMap_PaintToWin(TPixMap *pxm, Window WinID, int left, int top) {
  long gcm = 0;
  GC gc = pxm->gc;

	TPixMap_XPutImage(pxm);

	if (pxm->stat & pmxStat_XMaskPixAkt) {
	
	    if (pxm->gcv.clip_mask != pxm->maskID) {
		pxm->gcv.clip_mask = pxm->maskID;
		gcm |= GCClipMask;
	    }
	    if ((pxm->gcv.clip_x_origin != left) || (pxm->gcv.clip_y_origin != top)) {
		pxm->gcv.clip_x_origin = left;
		pxm->gcv.clip_y_origin = top;
		gcm |= (GCClipXOrigin | GCClipYOrigin);
	    }
	    if (pxm->mask_gc && gcm) {
		ChangeGC(pxm->mask_gc, gcm, &pxm->gcv);
	    }

	    if (!pxm->mask_gc) {
		pxm->gcv.plane_mask = AllPlanes;
		pxm->gcv.function = GXcopy;
		pxm->gcv.fill_style = FillSolid;
		gcm |= GCFunction | GCPlaneMask | GCGraphicsExposures | GCLineWidth;
		pxm->mask_gc = CreateGC(gcm, &pxm->gcv);
	    }
	    gc = pxm->mask_gc;
	}

	if (!gc) gc = appXDat.Default_GC;
	XCopyArea(appXDat.dpy, (Drawable)pxm->pmxID, WinID, gc,
		  0, 0, pxm->width, pxm->height, left, top);
}

