/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"

/*____________________________________________________________________________*/
static int ImgDat_SetMask16RGB(Timg_rsz *rsz) {
  int w = rsz->src_w;
  int h = rsz->src_h;
  word *pws = rsz->src_dat;
  byte *pmd = rsz->src_mask;
  int x, mdz, md;
  int cw;

 	cw = ((rsz->src_mask_color >> 8) & 0xf800) |
	     ((rsz->src_mask_color >> 5) & 0x07e0) |
	     ((rsz->src_mask_color >> 3) & 0x001f);
	while (h) {
	    mdz = md = 0;
	    x = w;
	    while (x) {
		if (*pws != (word)cw) md |= (1 << mdz);
		pws++; mdz++;
		if (mdz > 7) {*pmd = md; mdz = md = 0; pmd++;}
		x--;
	    }
	    if (mdz) {*pmd = md; pmd++;}
	    pws += rsz->src_line_eoff;
	    h--;
	}
	return 0;
}

static int ImgDat_SetMask24RGB(Timg_rsz *rsz) {
  int w = rsz->src_w;
  int h = rsz->src_h;
  int *pws = rsz->src_dat;
  byte *pmd = rsz->src_mask;
  int x, mdz, md;
  int cw = rsz->src_mask_color;

	while (h) {
	    mdz = md = 0;
	    x = w;
	    while (x) {
		if (*pws != cw) md |= (1 << mdz);
		pws++; mdz++;
		if (mdz > 7) {*pmd = md; mdz = md = 0; pmd++;}
		x--;
	    }
	    if (mdz) {*pmd = md; pmd++;}
	    pws += rsz->src_line_eoff;
	    h--;
	}
	return 0;
}

void TPixMap_SetMaskRGB(TPixMap *pxm, dword Color) {
  Timg_rsz rsz;

	TPixMap_XGetImage(pxm);
	if (!pxm->mask_data) {
	    pxm->mask_data = xmalloc(((pxm->width+7) >> 3) * pxm->height);
	}

	rsz.src_dat = pxm->Ximg->data;
	rsz.src_mask = pxm->mask_data;
	rsz.src_w = pxm->width;
	rsz.src_h = pxm->height;
	rsz.src_mask_color = Color;
	if (pxm->Ximg->depth == 16) {
		rsz.src_line_eoff = (pxm->Ximg->bytes_per_line >> 1) - pxm->width;
		rsz.src_typ = pxm_2b_16bpp;
		ImgDat_SetMask16RGB(&rsz);
	} else if (pxm->Ximg->depth == 24) {
		rsz.src_line_eoff = (pxm->Ximg->bytes_per_line >> 2) - pxm->width;
		rsz.src_typ = pxm_4b_24bpp;
		ImgDat_SetMask24RGB(&rsz);
	}

	pxm->stat &= ~pmxStat_XMaskPixAkt;
	pxm->stat |= pmxStat_MaskImgAkt;
}
