/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appXbase.h"
#include "tpixmap.h"

/*____________________________________________________________________________*/
static void _img_shift(Timg_rsz *rsz) {
  int x, y;
  int w = rsz->src_w;
  int h = rsz->src_h;
  int xo = rsz->to_w;

	if (rsz->src_typ == pxm_2b_16bpp) {
	    word* dpx = (word*)rsz->src_dat;
	    word *spx;
	    if (xo < 0) {
		for (y=h; y>0; y--) {
		    spx = dpx - xo;
		    for (x=w+xo; x>0; x--) {
			*dpx = *spx; dpx++; spx++;
		    }
		    dpx = spx;
		}
	    }
	} else if (rsz->src_typ == pxm_4b_24bpp) {
	    dword* dpx = (dword*)rsz->src_dat;
	    dword *spx;
	    if (xo < 0) {
		for (y=h; y>0; y--) {
		    spx = dpx - xo;
		    for (x=w+xo; x>0; x--) {
			*dpx = *spx; dpx++; spx++;
		    }
		    dpx = spx;
		}
	    }

	}
}

void TPixMap_shift(TPixMap *pxm, int xo, int yo) {
  Timg_rsz rsz;

	TPixMap_XGetImage(pxm);
	TImage_SetBase_rsz((TImage*)pxm, &rsz);
	rsz.to_w = xo;
	rsz.to_h = yo;
	pxm->stat &= ~pmxStat_XPixAkt;

	_img_shift(&rsz);
}

