/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include <errno.h>
#include <fcntl.h>

TappDat appDat;

void (*FAppRun)();

#ifdef TEST_NOTIFY_TIME
dword test_notify_us = 0;
dword test__us = 0;
static dword az_notify_us;
#endif

#include <windows.h>

#define MAXMSGEVENT	8
static HANDLE MsgEvent[MAXMSGEVENT];
static int MsgEventCount;

/*
void AzAppMsgEvent() {
 printf("%d %06x %06x %06x %06x %06x %06x %06x %06x\n", MsgEventCount, 
	(int)MsgEvent[0], (int)MsgEvent[1], (int)MsgEvent[2], (int)MsgEvent[3],
	(int)MsgEvent[4], (int)MsgEvent[5], (int)MsgEvent[6], (int)MsgEvent[7]);
}
*/

bool AddAppMsgEvent(HANDLE h) {
  int i;
	if (ChkFileHandleAkt(h) && (MsgEventCount < MAXMSGEVENT)) {
	    for (i=0;i<MsgEventCount;i++) {
		if (MsgEvent[i] == h) return true;
	    }
	    MsgEvent[MsgEventCount] = h;
	    MsgEventCount++;
	    return true;
	}
	return false;
}

bool DelAppMsgEvent(HANDLE h) {
  int i, j;

	if (ChkFileHandleAkt(h) && MsgEventCount) {
	    j = -1;
	    for (i=0;i<MsgEventCount;i++) {
		if (MsgEvent[i] == h) {
		    MsgEvent[i] = NULL;
		    j = i;
		} else if (j >= 0) {
		    MsgEvent[j] = MsgEvent[i];
		    MsgEvent[i] = NULL;
		    j++;
		}
	    }
	    if (j >= 0) {
		MsgEventCount--;
		return true;
	    }
	}
	return false;
}

void initapp(int fu, int argc, char **argv) {
	app_name = *argv;

//	SetCPU_Flags(NULL);
#ifdef TEST_NOTIFY_TIME
	az_notify_us = GetTime_us();
#endif
	set_app_time(&appDat.app_us, &appDat.app_ms, &appDat.Hz30, &appDat.app_tv.tv_sec);
	appDat.app_start_us  = appDat.app_us;
	appDat.app_start_ms  = appDat.app_ms;
	appDat.app_start_sec = appDat.app_tv.tv_sec;
}

bool AppProcessMessages() {
	if (appDat.X11DispatchEvent) appDat.X11DispatchEvent();
//	if (appDat.UserAppEvent) appDat.UserAppEvent();
	if (appDat.MSG_Buf_Ev) appDat.MSG_Buf_Ev();
	if (appDat.TimerDispatch) appDat.TimerDispatch();
	if (appDat.gQUIT_Ev) return False;
	if (appDat.Wins_PaintOnEvEnd) appDat.Wins_PaintOnEvEnd();
	return True;
}

void AppSetWait0_single() {
	atomic_or(&appDat.appFu, appFu_select_t0_single);
}
void AppSetWait1_single() {
	atomic_or(&appDat.appFu, appFu_select_t1_single);
}

dword w32_app_ms = 50;

bool AppHandleMessage() {
  dword wres, ms;
//  int hCount;
  TEv_Array *pev, **ppev;
//  HANDLE EventHandles[2];
  bool ret;

	appDat.Sleep = True;
	ms = w32_app_ms;
	if (appDat.appFu & appFu_select_t1_single) ms = 10;
	if (appDat.appFu & (appFu_select_t_NULL|appFu_select_t0_single)) ms = 0;
/*
	hCount = 0;
	if (appDat.app_Event) {
	    EventHandles[0] = appDat.app_Event;
	    hCount++;
	}
	if (appDat.com_Event) {
	    EventHandles[hCount] = appDat.com_Event;
	    hCount++;
	}
*/
	appDat.tapp_us += GetTime_us() - (dword)appDat.app_us;

	wres = MsgWaitForMultipleObjectsEx(MsgEventCount, MsgEvent, ms, QS_ALLINPUT, 0);
	appDat.Sleep = False;
	atomic_and(&appDat.appFu, ~(appFu_select_t0_single|appFu_select_t1_single));
// printf("%s(%d): 0x%04x t=%dms\n", FL, wres, GetTime_ms());

//	set_app_time();
	set_app_time(&appDat.app_us, &appDat.app_ms, &appDat.Hz30, &appDat.app_tv.tv_sec);

	if (appDat.thd_private_EV) appDat.thd_private_EV();
	ret = AppProcessMessages();

	if (appDat.appEv_Array) {
	    pev = appDat.appEv_Array;
	    ppev = &appDat.appEv_Array;
	    while (pev) {
		if (pev->On_appEv) {
		    pev->On_appEv(pev);
		    ppev = &pev->next;
		    pev = pev->next;
		} else {
		    *ppev = pev->next;
		    xfree(pev);
		    pev = *ppev;
		}
	    }
	}

#ifdef MEM_CHK
#ifdef MEM_CHKappAZ
	MEM_CHK_AZ();
#endif
#endif
#ifdef TEST_NOTIFY_TIME
	if (GetCurTimeDiv_us(az_notify_us) > 10000000) {
	    printf("Debug %s(%d): notify_us=%uus  t2=%uus\n", FL, test_notify_us, test__us);
	    az_notify_us = GetTime_us();
	    test_notify_us = 0;
	    test__us = 0;
	}
#endif
	return ret;
}

void AppRun() {
	appDat.AppRun = True;
	if (FAppRun) {
	    FAppRun();
	    appDat.AppExit = True;
	} else {
	    while (AppHandleMessage());
	    appDat.AppExit = True;
	}
	appDat.AppRun = False;
}

void Close() {
	appDat.gQUIT_Ev = True;
}
