/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "appbase.h"
#include "tsearch.h"
#include <unistd.h>
#include <fcntl.h>

bool ChkAppRun(const char *fn, int fu, char **ppc) {
  int lg;
  int fd;
  TSearch_Rec *sr;
  const char *appfn, *tmpfn;
  char pidnr[16];
  char line[1024];
  char tmpf[4096];

	appfn = GetFileName_pc(fn);
	snprintf(pidnr, sizeof(pidnr), "%d", appDat.self_pid);
	sr = TSearch_Create("/proc/", findDIR, fsNoFileName | fsNoLinkName);

	if (Find_First(sr)) {
	  while (Find_Next(sr)) {
	    if ((sr->ret_entry->d_name[0] >= '1') && 
		(sr->ret_entry->d_name[0] <= '9') &&
		(!pccmp(sr->ret_entry->d_name, pidnr))) {

		lg = 0;
		if (fu & carfu_cmd) {
		  snprintf(line, sizeof(line), "/proc/%s/cmdline", sr->ret_entry->d_name);
		  fd = open(line, O_RDONLY);
		  if (fd > 0) {
		    lg = read(fd, tmpf, sizeof(tmpf));
		    close(fd); 
		  }
		} else {
		  snprintf(line, sizeof(line), "/proc/%s/exe", sr->ret_entry->d_name);
		  lg = readlink(line, tmpf, sizeof(tmpf));
		}
		if (lg > 0) {
		    tmpf[lg] = 0;
		    tmpfn = GetFileName_pc(tmpf);
		    if (pccmp(appfn, tmpfn)) {
			if (ppc) {
			    snprintf(line, sizeof(line), "/proc/%s/", sr->ret_entry->d_name);
			    *ppc = pcdup(line);
			}
			Tfree(sr);
			return True;
		    }
	        }
	    }
	  }
	}
	Tfree(sr);
	return False;
}
