/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"

#ifdef _OS_WIN32

int exec_pc(const char *args) {
  word *lpCommandLine;
  STARTUPINFOW StartupInfo;
  PROCESS_INFORMATION ProcessInformation;


	Fill0(&StartupInfo, sizeof(StartupInfo));
	StartupInfo.cb = sizeof(StartupInfo);
	Fill0(&ProcessInformation, sizeof(ProcessInformation));

	lpCommandLine = UTF8topwc(args);
	CreateProcessW(NULL, lpCommandLine, NULL, NULL,
			False, NORMAL_PRIORITY_CLASS, NULL, NULL, 
			&StartupInfo, &ProcessInformation);
	xfree(lpCommandLine);
	return ProcessInformation.dwProcessId;
}

#else /* _OS_WIN32 */

int exec_pc(const char *args) {
  char **argv = NULL;

	if (!args || !*args) return 0;
	cmdtoargs(args, NULL, &argv);
	return exec_pipe_argv(argv, expipfu_args_free, NULL);
}
#endif /* Linux */
