/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include <unistd.h>

Tfd_list *AddPipeProc_TmpRes(FileHandle fd, int fu, TOnPipe OnPipe, void *obj) {
  Tfd_list *fdl;

	fd_set_count(fd);

	fdl = &appDat.fd_list[fd];
	appDat.AktPipes[fd] = fu;
	fdl->Proc = OnPipe;
	fdl->io = NULL;
	fdl->obj = obj;
	fdl->m = 0;
	return fdl;
}

void AddPipeProc(FileHandle fd, int fu, TOnPipe OnPipe, void *obj) {
	AddPipeProc_TmpRes(fd, fu, OnPipe, obj);
}

void REGP2 ClosePipeProc(FileHandle fd, int fu) {
  Tfd_list *fdl;
  bool mk;

	if (fd < 0) return;
	fdl = &appDat.fd_list[fd];
	mk = appDat.AktPipes[fd] != 0;
	appDat.AktPipes[fd] = 0;
	if ((fu & clpp_io) && fdl->io) fclose(fdl->io);
	if (((fu & clpp_fd) && mk) || (fu & clpp_fdx)) close(fd);
	fdl->io = NULL;
	fdl->Proc = NULL;
}

void REGP1 pClosePipe(FileHandle *fd) {
	if (*fd >= 0) {
	    close(*fd);
	    *fd = -1;
	}
}

void REGP1 ClosePipe(FileHandle fd) {
	if (fd >= 0) close(fd);
}
