/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "tthread.h"
#include <unistd.h>
#ifndef _OS_WIN32
#include <sys/wait.h>
#endif
#include <setjmp.h>


#define MaxMsgBuf 16

typedef struct TOVthdMSG {
  struct TOVthdMSG *next;
  TThread_MSG thdMSG;
} TOVthdMSG;

typedef struct {
  TOVthdMSG *OVthdMSG;
  int msg_in;
  int msg_out;
  TThread_MSG thdMSG[MaxMsgBuf];
} TthdMsgBuf;

typedef struct TThread_pv {
#ifdef _OS_WIN32
  DWORD id;
  CRITICAL_SECTION mutex;
#else
  pthread_t id;
  pthread_mutex_t mutex;
#endif
  jmp_buf ptAbort;
  int Start;
  int Stop;
  int free;
  int Sleep;
  int flag;
#ifdef _OS_WIN32
  HANDLE handle;
  HANDLE Event;
#endif
  TthdMsgBuf thdMsgBuf;
  TthdMsgBuf appMsgBuf;
  bool IsWaitThdToAppMSG;
  bool IsWaitThdToAppMSG_Result;
  bool IsWaitAppToThdMSG;
  bool IsWaitAppToThdMSG_Result;
  int ResWaitThdToAppMSG;
  TThread_MSG WaitThdToAppMSG;
  TThread_MSG WaitThdToAppMSG_Result;
  TThread_MSG WaitAppToThdMSG;
  TThread_MSG WaitAppToThdMSG_Result;
#ifndef _OS_WIN32
  fd_set fdset_in;
#endif
} TThread_pv;

#define THDflag_EVsend	1
