/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

void dotdot_scan(char *pc0) {
  char *pc = pc0;

	if (*pc != '/') return;
	while (*pc) {
	    if ((*pc == '/') && (pc[1] == '.')) {
		if (pc[2] == '/') {
		    pcmove(pc+1, pc+3);
		    continue;

		} else if ((pc[2] == '.') && (pc[3] == '/')) {
		    char *pce = pc+3;
		    if (pc > pc0) pc--;
		    while ((*pc != '/') && (pc > pc0)) pc--;
		    pcmove(pc, pce);
		    continue;

		} else if ((pc[2] == '.') && !pc[3]) {
		    if (pc > pc0) pc--;
		    while ((*pc != '/') && (pc > pc0)) pc--;
		    if (*pc != '/') return;
		    pc[1] = 0;
		    return;
		}
	    } 
	    pc++;
	}
}

// not encode ./abc/def
char *dotdot_korr(const char *s) {
  const char *pc;
  char *fns, *tpc;
  TPathInfo pathi;

	if (!get_PathInfo(s, &pathi)) return NULL;

	fns = pcdup(pathi.path_anf);
	if (!fns) {	// "ftp://URL" --> "ftp://URL/"
	    pc = S_SLASH;
	    goto add_pc;
	}
	slash_korr(fns, False);
	pc = fns;
	dotdot_scan(fns);

#ifdef _OS_WIN32
	if (pathi.RA_lg || (pathi.fu & pathi_SMB)) {
#else
	if (pathi.RA_lg) {
#endif /* ! _OS_WIN32 */
add_pc:
	    tpc = pcnnadd(s, pathi.path_anf - s, pc, pclen(pc));
	    xfree(fns);
	    fns = tpc;
	}
#ifdef _OS_WIN32
	slash_korr(fns, (pathi.fu & (pathi_SMB|pathi_RA_SMB)) || (pathi.fu & pathi_Local));
#else
	slash_korr(fns, False);
#endif /* ! _OS_WIN32 */

	return fns;
}

void ppc_dotdot_korr(char **s) {
  char *res;
	res = dotdot_korr(*s);
	xfree(*s);
	*s = res;
}
