/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "elf_info.h"

#if USE_ELFx64
typedef Elf64_Shdr Elf_Shdr;

typedef Elf64_Verdef Elf_Verdef;
typedef Elf64_Verdaux Elf_Verdaux;

typedef Elf64_Verneed Elf_Verneed;
typedef Elf64_Vernaux Elf_Vernaux;

typedef Elf64_Dyn Elf_Dyn;
typedef int64_t Telf_offset;

#else
typedef Elf32_Shdr Elf_Shdr;

typedef Elf32_Verdef Elf_Verdef;
typedef Elf32_Verdaux Elf_Verdaux;

typedef Elf32_Verneed Elf_Verneed;
typedef Elf32_Vernaux Elf_Vernaux;

typedef Elf32_Dyn Elf_Dyn;
typedef int Telf_offset;

#endif

typedef struct {
  TELF_Info *elf_info;
  char *e_data;
  Telf_offset e_size;
  bool e_mmap, isElf64, ncb2, ncb3;
  bool gotHASH, gotGNUHASH, gotDEBUG, ncb7;
  int scn0_count;
  Elf_Shdr *scn0;
  char *pscn0;
} TELF_private;
