/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

static bool filechk(Tstat64 *st, int findAtr) {
  mode_t st_mode;
	if (!st) return False;
	st_mode = st->mode;
	xfree(st);
	return file_stat_mode_match(findAtr, st_mode);
}

bool file_chk_exist_gp(TglobPath *gp, int findAtr) {
  Tstat64 *st;
	st = file_stat_gp(gp, fsNoFileName|fsNoLinkName|fsLinkDirekt);
	return filechk(st, findAtr);
}

bool file_chk_exist(const char *fn, int findAtr) {
  Tstat64 *st;
	st = file_stat_fn(fn, fsNoFileName|fsNoLinkName|fsLinkDirekt);
	return filechk(st, findAtr);
}

