/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>
#include <sys/stat.h>

bool file_chmod_OS(const charOS *fn, TNetErrRet *ErrRet, int mode) {
  bool result;

#ifdef _OS_WIN32
	result = SetFileAttributesW(fn, mode) != 0;
#else
	result = chmod(fn, mode) == 0;
#endif
	if (!result && ErrRet) ErrRet->sys_errno = errno;
	return result;
}

bool file_chmod(const char *fn, TNetErrRet *ErrRet, int mode) {
  charOS *tmp;
  bool result;

	tmp = path_to_local_OS_err(fn, ErrRet);
	if (!tmp) return False;
	result = file_chmod_OS(tmp, ErrRet, mode);
	xfree(tmp);
	return result;
}

bool file_chmod_gp(TglobPath *gp, TNetErrRet *ErrRet, int mode) {
  char *fn;
  bool result;
	fn = gptopc(gp, gptfu_del_slash|gptfu_noRootArt);
	result = file_chmod(fn, ErrRet, mode);
	xfree(fn);
	return result;
}
