/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <unistd.h>
#include <errno.h>

bool file_chown(const char *fn, TNetErrRet *ErrRet, int uid, int gid) {
  bool result;

#ifdef _OS_WIN32
	errno = EPERM;
	result = False;
#else
	result = chown(fn, uid, gid) >= 0;
#endif
	if (!result && ErrRet) ErrRet->sys_errno = errno;
	return result;
}

bool file_chown_gp(TglobPath *gp, TNetErrRet *ErrRet, int uid, int gid) {
  char *fn;
  bool result;
	fn = gptopc(gp, gptfu_del_slash|gptfu_noRootArt);
	result = file_chown(fn, ErrRet, uid, gid);
	xfree(fn);
	return result;
}
