/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

int file_mkdir_parents(const char *fn, TNetErrRet *ErrRet, int mode) {
  Tstat64 *st;
  int result;

	result = 0;
	st = file_stat_fn(fn, fsNoFileName | fsNoLinkName | fsLinkDirekt);
	if (st) {
	    if (st->st & st_Dir) {
		result = MkDirExists;
	    } else if (ErrRet) {
		ErrRet->const_err = "exists and is not a directory";
	    }
	    xfree(st);

	} else {
	    char *pc;
	    if (path_sub(fn, &pc)) {
		if (file_mkdir_parents(pc, ErrRet, mode)) {
		    result = file_mkdir(fn, ErrRet, mode);
		}
		xfree(pc);
	    }
	}
	return result;
}
