/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>

bool file_mv(const char *fn, TNetErrRet *ErrRet, const char *new_fn) {
  bool result;

#ifdef _OS_WIN32
	word *wcf = get_pcw_filename(fn,     del_path_end_slash);
	word *wcn = get_pcw_filename(new_fn, del_path_end_slash);
	result = _wrename(wcf, wcn) == 0;
	xfree(wcn);
	xfree(wcf);
#else
	result = rename(fn, new_fn) >= 0;
#endif
	if (!result && ErrRet) ErrRet->sys_errno = errno;
	return result;
}

bool file_mv_gp(TglobPath *gp, TNetErrRet *ErrRet, TglobPath *gp_new) {
  char *fn, *new_fn;
  bool result;
	fn     = gptopc(gp,     gptfu_del_slash|gptfu_noRootArt);
	new_fn = gptopc(gp_new, gptfu_del_slash|gptfu_noRootArt);
	result = file_mv(fn, ErrRet, new_fn);
	xfree(fn);
	xfree(new_fn);
	return result;
}
