/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

static TUserGroupList *UserList = NULL;
static TUserGroupList *GroupList = NULL;

static TUserGroupList *ugl_new_add(PSID *pid, TUserGroupList **ppul) {
  TUserGroupList *ugl;
  DWORD cbName ,cbDomain;
  SID_NAME_USE eUse;
  word Name[UGL_NAME_LENGTH];
  word DomainName[UGL_NAME_LENGTH];

	ugl = xcalloc(sizeof(TUserGroupList));
	ugl->lg = GetLengthSid(pid);
	pnmove(ugl->sid, pid, ugl->lg);

	cbName = cbDomain = UGL_NAME_LENGTH;
	if (LookupAccountSidW(NULL, pid, Name, &cbName, 
				DomainName, &cbDomain, &eUse)) {
	    WCharsToUtf8(ugl->Name, UGL_NAME_LENGTH, Name, 
				pwclen(Name), UC_force_LastChar0);
	    WCharsToUtf8(ugl->DomainName, UGL_NAME_LENGTH, DomainName, 
				pwclen(DomainName), UC_force_LastChar0);
// printf("%s(%d): %d(%s) %d(%s)\n", FL, (int)cbName, ugl->Name, (int)cbDomain, ugl->DomainName);
	}

	while (*ppul) ppul = &(*ppul)->next;
	*ppul = ugl;
	return ugl;
}

/* __________________________ UserList ___________________________________*/
static void ul_free() {
	while (UserList) {
	    TUserGroupList *ul = UserList;
	    UserList = ul->next;
	    xfree(ul);
	}
}

TUserGroupList *ul_getby_uid(PSID *puid) {
  TUserGroupList *ul = UserList;
  dword lg;

	if (!IsValidSid(puid)) return NULL;
	lg = GetLengthSid(puid);
	if (lg > 20) return NULL;
// printf("%s(%d): GetLengthSid=%u\n", FL, lg);
	while (ul && ((ul->lg != lg) || !EqualSid(ul->sid, puid))) ul = ul->next;
	if (!ul) ul = ugl_new_add(puid, &UserList);
	return ul;
}

/* _________________________ GroupList ___________________________________*/
static void gl_free() {
	while (GroupList) {
	    TUserGroupList *gl = GroupList;
	    GroupList = gl->next;
	    xfree(gl);
	}
}

TUserGroupList *gl_getby_gid(PSID *pgid) {
  TUserGroupList *ul = GroupList;
  dword lg;

	if (!IsValidSid(pgid)) return NULL;
	lg = GetLengthSid(pgid);
	if (lg > 20) return NULL;
// printf("%s(%d): GetLengthSid=%u\n", FL, lg);
	while (ul && ((ul->lg != lg) || !EqualSid(ul->sid, pgid))) ul = ul->next;
	if (!ul) ul = ugl_new_add(pgid, &GroupList);
	return ul;
}
/* __________________________ ul gl _____________________________________*/
void ul_gl_free() {
	ul_free();
	gl_free();
}

void ul_gl_init() {
//	ul_gl_free();
//	ul_init();
//	gl_init();
}
