/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <unistd.h>
#include <errno.h>

bool file_read(FileHandle fd, TNetErrRet *ErrRet, void *buf, size_t bufsize, size_t *retsize) {
	if (retsize) *retsize = 0;
#ifdef _OS_WIN32
  DWORD lg;
	if (!ReadFile(fd, buf, bufsize, &lg, NULL)) {
#else
  size_t lg = read(fd, buf, bufsize);
	if ((int)lg == -1) {
#endif
	    if (ErrRet) ErrRet->sys_errno = errno;
	    return False;
	}
	if (retsize) *retsize = lg;
	return True;
}
