/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>
#include <unistd.h>

bool file_rmdir(const char *fn, TNetErrRet *ErrRet) {
  bool result;

#ifdef _OS_WIN32
	word *tmpwc = UTF8topwc(fn);
	result = RemoveDirectoryW(tmpwc) != 0;
	xfree(tmpwc);
#else
	result = rmdir(fn) == 0;
#endif
	if (!result && ErrRet) ErrRet->sys_errno = errno;
	return result;
}

bool file_rmdir_gp(TglobPath *gp, TNetErrRet *ErrRet) {
  char *fn;
  bool result;
	fn = gptopc(gp, gptfu_del_slash|gptfu_noRootArt);
	result = file_rmdir(fn, ErrRet);
	xfree(fn);
	return result;
}
