/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <unistd.h>
#include <errno.h>

bool file_seek(FileHandle fd, TNetErrRet *ErrRet, int64_t Offset) {
#ifdef _OS_WIN32
	if (SetFilePointer(fd, ((ic64)Offset).l[0], &((ic64)Offset).l[1], FILE_BEGIN) == 0xFFFFFFFF) {
#else
	if (lseek64(fd, Offset, SEEK_SET) == -1) {
#endif
	    if (ErrRet) ErrRet->sys_errno = errno;
	    return False;
	}
	return True;
}
