/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <sys/stat.h>

bool file_stat_mode_match(int findAtr, int st_mode) {
  int m;

	if (!(findAtr & 0xff)) return True;
	m = st_mode & S_IFMT;
#ifdef _OS_WIN32
	return (((findAtr & findDIR)  && (m == S_IFDIR)) ||
	  ((findAtr & findCHR)  && (m == S_IFCHR)) ||
	  ((findAtr & findBLK)  && (m == S_IFBLK)) ||
	  ((findAtr & findREG)  && (m == S_IFREG)) ||
	  ((findAtr & findFIFO) && (m == S_IFIFO)));
#else
	return (((findAtr & findDIR)  && (m == S_IFDIR)) ||
	  ((findAtr & findCHR)  && (m == S_IFCHR)) ||
	  ((findAtr & findBLK)  && (m == S_IFBLK)) ||
	  ((findAtr & findREG)  && (m == S_IFREG)) ||
	  ((findAtr & findFIFO) && (m == S_IFIFO)) ||
	  ((findAtr & findLNK)  && (m == S_IFLNK)) ||
	  ((findAtr & findSOCK) && (m == S_IFSOCK)));
#endif
}
