/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

static FILE *file_stream_open_OS(const charOS *FileName, const char *opentype) {
#ifdef _OS_WIN32
  FILE *result;
  word *wo = UTF8topwc(opentype);
	result = _wfopen(FileName, wo);
	xfree(wo);
	return result;
#else
	return fopen(FileName, opentype);
#endif
}

FILE *file_stream_open(const char *FileName, const char *opentype) {
  charOS *fn;
  FILE *result;
	fn = path_to_local_OS(FileName);
	if (!fn) return NULL;
	result = file_stream_open_OS(fn, opentype);
	xfree(fn);
	return result;
}

FILE *file_stream_open_gp(TglobPath *gp, const char *opentype) {
  char *fn;
  FILE *result;

	fn = gptopc(gp, gptfu_noRootArt);
	result = file_stream_open(fn, opentype);
	xfree(fn);
	return result;
}
