/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>
#include <unistd.h>

bool file_unlink_OS(const charOS *fn, TNetErrRet *ErrRet) {
  bool result;
#ifdef _OS_WIN32
	result = DeleteFileW(fn) != 0;
#else
	result = unlink(fn) == 0;
#endif
	if (!result && ErrRet) ErrRet->sys_errno = errno;
	return result;
}

bool file_unlink(const char *fn, TNetErrRet *ErrRet) {
  charOS *tmp;
  bool result;

	tmp = path_to_local_OS_err(fn, ErrRet);
	if (!tmp) return False;
	result = file_unlink_OS(tmp, ErrRet);
	xfree(tmp);
	return result;
}

bool file_unlink_gp(TglobPath *gp, TNetErrRet *ErrRet) {
  char *fn;
  bool result;
	fn = gptopc(gp, gptfu_del_slash|gptfu_noRootArt);
	result = file_unlink(fn, ErrRet);
	xfree(fn);
	return result;
}
