/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <errno.h>
#include <unistd.h>

bool file_write(FileHandle fd, TNetErrRet *ErrRet, const void *buf, 
		size_t bufsize, size_t *retsize) {
	if (retsize) *retsize = 0;
#ifdef _OS_WIN32
  DWORD lg;
	if (!WriteFile(fd, buf, bufsize, &lg, NULL)) {
#else
  size_t lg = write(fd, buf, bufsize);
	if (lg < 0) {
#endif
	    if (ErrRet) ErrRet->sys_errno = errno;
	    return False;
	}
	if (retsize) *retsize = lg;
	return True;
}
