/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <unistd.h>

#ifndef _OS_WIN32
static uid_t uid;
static gid_t gid;
static bool akt;
#endif

#ifdef USE_uC
static bool group_member (gid_t group) {
  int i, n, size;
  gid_t *groups;

	size = 32;
loop:
	groups = alloca(size * sizeof(*groups));
	n = getgroups(size, groups);
	if (n < 0) {
	    size *= 2;
	    goto loop;
	}
	for (i=0;i<n;i++) {
	    if (groups[i] == group) return true;
	}
	return false;
}
#endif

static int file_get_access_st(Tstat64 *st) {
  int result;

	if (!st) return 0;
	result = st->mode;
#ifdef _OS_WIN32
	result >>= 6;
#else
	if (!akt) {
	    akt = true;
	    uid = getuid ();
	    gid = getgid ();
	}
	if (!uid || (st->uid == uid)) {
	    result >>= 6;
	} else if ((st->gid == gid) || group_member(st->gid)) {
	    result >>= 3;
	}
#endif
	return result & (X_OK | W_OK | R_OK);
}

bool file_chk_access_st(Tstat64 *st, int mode) {

	if (!st) return false;
	mode &= (X_OK | W_OK | R_OK);

	if (mode == F_OK) return true;	/* The file exists. */
	return (file_get_access_st(st) & mode) == mode;
}
