/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <sys/stat.h>

#ifndef S_IRGRP
#define	S_IRGRP	(S_IRUSR >> 3)	/* Read by group.  */
//#define	S_IWGRP	(S_IWUSR >> 3)	/* Write by group.  */
#define	S_IXGRP	(S_IXUSR >> 3)	/* Execute by group.  */
#endif

#ifndef S_IROTH
#define	S_IROTH	(S_IRGRP >> 3)	/* Read by others.  */
//#define	S_IWOTH	(S_IWGRP >> 3)	/* Write by others.  */
#define	S_IXOTH	(S_IXGRP >> 3)	/* Execute by others.  */
#endif

#ifdef _OS_WIN32
const int SBIT[9] = {
	0, 0, 0,
	0, 0, 0,
	0, 0, 0};
const int MBIT[9] = {
	S_IRUSR, S_IWUSR, S_IXUSR,
	S_IRGRP, 0, S_IXGRP,
	S_IROTH, 0, S_IXOTH};
#else /* _OS_WIN32 */
const int SBIT[9] = {
	0, 0, S_ISUID,
	0, 0, S_ISGID,
	0, 0, S_ISVTX};
const int MBIT[9] = {
	S_IRUSR, S_IWUSR, S_IXUSR,
	S_IRGRP, S_IWGRP, S_IXGRP,
	S_IROTH, S_IWOTH, S_IXOTH};
#endif /* ! _OS_WIN32 */


const char MODE1[] = "rwxrwxrwx";
const char MODE0[] = "---------";
const char SMODE1[] = "..s..s..t";
const char SMODE0[] = "..S..S..T";
const char TYPECHAR[] = "0pcCd?bB-?l?s???";

void file_str_mode_ppc(char **ppc, Tstat64 *st, int StrModT) {
  int i;
  int mode = 0;
  char *s = *ppc; //xcalloc(32);

	if (st) mode = st->mode;
	if (StrModT & StrModT_Art) {
	    *s = TYPECHAR[((mode >> 12) & 0x0f)];
	    s++;
	}

	for (i=0;i<9;i++) {
	    if (mode & SBIT[i]) {
		if (mode & MBIT[i]) *s = SMODE1[i]; else *s = SMODE0[i];
	    } else {
		if (mode & MBIT[i]) *s = MODE1[i]; else *s = MODE0[i];
	    }
	    s++;
	}
	if (st && (StrModT & StrModT_PlusACL) && (st->st & st_has_ACL_attr)) {
	    *s = '+';
	    s++;
	}
	*s = 0;
	*ppc = s;
}

int file_str_mode_pc(char *pc, Tstat64 *st, int StrModT) {
  char *tmp = pc;
	file_str_mode_ppc(&tmp, st, StrModT);
	return tmp - pc;
}

char *file_str_mode(Tstat64 *st, int StrModT) {
  char tmp[16];
  char *pc = tmp;
	file_str_mode_ppc(&pc, st, StrModT);
	return pcdup(tmp);
}
