/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

void file_str_size_ppc(char **ppc, uint64_t n, int fu) {
  const char *sv;
  dword m;
  int mdnk = 0;

	if (!ppc || !*ppc) return;
	m = n;
	if (n > 0x7ffffff) {	//>128MB
	    m = n >> 20;
	    sv = " MB";
	} else if (m > 0x3fffff) {	//>=4MB
	    m = (m + 0x1ff) >> 10;
	    sv = " MB";
	    mdnk += 0x100;
	} else if (m > 0x0fff) {	//>=4k
	    sv = " kB";
	    mdnk += 0x100;
	} else {
	    sv = " B";
	}
	if (mdnk) m = ((m+50) * 10) >> 10;
	ppcmove_v32(ppc, m, mdnk);
	if (!(fu & fstrSize_space)) sv++;
	ppcmove(ppc, sv);
}

int file_str_size_pc(char *pc, uint64_t n, int fu) {
  char *tmp = pc;
	file_str_size_ppc(&tmp, n, fu);
	return tmp - pc;
}

char *file_str_size(uint64_t n, int fu) {
  char tmp[16];
	file_str_size_pc(tmp, n, fu);
	return pcdup(tmp);
}

