/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include <time.h>

int GlobDateFormat = 0;

static const char *tm_dmY[4] = {
 "%d.%m.%Y",
 "%m.%d.%Y",
 "%Y.%m.%d",
 "%d.%m.%Y"
};

void REGP3 file_str_time_ppc_fu(char **ppc, time_t mtime, int df) {
  char *pc;
  int m;
  char buf[20];

	if (!ppc) return;
	pc = buf;
	ppcmove(&pc, tm_dmY[df & 0x03]);
	if ((df & 0x30) == DateFormat_pHM) {
	    ppcmove(&pc, " %H:%M");
	} else if (df & 0x30) {
	    ppcmove(&pc, " %H:%M:%S");
	}
	pc = *ppc;
	m = 0;
#ifdef _OS_WIN32
  struct tm *ut;
	ut = localtime(&mtime);
	if (ut) m = strftime (pc, 32, buf, ut);
#else
  struct tm ut;
	if (localtime_r(&mtime, &ut)) m = strftime (pc, 32, buf, &ut);
#endif
	if (m > 0) {
	    pc += m;
	    *pc = 0;
	    *ppc = pc;
	} else {
	    ppcmove(ppc, "--.--.--");
	}
}

void file_str_time_ppc(char **ppc, time_t mtime) {
	file_str_time_ppc_fu(ppc, mtime, GlobDateFormat);
}
void file_str_time_HM_ppc(char **ppc, time_t mtime) {
	file_str_time_ppc_fu(ppc, mtime, GlobDateFormat | DateFormat_pHM);
}
void file_str_time_HMS_ppc(char **ppc, time_t mtime) {
	file_str_time_ppc_fu(ppc, mtime, GlobDateFormat | DateFormat_pHMS);
}

/* file_str_time_pc */ 
static int file_str_time_pc_fu(char *pc, time_t mtime, int df) {
  char *ppc = pc;
	file_str_time_ppc_fu(&ppc, mtime, GlobDateFormat | df);
	return ppc - pc;
}

int file_str_time_pc(char *pc, time_t mtime) {
	return file_str_time_pc_fu(pc, mtime, 0);
}
int file_str_time_HM_pc(char *pc, time_t mtime) {
	return file_str_time_pc_fu(pc, mtime, DateFormat_pHM);
}
int file_str_time_HMS_pc(char *pc, time_t mtime) {
	return file_str_time_pc_fu(pc, mtime, DateFormat_pHMS);
}

/* file_str_time */ 
static char *file_str_time_fu(time_t mtime, int df) {
  char tmp[32];
  char *pc = tmp;
	file_str_time_ppc_fu(&pc, mtime, GlobDateFormat | df);
	return pcdup(tmp);
}

char *file_str_time(time_t mtime) {
	return file_str_time_fu(mtime, 0);
}
char *file_str_time_HM(time_t mtime) {
	return file_str_time_fu(mtime, DateFormat_pHM);
}
char *file_str_time_HMS(time_t mtime) {
	return file_str_time_fu(mtime, DateFormat_pHMS);
}
