/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

bool get_pid_stat(Tpid_stat *pid_stat, const char *fn, int fkt) {
  FileHandle fd;
  size_t retsize;
  const char *pc, *pca;
  char buf[1024];

	if (!file_open_rd(fn, NULL, &fd)) return False;
	if (!file_read(fd, NULL, buf, sizeof(buf), &retsize) || (retsize < 32)) {
	    file_close(fd, NULL);
	    return False;
	}
	file_close(fd, NULL);

	pc = buf;
	pid_stat->pid = ppctoint(&pc);
	while (*pc == ' ') pc++;
	if (*pc != '(') return False;
	pc++;
	pca = pc;
	while (*pc && (*pc != ')')) pc++;
	if (!*pc) return False;
	pid_stat->tcomm = NULL;
	if (!(fkt & PIDSTAT_NO_NAME)) pid_stat->tcomm = pcndup(pca, pc-pca);
	pc++;
	if (!*pc) goto err;
	while (*pc == ' ') pc++;
	if (!*pc) goto err;
	pid_stat->state[0] = *pc;
	pid_stat->state[1] = 0;
	pc++;
	pid_stat->ppid = ppctoint(&pc);
	pid_stat->pgrp = ppctoint(&pc);
	pid_stat->sid = ppctoint(&pc);
	pid_stat->tty_nr = ppctoint(&pc);
	pid_stat->tty_pgrp = ppctoint(&pc);
	pid_stat->flags = ppctoint(&pc);
	pid_stat->min_flt = ppctoint(&pc);
	pid_stat->cmin_flt = ppctoint(&pc);
	pid_stat->maj_flt = ppctoint(&pc);
	pid_stat->cmaj_flt = ppctoint(&pc);
	pid_stat->utime = ppctoint(&pc);
	pid_stat->stime = ppctoint(&pc);
	pid_stat->cutime = ppctoint(&pc);
	pid_stat->cstime = ppctoint(&pc);
	pid_stat->priority = ppctoint(&pc);
	pid_stat->nice = ppctoint(&pc);
	pid_stat->num_threads = ppctoint(&pc);
	pid_stat->it_real_value = ppctoint(&pc);
	pid_stat->start_time = ppctoint(&pc);
	pid_stat->vsize = ppctoint(&pc);
	pid_stat->rss = ppctoint(&pc);
	if (!*pc) goto err;

	return True;
err:
	pid_stat_clr(pid_stat);
	return False;
}

void pid_stat_clr(Tpid_stat *pid_stat) {
	if (pid_stat) {
	    ppcfree(&pid_stat->tcomm);
	}
}
