/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "tdirlist.h"

#include "tmime_pv.h"

TMimeObj *TMimeEnum(TMimeObj *mo) {
  TMime_private *pv;
  TMimeObj **ppmo;

	if (!app_mime) return NULL;
	pv = app_mime->private;
	ppmo = pv->mos;
	
	if (mo) {
	    while (*ppmo && (*ppmo != mo)) ppmo++;
	    if (*ppmo) ppmo++;
	}
	return *ppmo;
}

TMimeObj *TMimeObjEnum(TMimeObj *mo) {
	if (!mo) return NULL;
	return mo->next;
}

char *TMimeObjPath(TMimeObj *mo) {
	if (!mo) return NULL;
	if (mo->ObjNy) {
	    TglobPath *gp = TDirListObjNy_Get_gp(mo->ObjNy);
	    return gptopc(gp, gptfu_noPasswd|gptfu_noRootArt);
	} else {
	    return pcdup(mo->altpath);
	}
}

TMimeDat_app *TMimeObjAppEnum(TMimeObj *mo, TMimeDat_app *mda) {
	if (!mo) return NULL;
	if (!mda) return mo->mda;
	return mda->next;
}

const char *TMimeDatAppName(TMimeDat_app *mda) {
	if (!mda) return NULL;
	return mda->fn;
}
