/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#ifndef	__IO_MIME_pv_H__
#define	__IO_MIME_pv_H__    1

#define bfn_max_size		24
#define bexec_max_size		64
#define bname_max_size		24
#define bicon_max_size		24
#define bmimetype_max_size	64
#define bcategories_max_size	40
#define bpattern_max_size	32
#define bcomment_max_size	32

/* TMimeDat.stat */
#define ME_Pic16_NoFound		(1<<8)
#define ME_Pic32_NoFound		(1<<9)




#define AlgTMimeDat struct TCMimeDat *next; \
  struct TCMimeDat *next_hash; \
  TDirFileList *dfl; \
  int type; \
  int stat; \
  struct TPic *pic16; \
  struct TPic *pic32; \
  char *fn; \
  char *icon; \
  char *mimetype; \
  char bfn[bfn_max_size]; \
  char bicon[bicon_max_size]; \
  char bmimetype[bmimetype_max_size];

#define TCMimeDat TMimeDat_x
typedef struct TMimeDat_x {
  AlgTMimeDat
} TMimeDat_x;
#undef TCMimeDat

#define TCMimeDat TMimeDat_app
typedef struct TMimeDat_app {
  AlgTMimeDat
  char *exec;
  char bexec[bexec_max_size];
} TMimeDat_app;
#undef TCMimeDat

#define TCMimeDat TMimeDat_type
typedef struct TMimeDat_type {
  AlgTMimeDat
  char *pattern;
  char bpattern[bpattern_max_size];
} TMimeDat_type;
#undef TCMimeDat

typedef union {
  TMimeDat_app app;
  TMimeDat_type typ;
} TMimeDat_u;

// #define mofu_use_mime_path	1

typedef struct TMimeObj {
  struct TMimeObj *next;
  struct TMimeObj **ppmo_root;
  TMime *mime_self;
  TMimeDat_app *mda;
  TMimeDat_type *mdt;
  TDirListObjNy *ObjNy;
  TDirFileList *dfl;
  int fu;
  char *altpath;  //only set ObjNy==NULL
} TMimeObj;

typedef struct TMime_private {
  TpcIni *exec_start_ini;
  int stat;
  TEv_Array *appEv;
  dword us;
  time_t mtime;
  int64_t size;

  char *path_overwrite;
  char *fn_mime_overwrite;
  TpcIni *overwrite_ini;

  TMimeObj **mos;
  TMimeDat_x *md_hashtable[16];
} TMime_private;

cHIDDEN void TMime_stat_set_mime_id(struct TMime *self, Tstat64 *st, const char *fn);
cHIDDEN struct TPic *TMime_stat_mime_getpic16(TMime *self, Tstat64 *st);
cHIDDEN struct TPic *TMime_stat_mime_getpic32(TMime *self, Tstat64 *st);
extern TMimeDat_x *TMime_get_md(TMime *self, void *md);

#endif /* __IO_MIME_pv_H__ */
