/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include "net_xxx.h"

static ThNetStreamLoader **hNetStreamLd = NULL;

static FILE *net_stream_open_fu_gp(TglobPath *gp, const char *opentype, int fu) {
  ThNetStreamLoader *hLD;

	if (gp_test_local_drive(gp)) {
	    return file_stream_open_gp(gp, opentype);

	} else {
	    hLD = GetNet4_hLD((void*)hNetStreamLd, gp, 2, fu);
	    if (!hLD) return PTR_FAILED;
	    return hLD->stream_open(gp, opentype);
	}
}

FILE *net_stream_open_gp(TglobPath *gp, const char *opentype) {
	return net_stream_open_fu_gp(gp, opentype, hNet_appERR);
}

FILE *net_stream_open_gp_noERR(TglobPath *gp, const char *opentype) {
	return net_stream_open_fu_gp(gp, opentype, 0);
}

bool net_stream_gp_test(TglobPath *gp) {
  ThNetStreamLoader *hLD;
	if (!gp_test_local_drive(gp)) {
	    hLD = GetNet4_hLD((void*)hNetStreamLd, gp, 2, 0);
	    if (!hLD) return False;
	}
	return True;
}

FILE *net_stream_open(const char *fn, const char *opentype) {
  FILE *res;
  TglobPath *gp = pctogp(fn);
	res = net_stream_open_gp(gp, opentype);
	gpFree(gp);
	return res;
}

void ThNetStreamLoader_Reg(int n, ...) {
  va_list args;
	va_start(args, n);
	pp_void_va_add((void*)&hNetStreamLd, n, args);
	va_end(args);
}
