/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

char REGP3 *path_add_noChk(const char *basepath, const char *s) {
  int l1, l2;
  char *pc;
  char *result = NULL;

	l1 = pclen(basepath);
	l2 = pclen(s);
	if (!(l1 | l2)) return NULL;

	result = xmalloc(l1 + l2 + 3);
	pc = result;
	ppcnmove(&pc, basepath, l1);

	if (l1 && l2) {
	    if (TestNoSlash(pc[-1])) {*pc = '/'; pc++;}
	    if (TestSlash(*s)) s++;
	}
	if (l2) pcmove(pc, s);
	return result;
}

char *path_add(const char *basepath, const char *s) {
  int lg;
  char *result;
  xchar xs;
  TPathInfo pathi;

	result = path_add_noChk(basepath, s);
	if (get_PathInfo(result, &pathi)) {
	    xs.s_const = pathi.path_anf;
	    lg = pclen(xs.s);
	    if ((lg > 1) && TestSlash(xs.s[lg-1])) xs.s[lg-1] = 0;
	}
	return result;
}

void path_add_ppc(char **basepath, const char *s) {
  char *tmp;
	if (!basepath) return;
	tmp = path_add(*basepath, s);
	xfree(*basepath);
	*basepath = tmp;
}
