/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

char *path_cut(const char *path, int max_char) {
  char *result;
  int lg;
  char *pc, *pca, *pce;
  TPathInfo pathi;

	if (!get_PathInfo(path, &pathi)) return NULL;

	if (pathi.fu & pathi_Local) {
	    result = dotdot_korr(pathi.path_anf);
	} else {
	    result = dotdot_korr(path);
	}

	lg = pclen(result);
	if ((max_char <= 0) || (lg <= max_char)) return result;

	get_PathInfo(result, &pathi);

	pce = NULL;
	pca = pathi.path_anf_s + 1;
	if (pathi.url_anf && 
	    ((pathi.path_anf - pathi.path + 5 +
	      pclen(GetFileName_pc(pathi.path_anf))) > max_char)) {
	    pca = pathi.url_anf_s;
	}
	pc = pca;
loop:
	while (*pc && TestNoSlash(*pc)) pc++;
	if (TestSlash(*pc)) {
	    pce = pc;
	    pc++;
	    if ((lg + 3 - (pce - pca)) > max_char) goto loop;
	}

	if (pce && ((pce - pca) > 3)) {
	    *pca = '.'; pca++;
	    *pca = '.'; pca++;
	    *pca = '.'; pca++;
	    pcmove(pca, pce);
	}
	return result;
}
