/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "tdirlist.h"

TDirFileList *dfl_create(Tstat64 *st) {
  TDirFileList *dfl;
	dfl = xcalloc(sizeof(TDirFileList) + st->StructSize + 2);
	pnmove(dfl->st, st, st->StructSize);
	dfl->fn = Get_ExFileDat_pc(dfl->st, exfdt_FileName);
	dfl->chstat = chstat_Add;
	return dfl;
}

void TDirListLoader_New_st(TDirListLoader *self, Tstat64 *st, TFileMsg *fmsg) {

// printf("%s(%d): dlbef_New_st %s\n", FL, Get_ExFileDat_pc(st, exfdt_FileName));

	fmsg->art = fmArt_DirList;
	fmsg->typD = fmTyp_int;
	fmsg->D.m = self->obef | dlbef_New_st;
	fmsg->typF = fmTyp_stat;
	fmsg->F.st = st;

	if (self->gp) {
	    fmsg->typR = fmTyp_gp;
	    fmsg->R.gp = self->gp;
	}
	file_msg_ev(fmsg, (TTC0*)self->owner, self->OnFileMsg);
}

TDirFileList *dfl_dup(TDirFileList *org_dfl) {
  TDirFileList *dfl = dfl_create(org_dfl->st);
	return dfl;
}

bool chk_file_ok(Tstat64 *st, const char *path) {
  const char *fn;
  bool root_path;

	fn = Get_ExFileDat_pc(st, exfdt_FileName);
	if (!fn) return False;
	root_path = path && (path[0] == '.') && !path[1];
	if (fn[0] == '.') {
	    if (!fn[1]) return False;
	    if (root_path && (fn[1] == '.') && !fn[2]) return False;
	}

	if (st->st & st_Link) {
	    fn = Get_ExFileDat_pc(st, exfdt_LinkName);
	    if (!fn || ((fn[0] == '.') && !fn[1])) return False;
	}
	return True;
}

bool chk_pattern_match(TPattern *patt, const char *fn, Tstat64 *st) {
	if (!patt || !patt->match_pattern) return True;
	return patt->match_pattern(patt, fn, st);
}
