/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "xcopy_pv.h"

static const char *warn_msgstr[3] = {
  "general", 
  "overwrite dir",
  "overwrite file",
};

static const char *err_msgstr[13] = {
  "general", 
  "src not exist",
  "dest not exist",
  "overwrite type",
  "overwrite type dest is dir",
  "same file",
  "del file",
  "open read",
  "open write",
  "make dir",
  "make link",
  "make node",
  "type",
};

const char *XCopy_GetMsg_pc(TXCopy_wd *wd, int xcyMsg) {
  int bef = xcyMsg & xpyMsg_NrMask;

	if (xcyMsg & xpyErr_Alg) {
	    if (bef > 13) bef = 0;
	    return err_msgstr[bef];
	}
	if (bef > 2) bef = 0;
	return warn_msgstr[bef];
}
