/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "cpuid.h"

#if defined (__arm__)
dword GetCPU_Flags() {
	return 0;
}
#elif defined(__i386__) || defined(__x86_64__)
static dword CPU_Flags = 0;

dword GetCPU_Flags() {
  TCPUID *id;
  int i;
	if (!CPU_Flags) {
	    id = xcalloc(sizeof(TCPUID));
	    i = Get_CPUID(id);
	    CPU_Flags = 0x80000000;
	    if (i) {
		if (id->FeatureFlags1 & MMX_FLAG)  CPU_Flags |= CPU_has_MMX;
		if (id->FeatureFlags1 & SSE_FLAG) {
		    CPU_Flags |= CPU_has_SSE;
		    if (id->FeatureFlags1 & SSE2_FLAG) CPU_Flags |= CPU_has_SSE2;
		    if (id->FeatureFlags1 & SSE3_FLAG) CPU_Flags |= CPU_has_SSE3;
		}
		if (id->FeatureFlags0 & TSC_FLAG) CPU_Flags |= CPU_has_TSC;
	    }
	    xfree(id);
	}
	return CPU_Flags & 0x7fffffff;
}
#else
# error "Unsupported architecture!"
#endif
