/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball

i386 regparm(3)  arguments in registers EAX, EDX, and ECX
x86_64 arguments in registers RDI, RSI, RDX, RCX, r8, r9 / XMM0-7
*/
//	.align 4

#ifdef _OS_WIN32
.global _Get_CPUID
_Get_CPUID:
#else
.globl Get_CPUID
	.type	 Get_CPUID,@function
Get_CPUID:
#endif

#ifdef __x86_64__
#define DREG %rdi
	push	%rbx
#else
#define DREG %edi
	push	DREG
	push	%esi
	push	%ebx
	mov	%eax, DREG
	pushf
	pop	%eax
	mov	%eax, %ecx
	xor	$0x200000, %eax
	push	%eax
	popf
	pushf
	pop	%eax
	xor	%eax, %ecx
       jz      no_CPUID
#endif

	mov	$0, %eax
       call    rd_CPUID_save
	mov	$0, %eax
	mov	%eax, (DREG)
	add	$0x04, DREG

	mov	$1, %eax
       call    rd_CPUID_save

	mov	$2, %eax
       call    rd_CPUID_save
    // Test Ext
	mov	$0x80000000, %eax
       call    rd_CPUID_save
	cmp	$0x80000004, %eax
       jb      no_Processor_Name
	sub	$0x80000003, %eax
	mov	%eax, %esi
    // Ext1_FeatureFlag
	mov	$0x80000001, %eax
	CPUID
	mov	%edx, (DREG)
	add	$0x04, DREG
    // ProcessorName
	mov	$0x80000002, %eax
       call    rd_CPUID_save
	mov	$0x80000003, %eax
       call    rd_CPUID_save
	mov	$0x80000004, %eax
       call    rd_CPUID_save

	dec	%esi
       jz      ext_End
	mov	$0x80000005, %eax
       call    rd_CPUID_save
    // Ext6_L2
	dec	%esi
       jz      ext_End
	mov	$0x80000006, %eax
       call    rd_CPUID_save

	dec	%esi
       jz      ext_End
	mov	$0x80000007, %eax
       call    rd_CPUID_save

	dec	%esi
       jz      ext_End
	mov	$0x80000008, %eax
       call    rd_CPUID_save

ext_End:
	mov	$2, %eax
       jmp	no_CPUID

no_Processor_Name:
	mov	$1, %eax
no_CPUID:
#ifdef __x86_64__
	pop	%rbx
#else
	pop	%ebx
	pop	%esi
	pop	DREG
#endif
       ret

rd_CPUID_save:
	CPUID;
save_CPUID:	mov	%eax, 0x00(DREG)
	mov	%ebx, 0x04(DREG)
	mov	%ecx, 0x08(DREG)
	mov	%edx, 0x0c(DREG)
	add	$0x10, DREG
       ret;

	.align 4

#ifdef _OS_WIN32
.global _Get_TSC
_Get_TSC:
#else
.globl Get_TSC
	.type	 Get_TSC,@function
Get_TSC:
#endif
#ifdef __x86_64__
	rdtsc;
	mov	%eax, 0x00(%rdi)
	mov	%edx, 0x04(%rdi)
#else
	mov	%eax, %ecx
	rdtsc;
	mov	%eax, 0x00(%ecx)
	mov	%edx, 0x04(%ecx)
#endif
       ret

