/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/


#include "sysbase.h"


#if defined (__arm__)

#if (!defined (__ARM_ARCH_2__) && !defined (__ARM_ARCH_3__) \
     && !defined (__ARM_ARCH_3M__) && !defined (__ARM_ARCH_4__) \
     && !defined (__ARM_ARCH_4T__) && !defined (__ARM_ARCH_5__) \
     && !defined (__ARM_ARCH_5T__))
void REGP2 atomic_and(dword *var, dword op) {
	dword tmp, tmp2;

	__asm__ __volatile__(
"1:	ldrex	%0, [%2]\n"
"	and	%0, %0, %3\n"
"	strex	%1, %0, [%2]\n"
"	teq	%1, #0\n"
"	bne	1b"
	: "=&r" (tmp), "=&r" (tmp2)
	: "r" (var), "Ir" (op)
	: "cc");
}

void REGP2 atomic_or(dword *var, dword op) {
	dword tmp, tmp2;

	__asm__ __volatile__(
"1:	ldrex	%0, [%2]\n"
"	orr	%0, %0, %3\n"
"	strex	%1, %0, [%2]\n"
"	teq	%1, #0\n"
"	bne	1b"
	: "=&r" (tmp), "=&r" (tmp2)
	: "r" (var), "Ir" (op)
	: "cc");
}
#else /* ARM_ARCH_6 */

void REGP2 atomic_and(dword *var, dword op) {
	*var &= op;
}

void REGP2 atomic_or(dword *var, dword op) {
	*var |= op;
}
#warning "TODO atomic_op ! "
#endif /* __LINUX_ARM_ARCH__ */

#elif defined(__i386__) || defined(__x86_64__)
void REGP2 atomic_and(dword *var, dword op) {
  __asm__ __volatile__("lock; and %1, %0;"
	    	       : : "m"(*var), "r" (op));
}

void REGP2 atomic_or(dword *var, dword op) {
  __asm__ __volatile__("lock; or %1, %0;"
	    	       : : "m"(*var), "r" (op));
}
#else
# error "Unsupported architecture!"
#endif
