/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

void SetBits8(TBitsIO *bits, int v, int n) {
	bits->buf |= (v & ((1 << n) - 1)) << bits->k;
	bits->k += n;
	while (bits->k >= 8) {
	    if (bits->io.wr_byte) {
		bits->io.wr_byte(bits->io_struct, bits->buf);
	    } else {
		*bits->dat = bits->buf;
		bits->dat++;
	    }
	    bits->buf >>= 8; 
	    bits->k -= 8;
	}
}

void SetBits8End(TBitsIO *bits) {
	if (bits->k) {
	    if (bits->io.wr_byte) {
		bits->io.wr_byte(bits->io_struct, bits->buf);
	    } else {
		*bits->dat = bits->buf;
		bits->dat++;
	    }
	    bits->k = bits->buf = 0;
	}
} 

int GetBits8(TBitsIO *bits, int n) {
  dword m;

	while (n > bits->k) {
	    if (bits->io.rd_byte) {
		m = bits->io.rd_byte(bits->io_struct);
	    } else {
		m = *bits->dat;
		bits->dat++;
	    }
	    bits->buf |= m << bits->k;
	    bits->k += 8;
	}
	m = bits->buf & ((1 << n) - 1);
	bits->buf >>= n;
	bits->k -= n;
	return m;
}

void REGP2 SetBits8Data(TBitsIO *bits, const byte *dat) {
	bits->dat_const = dat;
	bits->buf = bits->k = 0;
}
