/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

void nmove(void **dest, const void *src, long len) {
  char *p;
	if (!dest || !*dest || !src || (len < 1)) return;
	p = *dest;
	memmove(p, src, len);
	p += len;
	*dest = p;
}

void pnmove(void *dest, const void *src, long len) {
	if (!dest || !src || (len < 1)) return;
	memmove(dest, src, len);
}

long ppcmove(char **dest, const char *src) {
	if (!dest || !*dest || !src) return 0;
  char *pc = *dest;
//  int len = strlen(src);
  long len = pclen(src);
	if (len > 0) memmove(pc, src, len);
	pc += len;
	*pc = 0;
	*dest = pc;
	return len;
}

long pcmove(char *dest, const char *src) {
	if (!dest || !src) return 0;
//  int len = strlen(src);
  long len = pclen(src);
	if (len > 0) memmove(dest, src, len);
	dest[len] = 0;
	return len;
}

void pcnmove(char *dest, const char *src, long len) {
	if (!dest || !src || (len < 0)) return;
	if (len > 0) memmove(dest, src, len);
	dest[len] = 0;
}
void ppcnmove(char **dest, const char *src, long len) {
	if (!dest || !*dest || !src || (len < 0)) return;
  char *pc = *dest;
	if (len > 0) memmove(pc, src, len);
	pc += len;
	*pc = 0;
	*dest = pc;
}

int pcxmove(char *dest, const char *src, long max_len) {
	if (!dest || !src || (max_len < 0)) return 0;
//  int len = strlen(src);
  long len = pclen(src);
	if (len > max_len) len = max_len;
	if (len > 0) memmove(dest, src, len);
	dest[len] = 0;
	return len;
}
