/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under the LGPL v2.1, see the file COPYING.LIB
*/

#include "sysbase.h"

dword Get_WChar(int idx, const char *pc, int lg, bool UTF8on) {
	if (!pc || (idx >= lg) || (idx < 0)) return 0;
	if (UTF8on) return Utf8CharToWChar(&pc[idx]);
	return ((const byte*)pc)[idx];
}

dword GetNext_WChar(int *idx, const char *pc, int lg, bool UTF8on) {
	if (!pc || (*idx >= lg)) return 0;
	if (UTF8on) {
	    *idx += (get_Utf8Chars(&pc[*idx]) & ~Char_ErrorUTF8); 
	} else (*idx)++;
	if (*idx >= lg) return 0;
	if (UTF8on) return Utf8CharToWChar(&pc[*idx]);
	return ((const byte*)pc)[*idx];
}

dword GetPrev_WChar(int *idx, const char *pc, bool UTF8on) {
	if (!pc || (*idx < 0)) return 0;
	if (*idx > 0) {
	    if (UTF8on) DecUtf8Idx(idx, pc); else (*idx)--;
	}
	if (UTF8on) return Utf8CharToWChar(&pc[*idx]); 
	return ((const byte*)pc)[*idx];
}

