/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include "gp.h"


const char *pcsetgp_url(TglobPath *gp, const char *url, int URL_lg) {
  const char *pcn, *result;
  
	result = url;
	if (gp) {
	    ppcfree(&gp->user);
	    ppcfree(&gp->passwd);
	    ppcfree(&gp->URL);

	    if (url) {
		if (URL_lg <= 0) {
		    while (TestSlash(*url)) url++;
		    pcn = url;
		    while (*pcn && TestNoSlash(*pcn)) pcn++;
		    URL_lg = pcn - url;
		}
		result += URL_lg;
		while (*result && TestSlash(result[1])) result++;

		gpset_url_pv(gp, url, URL_lg);
	    }
	}
	return result;
}

const char *pcsetgp_path(TglobPath *gp, const char *path) {
  const char *result;

	result = path;
	if (gp) {
	    ppcfree(&gp->path);
	    if (path && TestSlash(*path)) {
		while (TestSlash(path[1])) path++;
		return gpset_path_pv(gp, path);
	    }
	}
	return result;
}
