/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include "gp.h"

void REGP3 gpset_url_pv(TglobPath *gp, const char *url, int URL_lg) {
  const char *pcn, *pcu, *pcp;

	pcn = pcu = pcp = url;
	while (URL_lg) {
	    if (*pcn == ':') {
		ppcnchange(&gp->user, pcu, pcn-pcu);
		pcp = pcn+1;
	    } else if (*pcn == '@') {
		if (gp->user) ppcnchange(&gp->passwd, pcp, pcn-pcp);
		else ppcnchange(&gp->user, pcp, pcn-pcp);
		pcu = pcn+1;
	    } 
	    pcn++; URL_lg--;
	}
	gp->URL = pcndup(pcu, pcn-pcu);
}

const char REGP3 *gpset_path_pv(TglobPath *gp, const char *path) {
	if (!path) return path;
	const char *result = GetFileName_pc(path);
	int path_lg = result - path;
	if (path_lg > 0) gp->path = pcndup(path, path_lg);
	return result;
}

void pcsetgp(TglobPath *gp, const char *fn) {
  const char *pcn;
  TPathInfo pathi;

	if (!gp) return;
	gp_pc_free(gp);

	if (!get_PathInfo(fn, &pathi)) goto ende;

	gp->fu = pathi.fu;
	if (pathi.fu & pathi_rel) {
	    gp->fu |= gpi_Local;
	    WARN_1("%s(%d): WARN: rel path \"%s\"\n", FL, fn);
	}

#ifdef _OS_WIN32
	if (pathi.fu & pathi_SMB) {
	    gp->fu |= gpi_RA_SMB;
	    gp->RootArt = pcdup("smb:");
	} else
#endif
	if (pathi.RA_lg && !(pathi.fu & pathi_RA_file)) {
	    gp->RootArt = pcndup(fn, pathi.RA_lg);
	}

	if (pathi.url_anf) gpset_url_pv(gp, pathi.url_anf, pathi.URL_lg);

	pcn = gpset_path_pv(gp, pathi.path_anf);
	gp->name = pcdup(pcn);
ende:
	slash_korr(gp->path, False);
}

TglobPath *pctogp(const char *fn) {
  TglobPath *gp = xcalloc(sizeof(TglobPath));

	pcsetgp(gp, fn);
	return gp;
}


