/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball

regparm(3)  arguments in registers EAX, EDX, and ECX
*/

#define USE_SMALL 0

#define USE_MMX 0
//#define ONLY_MMX 1

nmove_down:
	mov	%eax,%ecx
	add	%esi,%ecx
	cmp	%edi,%ecx
       jle	nmove_up
	push	%edi
	lea	-4(%esi,%eax),%esi
	lea	-4(%edi,%eax),%edi
	std
#if USE_SMALL == 0
	cmp	$32, %eax
       jle	2f
	mov	$3,%ecx
	bt	$0,%esi
       jnc	1f
	add	%ecx,%esi
	add	%ecx,%edi
	movsb
	dec	%eax
	sub	%ecx,%esi
	sub	%ecx,%edi
1:
	bt	$1,%esi
       jnc	2f
	dec	%ecx
	add	%ecx,%esi
	add	%ecx,%edi
	movsw
	sub	%ecx,%eax
	sub	%ecx,%esi
	sub	%ecx,%edi
2:
#endif /* USE_SMALL == 0 */
	mov	%eax,%ecx
	shr	$2,%ecx
	rep	movsd
	mov	%eax,%ecx
	and	$0x03,%ecx
	add	$3,%esi
	add	$3,%edi
	rep	movsb
	pop	%edi
	cld
adj_edi:
	pop	%eax
	lea	(%edi,%eax),%edi
nmove_ret:
       ret

nmove_getlen:
	xor	%eax,%eax
	mov	%esi,%ecx
       jmp	2f
1:
	inc	%esi
2:
	cmpb	(%esi),%al
       jnz	1b
	sub	%ecx,%esi
	lea	1(%esi),%eax
	mov	%ecx,%esi
nmove_regA:
	test	%eax,%eax
       jle	nmove_ret
	push	%eax
	cmp	%esi,%edi
       je	adj_edi
       jg	nmove_down

nmove_up:
	cld
#if USE_SMALL == 0
	cmp	$23, %eax
       jl	nmove_4
	bt	$0,%edi
       jnc	1f
	movsb
	dec	%eax
1:
	bt	$1,%edi
       jnc	2f
	movsw
	sub	$2,%eax
2:
	bt	$2,%edi
       jnc	4f
	movsd
	sub	$4,%eax
4:
#if USE_MMX
	mov	%eax,%ecx
	shr	$4,%ecx
5:
	movq	(%esi),%mm0
	movq	8(%esi),%mm1
	lea	16(%esi), %esi
	movq	%mm0,(%edi)
	movq	%mm1,8(%edi)
	lea	16(%edi), %edi
	dec	%ecx
       jnz	5b
	emms
	and	$0x0f,%eax
#else
#if 0
	test	$7,%esi
       jz	nmove_4
	push %eax
	push %ebx
	mov	%eax,%ecx
	shr	$3,%ecx
5:
	mov	(%esi),%eax
	mov	4(%esi),%ebx
	lea	8(%esi), %esi
	mov	%eax,(%edi)
	mov	%ebx,4(%edi)
	lea	8(%edi), %edi
	dec	%ecx
       jnz	5b
	pop %ebx
	pop %eax
	and	$0x07,%eax
#else

	push %eax
	push %ebx
	push %edx
	push %ebp
	mov	%eax,%ecx
	shr	$4,%ecx
5:
	mov	(%esi),%eax
	mov	4(%esi),%ebx
	mov	8(%esi),%edx
	mov	12(%esi),%ebp
	lea	16(%esi),%esi
	dec	%ecx
	mov	%eax,(%edi)
	mov	%ebx,4(%edi)
	mov	%edx,8(%edi)
	mov	%ebp,12(%edi)
	lea	16(%edi),%edi
       jnz	5b
	pop %ebp
	pop %edx
	pop %ebx
	pop %eax
	and	$0x0f,%eax
#endif
#endif

nmove_4:
#endif /* USE_SMALL == 0 */
	mov	%eax,%ecx
	shr	$2,%ecx
	rep	movsd
	mov	%eax,%ecx
	and	$0x03,%ecx
	rep	movsb
	pop	%eax
       ret

// ----------------------------------------------------------
chk_ppl:
	mov	0x18(%esp),%eax
	test	%eax,%eax
       jl	chk_err
chk_pp:
	mov	0x10(%esp),%edx
	test	%edx,%edx
       jz	chk_err
	mov	(%edx),%edi
       jmp	chk_edi
chk_pl:
	mov	0x18(%esp),%eax
	test	%eax,%eax
       jl	chk_err
chk_p:
	mov	0x10(%esp),%edi
chk_edi:
	mov	0x14(%esp),%esi
	test	%edi,%edi
       jz	chk_err
	test	%esi,%esi
       jz	chk_err
       ret
chk_err:
	xor	%eax,%eax
	pop	%edi
	pop	%edi
	pop	%esi
       ret
// ----------------------------------------------------------

#ifdef _OS_WIN32
.global _ppcnmove
_ppcnmove:
#else
.globl ppcnmove
	.type	 ppcnmove,@function
ppcnmove:
#endif
	push	%esi
	push	%edi
       call	chk_ppl
       call	nmove_regA
	movb	$0,(%edi)
	mov	%edi,(%edx)
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _pcnmove
_pcnmove:
#else
.globl pcnmove
	.type	 pcnmove,@function
pcnmove:
#endif
	push	%esi
	push	%edi
       call	chk_pl
       call	nmove_regA
	movb	$0,(%edi)
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _pnmove
_pnmove:
#else
.globl pnmove
	.type	 pnmove,@function
pnmove:
#endif
	push	%esi
	push	%edi
       call	chk_pl
       call	nmove_regA
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _nmove
_nmove:
#else
.globl nmove
	.type	 nmove,@function
nmove:
#endif
	push	%esi
	push	%edi
       call	chk_ppl
       call	nmove_regA
	mov	%edi,(%edx)
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _ppcmove
_ppcmove:
#else
.globl ppcmove
	.type	 ppcmove,@function
ppcmove:
#endif
	push	%esi
	push	%edi
       call	chk_pp
       call	nmove_getlen
	dec	%eax
	dec	%edi
	mov	%edi,(%edx)
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _pcmove
_pcmove:
#else
.globl pcmove
	.type	 pcmove,@function
pcmove:
#endif
	push	%esi
	push	%edi
       call	chk_p
       call	nmove_getlen
	dec	%eax
	pop	%edi
	pop	%esi
       ret

#ifdef _OS_WIN32
.global _pcxmove
_pcxmove:
#else
.globl pcxmove
	.type	 pcxmove,@function
pcxmove:
#endif
	push	%esi
	push	%edi
       call	chk_pl
	push	%edi
	push	%eax
	mov	%esi,%edi
	mov	%eax,%ecx
	xor	%eax,%eax
	repne	scasb
       jne	1f
	inc	%ecx
1:
	pop	%eax
	pop	%edi
	sub	%ecx, %eax
       jg	2f
	xor	%eax,%eax
2:
       call	nmove_regA
	movb	$0,(%edi)
	pop	%edi
	pop	%esi
       ret
