/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

#define tiMaxLineLg	16384

void TpcIni_Save(TpcIni *self) {
  TGruppe *Gp;
  TGruppeDat *Gpd;
  FILE *fd;
  char line[1024];

	if (!self || !self->Changed) return;

	self->Changed = False;
	fd = file_stream_open(self->FileName, "w");
	if (!fd) return;

	if (self->BOM_UTF8) {
	    line[0] = 0xEF;
	    line[1] = 0xBB;
	    line[2] = 0xBF;
	    line[3] = 0x00;
	    fputs(line, fd);
	}

	Gp = self->Gruppe0;
	while (Gp) {
	    snprintf(line, sizeof(line), "[%s]\n", Gp->name);
	    fputs(line, fd);
	    Gpd = Gp->Dat;
	    while (Gpd) {
		if (Gpd->org) fputs(Gpd->org, fd);
		fputs("\n", fd);
		Gpd = Gpd->next;
	    }
	    Gp = Gp->next;
	}
	fclose(fd);
}

void TpcIni_SaveAndFree(TpcIni *self) {
	TpcIni_Save(self);
	Tfree(self);
}

void TpcIni_WR(TpcIni *self, const char *Gruppe, const char *Funkt, const char *Dat) {
  int lg;
  TGruppeDat *Gpd = NULL;
  char line[tiMaxLineLg];
  bool mk;

	mk = True;
	if (Funkt && Dat) {
	    snprintf(line, tiMaxLineLg, "%s=%s", Funkt, Dat);
	} else if (Funkt) {
	    snprintf(line, tiMaxLineLg, "%s=", Funkt);
	} else if (Dat) {
	    pcxmove(line, Dat, tiMaxLineLg);
	    TpcIni_FindGruppe(self, Gruppe); // init self->lastGp
	    mk = False;
	} else return;

	if (mk) Gpd = TpcIni_FindGruppeDat(self, Gruppe, Funkt);
	if (Gpd) {
	    if (!pccmp(Gpd->dat, Dat)) {
		lg = pclen(line);
		TpcIni_ChangeGruppeDat(self, lg, line, Gpd);
		self->Changed = True;
	    }
	} else {
	    self->Changed = True;
	    if (!self->lastGp) {
		lg = pclen(Gruppe);
		if (lg) TpcIni_AddGruppe(self, lg, Gruppe);
	    }
	    if (self->lastGp) {
		self->npGruD = &self->lastGp->Dat;
		while (*self->npGruD) self->npGruD = &(*self->npGruD)->next;
		lg = pclen(line);
		TpcIni_AddGruppeDat(self, lg, line);
	    }
	}
}
