/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

static void  __attribute__ ((noinline)) LB8_GetLineEOL_lgs(TLineBuf *lb, Tlgs *lgs, int *fuEOL) {
  int i, max, lg;
  char *tmp, *pcs;
  int lgEOL = 0;
  bool EOL0;

	max = lb->maxLineLen;
	if (max <= 0) max = 1024;

	pcs = lb->pc;
	if (lb->pc_rdidx) pcs = lb->pc_rdidx;

	tmp = pcs;
	EOL0 = (*fuEOL & fio_add_EOL_0) != 0;
	lg = lb->lg;
	for (i=0; lg>0; i++) {
	    if ((i >= max) || 
		(*tmp == 10) || 
		((*tmp == 13) && (lg > 1) && (tmp[1] == 10)) || 
		(!*tmp && EOL0)) {

		lgs->lg = i;
		lgs->s = pcs;

		if (*tmp == 10) {
		    *fuEOL |= fio_EOLunix;
		    lgEOL = 1;
		    tmp++;
		    lg--;
		} else if ((*tmp == 13) && (lg > 1) && (tmp[1] == 10)) {
		    *fuEOL |= fio_EOLwindos;
		    lgEOL = 2;
		    tmp += 2;
		    lg -= 2;
		} else if (!*tmp && EOL0) {
		    *fuEOL |= fio_EOL_0;
		    lgEOL = 1;
		    tmp++;
		    lg--;
		} else *fuEOL |= fio_EOLnone;
		lb->lg = lg;
		lb->pc_rdidx = tmp;
		if ((*fuEOL & fio_GetLgPlusEOL)) lgs->lg += lgEOL;
		break;
	    }
	    lg--;
	    tmp++;
	}

	if (!lgs->s && lb->eof) {
	    lgs->s = pcs;
	    lgs->lg = lb->lg;
	    *fuEOL |= (fio_EOLnone | fio_EOF);
	    lb->lg = 0;
	}
}

static void __attribute__ ((noinline)) LB16_GetLineEOL_lgs(TLineBuf *lb, Tlgs *lgs, int *fuEOL) {
  int i, max, reslg, lg;
  word *tmp, *pcs, *ress;
  dword c, c2;
  int lgEOL = 0;
  int UCfu = 0;
  bool BE, EOL0;


	if ((*fuEOL & fio_txtTyp_Mask) == fio_txtTyp_UnicodeBE) UCfu = UC_WCharBE;
	if (*fuEOL & fio_force_ASCII) UCfu |= UC_force_ASCII;

	max = lb->maxLineLen;
	if (max <= 0) max = 1024;

	reslg = 0;
	ress = NULL;
	pcs = (word*)lb->pc;
	if (lb->pc_rdidx) pcs = (word*)lb->pc_rdidx;

	tmp = pcs;
	BE = (UCfu & UC_WCharBE) != 0;
	EOL0 = (*fuEOL & fio_add_EOL_0) != 0;

	lg = lb->lg >> 1;
	for (i=0;lg>0;i++) {

	    c = *tmp;
	    c2 = 0;
	    if (lg > 1) c2 = tmp[1];
	    if (BE) {
		c = ((c & 0xff)<<8)+((c >> 8) & 0xff);
		c2 = ((c2 & 0xff)<<8)+((c2 >> 8) & 0xff);
	    }
	    if ((i >= max) || (c == 10) || ((c == 13) && (c2 == 10)) || (EOL0 && !c)) {
		lb->lg -= i<<1;
		reslg = i;
		ress = pcs;
		if (c == 10) {
		    *fuEOL |= fio_EOLunix;
		    lgEOL = 1;
		    tmp++;
		    lb->lg -= 2;
		} else if ((c == 13) && (c2 == 10)) {
		    *fuEOL |= fio_EOLwindos;
		    lgEOL = 2;
		    tmp += 2;
		    lb->lg -= 4;
		} else if (EOL0 && !c) {
		    *fuEOL |= fio_EOL_0;
		    lgEOL = 1;
		    tmp++;
		    lb->lg -= 2;
		} else *fuEOL |= fio_EOLnone;
		lb->pc_rdidx = (char*)tmp;
		if ((*fuEOL & fio_GetLgPlusEOL)) reslg += lgEOL;
		break;
	    }
	    lg--;
	    tmp++;
	}

	if (!ress && lb->eof) {
	    ress = pcs;
	    reslg = lb->lg >> 1;
	    *fuEOL |= fio_EOLnone | fio_EOF;
	    lb->lg = 0;
	}

	if (!lb->UTF8_buf || ((reslg<<2) > lb->UTF8_buf_size)) {
	    if (max < reslg) max = reslg;
	    lb->UTF8_buf_size = max << 2;
	    lb->UTF8_buf = xmalloc(lb->UTF8_buf_size);
	}

	if (ress) {
	    lgs->lg = WCharsToUtf8(lb->UTF8_buf, lb->UTF8_buf_size, ress, reslg, UCfu);
	    lgs->s = lb->UTF8_buf;
	}
}

bool TLineBuf_GetLineEOL_lgs(TLineBuf *lb, Tlgs *lgs, int *fuEOL) {
  int tmpEOL = 0;

	lgs->s = NULL;
	lgs->lg = 0;

	if (!fuEOL) fuEOL = &tmpEOL;
	if (lb->lg <= 0) goto chk_EOF;

	if (*fuEOL & fio_Chk_BOM) {
	    int lg_off = 0;
	    byte *pcs = (byte*)lb->pc;
	    if (lb->pc_rdidx) pcs = (byte*)lb->pc_rdidx;

	    *fuEOL &= ~fio_txtTyp_Mask_BOM;
	    if ((lb->lg > 2) && (pcs[0] == 0xef) && (pcs[1] == 0xbb) && (pcs[2] == 0xbf)) {
		*fuEOL |= fio_txtTyp_UTF8;
		lg_off = 3;
	    } else if ((lb->lg > 1) && (*((word*)pcs) == 0xfeff)) {
		*fuEOL |= fio_txtTyp_Unicode;
		lg_off = 2;
	    } else if ((lb->lg > 1) && (*((word*)pcs) == 0xfffe)) {
		*fuEOL |= fio_txtTyp_UnicodeBE;
		lg_off = 2;
	    }
	    if (lg_off) {
		lb->pc_rdidx = (char*)(pcs + lg_off);
		lb->lg -= lg_off;
		*fuEOL |= fio_has_BOM;
	    }
	    *fuEOL &= ~fio_Chk_BOM;
	    if (!lb->lg) goto chk_EOF;
	}

	*fuEOL &= ~fio_Res_Mask;

	if (*fuEOL & fio_txtTyp_Unicode) {
	    LB16_GetLineEOL_lgs(lb, lgs, fuEOL);
	} else {
	    LB8_GetLineEOL_lgs(lb, lgs, fuEOL);
	}

	Chk_fio_UTF8_lgs(lgs, fuEOL);

chk_EOF:
	if (lb->eof) {
	    if (*fuEOL & fio_txtTyp_Unicode) {
		if (lb->lg < 2) *fuEOL |= fio_EOF;
	    } else {
		if (lb->lg < 1) *fuEOL |= fio_EOF;
	    }
	}

	return (lgs->s != NULL);
}
