/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"


//input Ascii or UTF8 !!!

void TLineBuf_SetLineEOL_lgs(TLineBuf *lb, Tlgs *lgs, int *fuEOL) {
  int tmpfuEOL = 0;
  int EOL = 0;
  int EOL_lg = 0;
  int mEOL;
  int txtTyp;
  int UCfu, dlg, dlgc;
  char *pcd;

	if (fuEOL) tmpfuEOL = *fuEOL;

	txtTyp = (tmpfuEOL & fio_txtTyp_Mask);
	if (tmpfuEOL & fio_Chk_BOM) {
	    int iBOM = 0;
	    int tmp_lg = 2;
	    if (txtTyp == fio_txtTyp_UTF8) {
		iBOM = 0x00bfbbef;
		tmp_lg = 3;
	    } else if (txtTyp == fio_txtTyp_Unicode) {
		iBOM = 0x0000feff;
	    } else if (txtTyp == fio_txtTyp_UnicodeBE) {
		iBOM = 0x0000fffe;
	    }
	    if (iBOM) TLineBuf_Add(lb, (char*)&iBOM, tmp_lg);
	    if (fuEOL) *fuEOL &= ~fio_Chk_BOM;
	}

	mEOL = tmpfuEOL & fio_EOL_Mask;
	if (mEOL) {
	    if (txtTyp == fio_txtTyp_Unicode) {
		if (mEOL == fio_EOLunix) {
		    EOL = 0x0000000a;
		    EOL_lg = 2;
		} else if (mEOL == fio_EOLwindos) {
		    EOL = 0x000a000d;
		    EOL_lg = 4;
		} else if (mEOL == fio_EOL_0) {
		    EOL_lg = 2;
		}
	    } else if (txtTyp == fio_txtTyp_UnicodeBE) {
		if (mEOL == fio_EOLunix) {
		    EOL = 0x00000a00;
		    EOL_lg = 2;
		} else if (mEOL == fio_EOLwindos) {
		    EOL = 0x0a000d00;
		    EOL_lg = 4;
		} else if (mEOL == fio_EOL_0) {
		    EOL_lg = 2;
		}
	    } else {
		if (mEOL == fio_EOLunix) {
		    EOL = 0x0000000a;
		    EOL_lg = 1;
		} else if (mEOL == fio_EOLwindos) {
		    EOL = 0x00000a0d;
		    EOL_lg = 2;
		} else if (mEOL == fio_EOL_0) {
		    EOL_lg = 1;
		}
	    }
	}

	UCfu = 0;
	if (txtTyp == fio_txtTyp_UnicodeBE) UCfu = UC_WCharBE;
	if (tmpfuEOL & fio_force_ASCII) UCfu |= UC_force_ASCII;

	dlg = dlgc = 0;
	if (lgs->s && (lgs->lg > 0)) {
	    dlg = dlgc = lgs->lg;
	    if (txtTyp & fio_txtTyp_Unicode) {
		dlgc = Utf8ToWChars(NULL, 0, lgs->s, lgs->lg, UCfu);
		dlg = (dlgc << 1);
	    } else if ((UCfu & UC_force_ASCII) &&
		       (txtTyp == fio_txtTyp_UTF8)) {
		dlg = dlgc = AsciiToUtf8(NULL, 0, lgs->s, lgs->lg);
	    }
	}

	if ((dlg + EOL_lg) <= 0) return;
	pcd = TLineBuf_Set_mem(lb, dlg + EOL_lg + 1);
	
	if (dlg > 0) {
	    if (txtTyp & fio_txtTyp_Unicode) {
		int m = Utf8ToWChars((word*)pcd, dlgc, lgs->s, lgs->lg, UCfu);
		pcd += (m << 1);
		lb->lg += (m << 1);
	    } else if ((UCfu & UC_force_ASCII) &&
		       (txtTyp == fio_txtTyp_UTF8)) {
		int m = AsciiToUtf8(pcd, dlgc, lgs->s, lgs->lg);
		pcd += m;
		lb->lg += m;
	    } else {
		ppcnmove(&pcd, lgs->s, lgs->lg);
		lb->lg += lgs->lg;
	    }
	}
	if (EOL_lg > 0) {
	    ppcnmove(&pcd, (char*)&EOL, EOL_lg);
	    lb->lg += EOL_lg;
	}
}
