/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

double ppctodouble_scan(const char **ppc, bool Scan) {
  int Mk;
  const char *pc;
  double res = 0;
  double dez = 0.1;

	if (!ppc) return 0;
	pc = *ppc;
	if (!pc) return 0;
	Mk = res = 0;
	while (*pc) {
	    if ((*pc >= '0') && (*pc <= '9')) {
		Mk |= 0x8000;
		if (Mk & 0x01) {
		    res += (*pc & 0x0f) * dez;
		    dez *= 0.1;
		} else {
		    res = (res * 10) + (*pc & 0x0f);
		}
	    } else if (*pc == '-') {
		if ((Mk & 0x8000) == 0) Mk |= 0x8100; else break;
	    } else if ((*pc == '.') || (*pc == ',')) {
		if (Mk & 0x01) break;
		Mk |= 0x01;
	    } else if ((*pc == ' ') || (*pc == 0x09)) {
		if (Mk) break; //Leerzeichen am Anfang erlaubt
	    } else {
		if (!Scan || Mk) break;
	    }
	    pc++;
	}
	if (Mk & 0x100) res = -res;
	*ppc = pc;
	return res;
}

double ppctodouble(const char **ppc) { return ppctodouble_scan(ppc, False);}

double pctodouble(const char *pc) { 
  const char *ppc = pc;
	return ppctodouble_scan(&ppc, False);
}
