/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

int pwccasecmp_fi(const word *a, const word *b, int fu) {
	if (!a && !b) return 0;
	if (!a) return -1;
	if (!b) return 1;
#ifdef USE_CHAR_NOTAB
  word c1, c2;
loop:
	c1 = *a; c2 = *b;
	if (!c1 && !c2) return 0;
	if ((c1 >= 'a') && (c1 <= 'z')) c1 -= 0x20;
	if ((c2 >= 'a') && (c2 <= 'z')) c2 -= 0x20;
	if (c1 != c2) {
		if (c1 > c2) return 1; else return -1;
	} 
	a++; b++;
	goto loop;
#else /* USE_CHAR_NOTAB */
  const byte *ct;

	switch (fu & 0xff) {
#ifdef USE_CHAR_ASCII
	case FU_CASE_ASCII: ct = (const byte*)l_ascii; break;
#endif
#ifdef USE_CHAR_iso8859_1
	case FU_CASE_8859_1: ct = (const byte*)l_iso8859_1; break;
#endif
	default:
	    ct = (const byte*)USE_CHAR_DEFAULT;
	}

	while (1) {
  word c1, c2;
	    if ((*a < 256) && (*b < 256)) {
		c1 = ct[(byte)*a]; c2 = ct[(byte)*b];
	    } else {
		c1 = *a; c2 = *b;
	    }
	    if (!c1 && !c2) return 0;
	    if (c1 != c2) {
		if (c1 > c2) return 1; else return -1;
	    }
	    a++; b++;
	}
#endif /* !USE_CHAR_NOTAB */
}
