/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

bool str_match(const char *pattern, const char *string, int fu) {
	if (!string || !*string) {
	    if (!pattern || !*pattern) return True;
	    return (pccmp(pattern,"*"));
	}
	if (!pattern || !*pattern) return True;

	while (*string && *pattern) {
	    if (*pattern == '?') {
		pattern++;
		string++;
	    } else if (*pattern == '*') {
		pattern++;
		if (!*pattern) return True;
		while (*string) {
		    if (str_match(pattern, string, fu)) return True;
		    string++;
		}
		return False;
	    } else {
#ifdef USE_CHAR_NOTAB
		if (fu & FU_CASE_MASK) {
	char c1, c2;
		    c1 = *pattern;
		    c2 = *string;
		    if ((c1 >= 'a') && (c1 <= 'z')) c1 -= 0x20;
		    if ((c2 >= 'a') && (c2 <= 'z')) c2 -= 0x20;
		    if (c1 != c2) return False;
		} else {
		    if (*pattern != *string) return False;
		}
#else /* USE_CHAR_NOTAB */
	int c1, c2;
		c1 = (byte)*pattern;
		c2 = (byte)*string;
		switch (fu & FU_CASE_MASK) {
		case 0:
		    if (c1 != c2) return False;
		    break;
#ifdef USE_CHAR_iso8859_1
		case FU_CASE_8859_1:
		    if (l_iso8859_1[c1] != l_iso8859_1[c2]) return False;
		    break;
#endif
		default:
		    if (l_ascii[c1] != l_ascii[c2]) return False;
		    break;
		}
#endif /* !USE_CHAR_NOTAB */
		pattern++;
		string++;
	    }
	}
	if(!*pattern && !*string) return True;
	if(!*string && pccmp(pattern, "*")) return True;
	return False;
}
