/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

/*_____________________________ Free ____________________________________*/
bool TItem__Destroy(TItem *item) {

	if (item->prev) {
	    item->prev->next = item->next;
	}
	if (item->next) {
	    item->next->prev = item->prev;
	}
	if (item == *item->pproot) *item->pproot = item->next;
	return False;
}

/*_____________________________ Create __________________________________*/
/* void *TItemAdd(TItem **pproot, TItem *prev, int size, int wtyp) {
  TItem *self = TItem_Create(pproot, size, wtyp);

	if (self) {
	     if (prev) {
		self->prev = prev;
		self->next = prev->next;
		prev->next = self;
		if (self->next) self->next->prev = self;
	     } else {
		self->next = *pproot;
		if (self->next) self->next->prev = self;
		*pproot = self;
	     }
	}
	return self;
} */
void TItemIns(TItem *prev, TItem *self) {
	if (!self) return;
	if (prev) {
	    self->prev = prev;
	    self->next = prev->next;
	    prev->next = self;
	    if (self->next) self->next->prev = self;
	} else {
	    self->next = *self->pproot;
	    if (self->next) self->next->prev = self;
	    *self->pproot = self;
	}
}

void *TItemAddTo(TItem **pproot, TItem *prev, int size, int wtyp) {
  TItem *self = TItem_Create(pproot, size, wtyp);

	TItemIns(prev, self);
	return self;
}

void *TItemAdd(TItem **pproot, int size, int wtyp) {
  TItem *prev;
	if (!pproot) return NULL;
	prev = *pproot;
	if (prev) while (prev->next) prev = prev->next;
	return TItemAddTo(pproot, prev, size, wtyp);
}

void *TItem_Create(TItem **pproot, int size, int wtyp) {
  TItem *self = NULL;

	if (!pproot || (size < sizeof(TItem))) return NULL;
	if (!wtyp) wtyp = wtyp_TItem;
	self = ttc_create(size, wtyp);
	self->destroy = (TDESTROY)TItem__Destroy;
	self->pproot = pproot;
	return self;
}
