/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"

void TLines_Paste_lgs(TLines *tls, int *lineNr, int *charPos, Tlgs *lgs, int maxLineLen) {
  int lr;
  char *tmps, *s, *sr = NULL;
  TColS *cs;
  int idx = 0, pos = 0;
  TLineBuf lb;
  Tlgs gs;
  int eol = 0; //fio_noEOL_0;

	if (lineNr) idx = *lineNr;
	if (charPos) pos = *charPos;


	if ((idx < 0) || !lgs) return;
	lb.lg = lgs->lg;
	lb.memlg = lgs->lg;
	lb.pc = lgs->s;
	lb.pc_rdidx = NULL;
	lb.UTF8_buf = NULL;
	lb.maxLineLen = maxLineLen;
	lb.eof = True;

	if (idx >= tls->Count) {
	    while (TLineBuf_GetLineEOL_lgs(&lb, &gs, &eol)) {
		    TLines_Add_lgs(tls, &gs, eol);
		    if (charPos) *charPos = gs.lg;
	    }
	    if ((eol & fio_EOL_Mask) != fio_EOLnone) {
		    if (lineNr) *lineNr = tls->Count;
		    if (charPos) *charPos = 0;
	    } else {
		    if (lineNr) *lineNr = tls->Count - 1;
	    }
	} else {
	    if (!TLineBuf_GetLineEOL_lgs(&lb, &gs, &eol)) return;
	    cs = tls->lines->cs[idx];
	    TLines_ResLinec(tls, cs, idx);
	    tmps = cs->s;
	    if (pos > cs->lg) pos = cs->lg;
	    lr = cs->lg - pos;
	    if (tmps) sr = &tmps[pos];
	    cs->s = pcnnadd(tmps, pos, gs.s, gs.lg);
	    cs->lg = pos + gs.lg;
	    TLines_DoLineChange(tls, idx);
	    if ((eol & fio_EOF) == 0) {
		while (TLineBuf_GetLineEOL_lgs(&lb, &gs, &eol)) {
		    idx++;
		    TLines_nIns(tls, idx, gs.s, gs.lg);
		}
	    }
	    if ((eol & fio_EOL_Mask) != fio_EOLnone) {
		idx++;
		TLines_nIns(tls, idx, NULL, 0);
	    }

	    cs = tls->lines->cs[idx];
	    if (charPos) *charPos = cs->lg;
	    if (lr > 0) {
		TLines_ResLinec(tls, cs, idx);
		s = cs->s;
		cs->s = pcnnadd(s, cs->lg, sr, lr);
		cs->lg += lr;
		xfree(s);
		TLines_DoLineChange(tls, idx);
	    }

	    if (lineNr) *lineNr = idx;
	    xfree(tmps);
	}
}

void TLines_Paste(TLines *tls, int *lineNr, int *charPos, const char *s) {
  Tlgs lgs;
	lgs.s_const = s;
	lgs.lg = pclen(s);
	TLines_Paste_lgs(tls, lineNr, charPos, &lgs, 0);
}

