/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

static const char *ScanSpace(const char *s) {
	while (*s && ((byte)*s <= 0x20)) s++;
	return s;
}

static const char *pcGetTokenFu(const char *indata, const char **token, int *lg, int fu) {
  const char *t, *ta;
  bool mk;

	*token = NULL;
	*lg = 0;
	if (!indata) return NULL;
	t = ScanSpace(indata);

	if (!*t) return NULL;
	ta = t;
	if (*t == '"') {
	    mk = (fu & TokenFu_PlusSep) != 0;
	    t++;
	    if (!mk) ta++;
	    while (*t && (*t != '"')) t++;
	    if (mk && (*t == '"')) t++;
	    if (token) {*token = ta; *lg = t - ta;}
	    if (!mk && (*t == '"')) t++;

	} else {
	    while (*t && ((byte)*t > 0x20)) t++;
	    if (token) {*token = ta; *lg = t - ta;}
	}
	t = ScanSpace(t);
	if (!*t) return NULL;
	return t;
}

const char *pcGetToken(const char *indata, const char **token, int *lg) {
	return pcGetTokenFu(indata, token, lg, 0);
}

const char *GetTokenFu(const char *indata, char **token, int fu) {
  int lg;
  const char *res, *pc;
	res = pcGetTokenFu(indata, &pc, &lg, fu);
	if (token) *token = pcndup(pc, lg);
	return res;
}

const char *GetToken(const char *indata, char **token) {
	return GetTokenFu(indata, token, 0);
}
