/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"

static const char chesc[256] = {
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x00,0x01 ,0x01,0x00,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x00,0x00,0x01,0x01 ,0x00,0x02,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x01,0x00,0x01,0x00,

  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x01 ,0x01,0x01,0x01,0x00,
  0x01,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x01 ,0x01,0x01,0x00,0x01,

  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,

  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
};

int CharsToUtf8esc(char *dpc, int DChars, const char *spc, int SChars, int UCfu) {
  int count;
	if (!spc || (SChars <= 0)) return 0;
	count = 0;
	if (dpc && (DChars > 0)) {

	    if (UCfu & UC_force_LastChar0) DChars--;
	    while ((SChars > 0) && (DChars > 0)) {
		
		if (chesc[(byte)spc[0]] &&
		    ((chesc[(byte)spc[0]] != 2) || 
		     (SChars < 2) ||
		     (!zC_HEX[(byte)spc[1]] && 
		      !zC_HEX[(byte)spc[2]]))) {

		    *dpc = '%';
		    if (DChars > 0) {dpc++; *dpc = zC_HEX2ASCII[(byte)spc[0] >> 4]; DChars--; count++;}
		    if (DChars > 0) {dpc++; *dpc = zC_HEX2ASCII[(byte)spc[0] & 0x0f]; DChars--; count++;}
		} else {
		    *dpc = *spc;
		}
		dpc++; spc++; DChars--; SChars--; count++;
	    }
	    if ((DChars > 0) || (UCfu & UC_force_LastChar0)) *dpc = 0;

	} else {
	    while (SChars > 0) {
		if (chesc[(byte)spc[0]] &&
		    ((chesc[(byte)spc[0]] != 2) || 
		     (SChars < 2) ||
		     (!zC_HEX[(byte)spc[1]] && 
		      !zC_HEX[(byte)spc[2]]))) count += 2;

		spc++; SChars--; count++;
	    }
	}
	return count;
}

void pctoUTF8esclgs(const char *pc, Tlgs *lgs) {
	if (!lgs) return;
	if (!pc) {
	    lgs->lg = 0;
	    lgs->s = NULL;
	    return;
	}
	lgs->lg = CharsToUtf8esc(NULL, 0, pc, pclen(pc), 0);
	lgs->s = xmalloc(lgs->lg+1);
	CharsToUtf8esc(lgs->s, lgs->lg+1, pc, pclen(pc), 0);
}

char *pctoUTF8esc(const char *pc) {
  Tlgs lgs;
	pctoUTF8esclgs(pc, &lgs);
	return lgs.s;
}

/* --------------------- Utf8esc -> Char ----------------------------- */
int Utf8escToChars(char *dpc, int DChars, const char *spc, int SChars, int UCfu) {
  int count;
	if (!spc || (SChars <= 0)) return 0;
	count = 0;
	if (dpc && (DChars > 0)) {
	    if (UCfu & UC_force_LastChar0) DChars--;
	    while ((SChars > 0) && (DChars > 0)) {
		
		if ((spc[0] == '%') &&
		    (SChars > 1) &&
		    zC_HEX[(byte)spc[1]] && 
		    zC_HEX[(byte)spc[2]]) {

		    *dpc = (zC_ASCII2INT[(byte)spc[1]]<<4) | zC_ASCII2INT[(byte)spc[2]];
		    spc += 2;
		} else {
		    *dpc = *spc;
		}
		dpc++; spc++; DChars--; SChars--; count++;
	    }
	    if ((DChars > 0) || (UCfu & UC_force_LastChar0)) *dpc = 0;

	} else {
	    while (SChars > 0) {
		if ((spc[0] == '%') &&
		    (SChars > 1) &&
		    zC_HEX[(byte)spc[1]] && 
		    zC_HEX[(byte)spc[2]]) spc += 2;

		spc++; SChars--; count++;
	    }
	}
	return count;
}

void UTF8esctopclgs(const char *pc, Tlgs *lgs) {
	if (!lgs) return;
	if (!pc) {
	    lgs->lg = 0;
	    lgs->s = NULL;
	    return;
	}
	lgs->lg = Utf8escToChars(NULL, 0, pc, pclen(pc), 0);
	lgs->s = xmalloc(lgs->lg+1);
	Utf8escToChars(lgs->s, lgs->lg+1, pc, pclen(pc), 0);
}

char *UTF8esctopc(const char *pc) {
  Tlgs lgs;
	UTF8esctopclgs(pc, &lgs);
	return lgs.s;
}
