/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include <signal.h>

static int TForm_EvProc(Tobjmsg *msg) {
  TForm *self;
  XEvent *ev;

//	self = (TForm *) msg->ap->wins;
//	if (!self) return 0;
	self = (TForm*)msg->wins;
	if (!self) return 0;

	switch(msg->msg) {
	case msgXEv:
	    ev = (XEvent *) msg->p;
	    switch(ev->type) {
	    case ConfigureNotify: //22
/*
 printf("ConfigureNotify: 0x%x 0x%x 0x%x %d %d %dx%d\n", 
  (int)ev->xconfigure.event, (int)ev->xconfigure.window, (int)ev->xconfigure.above,
  ev->xconfigure.x, ev->xconfigure.y,
  ev->xconfigure.width, ev->xconfigure.height);
*/
		self->left = ev->xconfigure.x;
		self->top = ev->xconfigure.y;

		self->width = ev->xconfigure.width;
		self->height = ev->xconfigure.height;
		if ((self->xwc.left != self->left) || (self->xwc.top != self->top)) {
		    if (self->ResizeStartMk && self->IsParent) {
			if (self->OnMove) self->OnMove(self);
		    }
		    self->xwc.left = self->left;
		    self->xwc.top = self->top;
// printf("ConfigureNotify: 0x%x 0x%x 0x%x %d %d %d %d\n", (int)ev->xconfigure.event, (int)ev->xconfigure.window, (int)ev->xconfigure.above, self->left, self->top, self->width, self->height);
		}
		if ((self->xwc.width != self->width) || (self->xwc.height != self->height)) {
		    self->xwc.width = self->width;
		    self->xwc.height = self->height;
		    if (self->ResizeStartMk && self->IsParent && self->OnResize) 
				self->OnResize(self);
		    TWins_Resize((TWins*)self);
// printf("ConfigureNotify: 0x%x 0x%x 0x%x %d %d %d %d\n", (int)ev->xconfigure.event, (int)ev->xconfigure.window, (int)ev->xconfigure.above, self->left, self->top, self->width, self->height);
		}
		break;
	    case ClientMessage:
// printf("ClientMessage.format=%d %d\n", ev->xclient.format, ev->xclient.data.l[0]);
		if ((ev->xclient.format == 32) && 
		    (ev->xclient.data.l[0] == cXA_WM_DELETE_WINDOW)) {
			self->CloseIsWM_DELETE = true;
			if (self->Close) self->Close(self);
			return 1;
		}
		break;
//	    default:
//		break;
	    }
	    break;
	case msgVisibleFormShow:
		if (self->Visible && self->Show) self->Show(self);
		return 1;
		break;
#ifdef DRAG_AND_DROP
/*	case msg_dnd:
		switch(msg->f) {
		case msgf_dndEnter:
			if (appXDat.dnd) return 1;
			break;
		}
		break; */
#endif
	} 
	return TWins_EvProc(msg);
}


void TForm_Close (TForm *self) {
  int CanClose;

	CanClose = FormClose;
	if (self->OnCanClose) self->OnCanClose(self, &CanClose);
	if (CanClose) {
	    if (appXDat.StartForm == self) {
		appDat.gQUIT_Ev = true;
	    } else {
		if (CanClose & FormCloseAndFree) {
		    Tfree(self);
		    return;
		} else {
		    TWins_SetVisible((TWins*)self, false);
		}
	    }
	}
	self->CloseIsVisibleFalse = false;
	self->CloseIsWM_DELETE = false;
}

void  TForm_Show(TForm *self) {
  int x, y, m;
  RECT rc;

	if (self->Visible && self->IsParent) {
	    XSetInputFocus(appXDat.dpy, self->WinID, RevertToParent, CurrentTime);
	} else {
	    if (self->FormPosition != poDefault) {
		x = self->left;
		y = self->top;
		if (self->FormPosition == poCenter) {
		    XID ParentWinID = appXDat.RootW;
		    if (self->Parent) ParentWinID = self->Parent->WinID;
		    if (ParentWinID && GetWindowRect(ParentWinID, &rc)) {
			m = rc.right - rc.left;
			x = rc.left + ((m - self->width) >> 1);
			m = rc.bottom - rc.top;
			y = rc.top + ((m - self->height) >> 1);
		    } else {
			x = (appXDat.Root_width - self->width) >> 1;
			y = (appXDat.Root_height - self->height) >> 1;
		    }

		    if (x+self->width > appXDat.Root_width) 
			x = appXDat.Root_width - self->width;
		    if (y+self->height > appXDat.Root_height) 
			y = appXDat.Root_height - self->height;
		    if (x < 0) x = 0;
		    if (y < 0) y = 0;
		}
		SetPosition((TWins*)self, x, y);
	    }

/*
	    if (self->FormZStyle & fszNoResize) {
		self->min_width = self->width;
		self->max_width = self->width;
		self->min_height = self->height;
		self->max_height = self->height;
	    }

	    if (!self->IsParent) {
		self->IsParent = true;
		xw = appXDat.RootW;
		if (self->ParentWinID) xw = self->ParentWinID;
		TWins_AdjustSize((TWins*)self);
	    }
*/

	    if (!self->IsParent) {
	        self->IsParent = true;
	        TWins_AdjustSize((TWins*)self);
	    }
	    self->Visible = true;
	    MapWinID(self->WinID, 2);

	    Resize((TWins *)self);
	}
	if (self->OnShow) self->OnShow(self);

}

static int TForm_DoKeyDown(TForm *self, TKeyEvent *KeyEv) {
	if (self->Root_MenuButton && self->Root_MenuButton->mbuStat) return 1;
	return TWins_DoKeyDown((TWins*)self, KeyEv);
}

static int TForm_DoKeyUp(TForm *self, TKeyEvent *KeyEv) {
	if (!self->Root_MenuButton || !self->Root_MenuButton->mbuStat) {
	    TWins_DoKeyUp((TWins*)self, KeyEv);
	}
	if (!(KeyEv->state & 0x4) && 
            ((KeyEv->keysym == XK_Meta_L) || (KeyEv->keysym == XK_Alt_L))) {
	    if (self->DoMenuButtonExec) self->DoMenuButtonExec(self);
	}
	return 1;
}


static void TForm_SetCaption(TForm *self, const char *s) {
  int lg = pclen(s);
	if ((self->vds.lg != lg) || !pcncmp(self->vds.s, s, lg)) {
	    ppcchange(&self->vds.s, s);
	    self->vds.lg = pclen(s);
	    word *pwc = UTF8lgstopwc((Tlgs*)&self->vds, 0);
	    SetWindowTextW(self->WinID, pwc);
	    xfree(pwc);
	}
}

void TForm_SetVisible(TForm *self, bool Value) {
	if (self->Visible != Value) {
	    if (self->Visible) {
		self->CloseIsVisibleFalse = true;
		if (self->Close) self->Close(self);
	    } else {
		if (self->Show)  self->Show(self);
	    }
	}
}

/*_____________________________ Destroy _________________________________*/
bool TForm__Destroy(TForm *self) {
	return TWins__Destroy((TWins*)self);
}

/*____________________________ Create ___________________________________*/
void TForm_CreateParams(TWins_Create_struct *wcs) {
  TForm *self;

	self = wcs->wins;
	self->dnd_isEnable = false;
	self->FormStruct = (TWins*)self;

	self->width = 320;
	self->height = 240;
	self->top = CW_USEDEFAULT; //10;
	self->left = CW_USEDEFAULT; //10;

	self->EvProc = TForm_EvProc;
	self->SetCaption = TForm_SetCaption;
	self->SetVisible = TForm_SetVisible;

	self->DoKeyDown = TForm_DoKeyDown;
	self->DoKeyUp = TForm_DoKeyUp;
	self->Show = TForm_Show;
	self->Close = TForm_Close;

	if (!appXDat.StartForm) appXDat.StartForm = self;

//	self->apph->aos |= aosIsForm;
	wcs->XAttr.event_mask |= FocusChangeMask;
	wcs->XAttr.border_pixmap = (Pixmap)LoadIcon(appXDat.dpy->appInstance, "APPICON");
	if (wcs->SubP) wcs->XAttr.TransientWindow = ((TWins*)wcs->SubP)->WinID;
}

void *TForm_CreatParamAlg(TWins *Parent, int FormMemSize) {
  TWins_Create_struct wcs;

	TWins_Create_struct_init(&wcs, FormMemSize, wtyp_Form);
	wcs.SubP = Parent;
	wcs.CreateParams = TForm_CreateParams;

	TWins_DefaultConf(&wcs);
	((TForm*)wcs.wins)->Parent = Parent;

	return wcs.wins;
}

TForm *TForm_Create(TWins *Parent) {
	return TForm_CreatParamAlg(Parent, sizeof(TForm));
}
