/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

void TButtonPic_DoPaint(TButtonPic *self) {
  TPic *pic;
  int x, y;

	TButton_DoPaint((TButton*)self);
	pic = self->pic;
	if (self->dispic && !TestWinIsEnabled((TWins*)self)) pic = self->dispic;
	if (!pic) return;

	x = 0;
	if (self->pic_fu & mBuPicRigth) {
	    x = self->width - pic->width;
	} else if (!(self->pic_fu & mBuPicLeft)) {
	    x = ((self->width - pic->width) / 2);
	}

	y = 0;
	if (self->pic_fu & mBuPicBottom) {
	    y = self->height - pic->height;
	} else if (!(self->pic_fu & mBuPicTop)) {
	    y = ((self->height - pic->height) / 2);
	}
	x += self->pic_offX;
	y += self->pic_offY;

	DrawPic(self->WinID, pic, x, y);
}

/*____________________________ Create ___________________________________*/
TButtonPic *TButtonPic_Create(TWins *Parent) {
  TButtonPic *self;
  TWins_Create_struct wcs;

	TWins_Create_struct_init(&wcs, sizeof(TButtonPic), wtyp_ButtonPic);
	wcs.Parent = Parent;
	wcs.CreateParams = TButton_CreateParams;
	TWins_DefaultConf(&wcs);
	self = wcs.wins;
	self->DoPaint = TButtonPic_DoPaint;
	return self;
}

TButtonPic *TButtonPic_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s) {
  TButtonPic *self;
	self = TButtonPic_Create(Parent);
	SelfCreateS((TWins*)self, Left, Top, Width, Height, s);
	return self;
}
