/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "cicons.h"

//*********************** TChkBox ************************
#define cbw 13

static int TChkBox_cyo(TChkBox *cb) {
  int cyo;
	cyo = cb->height - cbw;
	if (cyo < 0) cyo = 0;
	cyo = cyo >> 1;
	return cyo;
}
// Chk_Ok_ico
static void TChkBox_Chk_Ok_Paint(TChkBox *cb) {
  int cyo = TChkBox_cyo(cb);
	if (cb->Checked) {
	    DrawPic(cb->WinID, get_pic9_ok(False), 3, cyo+2);
	} else {
	    Fill_Rect(cb->WinID, appXDat.GC_FFFFFF, 3, cyo+2, cbw-4, cbw-4);
	}
}

static void TChkBox_DoPaint(TChkBox *self) {
  int cyo;
	self->CaptionOffX = cbw+2;
	TWins_DoPaint((TWins*)self);
	cyo = TChkBox_cyo(self);
	StdBorderPaint(self->WinID, mBorder | mBorderL | mBorderW2, 1, cyo, cbw, cbw);
	if ((self->KeyFu & mHasFocus) && !(self->CaptionFu & mFocusRecIsPaint)) {
	    DrawRectFocus(self->WinID, cbw+1, 0, self->width-cbw-1, self->height);
	    self->CaptionFu |= mFocusRecIsPaint;
	}
	TChkBox_Chk_Ok_Paint(self);
}

static void cb_DoClick(TChkBox *self, long KeyState, bool DblClick) {
	TWins_DoClick((TWins*)self, KeyState, DblClick);
	TChkBox_Chk_Ok_Paint(self);
}

static void TChkBox_DoClick(TChkBox *self, long KeyState, bool DblClick) {
  TMouseDown *md = &appXDat.MouseDown;
  bool Check = !self->OnlyInBoxCheck || (md->x <= cbw+1);

	if (Check && self->AutoToggle) {
	    self->Checked = (self->Checked & 0x01) ^ 0x01;
	}
	cb_DoClick(self, KeyState, DblClick);
}

static int TChkBox_DoKeyDown(TChkBox *self, TKeyEvent *KeyEv) {
	if ((KeyEv->keysym == XK_space) || (KeyEv->keysym == XK_Return)) {
	    if (self->AutoToggle) {
		self->Checked = (self->Checked & 0x01) ^ 0x01;
	    }
	    cb_DoClick((TChkBox*)self, KeyEv->state, False);
	    return 1;
	}
	return TWins_DoKeyDown((TWins*)self, KeyEv);
}

static void TChkBox_DoFocus(TChkBox *self, int Change) {
	TWins_DoFocus((TWins*)self, Change);
	TWins_RePaint((TWins*)self);
}

void TChkBox_SetChecked(TChkBox *self, bool Value) {
	if (self->Checked == Value) return;
	self->Checked = Value;
	TChkBox_Chk_Ok_Paint(self);
}

void TChkBox_SetChecked_ev(TChkBox *self, bool Value) {
	if (self->Checked == Value) return;
	self->Checked = Value;
	cb_DoClick(self, appXDat.last_KeyState, False);
//	TChkBox_Chk_Ok_Paint(self);
//	TChkBox_DoClick(self, appXDat.last_KeyState, False);
}

/*_____________________________ Create __________________________________*/
static void TChkBox_CreateParams(TWins_Create_struct *wcs) {
  TChkBox *self = wcs->wins;
	self->DoPaint = TChkBox_DoPaint;
	self->DoClick = TChkBox_DoClick;
	self->DoKeyDown = TChkBox_DoKeyDown;
	self->DoFocus = TChkBox_DoFocus;

	self->CaptionFu = mCaptionPaint | mCaptionLeft;
	self->KeyFu = mCanFocus | mK_Right | mK_Down | mK_Left | mK_Up | mK_Tab;
	self->AutoToggle = True;
}

TChkBox *TChkBox_Create(TWins *Parent) {
  TWins_Create_struct wcs;

	TWins_Create_struct_init(&wcs, sizeof(TChkBox), wtyp_ChkBox);
	wcs.Parent = Parent;
	wcs.CreateParams = TChkBox_CreateParams;
	TWins_DefaultConf(&wcs);
	return wcs.wins;
}

TChkBox *TChkBox_CreateS(TWins *Parent, int Left, int Top, int Width, int Height, const char *s) {
  TChkBox *self;

	self = TChkBox_Create(Parent);
	SelfCreateS((TWins*)self, Left, Top, Width, Height, s);
	return self;
}
