/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

//fu 0=Select 1=Deselect 2=Del 3=Deselect+Del
/* static void DoSelect(TGrid *gr, int fu) {
	if (gr->DoSelect) gr->DoSelect(gr, 0);
} */

static void gr_Select(TGrid *gr, int Col, int Row) {
  int i, m;
  bool mk;

	if (Row >= gr->RowCount) return; //Row = gr->RowCount-1;
	if (gr->FixedRows > Row) Row = gr->FixedRows;
	gr->SelectIdxRow = Row;
	if (Col >= gr->ColCount) return; //Col = gr->ColCount-1;
	if (gr->FixedCols > Col) Col = gr->FixedCols;
	gr->SelectIdxCol = Col;

	mk = False;
	if (gr->OnSelect) mk = gr->OnSelect(gr, Col, Row, grBefFu_Select);
	if (!mk) {
	    for (i=gr->FixedCols;i<gr->ColCount;i++) {
		m = 0;
		TGrid_PaintCell(gr, i, gr->SelectIdxRow, &m);
	    }
	}
	TGrid_ChkSelect_RC(gr, gr->SelectIdxCol, gr->SelectIdxRow);
}

static void gr_Deselect(TGrid *gr, int fu) {
  int i, m, oRow;
  bool mk;

	if (gr->SelectIdxRow >= 0) {
	    mk = False;
	    if (gr->OnSelect) mk = gr->OnSelect(gr, gr->SelectIdxCol, gr->SelectIdxRow, fu);
	    oRow = gr->SelectIdxRow;
	    gr->SelectIdxCol = -1;
	    gr->SelectIdxRow = -1;
	    if (!mk) {
		for (i=gr->FixedCols;i<gr->ColCount;i++) {
		    m = 0;
		    TGrid_PaintCell(gr, i, oRow, &m);
		}
	    }
	}
}

//fu 0=Select 1=Deselect 2=Del 3=Deselect+Del
void TGrid_DoSelect(TGrid *gr, int fu) {

	if ((fu & grBefFu_Mask) == grBefFu_Select) {
	    if ((gr->SelectFu & grSelFu_Row) && 
	        (gr->FixedRows <= gr->MouseCell.Row) &&
	        ((gr->SelectIdxRow != gr->MouseCell.Row) ||
	         (gr->SelectIdxCol != gr->MouseCell.Col))) {

		gr_Deselect(gr, grBefFu_Deselect);
		gr_Select(gr, gr->MouseCell.Col, gr->MouseCell.Row);
	    }
	} else {
	    gr_Deselect(gr, fu);
	}
}


void TGrid_Select(TGrid *gr, int Col, int Row, int fu) {

	if (fu & grBefFu_Select_Idx) {
	    Col = gr->SelectIdxCol;
	    Row = gr->SelectIdxRow;
	}

	if ((gr->FixedRows > Row) || (Row >= gr->RowCount)) return;
	switch (fu & grBefFu_Mask) {
	case grBefFu_Select:		//Select
	    gr->MouseCell.Col = Col;
	    gr->MouseCell.Row = Row;
	    if (gr->DoSelect) gr->DoSelect(gr, fu);
	    break;

	case grBefFu_Deselect:		//Deselect
	    if (gr->DoSelect) gr->DoSelect(gr, fu);
	    break;

	case grBefFu_DelRow:		//DelRow
	case grBefFu_Deselect_DelRow:	//Deselect_DelRow
	    TGrid_DelRow(gr, Row);
	    if ((fu & grBefFu_Mask) == grBefFu_DelRow) {
		gr_Select(gr, Col, Row);
	    }
	    break;
	}
	if (fu & grBefFu_Repaint) Refresh((TWins*)gr);
}

void TGrid_Deselect(TGrid *gr) {
	gr_Deselect(gr, grBefFu_Deselect);
}

/* void TGrid_DoPaintSelectCell(TGrid *gr, int ACol, int ARow, TWRect *rc, int *fu) {
	if ((gr->FixedCols > ACol) || (gr->FixedRows > ARow)) return;
	if ((gr->SelectFu & grSelFu_Row) && 
            (gr->SelectIdxRow == ARow)) {
		TClassGC_FillSelectRect_rc(gr->CellGC, rc);
		if (gr->SelectIdxCol == ACol) {
		    TClassGC_DrawFocusRect_rc(gr->CellGC, rc);
		}
	}
} */

