/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"

//*********************** ScrollWin ************************

static bool Tscrpw_AdjustSize(TWins *self) {
  TScrollWin *ow = (TScrollWin*)self->owner;
  TWRect rc;
  int o;
  bool result;

	o = 0;
	result = TWins_AdjustSize(self);
	Get_ClientRect(self, &rc);

	if (ow->VSB->Visible) rc.width -= ow->VSB->width;
	if (ow->HSB->Visible) rc.height -= ow->HSB->height;
	if (ow->HSB->Visible && ow->VSB->Visible) o = 1;

	ow->HSB->left = rc.left;
	ow->HSB->top = rc.top + rc.height;
	ow->HSB->width = rc.width + o;

	ow->VSB->left = rc.left + rc.width;
	ow->VSB->top = rc.top;
	ow->VSB->height = rc.height + o;

	TWins_SetRC(ow->pws, rc.left, rc.top, rc.width, rc.height);
	return result;
}


void TScrollWin_SetParent(TScrollWin *self, TWins *Parent) {
	TWins_SetParent(self->pw, Parent);
}

static bool TScrollWin_GetIsParent(TScrollWin *self) {
	if (!self || !self->pw) return false;
	return self->pw->IsParent;
}

static void TScrollWin_SetColor(TScrollWin *self, dword Color) {
	TWins_SetColor(self->pws, Color);
	TWins_SetColor((TWins*)self, Color);
}

void TScrollWin_SetMouseZ_Wheel(TScrollWin *self, int Value) {

//	self->MouseZ_Wheel = Value;
	self->HSB->MouseZ_Wheel = Value;
	self->VSB->MouseZ_Wheel = Value;
}

/*_____________________________ Create __________________________________*/
void TScrollWin_CreateParams(TWins_Create_struct *wcs) {
  TScrollWin *self = wcs->wins;
	self->Color = 0xffffff;
	self->SetParent = TScrollWin_SetParent;
	self->GetIsParent = TScrollWin_GetIsParent;
	self->SetColor = TScrollWin_SetColor;
//	self->MouseZ_Wheel = appXDat.Default_MouseZ_Wheel;
}

void TScrollWin_DefaultConf(TWins_Create_struct *wcs) {
  TScrollWin *self = wcs->wins;
  TWins *Parent = wcs->Parent;

	self->pw = TWins_Create(Parent);
	self->pw->BorderFu = mBorder | mBorderL;
	self->pw->owner = (TWins*)self;
	self->pw->AdjustSize = Tscrpw_AdjustSize;
	self->pw->width = 100;
	self->pw->height = 100;
	TWins_SetDefaultBorderWidth(self->pw);

	self->pws = TWins_Create(self->pw);
	Set_Parent(self->pws, self->pw);

	self->HSB = (TScrollBar*)TScrollBarHorz_CreateP(self->pw);
	self->HSB->owner = (TWins*)self;
	self->HSB->BorderFu = mBorder|mBorderL|mBorderNoBottom|mBorderNoLeft|mBorderNoRigth;
	self->HSB->height = 16;
	self->VSB = (TScrollBar*)TScrollBarVert_CreateP(self->pw);
	self->VSB->owner = (TWins*)self;
	self->VSB->BorderFu = mBorder|mBorderL|mBorderNoTop|mBorderNoBottom|mBorderNoRigth;
	self->VSB->width = 16;

	wcs->Parent = self->pws;
	TWins_DefaultConf(wcs);
	TWins_SetParent((TWins*)self, self->pws);
}

TScrollWin *TScrollWin_Create(TWins *Parent) {
  TWins_Create_struct wcs;
	TWins_Create_struct_init(&wcs, sizeof(TScrollWin), wtyp_ScrollWin);
	wcs.Parent = Parent;
	wcs.CreateParams = TScrollWin_CreateParams;
	TScrollWin_DefaultConf(&wcs);
	return wcs.wins;
}

TScrollWin *TScrollWin_CreateU(TWins *Parent, int Left, int Top, int Width, int Height, int BorderFu, int Align, bool mParent) {
  TScrollWin *self;
	self = TScrollWin_Create(Parent);
	self->top = Top;
	self->left = Left;
	self->width = Width;
	self->height = Height;
	if (BorderFu >= 0) self->BorderFu = BorderFu;
	self->Align = alClient;
	if (Align) self->pw->Align = Align;
	if (mParent) Set_Parent((TWins*)self, Parent);
	return self;
}
