/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "dlg.h"

static void Login_Dlg_buOk_Click(TButton *self, long KeyState, bool DblClick) {
  TLogin_Dlg *dlgw = (TLogin_Dlg*)self->FormStruct;

//	if (DblClick) return;
	SetVisible(self->FormStruct, False);
	dlgw->RetCode = 1;
}

static void Login_Dlg_buCancel_Click(TButton *self, long KeyState, bool DblClick) {
	SetVisible(self->FormStruct, False);
}

static void Login_Dlg_edPasswd_OnKeyDown(TEdit *self, TKeyEvent *KeyEv) {
  TLogin_Dlg *dlgw;
	if (KeyEv->keysym == XK_Return) {
	    dlgw = (TLogin_Dlg*)self->FormStruct;
	    SetVisible(self->FormStruct, False);
	    dlgw->RetCode = 1;
	}
}

bool Login_Dlg_Execute(TLogin_Dlg *dlgw, TglobPath *gp) {
  bool res;
  char *s = NULL;

	dlgw->RetCode = 0;
	s = pcadd_n(3, gp->RootArt, "//", gp->URL);
	SetCaption(dlgw->lblHostName, s);
	xfree(s);

	SetCaption((TWins*)dlgw->edUser, gp->user);
	SetCaption((TWins*)dlgw->edPasswd, NULL);
	if (gp->passwd) dlgw->edPasswd->Passwd = ed_passwd_akt|ed_passwd_akt_NULL;
	dlgw->FocusWin = (TWins*)dlgw->edUser;

	SetVisible((TWins*)dlgw, True);
	while (dlgw->Visible && AppHandleMessage());
	res = (dlgw->RetCode == 1);
	if (res) {
	    ppcchange(&gp->user, dlgw->edUser->vds.s);
	    if (!(dlgw->edPasswd->Passwd & ed_passwd_akt_NULL)) 
			ppcchange(&gp->passwd, dlgw->edPasswd->vds.s);
	}
	return res;
}

static void Login_Dlg_OnResize(TLogin_Dlg *self) {
  int m;

	m = self->height - self->buOk->height - 2;
	self->buOk->top = m;
	self->buCancel->top = m;

	m = self->width >> 1;
	self->buOk->left = m - self->buOk->width - 5;
	self->buCancel->left = m + 5;

	m = self->width - 4;
	self->lblHostName->width = m - self->lblHostName->left;

	m -= self->edUser->left;
	self->edUser->width = m;
	self->edPasswd->width = m;
}

TLogin_Dlg *Create_Login_Dlg(TWins *parent) {
  TLogin_Dlg *self;
  int y;

	self = TForm_CreatParamAlg(parent, sizeof(TLogin_Dlg));
	self->Visible = False;
	self->FormZStyle = fszTransient;
	self->FormPosition = poCenter;
	self->OnResize = Login_Dlg_OnResize;

	SetCaption((TWins*)self, "Login Dlg");
	self->width = 280;
	self->height = 106;
	self->min_width = 280;
	self->min_height = 106;

	y = 4;
	self->lblHost = TWins_CreateLabel((TWins*)self, 4, y, 40, 16, "Host:", mCaptionLeft, 0);
	self->lblHostName = TWins_CreateLabel((TWins*)self, 44, y, 200, 16, "?", mCaptionLeft, 0);

	y += 24;
	self->lblUser = TWins_CreateLabel((TWins*)self, 4, y, 70, 16, "Username", mCaptionLeft, 0);
	self->edUser = TEdit_CreateS((TWins*)self, 74, y, 200, 20, NULL);
	self->edUser->KeyFu |= mK_ReturnTab;

	y += 24;
	self->lblPasswd = TWins_CreateLabel((TWins*)self, 4, y, 70, 16, "Passwd", mCaptionLeft, 0);
	self->edPasswd = TEdit_CreateS((TWins*)self, 74, y, 200, 20, NULL);
	self->edPasswd->OnKeyDown = Login_Dlg_edPasswd_OnKeyDown;
	self->edPasswd->Passwd = ed_passwd_akt;

	self->buOk = TButton_CreateS((TWins*)self, 0, 0, 64, 24, "OK");
	self->buOk->OnClick = Login_Dlg_buOk_Click;
	self->buCancel = TButton_CreateS((TWins*)self, 0, 0, 64, 24, "Cancel");
	self->buCancel->OnClick = Login_Dlg_buCancel_Click;

	return self;
}

bool Login_Dlg_Create_Execute(TWins *parent, TglobPath *gp) {
  TLogin_Dlg *dlgw;
  bool res;

	dlgw = Create_Login_Dlg(parent);
	res = Login_Dlg_Execute(dlgw, gp);
	if (res == 1) NetPasswdSave(gp);
	Tfree(dlgw);
	return res;
}
