/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "dlg.h"

static void Replace_Dlg_buOk_Click(TButton *self, long KeyState, bool DblClick) {
  TReplace_Dlg *rw = (TReplace_Dlg*)self->FormStruct;

//	if (DblClick) return;
	SetVisible(self->FormStruct, False);
	if (pclen(rw->edFind->vds.s) > 0) {
		rw->RetCode = 1;
	}
}

static void Replace_Dlg_buCancel_Click(TButton *self, long KeyState, bool DblClick) {
	SetVisible(self->FormStruct, False);
}

static void Replace_Dlg_edFind_OnKeyDown(TComboBox *self, TKeyEvent *KeyEv) {
	if (KeyEv->keysym == XK_Return) Replace_Dlg_buOk_Click((TButton*)self, 0, False);
}

static void cb_SetItem(TComboBox *cb) {
	TComboBox_DelItemS(cb, cb->vds.s);
	TComboBox_AddItem(cb, cb->vds.s, miAddInv, NULL);
}

void Replace_Dlg_SetUTF8(TReplace_Dlg *self, bool UTF8) {
	if (!self) return;
	TWins_SetUTF8((TWins*)self->edFind, UTF8);
	TWins_SetUTF8((TWins*)self->edRepl, UTF8);
}

bool Replace_Dlg_Execute(TReplace_Dlg *self, const char *s) {

	if (s) SetCaption((TWins*)self->edFind, s);
	self->FocusWin = (TWins*)self->edFind;

	SetVisible((TWins*)self, True);
	self->RetCode = 0;
	while (self->Visible && AppHandleMessage());
	if (self->RetCode == 1) {
	    cb_SetItem(self->edFind);
	    cb_SetItem(self->edRepl);
	}
	return (self->RetCode == 1);
}

static void Replace_Dlg_OnResize(TReplace_Dlg *self) {
  int m;

	m = self->height - 2 - self->buOk->height;
	self->buOk->top = m;
	self->buCancel->top = m;

	m = self->width >> 1;
	self->buOk->left = m - 5 - self->buOk->width;
	self->buCancel->left = m + 5;

	m = self->width - 4 - self->edFind->left;
	self->edFind->width = m;
	self->edRepl->width = m;
}

TReplace_Dlg *Create_Replace_Dlg(TWins *parent) {
  TReplace_Dlg *self;

	self = TForm_CreatParamAlg(parent, sizeof(TReplace_Dlg));
	self->Visible = False;
	self->FormZStyle = fszTransient;
	self->FormPosition = poCenter;
	self->OnResize = Replace_Dlg_OnResize;

	SetCaption((TWins*)self, "Replace Dlg");
	self->width = 300;
	self->height = 160;
	self->min_width = 300;
	self->min_height = 160;

	self->lbl1 = TWins_CreateLabel((TWins*)self, 4, 2, 100, 16, "Text to Find", mCaptionLeft, 0);

	self->edFind = TComboBox_CreateS((TWins*)self, 4, 18, 300, 20, NULL);
	self->edFind->OnKeyDown = Replace_Dlg_edFind_OnKeyDown;

	self->lbl2 = TWins_CreateLabel((TWins*)self, 4, 42, 100, 16, "Replace With", mCaptionLeft, 0);
	self->edRepl = TComboBox_CreateS((TWins*)self, 4, 58, 300, 20, NULL);

	self->cbCase = TChkBox_CreateS((TWins*)self, 4, 80, 140, 15, "Case Sensitive");
	self->cbBack = TChkBox_CreateS((TWins*)self, 4, 96, 140, 15, "Find Backwards");
	self->cbBack->Enabled = False;
	self->cbBegin = TChkBox_CreateS((TWins*)self, 4, 112, 140, 15, "From Beginning");
	self->cbBegin->Enabled = False;
	self->buOk = TButton_CreateS((TWins*)self, 0, 0, 64, 24, "OK");
	self->buOk->OnClick = Replace_Dlg_buOk_Click;
	self->buCancel = TButton_CreateS((TWins*)self, 0, 0, 64, 24, "Cancel");
	self->buCancel->OnClick = Replace_Dlg_buCancel_Click;

	return self;
}


