/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "highl.h"

//*********************** highlight - bash ******************************
void highlight_Make(Thighlight *hl, TLines *tls, int edAnf, int edEnd, int fu);

const char *sDat_Make = 
"do fi if in \
for \
case done else esac exit ifeq test then \
endif endef ifdef ifneq while \
define export ifndef return \
include function ";

static const char C_zMake[256] = {
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x22,0x23 ,0x00,0x00,0x00,0x27 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x00,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x00 ,0x5c,0x00,0x00,0x01,
  0x60,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00};

Thighlight *Thighlight_Make_Create(TWins *wins, TLines *tls) {
  Thighlight *hl;

	hl = Thighlight_Create(wins, tls);
	if (!hl) return NULL;

	hl_Set_keyword(hl, &hl->fc0_Dat, sDat_Make, FONT_Bold, 0x000000, hl->Font->g.BackColor);
//	hl_Set_keyword(&hl->fc1_Dat, sDat_C2, hl->Font, 0x800000, hl->Font->BackColor);

	hl->ChangeLine = highlight_Make;
//	hl->SetCaret = highlight_SetCaret_C;
	return hl;
}

static bool Get_Make_STok(Thldat *hid, Tstoken *t) {
  byte *s = t->s;
  int i;
  char m;
	if (!s || !*s) return False;
	while (*s && !C_zMake[*s]) s++;
	t->s = s;
	if (!*s) return False;
	i = 0;
	m = C_zMake[*s];
	if (*s) {s++; i++;}
	if (m != '"') while (*s && (m == (C_zMake[*s]))) {s++; i++;}
	t->next = s;
	t->lg = i;
	t->c = m;
	return True;
}

static void hlSetLine_Make(Thldat *hid) {
  Tstoken t;
  int i, m;
  byte *pc;

	xfree(hid->cs->c);
	hid->cs->c = NULL;
	hid->t = &t;
	t.s = (byte*)hid->cs->s;
	t.next = (byte*)hid->cs->s;
	if (hid->mk & hl_strline) {
	    add_scd_str(hid, &t);
	    t.s = t.next;
	} else if (hid->mk & hl_defline) {
	    add_scd_str_fc(hid, &t, hl_defline, '`', &hid->hl->fc_def);
	    t.s = t.next;
	}

	if (t.s && *t.s && (*t.s != ' ') && (*t.s != 0x09) && (*t.s != '#')) {
	    pc = t.s;
	    while (*pc && (*pc >= 0x20) && (*pc != ':')) pc++;
	    if (*pc == ':') {
		add_scd_str_fc(hid, &t, hl_defline, ':', &hid->hl->fc_def);
		t.s = t.next;
	    }
	}

	while (Get_Make_STok(hid, &t)) {
	    if (t.c == 0x01) {
		m = 0;
		if ((t.s[0] == '0') && (t.lg > 2) && (t.s[1] == 'x') && (zC_HEX[t.s[2]])) {
		    m = 1;
		    for (i=3; i<t.lg; i++) {
			if (!zC_HEX[t.s[i]]) {m = 0; break;}
		    }
		    if (m) add_scd_nr(hid, (char*)t.s, t.lg);
		} else if (zC_DIGIT[t.s[0]]) {
		    m = 1;
		    for (i=1; i<t.lg; i++) {
			if (!zC_DIGIT[t.s[i]]) {m = 0; break;}
		    }
		    if (m) add_scd_nr(hid, (char*)t.s, t.lg);
		}
		if (!m) {
		    if (t.lg > 1) {
			hl_keyword_c0(hid, hid->hl->fc0_Dat);
		    }
		}

	    } else if (t.c == '"') {
		add_scd_str(hid, &t);

	    } else if (t.c == '`') {
		add_scd_str_fc(hid, &t, hl_defline, '`', &hid->hl->fc_def);

	    } else if (t.c == '#') {
		t.lg = pclen((char*)t.s);
		add_scd_comment(hid, (char*)t.s, t.lg);
		break;
	    }
	    t.s = t.next;
	}
}

void highlight_Make(Thighlight *hl, TLines *tls, int edAnf, int edEnd, int fu) {
  int i;
  Thldat hld;

	hld.hl = hl;
	hld.mk = 0;

	if (fu & clfu_use_yaye) {
	    if (edAnf > 0) {
		hld.cs = tls->lines->cs[edAnf-1];
		hld.mk = hld.cs->hl_mk;
	    }
	    if (edEnd >= tls->Count) edEnd = tls->Count-1;
	    for (i=edAnf; i<=edEnd; i++) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_Make(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }

	    for (; i<tls->Count; i++) {
		hld.cs = tls->lines->cs[i];
		if (hld.mk == hld.cs->hl_mk) break;
		hld.cs = tls->lines->cs[i];
		hlSetLine_Make(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	    if (i < tls->Count) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_Make(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	} else {
	    for (i=0; i<tls->Count; i++) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_Make(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	}
}
