/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "highl.h"

//*********************** highlight - Pascal ******************************

static const char *sDat_Pas = 
 "as do if is of or to and asm div end for nil mod not shl shr try var xor case else "
 "file goto read then type unit uses with array cdecl class const begin label "
 "raise until while write downto except object packed public record repeat "
 "finally private virtual function override property inherited interface "
 "procedure protected published destructor constructor implementation ";

static const char *sDat_Pas2 = 
"string integer boolean byte char word longword float double";


static const char C_zPas[256] = {
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x01,0x00,0x00,0x27 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x10,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x00,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x00 ,0x01,0x00,0x00,0x01,
  0x00,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01,
  0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x01 ,0x01,0x01,0x01,0x10 ,0x00,0x10,0x00,0x00,

  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,

  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00,
  0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00 ,0x00,0x00,0x00,0x00};

void highlight_Pas(Thighlight *hl, TLines *tls, int edAnf, int edEnd, int fu);
void highlight_SetCaret_Pas(Thighlight *hl, TLines *tls, int idx, int idy, int fu);

Thighlight *Thighlight_Pas_Create(TWins *wins, TLines *tls) {
  Thighlight *hl;
	hl = Thighlight_Create(wins, tls);
	if (!hl) return NULL;

	hl_Set_keyword(hl, &hl->fc0_Dat, sDat_Pas, FONT_Bold, 0x000000, hl->Font->g.BackColor);
	hl_Set_keyword(hl, &hl->fc1_Dat, sDat_Pas2, FONT_Medium, 0x800000, hl->Font->g.BackColor);

	hl->ChangeLine = highlight_Pas;
	hl->SetCaret = highlight_SetCaret_Pas;
	hl->OldCaretX = -1;
	hl->OldCaretY = -1;
	hl->CharCase = True;
	return hl;
}

static bool Get_Pas_STok(Thldat *hid, Tstoken *t) {
  unsigned char *s = t->s;
  int i;
  char m, c;
	if (!s || !*s) return False;
	while (*s && !C_zPas[*s]) s++;
	t->s = s;
	if (!*s) return False;
	i = 0;
	m = C_zPas[*s];
	if (m == 0x10) {
	    while (*s && (m == C_zPas[*s])) {
		c = *s;
		s++; i++;
		if (c == 0x27) break;
		if (((c == '{') && !(hid->mk & hl_comline)) || 
		    ((c == '}') && (hid->mk & hl_comline))) break;
		if ((c == '/') && (*s == '/')) {
		    if (i == 1){i++; s++; break;}
		    if (i > 1) {i--; s--; break;}
		}
	    }
	} else {
		if (*s) {s++; i++;}
		if (m != 0x27)
			while (*s && (m == C_zPas[*s])) {s++; i++;}
	}
	t->next = s;
	t->lg = i;
	t->c = m;
	return True;
}

static bool findEnd_Pas_comline(Thldat *hid) {
  Tstoken t;
	t.s = hid->t->next;
	t.next = hid->t->next;
	while (Get_Pas_STok(hid, &t)) {
	    if ((t.c == 0x10) && (t.lg == 1)) {
		if (t.s[0] == '}') {
			hid->t->lg = t.next - hid->t->s;
			hid->t->next = t.next;
			hid->mk &= ~hl_comline;
			return True;
		}
	    }
	    t.s = t.next;
	}
	hid->t->lg = pclen((char*)hid->t->s);
	hid->t->next = t.next;
	return False;
}

static void add_scd_pas_str(Thldat *hid, Tstoken *t) {
  byte *pc;
	hid->mk &= ~hl_strline;
	pc = t->next;
	if (!pc) return;
	while (*pc && (*pc != 0x27)) pc++;
	if (*pc == 0x27) pc++;
	t->lg = pc - t->s;
	t->next = pc;
	add_scd(hid->cs, (char*)t->s, t->lg, &hid->hl->fc_str, 0);
}

static void hlSetLine_Pas(Thldat *hid) {
  Tstoken t;
  int i, m;
  bool mk;

	xfree(hid->cs->c);
	hid->cs->c = NULL;
	hid->t = &t;
	t.s = (byte*)hid->cs->s;
	t.next = (byte*)hid->cs->s;
	if (hid->mk & hl_comline) {
	    mk = findEnd_Pas_comline(hid);
	    add_scd_comment(hid, (char*)t.s, t.lg);
	    if (!mk) return;
	    t.s = t.next;
	} else if (hid->mk & hl_strline) {
	    add_scd_pas_str(hid, &t);
	    t.s = t.next;
	} else if (hid->mk & hl_defline) {
	    add_scd_def(hid, &t);
	    t.s = t.next;
	}

	while (Get_Pas_STok(hid, &t)) {
	    if (t.c == 0x10) {
		if (t.lg == 2) {
		    if ((t.s[0] == '/') && (t.s[1] == '/')) {
			t.lg = pclen((char*)t.s);
			add_scd_comment(hid, (char*)t.s, t.lg);
			break;
		    }
		} else if (t.lg == 1) {
		    if (t.s[0] == '{') {
			hid->mk |= hl_comline;
			findEnd_Pas_comline(hid);
			add_scd_comment(hid, (char*)t.s, t.lg);

		    } else if (t.s[0] == '}') {
			add_scd_comment(hid, (char*)t.s, t.lg);
			hid->mk &= ~hl_comline;
		    }
		} 
	    } else if (t.c == 0x01) {
		m = 0;
		if ((t.s[0] == '$') && (t.lg > 1) && zC_HEX[t.s[1]]) {
		    m = 1;
		    for (i=3; i<t.lg; i++) {
			if (!zC_HEX[t.s[i]]) {m = 0; break;}
		    }
		    if (m) add_scd_nr(hid, (char*)t.s, t.lg);
		} else if (zC_DIGIT[t.s[0]]) {
		    m = 1;
		    for (i=1; i<t.lg; i++) {
			if (!zC_DIGIT[t.s[i]]) {m = 0; break;}
		    }
		    if (m) add_scd_nr(hid, (char*)t.s, t.lg);
		}
		if (!m) {
		    if (t.lg > 1) {
			if (!hl_keyword_c0(hid, hid->hl->fc0_Dat))
				hl_keyword_c0(hid, hid->hl->fc1_Dat);
		    }
		}

	    } else if (t.c == 0x27) {  
		add_scd_pas_str(hid, &t);
	    }
	    t.s = t.next;
	}
}

void highlight_Pas(Thighlight *hl, TLines *tls, int edAnf, int edEnd, int fu) {
  int i;
  Thldat hld;

	hld.hl = hl;
	hld.mk = 0;

	if (fu & clfu_use_yaye) {
	    if (edAnf > 0) {
		hld.cs = tls->lines->cs[edAnf-1];
		hld.mk = hld.cs->hl_mk;
	    }
	    if (edEnd >= tls->Count) edEnd = tls->Count-1;
	    for (i=edAnf; i<=edEnd; i++) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_Pas(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }

	    for (; i<tls->Count; i++) {
		hld.cs = tls->lines->cs[i];
		if (hld.mk == hld.cs->hl_mk) break;
		hld.cs = tls->lines->cs[i];
		hlSetLine_Pas(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	    if (i < tls->Count) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_Pas(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	} else {
	    for (i=0; i<tls->Count; i++) {
		hld.cs = tls->lines->cs[i];
		hlSetLine_Pas(&hld);
		if (hld.cs->c) hld.cs->hl_mk = hld.mk; else hld.cs->hl_mk = 0;
	    }
	}
}

static int hl_begin(byte *s0, byte *s) {
  int i = 0;
  const char *pc; 
	switch (l_ascii[*s]) {
	case 'b': i = 5; pc = "begin"; break;
	case 'c': i = 4; pc = "case"; break;
	case 't': i = 3; pc = "try"; break;
	default: return 0;
	}
	if (pcncasecmp_fi((char*)s, pc, i, FU_CASE_ASCII)) return 0;
	if ((C_zPas[s[i]] != 0x01) || !s[i]) return i;
	return 0;
}

static bool hl_begin_scan(byte *s0, byte *s) {
	while ((s > s0) && (C_zPas[s[-1]] == 0x01)) s--;
	return hl_begin(s0, s);
}

static bool hl_end(byte *s0, byte *s) {
	if ((*s == 'e') || (*s == 'E')) {
	    if ((s > s0) && (C_zPas[s[-1]] == 0x01)) return False;

	    return (((s[1] == 'n') || (s[1] == 'N')) &&
		    ((s[2] == 'd') || (s[2] == 'D')) &&
		    ((C_zPas[s[3]] != 0x01) || !s[3]));
	}
	return False;
}

static bool hl_end_scan(byte *s0, byte *s) {
	while ((s > s0) && (C_zPas[s[-1]] == 0x01)) s--;
	return hl_end(s0, s);
}

static bool hl_comCharAnf_Pas(byte *pc) {
	return (((*pc == '/') && (pc[1] == '/')) || (*pc == '{'));
}

void highlight_SetCaret_Pas(Thighlight *hl, TLines *tls, int idx, int idy, int fu) {
  TLineEdit *le = (TLineEdit*)hl->wins;
  TColS *cs;
  int x, xe, y, h, idxe = 0, count = 1, maxy=1000;
  int txz = 0, res_x = -1, res_y = -1;
  byte *pc, *s0;
  byte c, cpc;
  bool mkc;

	if (!fu) goto NoSelChar;
	if (!hl && !hl->wins) goto NoSelChar;
	if (hl->wins->wtyp != wtyp_LineEdit) goto NoSelChar;

	cs = TLines_Get_pcs(tls, idy);
	if (!cs || !cs->s) goto NoSelChar;
	if (idx >= cs->lg) goto NoSelChar;
	if (cs->hl_mk & hl_comline) goto NoSelChar;
	s0 = (byte*)cs->s;
	pc = &s0[idx];
	x = 0;
	if ((*pc == '(') || hl_begin_scan(s0 ,pc)) {
	    x = 1;
	} else if ((*pc == ')') || hl_end_scan(s0 ,pc)) {
	    x = 2;
	} else if (idx && (pc[-1] == '(')) {
	    pc--; idx--;
	    x = 1;
	} else if (idx && (pc[-1] == ')')) {
	    pc--; idx--;
	    x = 2;
	}

	if (x == 1) {
	    mkc = (*pc != '(');
	    pc++;
	    cpc = 0x01;
loop_v:
	    while (*pc && !hl_comCharAnf_Pas(pc) && count) {
	      if (*pc == 0x27) txz++;
	      if ((txz & 1) == 0) {
		if (mkc) {
		    c = C_zPas[*pc];
		    if (!cpc && (c == 0x01)) {
			cpc = 0x01;
			if (hl_end(s0 ,pc)) count--;
			else if (hl_begin(s0 ,pc)) count++;
		    } else if (c != 0x01) cpc = 0;
		} else {
		    if (*pc == ')') count--; else if (*pc == '(') count++;
		}
	      }
	      if (count) pc++;
	    }
	    cpc = 0;
loop_vs0:
	    maxy--;
	    if (!maxy) goto NoSelChar;
	    if (count) {
		idy++;
		cs = TLines_Get_pcs(tls, idy);
		if (!cs) goto NoSelChar;
		if (!cs->s) goto loop_vs0;
		if (cs->hl_mk & hl_comline) goto loop_vs0;
		pc = s0 = (byte*)cs->s;
		goto loop_v;
	    }
	    idx = pc - (byte*)cs->s;
	    idxe = idx+1;
	    if (mkc) idxe += 2;

	} else if (x == 2) {
	    mkc = (*pc != ')');
	    cpc = 0x01;
loop_r:
	    if (idx) {pc--; idx--;}
	    while (idx && count) {
	      if (*pc == 0x27) txz++;
	      if ((txz & 1) == 0) {
		if (mkc) {
		    c = C_zPas[*pc];
		    if (!cpc && (c == 0x01)) {
			cpc = 0x01;
			if (hl_end_scan(s0 ,pc)) count++;
			else if (hl_begin_scan(s0 ,pc)) count--;
		    } else if (c != 0x01) cpc = 0;
		} else {
		    if (*pc == '(') count--; else if (*pc == ')') count++;
		}
	      }
	      if (count) {pc--; idx--;}
	    }
	    cpc = 0;
loop_rs0:
	    maxy--;
	    if (!maxy) goto NoSelChar;
	    if (count) {
		idy--;
		cs = TLines_Get_pcs(tls, idy);
		if (!cs) goto NoSelChar;
		if (!cs->s) goto loop_rs0;
		if (cs->hl_mk & hl_comline) goto loop_rs0;
		idx = 0;
		pc = s0 = (byte*)cs->s;
		while (*pc && !hl_comCharAnf_Pas(pc)) {pc++; idx++;}
		goto loop_r;
	    }
	    idxe = idx+1;
	    if (mkc) {
		idx -= hl_begin_scan(s0 ,pc)-1;
	    }
	}

	if (!count) {
	    TLineEdit_GetChar_xy(le, idx, idy, &x, &y, &h);
	    TLineEdit_GetChar_xy(le, idxe, idy, &xe, &y, &h);
	    if ((x >= 0) && (x < xe)) {
		y += h - 2;
		DrawRectRGB(le->WinID, 0x004000, x, y, xe-x, 2);
	    }
	}

NoSelChar:
	hl->OldCaretX = res_x;
	hl->OldCaretY = res_y;
	return;
}
