/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appXbase.h"
#include "tlineedit.h"

void TLineEdit_Paste(TLineEdit *le, int *lineNr, int *charPos, const char *s) {
	TLines_Paste(le->tls, lineNr, charPos, s);
}

void TLineEdit_AddPaste(TLineEdit *le, const char *s) {
  TLines *tls = le->tls;
  TColS *pcs;
  int lineNr, charPos;

	lineNr = tls->Count-1;
	if (lineNr < 0) lineNr = 0;
	pcs = TLines_Get_pcs(tls, lineNr);
	charPos = 0;
	if (pcs) charPos = pcs->lg;
	TLines_Paste(le->tls, &lineNr, &charPos, s);
//	TLineEdit_SetCaretXY(le, charPos, lineNr);
	Refresh((TWins*)le);
}

void TLineEdit_Add(TLineEdit *le, const char *s) {
  TLines *tls = le->tls;
  int lineNr, charPos;

	lineNr = tls->Count;
	TLines_Paste(le->tls, &lineNr, &charPos, s);
	Refresh((TWins*)le);
}
