/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldconsole.h"
#include <sys/wait.h>

static void mClear_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormAHconsole *fmain = (TFormAHconsole*)self->FormStruct;

	Tleterm_Clear(fmain->leterm, False);
	leAddChar(fmain, "\0");		//refresh
}

static void mKill_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  int pid = pctoint_scan(smi->s);
	if (pid > 0) kill(pid, SIGKILL);
}

static void mExit_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  Close();
}

static void mFile_OnMenuOpen(TMenu *self) {
  TFormAHconsole *fmain = (TFormAHconsole*)self->FormStruct;
  Tleterm *term = fmain->leterm;
  TMenuItem *mi;
  TPidStat *PidStat;
  bool sh_L1, sh_slave;
  char buf[80];

	PidStat = NULL;
	sh_L1 = (term->le->tls->Count == 1) || 
		   (term->line[0] != '>') || (term->line[1] != ' ');
	sh_slave = chk_sh_slave(fmain, &PidStat);
	mi = self->MenuItem;
	while (mi) {
	    if (mi->tag == 1) {
		mi->fu &= ~miNotEnabled;
		if (sh_slave || sh_L1) mi->fu |= miNotEnabled;

	    } else if (mi->tag == 2) {
		if (sh_slave && PidStat) {
		    mi->fu &= ~miNotEnabled;
		    snprintf(buf, sizeof(buf), "Kill  pid=%d \"%s\"", PidStat->pid, PidStat->name);
		    TMenuItem_SetCaption(mi, buf);
		    xfree(PidStat->name);
		    ppfree(&PidStat);
		} else {
		    mi->fu |= miNotEnabled;
		    TMenuItem_SetCaption(mi, "Kill");
		}
	    }
	    mi = mi->next;
	}
}

/* ______________________ Create _____________________________________ */
void MenuFile_Create(TFormAHconsole *fmain) {
	fmain->mbFile = TMenuButton_Create(fmain->PanelTop, (TMenuButton*)fmain);
	fmain->mbFile->top = 2;
	fmain->mbFile->left = 1;
	SetCaption((TWins*)fmain->mbFile, "File");
	Set_Parent((TWins*)fmain->mbFile, fmain->PanelTop);

	fmain->menuFile = TMenu_Create((TWins*)fmain);
	fmain->mbFile->menu = fmain->menuFile;
	fmain->menuFile->OnMenuOpen = mFile_OnMenuOpen;

	TMenu_AddItem(fmain->menuFile, "Clear", 0, mClear_OnClick)->tag = 1;
	TMenu_AddItem(fmain->menuFile, "KILL", 0, mKill_OnClick)->tag = 2;
	TMenu_AddItem(fmain->menuFile, "Exit", 0, mExit_OnClick);

}
