
#include "sysbase.h"

static char *Help_Msg = {
  "\n"
  "Usage: testchars [options] outfile\n"
  "  -a=0x0000            start char\n"
  "  -e=0x00ff            end char\n"
  "\n"
  "  -h, --help           Prints out this screen\n"
};

int main (int argc, char **argv) {
  int i, anf, end, idx, m;
  char *val, *OutFile;
  FILE *outf;
  word *wc0, *wc;
  bool help = False;
  bool err = False;

	OutFile = NULL;
	anf = 0;
	end = 0xff;

	i = 1;
	while (!err && !help && (i<argc)) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'a':
		    val++;
		    if (*val == '=') val++;
		    anf = RdInt(val);
		    break;
		case 'e':
		    val++;
		    if (*val == '=') val++;
		    end = RdInt(val);
		    break;
		case 'h':
		    help = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
		    } else err = True;
		    break;
		default: 
		    err = True;
		}
	    } else {
		OutFile = val;
	    }
	    i++;
	}

	anf &= 0xffff;
	end &= 0xffff;

	err = err || (anf >= end);
	if (help || err) {
	    printf(Help_Msg);
	    exit(err);
	}

	if (!OutFile) OutFile = "test_u16.txt";

	outf = fopen(OutFile, "wb");
	if (!outf) appError(EMSG_ERR_EXIT | EMSG_SYS, NULL);
#define LINESIZE 64
	wc0 = xmalloc((LINESIZE+2)*2);
	*wc0 = 0xfeff; //BOM u16
	fwrite(wc0, 1, 2, outf);

	m = anf & 0xff00;
	wc = wc0;
	idx = 0;
	while (anf <= end) {
	    *wc = anf;
	    wc++; idx++; anf++;
	    if ((idx >= LINESIZE) || (m != ( anf & 0xff00))) {
		*wc = 0x000a;
		wc++; idx++;
		if ((anf <= end) && (m != ( anf & 0xff00))) {
		    *wc = 0x000a;
		    idx++;
		}
		fwrite(wc0, 1, idx*2, outf);
		wc = wc0;
		idx = 0;
		m = anf & 0xff00;
	    }
	}

	if (idx) {
	    *wc = 0x000a;
	    idx++;
	    fwrite(wc0, 1, idx*2, outf);
	}

	fclose(outf);

	return 0;
}
