/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldconsole.h"

typedef struct {
  const int Key;
  const TKeyS k[2];
} TKeyTab;

const TKeyTab KeyTab[] = {
  {XK_BackSpace, .k[0].cc="\x7f\x00",     .k[1].cc="\x7f\x00"},
  {XK_Tab,       .k[0].cc="\x09\x00",     .k[1].cc="\x09\x00"},
  {XK_Return,    .k[0].cc="\x0d\x00",     .k[1].cc="\x0d\x00"},
  {XK_Escape,    .k[0].cc="\x1b\x00",     .k[1].cc="\x1b\x00"},

  {XK_Left,      .k[0].cc="\x1b""[D\0",   .k[1].cc="\x1b""OD\0"},
  {XK_Right,     .k[0].cc="\x1b""[C\0",   .k[1].cc="\x1b""OC\0"},
  {XK_Up,        .k[0].cc="\x1b""[A\0",   .k[1].cc="\x1b""OA\0"},
  {XK_Down,      .k[0].cc="\x1b""[B\0",   .k[1].cc="\x1b""OB\0"},

  {XK_Home,      .k[0].cc="\x1b""OH\0",   .k[1].cc="\x1b""OH\0"},
  {XK_Page_Up,   .k[0].cc="\x1b""[5~\0",  .k[1].cc="\x1b""[5~\0"},
  {XK_Page_Down, .k[0].cc="\x1b""[6~\0",  .k[1].cc="\x1b""[6~\0"},
  {XK_End,       .k[0].cc="\x1b""OF\0",   .k[1].cc="\x1b""OF\0"},
  {XK_Insert,    .k[0].cc="\x1b""[2~\0",  .k[1].cc="\x1b""[2~\0"},
  {XK_Delete,    .k[0].cc="\x1b""[3~\0",  .k[1].cc="\x1b""[3~\0"},

  {XK_F1,        .k[0].cc="\x1b""[[A\0",  .k[1].cc="\x1b""[11~\0"},
  {XK_F2,        .k[0].cc="\x1b""[[B\0",  .k[1].cc="\x1b""[12~\0"},
  {XK_F3,        .k[0].cc="\x1b""[[C\0",  .k[1].cc="\x1b""[13~\0"},
  {XK_F4,        .k[0].cc="\x1b""[[D\0",  .k[1].cc="\x1b""[14~\0"},
  {XK_F5,        .k[0].cc="\x1b""[[E\0",  .k[1].cc="\x1b""[15~\0"},

  {XK_F6,        .k[0].cc="\x1b""[17~\0", .k[1].cc="\x1b""[17~\0"},
  {XK_F7,        .k[0].cc="\x1b""[18~\0", .k[1].cc="\x1b""[18~\0"},
  {XK_F8,        .k[0].cc="\x1b""[19~\0", .k[1].cc="\x1b""[19~\0"},
  {XK_F9,        .k[0].cc="\x1b""[20~\0", .k[1].cc="\x1b""[20~\0"},
  {XK_F10,       .k[0].cc="\x1b""[21~\0", .k[1].cc="\x1b""[21~\0"},

  {XK_F11,       .k[0].cc="\x1b""[23~\0", .k[1].cc="\x1b""[23~\0"},
  {XK_F12,       .k[0].cc="\x1b""[24~\0", .k[1].cc="\x1b""[24~\0"},

  {0}
};


bool xktotty(int XK, int id, TKeyS *KeyS) {
  const TKeyTab *t = KeyTab;
  
	while (t->Key && (t->Key != XK)) {
	    t++;
	}
	if (!t->Key) return False;
	pnmove(KeyS, t->k[id].cc, 8);
	return True;
}
