/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#ifndef STANDALONE_BUILDIN
#include "buildin_app.h"
#endif
#include "appXbase.h"
#include "dlg.h"

static const char *bi_Copyright_MsgBox_Help_Msg = {
  "\n"
  "Usage: Copyright_MsgBox [options] \"Caption\"\n"
  "\n"
  "  -h, --help           Prints out this screen\n"
  "  version AHwm "VERSION"  (build %d  %s)\n"
};

#ifdef STANDALONE_BUILDIN
int main (int argc, char **argv) {
#else
int bi_Copyright_MsgBox_main (int argc, char **argv) {
#endif
  int i, m;
  char *pc, *caption;
  bool help = False;

	caption = NULL;
	for (i=1; i<argc; i++) {
	    pc = argv[i];
	    if (*pc == '-') {
		pc++;
		if (*pc == '-') {
#ifdef Test_Root_WinId
		    pc++;
		    if (pcncmp(pc, "TestRootWinID", 13)) {
			i++;
			pc = argv[i];
			if (pc && *pc != '-') {
				TestRootWinId = pctoint(pc);
			} else help = True;
		    } else help = True;
#endif
		} else help = True;
	    } else {
		if (*pc == '\"') {
		    pc++;
		    caption = pcdup(pc);
		    m = pclen(caption)-1;
		    if (m > 0 && caption[m] == '\"') caption[m] = 0;
		} else caption = pcdup(pc);
	    }
	}
	if (help) {
	    printf(bi_Copyright_MsgBox_Help_Msg, ALD_BUILD_V, __DATE__);
	    exit(1);
	}

	initXapp(0, argc, argv);
#ifdef USE_DECOR
	appXDat.DefaultButtonDecor = TDecor_button_w3b3_Create();
#endif
	Copyright_MsgBox_Show(NULL, caption);
	return 0;
}
