/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "buildin_app.h"
#include "aldbatmon.h"
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>

/*
static char *batico[]={
"20 20 9 1",
". c None",
"a c #000000",
"b c #000000",
"# c #585858",
"e c #808080",
"f c #a0a0a0",
"c c #c0c000",
"g c #c0c0c0",
"d c #ffffff",
"...........##aa##...",
"..........bcaddacb..",
".........bc#ae#accb.",
".........bbcceeccbb.",
"...faa...bgbbbbbbgb.",
"..fa.fa..bggggggggb.",
".fa...fa.bggggggggb.",
".fa....fabggggggggb.",
"..fa....fbggggggggb.",
"...fa....bggggggggb.",
"...ba....bggggggggb.",
"..beeb...bggggggggb.",
".b####b..bggggggggb.",
"bgggfffb.bggggggggb.",
"bg####fb.bggggggggb.",
"bbeeeebb.bggggggggb.",
".f#..f#..bggggggggb.",
".f#..f#..bggggggggb.",
".f#..f#...bggggggb..",
"...........bbbbbb..."};
*/

static const char baticoNet_AHico[] = {
 0x01,0x08,0x14,0x00,0x14,0x00,0x00,0x00,0xAC,0x00,0x00,0x00,0x00,0x00,0xCB,0x5A,
 0x10,0x84,0x13,0x9D,0x00,0xBE,0x17,0xBE,0xFF,0xFF,0x00,0xF8,0x01,0xC0,0x3F,0x00,
 0xFE,0x07,0xE0,0x7F,0x38,0xFE,0xC7,0xE6,0x7F,0xC6,0xFE,0x67,0xF8,0x7F,0x0C,0xFF,
 0x87,0xE1,0x7F,0x18,0xFE,0xC7,0xE3,0x7F,0x7E,0xFE,0xF7,0xEF,0x7F,0xFF,0xFE,0xF7,
 0xEF,0x7F,0x66,0xFE,0x67,0xE6,0x7F,0x66,0xFC,0x03,0x80,0x1F,0x12,0x20,0xA5,0xF8,
 0xD1,0xA4,0xC2,0x84,0x36,0x49,0xBB,0xB5,0x09,0x81,0x38,0x49,0x12,0x87,0x20,0x62,
 0xDB,0xB6,0x1D,0x82,0x88,0x6D,0xDB,0x76,0x08,0x22,0xB6,0x6D,0xDB,0x21,0x18,0xDB,
 0xB6,0xED,0x10,0xB1,0x6D,0xDB,0x4E,0x10,0xDB,0xB6,0xED,0x64,0x4B,0x6C,0xDB,0xB6,
 0x13,0x49,0x4A,0x6C,0xDB,0xB6,0x13,0xDB,0x24,0x13,0xDB,0xB6,0xED,0xC4,0x92,0xC4,
 0xC4,0xB6,0x6D,0x3B,0xC9,0xB6,0x25,0xB1,0x6D,0xDB,0x0E,0x45,0xC5,0xB6,0x6D,0x3B,
 0x14,0x15,0xDB,0xB6,0xED,0x50,0x54,0x6C,0xDB,0x4E,0x92,0x24};

/*
static char *baticoBat[]={
"20 20 9 1",
". c None",
"a c #000000",
"g c #0000ff",
"f c #0080ff",
"b c #303030",
"# c #585858",
"e c #c0c0c0",
"c c #c00000",
"d c #ffffff",
"...........##aa##...",
"..........bcaddacb..",
".........bc#ae#a#cb.",
".........bbccbbccbb.",
".........bebbbbbbeb.",
".........beeeeeeeeb.",
".........beeeeeeeeb.",
".........beeeeeeeeb.",
".........beeeeeeeeb.",
".........beeeeeeeeb.",
".........beeeeeeeeb.",
".........beeeeeeeeb.",
"...bbb...beeeeeeeeb.",
"....b....beeeeeeeeb.",
"....b....beeeeeeeeb.",
"..bbbbbbbbeeeeeeeeb.",
".bbfgggggbeeeeeeeeb.",
".bfgbbbbbbeeeeeeeeb.",
".bgb......beeeeeeb..",
".bgb.......bbbbbb..."};
*/

static const char baticoBat_AHico[] = {
 0x01,0x08,0x14,0x00,0x14,0x00,0x00,0x00,0x9F,0x00,0x00,0x00,0x1F,0x00,0x1F,0x04,
 0x86,0x31,0xCB,0x5A,0x17,0xBE,0x00,0xB8,0xFF,0xFF,0x00,0xF8,0x01,0xC0,0x3F,0x00,
 0xFE,0x07,0xE0,0x7F,0x00,0xFE,0x07,0xE0,0x7F,0x00,0xFE,0x07,0xE0,0x7F,0x00,0xFE,
 0x07,0xE0,0x7F,0x00,0xFE,0x07,0xE0,0x7F,0x38,0xFE,0x07,0xE1,0x7F,0x10,0xFE,0xC7,
 0xFF,0x7F,0xFE,0xFF,0xE7,0xFF,0x7F,0x0E,0xFC,0xE3,0x80,0x1F,0x24,0x40,0xCE,0xF8,
 0xE1,0xCD,0x44,0x09,0x7A,0x9B,0xBD,0xD9,0xDB,0xBA,0x6D,0x5B,0xB7,0xB6,0x6D,0xDB,
 0xAD,0x6D,0xDB,0x76,0x6B,0xDB,0xB6,0xDD,0xDA,0xB6,0x6D,0xB7,0xB6,0x6D,0xDB,0xAD,
 0x6D,0xDB,0x76,0x6B,0xDB,0xB6,0xDD,0xB6,0xB5,0x6D,0xDB,0x6E,0x6B,0xDB,0xB6,0xDD,
 0xD6,0xB6,0x6D,0xBB,0x6D,0xDB,0xB6,0xB6,0x6D,0xDB,0x6D,0x4A,0x92,0xAC,0x6D,0xDB,
 0x76,0x53,0xB6,0x6D,0x6B,0xDB,0xB6,0xDD,0xB2,0xB5,0x6D,0xBB,0x65,0xDB,0xB6};


/* 
---- /proc/acpi/battery/CMB1/info ----

present:                 yes
design capacity:         5200 mAh
last full capacity:      5200 mAh
battery technology:      rechargeable
design voltage:          10800 mV
design capacity warning: 0 mAh
design capacity low:     0 mAh
capacity granularity 1:  1 mAh
capacity granularity 2:  1 mAh
model number:            CP255100
serial number:           1
battery type:            LION
OEM info:                Fujitsu

---- /proc/acpi/battery/CMB1/state ----
present:                 yes
capacity state:          ok
charging state:          discharging		(or. charging)
present rate:            1546 mA
remaining capacity:      4320 mAh
present voltage:         11670 mV

---------------------------------------
/sys/class/power_supply/CMB1/uevent

POWER_SUPPLY_NAME=CMB1
POWER_SUPPLY_TYPE=Battery
POWER_SUPPLY_STATUS=Unknown
POWER_SUPPLY_PRESENT=1
POWER_SUPPLY_TECHNOLOGY=Li-ion
POWER_SUPPLY_VOLTAGE_MIN_DESIGN=10800000
POWER_SUPPLY_VOLTAGE_NOW=12328000
POWER_SUPPLY_CURRENT_NOW=0
POWER_SUPPLY_CHARGE_FULL_DESIGN=5200000
POWER_SUPPLY_CHARGE_FULL=5200000
POWER_SUPPLY_CHARGE_NOW=5100000
POWER_SUPPLY_MODEL_NAME=CP255102
POWER_SUPPLY_MANUFACTURER=Fujitsu
POWER_SUPPLY_SERIAL_NUMBER=1

*/



typedef struct TAHicoHead {
  char fu;
  char cols;
  short width;
  short height;
  int DataSize;
    //..... Data
} TAHicoHead;

static void InitBatImg(TBatMonForm *bmf) {
  TPixMap *pxm;

	pxm = CreateAHicoImg(baticoNet_AHico);
	bmf->paint_pxm = bmf->IcoBatNet = pxm;

	pxm = CreateAHicoImg(baticoBat_AHico);
	bmf->IcoBatBat = pxm;

	bmf->lastmode = 3;
}

bool StatStrScan(const char *keyw0, char key, char *pc, char **val) {
  bool res;
  const char *keyw;

	keyw = keyw0;
	while (*keyw && *pc && (*keyw == *pc)) {keyw++; pc++;}
	res = (*pc == key) && !*keyw;
	if (res) {
	    *val = NULL;
	    pc++;
	    while (*pc && (*pc == ' ')) pc++;
	    if (*pc) {
		*val = pc;
	    } else res = False;
	}
	return res;
}

static bool AHbatmon_StatStrScan(const char *keyw0, char *pc, char **val) {
  const char *keyw;
  bool res;

	keyw = keyw0;
	while (*keyw && *pc && (*keyw == *pc) && (*keyw != ' ')) {keyw++; pc++;}
	res = (*pc == ' ');
	if (res) {
	    *val = NULL;
	    pc++;
	    while (*pc && (*pc == ' ')) pc++;
	    if (*pc) {
		*val = pc;
	    } else res = False;
	}
	return res;
}

static void SetPix(XImage *Ximg, int RGB, int x, int y) {
  int w;
	if (Ximg->depth == 16) {
	    w = Ximg->bytes_per_line >> 1;
	    word *pix = (word*)Ximg->data + x + (w * y);
	    *pix = RGB24To16(RGB);
	} else if (Ximg->depth == 24) {
	    w = Ximg->bytes_per_line >> 2;
	    dword *pix = (dword*)Ximg->data + x + (w * y);
	    *pix = RGB;
	}
}

static void PaintBatIco(TBatMonForm *bmf) {
  int xk = 8;
  int yk = 14;
  byte colb[8] = {0xc0,0xd0,0xe0,0xd0,0xc0,0xb0,0xa0,0x90};
  TPixMap *pxm;
  int x, y, xo, yo, m, k, km, rgb;
  bool imgOk;

	if (!bmf->FormTaskBar) return;
	if (bmf->mode & 0x01) pxm = bmf->IcoBatBat; else pxm = bmf->IcoBatNet;
	imgOk = ((bmf->paint_pxm == pxm) && ((bmf->mode & 0x03) == (bmf->lastmode & 0x03)));
	km = xk * yk;
	k = bmf->capacity * km / 1000;

	if (!imgOk || (bmf->capmk != k)) {
	    bmf->capmk = k;
	    xo = 10;
	    for (y=0;y<yk;y++) {
		yo = 4;
		for (x=0;x<xk;x++) {
		    if (km > k) {
		      m = (colb[x]-0x80) + ((colb[x]-0x50) << 8) + ((colb[x]-0x40) << 16);
		    } else {
		      m = (colb[x]+0x1f) + ((colb[x]+0x10) << 8) + ((colb[x]-0x80) << 16);
		    }
		    SetPix(pxm->Ximg, m, x+xo, y+yo);
		    km--;
		    if (x == 0) yo++;
		    if (x == xk-2) yo--;
		}
	    }
	    pxm->stat &= ~pmxStat_XPixAkt;
	    TPixMap_PaintToWin(pxm, bmf->FormTaskBar->WinID, 0, 0);
	}

	if (!imgOk) {
	    bmf->paint_pxm = pxm;
	    bmf->lastmode = bmf->mode;
	    rgb = 0xc0c0c0;
	    if (bmf->mode & 0x01) rgb = 0xff8080;
	    if (bmf->mode & 0x02) rgb = 0x40c040;
	    SetColor((TWins*)bmf->FormTaskBar, rgb);
	}
}

static int oAmph = -1;
static int ocpuh, oscpuh;
static unsigned long oCPU_USER, oCPU_NICE, oCPU_SYS, oCPU_IDLE;

static void ALDWM_close(TBatMonForm *bmf) {
  XClientMessageEvent ev;

	ev.type = ClientMessage;
	ev.window = 0;
	ev.message_type = XInternAtom(appXDat.dpy, "XA_ALDesk_DESTROY", 0);
	ev.format = 32;
	ev.data.l[0] = 3;  //Quit force max. 20sec
	ev.data.l[1] = 0;
	XSendEvent(appXDat.dpy, appXDat.RootW, 0, SubstructureRedirectMask, (XEvent*)&ev);
}


static void AHbatmon_Set_Caption(TBatMonForm *bmf) {
  int i, m, cap;
  char *pc;
  char buf[48];
	pc = buf;
	ppcmove(&pc, "sysmon");
	if (bmf->buApply->Enabled) {*pc = '*';pc++;*pc = 0;}
	if (bmf->batdat[0]) {
	  cap = bmf->capacity / 10;
	  if (bmf->mode & 0x01) {
	    i = bmf->cap_time_min / 60;
	    m = bmf->cap_time_min - i * 60;
	    snprintf(pc, 32, "    Bat %d%%  %d:%02d", cap, i, m);
	  } else {
	    snprintf(pc, 32, "    Bat %d%%", cap);
	  }
	}
	SetCaption((TWins*)bmf->FormMain, buf);
}

static void set_sys_acpi_mAh(char *pc) {
  int i = 0;
	while (*pc && (*pc != ' ')) {pc++; i++;}
	if (i < 4) return;
	pc -= 3;
	pcnmove(pc, " mAh", 4);
}
static void set_sys_acpi_mV(char *pc) {
  int i = 0;
	while (*pc && (*pc != ' ')) {pc++; i++;}
	if (i < 4) return;
	pc -= 3;
	pcnmove(pc, " mV", 3);
}

static void AHbatmon_OnTimer(TgTimer *gTimer) {
  int i, m, mg, cpuh, scpuh, x, lfc, rmc;
  int Amph;
  FILE *f;
  char *tline, *pc, *val;
  const char *cpc;
  Tbatdat *bd;
  unsigned long CPU_USER, CPU_NICE, CPU_SYS, CPU_IDLE;
  TBatMonForm *bmf = gTimer->obj;
  char line[1024];

	bmf->tic_500ms++;
	bmf->mode &= ~0x03;
	bmf->present_rate = 0;
	i = 0;
	rmc = 0;
	lfc = 0;
	while (bmf->batdat[i]) {
	    bd = bmf->batdat[i];
	    bd->charging_state = 0;
	    i++;
	    f = fopen(bd->stat_fn, "r");
	    if (f) {
		lfc += bd->design_mAh;
loop:
		tline = fgets(line, sizeof(line)-1, f);
		if (tline) {
		    pc = tline;
		    while (*pc && (*pc != 10)) pc++;
		   *pc = 0;

		  if (bmf->PMmode == 3) {
		    if (StatStrScan("POWER_SUPPLY_STATUS", '=', tline, &val)) {
			if (!pcncasecmpASCII(val, "Discharging", 11)) bd->charging_state = 1;

		    } else if (StatStrScan("POWER_SUPPLY_CURRENT_NOW", '=', tline, &val)) {
			set_sys_acpi_mAh(val);
			SetCaption(bd->bpg.lbl_present_rate_v, val);
			bd->pres_mA = ppctoint((void*)&val);
			if (bd->pres_mA > 0x7fff) {
			    bd->pres_mA = 0;
			    SetCaption(bd->bpg.lbl_present_rate_v, "---");
			}
			bmf->present_rate += bd->pres_mA;
		    } else if (StatStrScan("POWER_SUPPLY_CHARGE_NOW", '=', tline, &val)) {
			set_sys_acpi_mAh(val);
			SetCaption(bd->bpg.lbl_remaining_capacity_v, val);
			bd->rem_mAh = ppctoint((void*)&val);
			rmc += bd->rem_mAh;
		    } else if (StatStrScan("POWER_SUPPLY_VOLTAGE_NOW", '=', tline, &val)) {
			set_sys_acpi_mV(val);
			SetCaption(bd->bpg.lbl_present_voltage_v, val);
			bd->pres_mV = ppctoint((void*)&val);
		    }
		  } else {
		    if (StatStrScan("charging state", ':', tline, &val)) {
			if (pcncmp(val, "discharging", 11)) bd->charging_state = 1;
		    } else if (StatStrScan("present rate", ':', tline, &val)) {
#ifdef TEST_BAT_CAP
			val = bd->s_remaining_capacity;
#endif
			SetCaption(bd->bpg.lbl_present_rate_v, val);
			bd->pres_mA = ppctoint((void*)&val);
			if (bd->pres_mA > 0x7fff) {
			    bd->pres_mA = 0;
			    SetCaption(bd->bpg.lbl_present_rate_v, "---");
			}
			bmf->present_rate += bd->pres_mA;
		    } else if (StatStrScan("remaining capacity", ':', tline, &val)) {
#ifdef TEST_BAT_CAP
			val = bd->s_remaining_capacity;
#endif
			SetCaption(bd->bpg.lbl_remaining_capacity_v, val);
			bd->rem_mAh = ppctoint((void*)&val);
			rmc += bd->rem_mAh;
		    } else if (StatStrScan("present voltage", ':', tline, &val)) {
			SetCaption(bd->bpg.lbl_present_voltage_v, val);
			bd->pres_mV = ppctoint((void*)&val);
		    }
		  }
		  goto loop;
		}
		fclose(f);
		if (bd->pres_mA > 0) {
		    if (bd->charging_state) {
			cpc = "discharging";
			bmf->mode |= 0x01;
		    } else {
			cpc = "charging";
			bmf->mode |= 0x02;
		    }
		} else cpc = "---";
		SetCaption(bd->bpg.lbl_charging_state_v, cpc);
	    }
	}

	if (rmc < 1) rmc = 1;
	if (lfc > 10) bmf->capacity = rmc * 1000 / lfc; else bmf->capacity = 0;
	if (bmf->capacity > 1000) bmf->capacity = 1000;
	if (bmf->capacity < 0) bmf->capacity = 0;

	if (bmf->mode & 0x01) {
	    if ((bmf->lastPMmode & 0x01) == 0) {
		bmf->discharge_tic = 3;
	    } else if (bmf->discharge_tic > 0) {
		if (bmf->present_rate < 50) {
		    bmf->present_rate = rmc;
		} else {
		    bmf->discharge_tic--;
		}
		bmf->cap_time_mk = bmf->present_rate << 5;
	    }
	    bmf->cap_time_mk += bmf->present_rate - (bmf->cap_time_mk >> 5);

	    m = bmf->cap_time_mk >> 5;
	    if (m < 1) m = 1;
	    bmf->cap_time_min = 54 * rmc / m;  //60min * 0,9 = 54
	}
	if (bmf->tic_500ms & 1) AHbatmon_Set_Caption(bmf);
	if ((bmf->tic_500ms & 0x0f) == 0x01) PaintBatIco(bmf);

	AHbatmon_CpuFreqReScan(bmf);

	AHbatmon_PM(bmf);

	if ((bmf->capacity <= 200) && (bmf->mode & 0x01)) {
	    if ((bmf->capacity <= 100) && (bmf->LowBatMk > 20)) bmf->LowBatMk = 20;
	    if ((bmf->capacity <= 50) && (bmf->LowBatMk > 5)) bmf->LowBatMk = 5;
	    if (bmf->capacity < 30) ALDWM_close(bmf);
	    if (bmf->LowBatMk < 3) XBell(appXDat.dpy, 25);
	    if (bmf->LowBatMk <= 0) bmf->LowBatMk = 120;
	    bmf->LowBatMk--;
	}

	if (!bmf->FormMain->Visible) return;

  TPixMap *pxm = bmf->syspxm;
	cpuh = pxm->height-1;
	Amph = cpuh;
	scpuh = cpuh;
	f = fopen("/proc/stat", "r");
	if (f) {
	    CPU_USER = oCPU_USER;  CPU_NICE = oCPU_NICE;
	    CPU_SYS = oCPU_SYS;    CPU_IDLE = oCPU_IDLE;
	    tline = fgets(&line[0], sizeof(line)-1, f);
	    if (tline) {
		if (AHbatmon_StatStrScan("cpu", tline, &val)) {
		    CPU_USER = ppctoint((void*)&val);
		    CPU_NICE = ppctoint((void*)&val);
		    CPU_SYS =  ppctoint((void*)&val);
		    CPU_IDLE = ppctoint((void*)&val);
		}
	    }
	    fclose(f);
	    m = (CPU_USER-oCPU_USER) + (CPU_NICE-oCPU_NICE) + (CPU_SYS-oCPU_SYS);
	    mg = m + (CPU_IDLE-oCPU_IDLE);
	    if (mg > 0) {
		    cpuh -= (m * (pxm->height-1)) / mg;
		    scpuh -= ((CPU_SYS-oCPU_SYS) * (pxm->height-1)) / mg;
	    }
	    oCPU_USER = CPU_USER;  oCPU_NICE = CPU_NICE;
	    oCPU_SYS = CPU_SYS;    oCPU_IDLE = CPU_IDLE;
	}

	if (pxm) {
	    x = pxm->width-2;
	    TPixMap_shift(pxm, -1, 0);
	    TPixMap_DrawLineRGB(pxm, 0xff0000, x, scpuh, x, oscpuh);
	    oscpuh = scpuh;
	    TPixMap_DrawLineRGB(pxm, 0xc000ff, x, cpuh, x, ocpuh);
	    ocpuh = cpuh;
        int stat_PanelGraf = 0;
	    if (bmf->batdat[0] && (bmf->batdat[0]->pres_mA || (oAmph > 0))) {

		Amph -= (bmf->batdat[0]->pres_mA * (pxm->height-1)) / 4000;
		if (Amph < 0) Amph = 0;
		if (oAmph < 0) oAmph = Amph;
		if (bmf->batdat[0]->charging_state) {
		    m = 0x0000ff;
		    stat_PanelGraf = 1;   //1=discharging
		} else {
		    m = 0x00c000;
		    stat_PanelGraf = 2;   //2=charging
		}
		TPixMap_DrawLineRGB(pxm, m, x, Amph, x, oAmph);
		oAmph = Amph;
		if (!bmf->batdat[0]->pres_mA) oAmph = -1;
	    }
	    if (bmf->stat_PanelGraf != stat_PanelGraf) {
		bmf->stat_PanelGraf = stat_PanelGraf;
		RePaint(bmf->PanelGraf);
	    }
	    if (bmf->FormMain->Visible) {
		TPixMap_PaintToWin(pxm, bmf->PanelGraf->WinID, 1, 1);
	    }
	}
}

static void AHbatmon_buClose_OnClick(TButton *self, long KeyState, bool DblClick) {
  TBatMonForm *bmf = self->subClass;
	if (!bmf) return;
	TForm_Close((TForm*)bmf->FormMain);
}

static void AHbatmon_buApply_OnClick(TButton *self, long KeyState, bool DblClick) {
  TBatMonForm *bmf = self->subClass;
	AHbatmon_Apply(bmf, True);
}

bool AHbatmon_buApply_ChkEnabled(TBatMonForm *bmf) {
  bool res;

	res = AHbatmon_Chk_CpuFreq_Ok(bmf) &&
	      AHbatmon_Chk_HD_Ok(bmf) &&
	      (bmf->Bell_EN == ((TChkBox*)bmf->chb_Bell)->Checked);

	SetEnabled((TWins*)bmf->buApply, res == False);
	AHbatmon_Set_Caption(bmf);
	return res;
}

static void AHbatmon_chb_Bell_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TBatMonForm *bmf = self->subClass;
	AHbatmon_buApply_ChkEnabled(bmf);
}

static void AHbatmon_OnResize(TForm *self) {
  int i;
  TBatMonForm *bmf = self->subClass;
  TCPUPage *CP;

	if (!bmf) return;

	bmf->buClose->left = self->width - bmf->buClose->width - 1;
	for (i=0;i<4;i++) {
	    CP =  bmf->CPUPage[i];
	    if (CP) {
		SetWidth(CP->lbl_modelname, self->width - 6);
	    }
	}
}

static void AHbatmon_PanelGraf_OnPaint(TWins *self) {
  TBatMonForm *bmf = self->subClass;
	self->vds.ForeColor = 0x000000;
	vds_SetStr(&self->vds, "100%");
	DrawColorString(self->width-33, 0, &self->vds);
	vds_SetStr(&self->vds, "0%");
	DrawColorString(self->width-26, self->height-13, &self->vds);

	if (bmf->stat_PanelGraf == 1) {         
	    self->vds.ForeColor = 0x0000ff;       //1=discharging
	} else if (bmf->stat_PanelGraf == 2) {
	    self->vds.ForeColor = 0x00c000;       //2=charging
	} else {
	    self->vds.ForeColor = 0xa0a0a0;
	}
//	self->vds.ForeColor = 0x008000;
  int h4 = (self->height-2) / 4;
	vds_SetStr(&self->vds, "3A");
	DrawColorString(self->width-26, h4 - 6, &self->vds);
	vds_SetStr(&self->vds, "2A");
	DrawColorString(self->width-26, h4*2 - 6, &self->vds);
	vds_SetStr(&self->vds, "1A");
	DrawColorString(self->width-26, h4*3 - 6, &self->vds);

	DrawLineRGB(self->WinID, self->vds.ForeColor, self->width-33, h4+1, self->width-29, h4+1);
	DrawLineRGB(self->WinID, self->vds.ForeColor, self->width-33, h4*2+1, self->width-29, h4*2+1);
	DrawLineRGB(self->WinID, self->vds.ForeColor, self->width-33, h4*3+1, self->width-29, h4*3+1);
}

static void AHbatmon_PanelGraf_OnResize(TWins *self) {
  TBatMonForm *bmf = self->subClass; // GetFormStruct(self);
	if (!bmf) return;
	Tfree(bmf->syspxm);
	bmf->syspxm = TPixMap_Create_depth(self->width-34, self->height-2, 0);
	TPixMap_SetXShm(bmf->syspxm);
	TPixMap_CreateXimg(bmf->syspxm);
	TPixMap_ClsRGB(bmf->syspxm, 0xffffff);
	ocpuh = bmf->syspxm->height-1;
	oscpuh = ocpuh;
}

static Tbatdat *AHbatmon_AddInfo(TBatMonForm *bmf, FILE *fd, int batnr) {
  int y;
  Tbatdat *bd;
  char *tline, *val;
  char line[1024];

	bd = xcalloc(sizeof(Tbatdat));

	snprintf(line, sizeof(line), "Battery %d", batnr);
	bd->bpg.Page = TPageControl_AddNewPage(bmf->PageControl, line);
	y = 2;
	bd->bpg.lbl_descap = TWins_CreateLabel((TWins*)bd->bpg.Page, 4, y, 130, 16, "design capacity:", mCaptionLeft, 0);
	bd->bpg.lbl_descap_v = TWins_CreateLabel((TWins*)bd->bpg.Page, 132, y, 80, 16, NULL, mCaptionRigth, mBorder | mBorderL);
	y += 18;
	bd->bpg.lbl_lastcap = TWins_CreateLabel((TWins*)bd->bpg.Page, 4, y, 130, 16, "last full capacity:", mCaptionLeft, 0);
	bd->bpg.lbl_lastcap_v = TWins_CreateLabel((TWins*)bd->bpg.Page, 132, y, 80, 16, NULL, mCaptionRigth, mBorder | mBorderL);
	y += 18;
	bd->bpg.lbl_designvolt = TWins_CreateLabel((TWins*)bd->bpg.Page, 4, y, 130, 16, "design voltage:", mCaptionLeft, 0);
	bd->bpg.lbl_designvolt_v = TWins_CreateLabel((TWins*)bd->bpg.Page, 132, y, 80, 16, NULL, mCaptionRigth, mBorder | mBorderL);
	y += 24;
	bd->bpg.lbl_charging_state = TWins_CreateLabel((TWins*)bd->bpg.Page, 4, y, 130, 16, "charging state:", mCaptionLeft, 0);
	bd->bpg.lbl_charging_state_v = TWins_CreateLabel((TWins*)bd->bpg.Page, 132, y, 80, 16, NULL, mCaptionRigth, mBorder | mBorderL);
	y += 18;
	bd->bpg.lbl_present_rate = TWins_CreateLabel((TWins*)bd->bpg.Page, 4, y, 130, 16, "present rate:", mCaptionLeft, 0);
	bd->bpg.lbl_present_rate_v = TWins_CreateLabel((TWins*)bd->bpg.Page, 132, y, 80, 16, NULL, mCaptionRigth, mBorder | mBorderL);
	y += 18;
	bd->bpg.lbl_remaining_capacity = TWins_CreateLabel((TWins*)bd->bpg.Page, 4, y, 130, 16, "remaining capacity:", mCaptionLeft, 0);
	bd->bpg.lbl_remaining_capacity_v = TWins_CreateLabel((TWins*)bd->bpg.Page, 132, y, 80, 16, NULL, mCaptionRigth, mBorder | mBorderL);
	y += 18;
	bd->bpg.lbl_present_voltage = TWins_CreateLabel((TWins*)bd->bpg.Page, 4, y, 130, 16, "present voltage:", mCaptionLeft, 0);
	bd->bpg.lbl_present_voltage_v = TWins_CreateLabel((TWins*)bd->bpg.Page, 132, y, 80, 16, NULL, mCaptionRigth, mBorder | mBorderL);

loop:
	tline = fgets(&line[0], sizeof(line)-1, fd);
	if (tline) {
	    val = tline;
	    while (*val && (*val != 10)) val++;
	    *val = 0;
	    if (bmf->PMmode == 3) {
		if (StatStrScan("POWER_SUPPLY_CHARGE_FULL_DESIGN", '=', tline, &val)) {
		    set_sys_acpi_mAh(val);
		    SetCaption(bd->bpg.lbl_descap_v, val);
		    bd->design_mAh = ppctoint((void*)&val);
		} else if (StatStrScan("POWER_SUPPLY_CHARGE_FULL", '=', tline, &val)) {
		    set_sys_acpi_mAh(val);
		    SetCaption(bd->bpg.lbl_lastcap_v, val);
		    bd->lastfull_cap = ppctoint((void*)&val);
		} else if (StatStrScan("POWER_SUPPLY_VOLTAGE_MIN_DESIGN", '=', tline, &val)) {
		    set_sys_acpi_mV(val);
		    SetCaption(bd->bpg.lbl_designvolt_v, val);
		    bd->design_mV = ppctoint((void*)&val);
		}
	    } else {
		if (StatStrScan("design capacity", ':', tline, &val)) {
			SetCaption(bd->bpg.lbl_descap_v, val);
			bd->design_mAh = ppctoint((void*)&val);
		} else if (StatStrScan("last full capacity", ':', tline, &val)) {
			SetCaption(bd->bpg.lbl_lastcap_v, val);
			bd->lastfull_cap = ppctoint((void*)&val);
//		} else if (BatStrScan("battery technology:", tline, &val, &art)) {
//			if (pcncmp(val, "rechargeable", 12)) bd->batt_tech = 1;
		} else if (StatStrScan("design voltage", ':', tline, &val)) {
			SetCaption(bd->bpg.lbl_designvolt_v, val);
			bd->design_mV = ppctoint((void*)&val);
//		} else if (BatStrScan("design capacity warning:", tline, &val, &art)) {
//			bd->design_cap_warn = RdInt_ppc(&val);
//		} else if (BatStrScan("design capacity low:", tline, &val, &art)) {
//			bd->design_cap_low = RdInt_ppc(&val);
//		} else if (BatStrScan("capacity granularity 1:", tline, &val, &art)) {
//			bd->cap_gran1 = RdInt_ppc(&val);
//		} else if (BatStrScan("capacity granularity 2:", tline, &val, &art)) {
//			bd->cap_gran2 = RdInt_ppc(&val);
//		} else if (BatStrScan("model number:", tline, &val, &art)) {
//			bd->model_number = pcdup(val);
//		} else if (BatStrScan("serial number:", tline, &val, &art)) {
//			bd->serial_number = pcdup(val);
//		} else if (BatStrScan("battery type:", tline, &val, &art)) {
//			bd->battery_type = pcdup(val);
//		} else if (BatStrScan("OEM info:", tline, &val, &art)) {
//			bd->OEM_info = pcdup(val);
		}
	    }
	    goto loop;
	}
	return bd;
}

// *********** sys_acpi ***********
static void AHbatmon_init_sys_acpi_page(TBatMonForm *bmf) {
  int i;
  TSearch_Rec *sr;
  FILE *f;
  Tbatdat *bd;
  char *val;
  char *tline;
  char line[1024];
  char fn[1024];

	sr = TSearch_Create("/sys/class/power_supply/", findDIR, fsFollowLink | fsNoFileName | fsNoLinkName);
	TPattern_set(&sr->patt, "CMB*,BAT*", NULL);

	i = 0;
	if (Find_First(sr)) {
loop_sr:
	    snprintf(fn, sizeof(fn), "%s%s/uevent", sr->path, sr->ret_entry->d_name);
	    f = fopen(fn, "r");
	    bd = NULL;
	    if (f) {
loop_n:
		tline = fgets(line, sizeof(line)-1, f);
		if (tline) {
		    if (StatStrScan("POWER_SUPPLY_PRESENT", '=', tline, &val)) {
			if (*val != '0') {
			    bd = AHbatmon_AddInfo(bmf, f, i);
			    bd->stat_fn = pcdup(fn);
			    bmf->batdat[i] = bd;
			    i++;
			}
		    } else goto loop_n;
		}
		fclose(f);
	    }
	    if (Find_Next(sr) && (i<4)) goto loop_sr;
	}
	Tfree(sr);
}

// *********** acpi **********
static void AHbatmon_init_acpi_page(TBatMonForm *bmf) {
  int i;
  TSearch_Rec *sr;
  FILE *f;
  Tbatdat *bd;
  char *val;
  char *tline;
  char line[1024];
  char fn[1024];

	sr = TSearch_Create("/proc/acpi/battery/", findDIR, fsNoFileName | fsNoLinkName);
	TPattern_set(&sr->patt, "CMB*,BAT*", NULL);

	i = 0;
	if (Find_First(sr)) {
loop_sr:
	    snprintf(fn, sizeof(fn), "/proc/acpi/battery/%s/info", sr->ret_entry->d_name);
	    f = fopen(fn, "r");
	    bd = NULL;
	    if (f) {
loop_n:
		tline = fgets(line, sizeof(line)-1, f);
		if (tline) {
		    if (StatStrScan("present", ':', tline, &val)) {
			if (pcncmp(val, "yes", 3)) {
			    bd = AHbatmon_AddInfo(bmf, f, i);
			    bmf->batdat[i] = bd;
			    i++;
			}
		    } else goto loop_n;
		}
		fclose(f);
	    }
	    if (bd) {
	      snprintf(fn, sizeof(fn), "/proc/acpi/battery/%s/state", sr->ret_entry->d_name);
	      f = fopen(fn, "r");
	      if (f) {
loop_y:
		tline = fgets(line, sizeof(line)-1, f);
		if (tline) {
		    if (StatStrScan("present", ':', tline, &val)) {
			if (pcncmp(val, "yes", 3)) {
			    bd->stat_fn = pcdup(fn);
			}
		    } else goto loop_y;
		}
		fclose(f);
	      }
	    }
	    if (Find_Next(sr) && (i<4)) goto loop_sr;
	}
	Tfree(sr);
}
// *********** apm **********
static void AHbatmon_init_apm_page(TBatMonForm *bmf) {
}

// *********** misc **********

static void AHbatmon_FormTaskBar_OnPaint(TSysTrayWin *self) {
  TBatMonForm *bmf = self->subClass;
	if (!bmf->paint_pxm) return;
	TPixMap_PaintToWin(bmf->paint_pxm, self->WinID, 0, 0);
}

static void AHbatmon_FormTaskBar_OnClick(TSysTrayWin *self, long KeyState, bool DblClick) {
  TBatMonForm *bmf = self->subClass;
	if (!bmf) return;
	if (!bmf->FormMain->Visible) {
	    TForm_Show((TForm*)bmf->FormMain);
	} else {
	    TForm_Close((TForm*)bmf->FormMain);
	}
}

#ifdef TEST_BAT_CAP
void sb_test_OnCount(TScrollBar* sb, int Count) {
  TBatMonForm *bmf = self->subClass; // GetFormStruct((TWins*)sb);
  int i = 0;
  int m;
  Tbatdat *bd;
  char buf[16];

	while (bmf->batdat[i]) {
	    bd = bmf->batdat[i];
	    m = bd->lastfull_cap * (100-Count) / 100;
	    WrInteger(m, buf);
	    pcchange(&bd->s_remaining_capacity, buf);
	    i++;
	}
}
#endif

static void m_Close(TMenu *menu, long KeyState, TMenuItem *smi) {
  Close();
}

static void AHbatmon_PipeProc(int fd, Tfd_list *fdl) {
  int lg;
  TBatMonForm *bmf;
  char line[BUFSIZ];

	lg = read(fd, line, BUFSIZ);
	if (lg > 0) {
	    line[lg] = 0;
	    bmf = fdl->obj;
	    if (!bmf) return;
	    if (!bmf->FormMain->Visible) TForm_Show((TForm*)bmf->FormMain);
// printf("%s(%d): AHbatmon_PipeProc fd=%d\"%s\"\n", FL, fd, line);
	}
}

static const char batmon_AHico[] = {
 0x00,0x04,0x10,0x00,0x10,0x00,0x00,0x00,0x52,0x00,0x85,0x21,0x87,0x24,0x07,0x23,
 0xCD,0x5C,0xC9,0xA5,0xFA,0x55,0xC9,0x27,0x00,0x00,0xAA,0x2E,0xC0,0x55,0x00,0xBC,
 0x70,0x00,0x02,0x5E,0x58,0x98,0x8B,0x57,0x58,0x58,0xF5,0x55,0x58,0x58,0x00,0x80,
 0xD8,0x78,0x55,0x55,0x35,0xE8,0x00,0x00,0x00,0x20,0x55,0x5F,0x25,0x40,0xD5,0x7F,
 0x95,0xE0,0xA5,0x78,0x11,0x30,0x2A,0xE0,0x14,0x10,0x0A,0xC0,0x14,0x11,0x15,0xE0,
 0x11,0x45};

const char *AHbatmon_Help_Msg = {
  "Usage: sysmon [options]\n"
  "\n"
  "  -t                   add to taskbar\n"
  "  -h, --help           Prints out this screen\n"
};


#ifdef STANDALONE_BUILDIN
int main (int argc, char **argv) {
	cmdline_slash_korr(argc, argv);
#else
int bi_BatMon_main (int argc, char **argv) {
#endif
  int i, fd, y;
  FILE *f;
  char *tline;
  char *val;
  int iofd[2] = {-1,-1};

  char line[1024];
  struct stat64 st_buf;

  bool err = False;
  bool help = False;
  bool TaskBar = False;
//  bool nc4;
  TBatMonForm bmf;

//	nc4 = False;
	Fill0(&bmf, sizeof(TBatMonForm));

	for (i=1; i<argc; i++) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		if (*val == 'h') {
			help = True;
		} else if (*val == 't') {
			TaskBar = True;
		} else if (*val == '-') {
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
#ifdef Test_Root_WinId
		    } else if (pcncmp(val, "TestRootWinID", 13)) {
			i++;
			val = argv[i];
			if (val && *val != '-') {
				TestRootWinId = ppctoint((void*)&val);
			} else err = True;
#endif
		    } else err = True;
		} else err = True;
	    } else err = True;
	}

	if (err || help) {
		printf(AHbatmon_Help_Msg);
		if (err) exit(1); else exit(0);
	}


	pipe(iofd);

	initXapp(0, argc, argv);
#ifdef STANDALONE_BUILDIN
	hGetDeskIcon = &hGetDeskIcon_buildin;
#else
//	hGetDeskIcon = &hGetDeskIcon_file;
//	ThImageRD_Reg(2, &hImageRD_xpm, &hImageRD_png);
#endif

	if (ChkAppRun(*argv, carfu_cmd, &tline)) {
	    snprintf(line, sizeof(line), "%sfd/%d", tline, iofd[0]);
	    fd = open(line, O_WRONLY);
	    if (fd > 0) {
		write(fd, "show", 4);
		close(fd);
	    } else printf("ERROR: %s\n", SysError_pc());
	    return 0;
	}

	appDat.inifile_app = pcadd(appDat.ALDini_dir, "/aldbatmon.ini");

	AddPipeProc(iofd[0], InPipe, AHbatmon_PipeProc, &bmf);

#ifdef USE_DECOR
	appXDat.DefaultButtonDecor = TDecor_button_w3b3_Create();
#endif
	if (stat64("/sys/class/power_supply", &st_buf) == 0) {
	    bmf.PMmode = 3;
	} else if (stat64("/proc/acpi", &st_buf) == 0) {
	    bmf.PMmode = 2;
	} else if (stat64("/proc/apm", &st_buf) == 0) {
	    bmf.PMmode = 1;
	}

	if (TaskBar) {
	    bmf.FormTaskBar = TSysTrayWin_Create();
	    bmf.FormTaskBar->subClass = &bmf;
	    bmf.FormTaskBar->OnPaint = AHbatmon_FormTaskBar_OnPaint;
	    bmf.FormTaskBar->OnClick = AHbatmon_FormTaskBar_OnClick;
	    bmf.FormTaskBar->PopupMenu = TMenu_Create(NULL);
	    TMenu_AddItem(bmf.FormTaskBar->PopupMenu, "System Monitor", miCanNotSelect, NULL);
	    TMenu_AddItem(bmf.FormTaskBar->PopupMenu, "-", 0, NULL);
	    TMenu_AddItem(bmf.FormTaskBar->PopupMenu, "Close", 0, m_Close);
	}

	bmf.LowBatMk = 5;

	bmf.FormMain =  TForm_Create(NULL);
	bmf.FormMain->Icon = GetZIcon(batmon_AHico);

	bmf.FormMain->subClass = &bmf;
	SetCaption((TWins*)bmf.FormMain, "sysmon");
	bmf.FormMain->Visible = (TaskBar == 0);
	bmf.FormMain->width = 240;
	bmf.FormMain->height = 300;
	bmf.FormMain->min_width = 220;
	bmf.FormMain->min_height = 290;
	bmf.FormMain->max_width = 800;
	bmf.FormMain->max_height = 300;
	bmf.FormMain->FormPosition = poDesigned;
	bmf.FormMain->OnResize = AHbatmon_OnResize;

	if (bmf.FormTaskBar && bmf.FormTaskBar->SysTrayWin) {
	    bmf.FormMain->Gravity = SouthEastGravity;
	}

  TgTimer *gTimer = gTimerX_Add(Timer_Enabled, 500, AHbatmon_OnTimer);
	gTimer->obj = &bmf;

	bmf.PanelTop = TWins_CreateBA((TWins*)bmf.FormMain, 0, 0, 200, 2, 0, alTop);

	bmf.PageControl = TPageControl_Create((TWins*)bmf.FormMain);
	bmf.PageControl->Align = alClient;
	Set_Parent((TWins*)bmf.PageControl, (TWins*)bmf.FormMain);

	y = 2;
	bmf.SYSPage = TPageControl_AddNewPage(bmf.PageControl, "SYS");
	y += 20;
	bmf.chb_Bell = TChkBox_CreateS((TWins*)bmf.SYSPage, 2, y, 150, 16, " AC/BAT Change Bell");
	bmf.chb_Bell->OnClick = AHbatmon_chb_Bell_OnClick;


	AHbatmon_CpuFreqPageInit(&bmf);

	if (bmf.PMmode == 1) {
	    AHbatmon_init_apm_page(&bmf);
	} else if (bmf.PMmode == 2) {
	    AHbatmon_init_acpi_page(&bmf);
	} else if (bmf.PMmode == 3) {
	    AHbatmon_init_sys_acpi_page(&bmf);
	}

	bmf.PanelGraf = TWins_CreateBA((TWins*)bmf.FormMain, 0, 0, 200, 102, mBorder | mBorderL, alBottom);
	bmf.PanelGraf->OnResize = AHbatmon_PanelGraf_OnResize;
	bmf.PanelGraf->OnPaint = AHbatmon_PanelGraf_OnPaint;
	bmf.PanelBottom = TWins_CreateBA((TWins*)bmf.FormMain, 0, 0, 200, 26, 0, alBottom);
	bmf.buClose = TButton_CreateS(bmf.PanelBottom, 100, 2, 64, 24, "OK");
	bmf.buClose->OnClick = AHbatmon_buClose_OnClick;
	((TForm*)bmf.FormMain)->FocusWin = (TWins*)bmf.buClose;
	bmf.buApply = TButton_CreateS(bmf.PanelBottom, 2, 2, 64, 24, "Apply");
	bmf.buApply->Enabled = False;
	bmf.buApply->OnClick = AHbatmon_buApply_OnClick;

	if (TaskBar) InitBatImg(&bmf);

	f = fopen("/proc/stat", "r");
	if (f) {
	    tline = fgets(line, sizeof(line)-1, f);
	    if (tline) {
		if (AHbatmon_StatStrScan("cpu", tline, &val)) {
		    oCPU_USER = ppctoint((void*)&val);
		    oCPU_NICE = ppctoint((void*)&val);
		    oCPU_SYS =  ppctoint((void*)&val);
		    oCPU_IDLE = ppctoint((void*)&val);
		}
	    }
	    fclose(f);
	}

	appDat.appIni = TpcIni_Create(appDat.inifile_app);


	AHbatmon_IniSetUp(&bmf);
	if (bmf.batdat[0]) TPage_SetPageAktiv((TPage*)((TbatPage*)bmf.batdat[0])->Page);

  TPage *TestPage = TPageControl_AddNewPage(bmf.PageControl, " HD ");
	bmf.pnlHD = TAHbatmon_pnlHD_Create((TWins*)TestPage);
	bmf.pnlHD->Align = alClient;

	Tfree(appDat.appIni);
	appDat.appIni = NULL;

	AHbatmon_Setup_HD(&bmf, False);

#ifdef TEST_BAT_CAP
  TScrollBar *sb_test;
	sb_test = TScrollBarVert_CreateP(bmf.PanelGraf);
	SetHeight((TWins*)sb_test, 100);
	sb_test->OnCount = sb_test_OnCount;
	sb_test_OnCount(sb_test, 0);
#endif

	AppRun();
	return 0;
}
