/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#ifndef __ALDBATMON_H__
#define __ALDBATMON_H__    1


#include "appXbase.h"
#include "tpixmap.h"
#include "tsearch.h"

// #define TEST_BAT_CAP 1

#define wtyp_TBatMonForm	wtyp_USER_Form
#define wtyp_TAHbatmon_pnlHD	wtyp_USER_Wins

typedef struct {
  TPage *Page;
  TWins *lbl_descap;
  TWins *lbl_descap_v;
  TWins *lbl_lastcap;
  TWins *lbl_lastcap_v;
  TWins *lbl_designvolt;
  TWins *lbl_designvolt_v;
  TWins *lbl_charging_state;
  TWins *lbl_charging_state_v;
  TWins *lbl_present_rate;
  TWins *lbl_present_rate_v;
  TWins *lbl_remaining_capacity;
  TWins *lbl_remaining_capacity_v;
  TWins *lbl_present_voltage;
  TWins *lbl_present_voltage_v;
} TbatPage;

typedef struct {
  TPage *Page;
  struct TBatMonForm *bmf;
  TWins *lbl_modelname;
  TWins *lbl_cpufreq;
  TWins *lbl_cpufreq_v;
  TWins *lbl_AC_freq;
  TComboBox *cb_AC_freq;
  TWins *lbl_bat_freq;
  TComboBox *cb_bat_freq;
  TMenuItem *mi_AC_freq;
  TMenuItem *mi_bat_freq;
  TPageControl *acPageControl;
  TPage *ACadapterPage;
  TPage *BatteryPage;
  char *akt_CPU_governors;
} TCPUPage;

typedef struct {
//  int info_present;
  TbatPage bpg;
//  char *design_cap_s;
  int design_mAh;
//  char *lastfull_cap_s;
  int lastfull_cap;
//  char *batt_tech_s;
//  int batt_tech;
//  char *design_volt_s;
  int design_mV;
//  int design_cap_warn;
//  int design_cap_low;
//  int cap_gran1;
//  int cap_gran2;
//  char *model_number;
//  char *serial_number;
//  char *battery_type;
//  char *OEM_info;
//  float design_Wh;

  char *stat_fn;
//  int stat_present;
//  int capacity_state;
  int charging_state;
//  int present_rate;
//  int remaining_capacity;
//  int present_voltage;
  int pres_mA;
  int rem_mAh;
  int pres_mV;
#ifdef TEST_BAT_CAP
  char *s_remaining_capacity;
#endif
} Tbatdat;

#define USE_PXM 1

typedef struct TBatMonForm {
  int PMmode; 		//1=apm 2=acpi

  TPage *SYSPage;
  TChkBox *chb_Bell;

  Tbatdat *batdat[4];
  TForm *FormMain;
  TSysTrayWin *FormTaskBar;
  TWins *PanelTop;
  TPageControl *PageControl;
  TCPUPage *CPUPage[4];

  struct TAHbatmon_pnlHD *pnlHD;

  TWins *PanelGraf;
  TWins *PanelBottom;
  TButton *buClose;
  TButton *buApply;
  TPixMap *syspxm;
  TPixMap *IcoBatNet;
  TPixMap *IcoBatBat;
  TPixMap *paint_pxm;

  unsigned long tic_500ms;
  int discharge_tic;
  int mode;	//0x01=discharging 0x02=charging
  int lastmode;
  int lastPMmode;
  int capacity; //0..1000
  int present_rate; 
  int cap_time_mk; 
  int cap_time_min;
  int capmk;
  int LowBatMk;
  int stat_PanelGraf; //0=none 1=discharging 2=charging
  bool Bell_EN;
} TBatMonForm;

void AHbatmon_CpuFreqPageInit(TBatMonForm *bmf);
void AHbatmon_IniSetUp(TBatMonForm *bmf);
bool AHbatmon_buApply_ChkEnabled(TBatMonForm *bmf);

bool AHbatmon_Chk_CpuFreq_Ok(TBatMonForm *bmf);
void AHbatmon_CpuFreqReScan(TBatMonForm *bmf);
void AHbatmon_Apply(TBatMonForm *bmf, bool Save);
void AHbatmon_PM(TBatMonForm *bmf);


#define TCSelf TAHbatmon_pnlHD
typedef struct TAHbatmon_pnlHD {
  AlgTWins
  void *subClass_Prev;
  TWins *lbl_HD;
  TWins *lbl_HD0;
  TWins *lbl_AC_HD0;
  TWins *lbl_Bat_HD0;
  TComboBox *cb_dev_HD0;
  TComboBox *cb_AC_HD0;
  TComboBox *cb_Bat_HD0;
  TMenuItem *mi_dev_HD0;
  TMenuItem *mi_AC_HD0;
  TMenuItem *mi_Bat_HD0;
  int akt_HD0_time;
} TAHbatmon_pnlHD;
#undef TCSelf

TAHbatmon_pnlHD *TAHbatmon_pnlHD_Create(TWins *Parent);
bool AHbatmon_Chk_HD_Ok(TBatMonForm *bmf);
bool StatStrScan(const char *keyw0, char key, char *pc, char **val);

void AHbatmon_Setup_HD(TBatMonForm *bmf, bool save);
void AHbatmonPM_Set_HD(TBatMonForm *bmf);

#endif /* __ALDBATMON_H__ */
