/*
 Copyright (C) 2010-2011 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appbase.h"
#include "buildin_app.h"

typedef struct {
  const char *s;
  TBuildin_app *bi_app;
} Tbi_AHapp;

Tbi_AHapp bi_Tab[] = {
  {"aldbatmon", bi_BatMon_main},
  {"aldmessagebox", bi_MsgBox_main},
  {"aldfilebox", bi_FileBox_main},
  {"Copyright_MsgBox", bi_Copyright_MsgBox_main},
  {"gethddevtyp", bi_gethddevtyp_main},
#ifdef USE_DEBUG_WIN
  {"wmDebugWin", bi_wmDebugWin_main},
#endif
  {NULL, NULL}
};

TBuildin_app *Get_Buildin_pc(char *pc) {
  Tbi_AHapp *bi = bi_Tab;

	while (bi->s) {
	    if (pccmp(bi->s, pc)) {
		return bi->bi_app;
	    }
	    bi++;
	}
	return NULL;
}

void BuildinHelp() {
  int x, l;
  char *pc;
  char line[128];
  Tbi_AHapp *bi = bi_Tab;

	printf("Usage: aldesk [function] [arguments]...\n\n");
	printf("aldesk Currently defined functions:\n");
	line[0] = 0x09;
	x = 8;
	pc = &line[1];
	while (bi->s) {
	    l = pclen(bi->s);
	    if ((x + l) > 76) {
		printf("%s\n", line);
		x = 8;
		pc = &line[1];
	    }
	    ppcmove(&pc, bi->s);
	    x += l;
	    bi++;
	    if (bi->s) ppcmove(&pc, ", ");
	}
	if (x > 8) printf("%s\n", line); 
}
