/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"
#include <stdarg.h>
#include <unistd.h>

bool DebugOn;
static Texec_pipe *Debug_expip;

static void Debug_OnExecProcEv(Texec_pipe* expip, int evtyp) {
	
	switch(evtyp) {
	case evtyp_ProcClose:
	    Debug_expip = NULL;
	    break;
	}
}

static void Show_DebugWinRun() {
  char *pc;
  char line[1024];

	pc = line;
#ifdef USE_BULDIN_APP
	pc += sprintf(pc, "%s wmDebugWin ", appDat.self_exe);
#else
	pcmove(&pc, "wmDebugWin ");
#endif
#ifdef Test_Root_WinId
	if (TestRootWinId) {
	    pc += sprintf(pc, "--TestRootWinID 0x%x ", (int)TestRootWinId);
	}
#endif
	ExecuteProcApp(line, outfd_Open, Debug_OnExecProcEv, NULL, &Debug_expip);
}

void Chk_DebugWinRun() {
  char *tline;

	if (!ChkAppRun("wmDebugWin", carfu_cmd, &tline)) {
	    Show_DebugWinRun();
	}
}

void Debug_msg(int lev, const char *s, ...) {
  va_list args;
  char line[2048];

	if (!DebugOn) return;

	va_start(args, s);
	vsnprintf(line, 2048, s, args);
	va_end(args);

	if (appDat.gQUIT_Ev) {
	    printf("wmDebugWin: %s", line);
	    return;
	}
	if (!Debug_expip) {
	    Show_DebugWinRun();
	    if (!Debug_expip) return;
	    AppHandleMessage();
	}
	if (!Debug_expip) return;


	write(Debug_expip->pp[evtyp_outfd].fd, line, pclen(line));
}
