/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"
#include <signal.h>


static void TwmDeskIcon_PID_OnTimer(TgTimer *gti) {
  Texec_pipe *expipe = gti->obj;

	if (ttc_chk_is_wtyp(expipe, wtyp_Texec_pipe)) {
	    expipe->p1 = NULL;
	    expipe->CloseFlag |= epCF_UserError;
	    kill(expipe->pida->pid, SIGKILL);
	    ShowExtMsgBox("TimeOut: Applkation killed\n%s\n\n"
		"or set in xxx.desktop StartupNotify=false", expipe->args);
	}
	Std_UngrabPointer();
}

void TwmDeskIcon_App_ExecEv(Texec_pipe* expipe, int evtyp) {
  TgTimer *gTimer;

	if (evtyp == evtyp_ProcStart) {
	    if (expipe->tag & (exGrabPointer|exAddTimer)) {
		gTimer = gTimerX_Add(Timer_Enabled | Timer_OnTimerAndFree, 30000, TwmDeskIcon_PID_OnTimer);
		gTimer->obj = expipe;
		expipe->p1 = gTimer;
		if (expipe->tag & exGrabPointer)
		    Std_GrabPointer((TWins*)wmRoot, appXDat.XCursors[XC_watch]);
	    }
	    if (!(expipe->tag & exNoStartPid)) wmRoot->DeskStartPid = expipe->pida->pid;

	} else if (evtyp == evtyp_ProcClose) {
	    if (expipe->p1) {   //Test Timer Run
		ppTfree(&expipe->p1);
		Std_UngrabPointer();
	    }

	    if (expipe->tag & exShowErrMsgBox) {
		if (expipe->CloseFlag & epCF_errfd) {
		    ShowExtMsgBox(expipe->pp[evtyp_errfd].lb->pc);
		} else if (expipe->CloseFlag & epCF_infd) {
		    ShowExtMsgBox(expipe->pp[evtyp_infd].lb->pc);
		}
	    }
	}
}

void ExecDesktopFile(char *fname, TWins *wins) {
  int ddkt;
  TpcIni *ini;
  char *token, *cmd;
  const char *cpc;
  Texec_pipe *ret_expip;

	ddkt = ddkt_desktop(fname);
	if (ddkt < 1) return;

	ini = TpcIni_Create(fname);
	switch (ddkt) {

	case ddkt_Application:
	    cmd = get_desktop_CMD(ini, NULL);
	    bool StartupNotify = TpcIni_RD_boolean(ini, Desktop_Entry, "StartupNotify", True);
	    int fu = exGrabPointer;
	    if (!StartupNotify) fu = 0;
	    ExecuteProcAppTag(cmd, 0, TwmDeskIcon_App_ExecEv, wmRoot, 
				&ret_expip, fu);
	    xfree(cmd);
	    if (ret_expip) ret_expip->fname = pcdup(fname); //is NET_WM_PID free in TwmWin
	    break;

	case ddkt_ALDeskBuildin:
	    cpc = TpcIni_RD(ini, Desktop_Entry, "ALDeskBuildin");
	    if (cpc) {
		cpc = GetToken(cpc, &token);
		exec_Buildin(wins, token, cpc, 0);
		xfree(token);
	    }
	    break;
	} //case
	Tfree(ini);
}

void menu_ExecDesktopFile(TMenuFile *mf, long KeyState, TWins *wins) {
  TMenuFileItem *mfi = (TMenuFileItem*)mf->SelItem;
  char *pc;
	if (mfi && mfi->filename) {
	    pc = pcadd(mf->path, mfi->filename);
	    ExecDesktopFile(pc, wins);
	    xfree(pc);
	}
}
