/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"

int glob_Border_width = 4;
int glob_Caption_height = 18;

GC MoveBorderGC;

void Create_globGC() {
  long gcm;
  XGCValues gcv;
	Fill0(&gcv, sizeof(XGCValues));
#ifdef USE_X11GC_plane_mask
	gcm = GCFunction | GCLineWidth | GCFillStyle | GCForeground | GCStipple |
		GCBackground | GCSubwindowMode | GCPlaneMask;
	gcv.plane_mask = AllPlanes;
#else
	gcm = GCFunction | GCLineWidth | GCFillStyle | GCForeground | GCStipple |
		GCBackground | GCSubwindowMode;
#endif
	gcv.function   = GXxor;
	gcv.line_width = 4;
	gcv.fill_style = FillOpaqueStippled;
	gcv.foreground = 255;
	gcv.background = 0xffffffff;
	gcv.stipple    = appXDat.Focus_bitmap;
	gcv.subwindow_mode = IncludeInferiors;
	MoveBorderGC = CreateGC(gcm, &gcv);
}

void CombineMask(Window WinID, Pixmap mask) {
	if (WinID) {
	    XShapeCombineMask(appXDat.dpy, WinID, ShapeBounding, 0, 0, mask, ShapeSet);
	}
}

void wmExcCMD_head(char **ppbuf, const char *proc) {
#ifdef USE_BULDIN_APP
	ppcmove_k(ppbuf, appDat.self_exe, kSPACE_ADD);
#endif
	ppcmove_k(ppbuf, proc, kSPACE_ADD);
}

void wmExcCMD_headX(char **ppbuf, const char *proc) {
	wmExcCMD_head(ppbuf, proc);
#ifdef Test_Root_WinId
	if (TestRootWinId) {
	    ppcmove(ppbuf, "--TestRootWinID ");
	    hexto0xppc(ppbuf, (int)TestRootWinId, kSPACE_ADD);
	}
#endif
}

void ShowExtMsgBoxEv(const char *msg, TOnExecProcEv OnExecProcEv) {
  char **argv = xcalloc(sizeof(void*) * 16);
  int argc = 0;
  char buf[32];

#ifdef USE_BULDIN_APP
	argv[argc] = pcdup(appDat.self_exe);
	argc++;
#endif
	argv[argc] = pcdup("aldmessagebox");
	argc++;

#ifdef Test_Root_WinId
	if (TestRootWinId) {
	    argv[argc] = pcdup("--TestRootWinID");
	    argc++;
	    hexto0xpc(buf, (int)TestRootWinId, 0);
	    argv[argc] = pcdup(buf);
	    argc++;
	}
#endif
	if (dpyMonitors.count > 1) {
	    TMonitor *mon = &dpyMonitors.mon[dpyMonitors.PrimaryIdx];
	    snprintf(buf, sizeof(buf), "-x=%d", mon->left);
	    argv[argc] = pcdup(buf);
	    argc++;
	    snprintf(buf, sizeof(buf), "-y=%d", mon->top);
	    argv[argc] = pcdup(buf);
	    argc++;
	    snprintf(buf, sizeof(buf), "-s=%dx%d", mon->right - mon->left, mon->bottom - mon->top);
	    argv[argc] = pcdup(buf);
	    argc++;
	}

	argv[argc] = pcdup("-n");
	argc++;
	argv[argc] = pcdup("-tERROR");
	argc++;
	argv[argc] = pcdup("-w1");
	argc++;
	argv[argc] = pcdup(msg);
	argc++;
	ExecuteProcApp_argv(NULL, argc, argv, 0, OnExecProcEv, NULL, NULL, 0);

}

void ShowExtMsgBox(const char *msg, ...) {
  va_list args;
  char line[2048];

	va_start(args, msg);
	vsnprintf(line, 2048, msg, args);
	va_end(args);
	ShowExtMsgBoxEv(line, NULL);
}
