/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"

static void menu_FormOpt_OnClick(TMenuFile *self, long KeyState, bool DblClick) {
//	if (DblClick) return;
	menu_ExecDesktopFile(self, KeyState, self->owner);
}

static void menu_FormOpt_OnInitDat(TMenuFile *self, bool iniEnd) {
  TMenuFileItem *mi;

	if (!iniEnd) return;
	mi = (TMenuFileItem*)TMenu_InsItem((TMenu*)self, "Win move to Desk", 2);
	mi->next_menu = (TMenuFile*)wmRoot->WinOptMenu_moveDesk;
	mi->next_menu->owner = self->owner;

	mi = self->MenuItem;
	while (mi) {
	    if (pccmp(mi->itemname, "killwin") &&
		self->owner && (self->owner->wtyp == wtyp_TwmWin)) {
		if (!((TwmWin*)self->owner)->pid_NET_WM) mi->fu |= miNotEnabled;
	    }
	    mi = mi->next;
	}
}

static void moveDeskMenu_OnClick(TMenu *menu, long KeyState, TMenuItem *mi) {
  TwmWin *wmw = (TwmWin*)menu->owner;
	if (wmw && (wmw->wtyp == wtyp_TwmWin)) {
	    TTaskbar_DeskMoveWin(wmRoot->Taskbar, wmw->Frame, mi->tag);
	}
}

static void moveDeskMenu_OnMenuOpen(TMenu *self) {
  TMenuItem *mi = self->MenuItem;
	while (mi) {
	    mi->fu &= ~miNotEnabled;
	    if (mi->tag == wmRoot->CurrentDesk) mi->fu |= miNotEnabled;
	    mi = mi->next;
	}
}

/*_____________________________ Create __________________________________*/
void menu_FormOpt(TwmRoot *wmr) {
  TMenuFile *mf;
  char *pc0;
  char line[512];

	pc0 = line;
	ppcmove(&pc0, wmr->MenuPath);
	ppcmove(&pc0, "/FormOptMenu");
	if (file_mkdir_parents_ae(line, 0750, EMSG_ERR_EXIT) == True) {
	    pcmove_directory(pc0);
	    dotdesktop_new(line, "Window Menu (Alt-F3)", "penguin", "minmax closewin -t killwin -t", NULL, NULL, ddkt_Directory);

	    pcmove_desktop(pc0, "minmax");
	    dotdesktop_new(line, "Maximize/Normal", NULL, "minmax_win", NULL, NULL, ddkt_ALDeskBuildin);

	    pcmove_desktop(pc0, "closewin");
	    dotdesktop_new(line, "Close Window (Alt-F4)", NULL, "close_win", NULL, NULL, ddkt_ALDeskBuildin);

	    pcmove_desktop(pc0, "killwin");
	    dotdesktop_new(line, "Kill Window", NULL, "kill_win", NULL, NULL, ddkt_ALDeskBuildin);
	}
	pc0[0] = '/'; pc0[1] = 0;
	mf = (TMenuFile*)TMenuFile_Create((TWins*)wmr);
	mf->path = pcdup(line);
//	mf->OnUnmap = menuStart_OnUnmap;
	mf->OnMenuOpen = (void*)Menu_OnMenuOpen;
	mf->OnMenuClose = (void*)Menu_OnMenuClose;
	mf->OnClick = menu_FormOpt_OnClick;
	mf->OnInitDat = menu_FormOpt_OnInitDat;
	mf->mfk = mfk_AddDirHead | mfk_AutoFree;
	wmr->WinOptMenu = mf;

/* ****** Menu move ein to Desktop ****** */
	wmr->WinOptMenu_moveDesk = TMenu_Create((TWins*)wmr);
	wmr->WinOptMenu_moveDesk->OnMenuOpen = moveDeskMenu_OnMenuOpen;
	TMenu_AddItem(wmr->WinOptMenu_moveDesk, "To Desktop 1", 0, moveDeskMenu_OnClick)->tag = 0;
	TMenu_AddItem(wmr->WinOptMenu_moveDesk, "To Desktop 2", 0, moveDeskMenu_OnClick)->tag = 1;
	TMenu_AddItem(wmr->WinOptMenu_moveDesk, "To Desktop 3", 0, moveDeskMenu_OnClick)->tag = 2;
	TMenu_AddItem(wmr->WinOptMenu_moveDesk, "To Desktop 4", 0, moveDeskMenu_OnClick)->tag = 3;

}
