/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldesk.h"
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <scsi/scsi.h>
#include <scsi/scsi_ioctl.h>

#ifdef	USE_DEBUG_WIN
int GrabXServer_count = 0;
#else
static int GrabXServer_count = 0;
#endif

bool chk_dev_removable(char *fn) {
  int fd, status;
  struct sdata {
	int  inlen;
	int  outlen;
	char cmd[256];
  } scsi_cmd;

	fd = open(fn, O_RDONLY | O_NONBLOCK);
	if (fd > 0) {
	    Fill0(&scsi_cmd, sizeof(scsi_cmd));
	    scsi_cmd.cmd[0] = ALLOW_MEDIUM_REMOVAL;
	    status = ioctl(fd, SCSI_IOCTL_SEND_COMMAND, (void *)&scsi_cmd);
	    close(fd);
	    if (!status) return True;
	}
	return False;
}

void SetXInputFocus(Window WinID) {
	XSetInputFocus (appXDat.dpy, WinID, RevertToParent, 0);
}

void GrabXServer() {
	if (!GrabXServer_count) {
	    XGrabServer(appXDat.dpy);
	    SyncX();
	}
	GrabXServer_count++;
}

void UngrabXServer() {
	if (!GrabXServer_count) return;
	GrabXServer_count--;
	if (!GrabXServer_count) XUngrabServer(appXDat.dpy);
}

void SyncX() {
	XSync(appXDat.dpy, 0);
}

int get_bef_dflEv(TFileMsg *fmsg, int *r_Bef) {
  int bef;

	if (r_Bef) *r_Bef = 0;
	if (!file_msg_chk_wtyp(fmsg, wtyp_TDirListObjNy, FL)) return 0;

	if (fmsg->art != fmArt_DirList) return 0;
	if (fmsg->typD != fmTyp_int) return 0;
	if (r_Bef) *r_Bef = fmsg->D.m;
	if (fmsg->typF != fmTyp_dfl) return 0;
	if (fmsg->typR != fmTyp_gp) return 0;
	bef = fmsg->D.m & dlbef_BefMask;

	if (fmsg->D.m & dlbef_ScanRun) {
	    if (bef == dlbef_Add) return dlbef_Add;
	} else if (fmsg->D.m & dlbef_NotifyRun) {
	    if ((bef == dlbef_Add) || (bef == dlbef_Change)) return 0;
	    return bef;
	}
	return 0;
}
