/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#include <unistd.h>
#include <sys/wait.h>

static TWins *FormMain;
static int pid;
static bool AutoStart, NoTaskbar;

/* static void TestDispatchEvent() {
  TXev_msg msg;
  XEvent ev;
  TWins *wins;

	XNextEvent(appXDat.dpy, &ev);
	msg.msg = msgXEv;
	msg.f = 0;
	msg.m = 0;
	msg.ev = &ev;

	wins = GetTWins(ev.xany.window);
	if (wins) {
	    Exec_Win_Ev((void*)&msg, ev.xany.window);
	} else {
 printf("TestDispatchEvent: 0x%x %d\n", (int)ev.xany.window, ev.type);
	}

}

static void wmX11DispatchEvent() {
	while (appXDat.dpy && XPending(appXDat.dpy) > 0) TestDispatchEvent();
} */

static void On_pid_close() {
	Close();
	pid = 0;
}

static void OnAppStart() {
  Texec_pipe *expipe;
  char *argv[8];
  char sid[32];
  int idx;

	expipe = Texec_pipe_Create();
	expipe->On_pid_close = On_pid_close;
	snprintf(sid, sizeof(sid), "0x%x", (int)FormMain->WinID);
	argv[0] = pcdup("./aldesk");
	argv[1] = pcdup("--TestRootWinID");
	argv[2] = pcdup(sid);

	idx = 3;
	if (!AutoStart) {
	    argv[3] = pcdup("--NoAutoStart");
	    idx++;
	}
	if (NoTaskbar) {
	    argv[idx] = pcdup("--NoTaskbar");
	    idx++;
	}
#ifdef	USE_DEBUG_WIN
	argv[idx] = pcdup("--debug"); idx++;
#endif
	argv[idx] = NULL;
	pid = exec_pipe_argv(&argv[0], expipfu_addPID_H, expipe);
}

static void OnAppClose() {
  int i;
	if (pid) {
		kill(pid, SIGQUIT);
		i = 50;
		while (i && pid) {
			usleep(50000);
			AppHandleMessage();
			i--;
		}
	}
}

int main (int argc, char **argv) {
  TWins_Create_struct wcs;
  int i;
  char *val;


	i = 1;
	while (i<argc) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'a':
		    AutoStart = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "NoTaskbar", 9)) {
			NoTaskbar = True;
		    }
		}
	    }
	    i++;
	}



	initXapp(0, argc, argv);
#if AppEvCountAz10s
	DisableAppEvCountAz10s = True;
#endif
	TWins_Create_struct_init(&wcs, sizeof(TForm), wtyp_Form);
	wcs.CreateParams = TForm_CreateParams;
	wcs.CreateXWin = NULL;
	TWins_DefaultConf(&wcs);

	wcs.XAttr.event_mask = 0;
	wcs.XMask |= CWOverrideRedirect;
	wcs.XAttr.override_redirect = 1;

	FormMain = wcs.wins;

	SetCaption((TWins *) FormMain, "Taskbar Test");
	FormMain->left = 0;
	FormMain->top = 0;
	FormMain->width = 800;
	FormMain->height = 600;
	FormMain->min_width = FormMain->width;
	FormMain->min_height = FormMain->height;
	FormMain->max_width = FormMain->width;
	FormMain->max_height = FormMain->height;
	FormMain->Color = 0x0050c0;
	((TForm*)FormMain)->FormPosition = poDesigned;

	TForm_CreateXWin(&wcs);
//	appDat.X11DispatchEvent = wmX11DispatchEvent;
	Set_Cursor(FormMain, 0);

	appXDat.OnAppStart = OnAppStart;
	appXDat.OnAppClose = OnAppClose;
	AppRun();
	if (pid) kill(0, SIGQUIT);
	return 0;
}
