/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldfile.h"

//#define cbSelCount 4

static int LastPosX, LastPosY;

#define TCSelf TFormDel
typedef struct TFormDel {
  AlgTForm

  TWins *pnlTop;
  TWins *pnlMiddle;
  TWins *pnlBottom;

  TWins *pnlMiddleLeft;
  TLineEdit *le;

  TEdit *edFrom;

  TButton *buStart;
  TButton *buCancle;
  
  TglobPath *gp_src;
  TglobPath *gp_dest;
} TFormDel;
#undef TCSelf

/* _____________________________ Ev __________________________________ */
static void buStart_OnClick(TButton *self, long KeyState, bool DblClick) {
  TFormDel *cf = GetParentForm((TWins*)self);

  TWins *Parent = cf->Parent;
  TLines *tls = cf->le->tls;
  TglobPath *gp_src = cf->gp_src;

	cf->le->tls = NULL;
	cf->gp_src = NULL;

	TForm_Close((TForm*)cf);
	TFormDelRun_Show(Parent, tls, gp_src, xcySkip_Dir);
}

static void buCancle_OnClick(TButton *self, long KeyState, bool DblClick) {
  TFormDel *cf = GetParentForm((TWins*)self);
	TForm_Close((TForm*)cf);
}

/* ____________________________ Resize _______________________________ */
static void PanelTop_OnResize(TWins *self) {
  TFormDel *cf = (TFormDel*)GetParentForm(self);
  int w;
	w = self->width - 43;
	if (w < 40) w = 40;
	SetWidth((TWins*)cf->edFrom, w);
}


static void PanelBottom_OnResize(TWins *self) {
  TFormDel *cf = (TFormDel*)GetParentForm(self);
  int w;

	w = self->width - 2 - cf->buCancle->width;
	SetLeft((TWins*)cf->buCancle, w);
}

/* ____________________________ Destroy ______________________________ */
static bool TFormDel__Destroy(TFormDel *self) {
	LastPosX = self->left;
	LastPosY = self->top;
	gpFree(self->gp_src);
	return TForm__Destroy((TForm*)self);
}

static void mf_OnCanClose(TFormDel *self, int *CanClose) {
	*CanClose = FormCloseAndFree;
}

/* ____________________________ Create _______________________________ */
void TFormDel_Show(TWins *Parent, char *pcsel) {
  TFormDel *self;
  char *pc;

	if (!pcsel) return;
	self = TForm_CreatParamAlg(Parent, sizeof(TFormDel));
	self->destroy = (TDESTROY)TFormDel__Destroy;
	self->FormZStyle = fszTransient;
	if (LastPosX || LastPosY) {
	    self->left = LastPosX;
	    self->top = LastPosY;
	    self->FormPosition = poDesigned;
	} else {
	    self->FormPosition = poCenter;
	}
	self->width = 480;
	self->height = 180;
	self->min_width = 360;
	self->min_height = 180;
	SetCaption((TWins*)self, "Del");
	self->OnCanClose = mf_OnCanClose;

	self->pnlTop = TWins_CreateBA((TWins*)self, 0, 0, 200, 21, mBorder, alTop);
	self->pnlTop->OnResize = PanelTop_OnResize;
	self->pnlMiddle = TWins_CreateBA((TWins*)self, 0, 0, 200, 21, mBorder, alClient);
	self->pnlBottom = TWins_CreateBA((TWins*)self, 0, 0, 200, 28, mBorder, alBottom);
	self->pnlBottom->OnResize = PanelBottom_OnResize;

	self->pnlMiddleLeft = TWins_CreateBA(self->pnlMiddle, 0, 0, 140, 21, 0, alLeft);
	self->le = TLineEdit_CreateA(self->pnlMiddle, 0, 0, 100, 100, alClient);
	self->le->ReadOnly = True;
	TWins_SetUTF8((TWins*)self->le, appXDat.FileSystemUTF8on);
	SetVisible((TWins*)self->le->HSB, False);
	self->le->KeyFu |= mNoKeyFocus;


	TWins_CreateLabel(self->pnlTop, 2,  3, 28, 16, "from:", mCaptionLeft, 0);

	self->gp_src = pcsel_to_tls(pcsel, self->le->tls);
	pc = get_DisplayFileStr(NULL, self->gp_src);
	self->edFrom = TEdit_CreateS(self->pnlTop, 40, 2, 45, 18, pc);
	xfree(pc);
	self->edFrom->KeyFu |= mNoKeyFocus;
	self->edFrom->ReadOnly = True;
	SetColor((TWins*)self->edFrom, 0xe0e0e0);
	TWins_SetUTF8((TWins*)self->edFrom, appXDat.FileSystemUTF8on);

	self->buStart = TButton_CreateS(self->pnlBottom, 2, 2, 64, 24, "START");
	self->buStart->OnClick = buStart_OnClick;
	self->buCancle = TButton_CreateS(self->pnlBottom, 2, 2, 64, 24, "CANCEL");
	self->buCancle->OnClick = buCancle_OnClick;

//	Set_Focus((TWins*)self->cbSel[0]);

	TForm_Show((TForm*)self);
	return;
}
