/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "appbase.h"
#include "buildin_app.h"

typedef struct {
  const char *s;
  TBuildin_app *bi_app;
} Tbi_AHapp;

Tbi_AHapp bi_Tab[] = {
#ifdef USE_BULDIN_ALL_APP
  {"aldfilebox", bi_FileBox_main},
#endif
  {"aldfind", bi_Find_main},
  {NULL, NULL}
};

TBuildin_app *Get_Buildin_pc(char *pc) {
  Tbi_AHapp *bi = bi_Tab;

	while (bi->s) {
		if (pccmp(bi->s, pc)) {
			return bi->bi_app;
		}
		bi++;
	}
	return NULL;
}

void BuildinHelp() {
  int x, l;
  char *pc;
  char line[128];
  Tbi_AHapp *bi = bi_Tab;

	printf("Usage: aldfile [function] [arguments]...\n\n");
	printf("aldfile Currently defined functions:\n");
	line[0] = 0x09;
	x = 8;
	pc = &line[1];
	while (bi->s) {
		l = pclen(bi->s);
		if ((x + l) > 76) {
			printf("%s\n", line);
			x = 8;
			pc = &line[1];
		}
		ppcmove(&pc, bi->s);
		x += l;
		bi++;
		if (bi->s) ppcmove(&pc, ", ");
	}
	if (x > 8) printf("%s\n", line); 
}
