/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldfile.h"
#include "dlg.h"

int xcy_ErrorMsgShow(TWins *parent, Txpy_wd wd, int xcyMsg) {
  const char *msga, *pc, *msgb;
  TglobPath *gp = NULL;
  int res;
  int bef = xcyMsg & xpyMsg_NrMask;
  char *pbuf;
  char buf[500];

	msga = NULL;
	if ((xcyMsg & xpyMsg_src) || (bef == xpyErr_Type)) {
	    msga = "Source File ";
	    gp = XCopy_GetSrc_gp(wd);
	} else if (xcyMsg & xpyMsg_dest) {
	    msga = "Destination File ";
	    gp = XCopy_GetDest_gp(wd);
	}

	pbuf = buf;
	if (gp) {
	    char *s = gptopc(gp, gptfu_noPasswd | gptfu_noName);
	    pbuf += pcxmove(pbuf, s, 160);
	    xfree(s);
	    *pbuf = '\n'; pbuf++;
	    pbuf += pcxmove(pbuf, gp->name, 160);
	    gpFree(gp);
	}

	pc = XCopy_GetErr_pc(wd, xcyMsg);
	if (pc) {
	    *pbuf = '\n'; pbuf++;
	    *pbuf = '\n'; pbuf++;
	    pbuf += pcxmove(pbuf, pc, 160);
	}
	*pbuf = 0;

	msgb = XCopy_GetMsg_pc(wd, xcyMsg);
	res = MsgBox_Show_Error(parent, NULL, msgSKIP|msgSKIPALL|msgCANCEL, 
			msgCANCEL, EMSG_ERR, 
			"%s %s\n\n%s", msga, msgb, buf);

	if (res & msgSKIP) return xcyRetEv_SKIP;
	if (res & msgSKIPALL) return xcyRetEv_SKIP|xcyRetEv_ALL;
	return xcyRetEv_CANCEL;
}
