/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldhex.h"
#include "tpixmap.h"
#include "cicons.h"

static void mHelp_Info(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *form = (TFormMain*)self->FormStruct;
  char buf[80];
	snprintf(buf, sizeof(buf), "ALDhex %s   (build-%d  %s)", 
			VERSION, build_v, build_date);
	Copyright_MsgBox_Show((TWins*)form, buf);
}

static void mHelp_cmd(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormMain *form = (TFormMain*)self->FormStruct;
  char *pc = xmalloc(pclen(Help_Msg)+60);
	sprintf(pc, Help_Msg, build_v, build_date);
	MsgBox_Show((TWins*)form, "ALDhex cmd", pc, msgOK | msgFontFixed, 0);
	xfree(pc);
}

/* ______________________ Create _____________________________________ */
void MenuHelp_Create(TFormMain *self) {
  TMenuItem *mi;

	self->mbHelp = TMenuButton_Create(self->PanelTop, self->mbFile);
	SetCaption((TWins*)self->mbHelp, "Help");
	Set_Parent((TWins*)self->mbHelp, self->PanelTop);

	self->menuHelp = TMenu_Create((TWins*)self);
	self->mbHelp->menu = self->menuHelp;

	mi = TMenu_AddItem(self->menuHelp, "Info", 0, mHelp_Info);
	mi->pic = get_pic16_info(False);
	mi = TMenu_AddItem(self->menuHelp, "cmd", 0, mHelp_cmd);
	mi->pic = get_pic16_shell(False);
}
