/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldhex.h"
#include "tpixmap.h"
#include "cicons.h"

void File_SaveAs(TFormMain *self) {
  char *s = NULL;
  Tstat64 *st = NULL;
  int m;
  bool err;

	self->IO_Run = True;
	if (!self->FileSave_Dlg) {
	    self->FileSave_Dlg = Create_FileSave_Dlg((TWins*)self);
	    if (TImageRD_AllFiletyp) file_dlg_InitAzPic(self->FileSave_Dlg);
	    const char *fn = THexEdit_GetFileName(self->HexEdit);
	    if (fn) File_Dlg_SetNamePath(self->FileSave_Dlg, fn);
	}
	if (File_Dlg_Execute(self->FileSave_Dlg)) {
	    File_Dlg_GetEdFileName(self->FileSave_Dlg, &s);

	    err = False;
	    st = net_stat(s, NULL, fsFollowLink | fsNoFileName | fsNoLinkName);
	    if (st == PTR_FAILED) goto end_err;
	    if (st) {
		char *azfn = get_DisplayFileStr(s, NULL);
		if (st->st & st_Reg) {
		  ppcchange_add_n(&azfn, 2, "Overwrite exists file \n", azfn);
		  m = MsgBox_Show((TWins*)self, "Warning !!!", azfn, 
			  msgIcoWARNING | msgYES | msgNO, msgNO);
		  if (m == msgNO) err = True;
		} else {
		  ppcchange_add_n(&azfn, 2, "Can't write file \n", azfn);
		  MsgBox_Show((TWins*)self, "ERROR !!!", azfn, 
			  msgIcoERROR | msgYES, msgYES);
		  err = True;
		}
		xfree(azfn);
	    }

	    xfree(st);
	    if (err) goto end_err;
	    THexEdit_SaveFile(self->HexEdit, s);
	    SetCaption((TWins*)self, s);
end_err:
	    xfree(s);
	}
	self->IO_Run = False;
}

void File_Save(TFormMain *self) {
//	if (self->HexEdit->FileName) {
	    self->IO_Run = True;
	    THexEdit_SaveFile(self->HexEdit, NULL);
	    self->IO_Run = False;
//	} else {
//	    File_SaveAs(self);
//	}
}

static void mbSave_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TFormMain *form = (TFormMain*)self->FormStruct;
	File_Save(form);
}

/* ______________________ Create _____________________________________ */
void MenuSave_Create(TFormMain *self) {
	self->mbSave = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbSave->Enabled = False;
	self->mbSave->pic = get_pic16_filesave(False);
	self->mbSave->dis_pic = get_pic16_filesave(True);
	self->mbSave->OnClick = mbSave_OnClick;
	Set_Parent((TWins*)self->mbSave, self->PanelTop);
}
