/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldhex.h"
#include "tpixmap.h"
#include "cicons.h"

void Chk_UnRedo(TFormMain *self) {
  bool mkundo, mkredo;
	TUnRedo_GetStat(self->HexEdit->UnRedo, &mkundo, &mkredo);
	SetEnabled((TWins*)self->mbUndo, mkundo);
	SetEnabled((TWins*)self->mbRedo, mkredo);
}

static void mbUndo_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TFormMain *form = (TFormMain*)self->FormStruct;
  TUnRedoLine *url = TUnRedo_GetUndo(form->HexEdit->UnRedo);
	if (url) {
	    if (!THexEdit_Undo(form->HexEdit, url)) {
		TUnRedo_Undo_Old(form->HexEdit->UnRedo);
	    }
	}
	Chk_UnRedo(form);
}

static void mbRedo_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TFormMain *form = (TFormMain*)self->FormStruct;
  TUnRedoLine *url = TUnRedo_GetRedo(form->HexEdit->UnRedo);
	if (url) {
	    if (!THexEdit_Redo(form->HexEdit, url)) {
		TUnRedo_Redo_Old(form->HexEdit->UnRedo);
	    }
	}
	Chk_UnRedo(form);
}

/* ______________________ Create _____________________________________ */
void MenuUnRedo_Create(TFormMain *self) {
// ******* Menu Undo *******
	self->mbUndo = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbUndo->Enabled = False;
	self->mbUndo->pic = get_pic16_undo(False);
	self->mbUndo->dis_pic = get_pic16_undo(True);
	self->mbUndo->OnClick = mbUndo_OnClick;
	Set_Parent((TWins*)self->mbUndo, self->PanelTop);

// ******* Menu Redo *******
	self->mbRedo = TMenuButton_Create(self->PanelTop, self->mbFile);
	self->mbRedo->Enabled = False;
	self->mbRedo->pic = get_pic16_redo(False);
	self->mbRedo->dis_pic = get_pic16_redo(True);
	self->mbRedo->OnClick = mbRedo_OnClick;
	Set_Parent((TWins*)self->mbRedo, self->PanelTop);

}
