/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under LGPL v2.1, see file COPYING.LIB in this tarball
*/

#include "sysbase.h"
#include "sysbaseio.h"
#include "tfio.h"


int64_t FIO_GetSize(TFIO *self) {
	if (!self || !self->GetSize) return 0;
	return self->GetSize(self);
}

int64_t FIO_GetSizeAbs(TFIO *self) {
	if (!self || !self->GetSizeAbs) return 0;
	return self->GetSizeAbs(self);
}

bool FIO_SetOffset(TFIO *self, int64_t Offset) {
	if (!self || !self->SetOffset) return False;
	return self->SetOffset(self, Offset);
}

int64_t FIO_GetOffset(TFIO *self) {
	if (!self || !self->GetOffset) return 0;
	return self->GetOffset(self);
}

bool FIO_OverWrite(TFIO *self, int64_t Offset, const char *pc, dword size) {
	if (!self || !self->OverWrite) return False;
	return self->OverWrite(self, Offset, pc, size);
}

bool FIO_Insert(TFIO *self, int64_t Offset, const char *pc, dword size) {
	if (!self || !self->Insert) return False;
	return self->Insert(self, Offset, pc, size);
}

bool FIO_Delete(TFIO *self, int64_t Offset, dword size) {
	if (!self || !self->Delete) return False;
	return self->Delete(self, Offset, size);
}

char *FIO_GetDataP(TFIO *self, int64_t Offset, int MaxChr) {
	if (!self || !self->GetDataP) return NULL;
	return self->GetDataP(self, Offset, MaxChr);
}

bool FIO_Close(TFIO *self) {
	if (!self || !self->Close) return True;
	return self->Close(self);
}

/* bool FIO_SaveAs(TFIO *self, const char *FileName) {
	if (!self || !self->SaveAs) return True;
	return self->SaveAs(self, FileName);
} */

bool FIO_Save(TFIO *self, const char *FileName) {
	if (!self || !self->Save) return True;
	return self->Save(self, FileName);
}

/* bool FIO_ReOpen(TFIO *self, const char *FileName) {
	if (!self || !self->ReOpen) return True;
	return self->ReOpen(self, FileName);
} */

bool FIO_Open(TFIO *self) {
	if (!self || !self->Open) return True;
	return self->Open(self);
}

dword FIO_GetIOfkt(TFIO *self) {
	if (!self) return 0;
	return self->IOfkt;
}

int FIO_GetArt(TFIO *self) {
	if (!self) return 0;
	return self->art;
}

bool FIO_GetChanged(TFIO *self) {
	if (!self || !self->GetChanged) return False;
	return self->GetChanged(self);
}

/*____________________________ Destroy __________________________________*/
bool TFIO__Destroy(TFIO *self) {
	xfree(self->FileName);
	return False;
}

/*____________________________ Create ___________________________________*/
TFIO *TFIO_Create(const char *FileName, int tcsize, int art) {
  TFIO *self;

	self = ttc_create(tcsize, wtyp_TFIO);
	self->art = art;
	self->FileName = pcdup(FileName);
	self->destroy = (TDESTROY)TFIO__Destroy;

	return self;
}
