/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#include "tpixmap.h"
#include "dlg.h"
#include "tfilewin.h"
#include "media_io.h"
#include "video_ioc.h"


#ifdef _OS_WIN32

#include "zsrc.h"

#ifdef DRAG_AND_DROP
#undef DRAG_AND_DROP
#endif

#ifdef Test_Root_WinId
#undef Test_Root_WinId
#endif

#endif /* _OS_WIN32 */


#define APPNAME "aldpic"

extern const int build_v;
extern const char *build_date;
extern const char *Help_Msg;

#define pmxWR_bppMAXnr		9

#define pmxWR_bppMask		0x0f0
#define pmxWR_bppDefault	0x000
#define pmxWR_bpp6		0x010
#define pmxWR_bpp7		0x020
#define pmxWR_bpp8		0x030
#define pmxWR_bpp9		0x040
#define pmxWR_bpp10		0x050
#define pmxWR_bpp12		0x060
#define pmxWR_bpp15		0x070
#define pmxWR_bpp16		0x080
#define pmxWR_bpp18		0x090


#define TCSelf TpnlColorScBar
typedef struct TpnlColorScBar {
  AlgTWins
  TChkBox *cb;
  TScrollBar *sb;
  TPic *pic;
  int val;
} TpnlColorScBar;
#undef TCSelf

#define TCSelf TFormPalette
typedef struct TFormPalette {
  AlgTForm
  TWins *lblColors;
  TWins *lblColorsTo;
  TDVal *dvColorsTo;
  TChkBox *cbColQuantOn;
  TWins *pnlPalette;
  TChkBox *cbPalette[20];
  dword PaletteColor[20];
  TWins *lblPosColor;
  TWins *wPosColor;
  TWins *lblR;
  TWins *lblG;
  TWins *lblB;
  TDVal *dvR;
  TDVal *dvG;
  TDVal *dvB;
  int rgbIdx;
  int rgbmdVal;
} TFormPalette;
#undef TCSelf

#define TCSelf TFormCutOut
typedef struct TFormCutOut {
  AlgTForm
  TWins *lblOrgStat;
  TWins *lblX;
  TDVal *dvX, *dvXz;
  TWins *lblY;
  TDVal *dvY, *dvYz;
  TWins *lblW;
  TDVal *dvW, *dvWz;
  TWins *lblH;
  TDVal *dvH, *dvHz;
  TChkBox *cbCutOutOn;

  int omx, omy, omw, omh;
  double odvX, odvXz, odvY, odvYz, odvW, odvWz, odvH, odvHz;
} TFormCutOut;
#undef TCSelf

#define TCSelf TFormAlphaClr
typedef struct TFormAlphaClr {
  AlgTForm
  TChkBox *cbAlphaClrOn;
  TChkBox *cbReplaceBackColor;
  TChkBox *cbRenderColor;
  TWins *lblR;
  TWins *lblG;
  TWins *lblB;
  TDVal *dvR;
  TDVal *dvG;
  TDVal *dvB;
  int onMk;
} TFormAlphaClr;
#undef TCSelf

#define ib_org_pxm	0x01
#define ib_rot_pxm	0x02
#define ib_rszbase_pxm	0x03
#define ib_rsz_pxm	0x04
#define ib_base_pxm	0x07

#define ib_vio_pxm	0x08
#define ib_paintbase_pxm 0x0f

#define ib_paint_pxm	0x10
#define ib_all_pxm	0x1f
#define ib_rszfree_pxm	0x1c


#define TCSelf TMainForm
typedef struct TMainForm {
  AlgTForm
  TFile_Dlg *File_Dlg;

  TWins *PanelTop;
  TWins *PanelMiddle;
  TWins *PanelBottom;

  TMenuButton *mbFile;
  TMenu *menuFile;
  TMenuItem *miSave;
  TMenuItem *miSaveAs;

  TMenuButton *mbView;
  TMenu *menuView;
    TMenuItem *miViewColor;

  TMenuButton *mbTools;
  TMenu *menuTools;
    TMenuItem *miToolsMaskCLR;
    TMenuItem *miSwapX;
    TMenuItem *miSwapY;
    TMenuItem *miRotat90;
    TMenuItem *miRotat180;
    TMenuItem *miRotat270;
    TMenuItem *miCopy;
    TMenuItem *miPaste;

  TMenuButton *mbSetting;
  TMenu *menuSetting;
   TMenu *menu_png;
    TMenuItem *miPngPallette;
    TMenu *menu_pngCompLev;
   TMenu *menu_jpg;
    TMenu *menu_jpgQuality;
   TMenuItem *miAutoMask;
//   TMenuItem *miSettingMaskCLR;

  TMenuButton *mbHelp;
    TMenu *menuHelp;

  TMenuButton *mbPlayleft;
  TMenuButton *mbPlay2left;
  TMenuButton *mbPlayrigth;
  TMenuButton *mbPlay2rigth;

  TMenuButton *mbZoom_no;
  TMenuButton *mbZoom_w;
  TMenuButton *mbZoom_h;
  TMenuButton *mbZoom_wh;

  TMenuButton *mbZoom_plus;
  TMenuButton *mbZoom_minus;

  TWins *pnlLoadZoomMod;

  TScrollWin *AzGraf;
  TWins *pnlColor;
  TWins *PanelList;
  TFileWin *FileWin;
  TWins *pnlZoom;
  TScrollBar *sbZoom;
  TWins *pnlZoomAZ;
  TWins *pnlPath;
  TChkBox *cbFastZoom;
  TWins *lblW;
  TEdit *edW;
  TChkBox *cbWen;

  TChkBox *cbColor;
  TpnlColorScBar *pnlBrightness;
  TpnlColorScBar *pnlContrast;
  TpnlColorScBar *pnlColorSat;
  TpnlColorScBar *pnlRed;
  TpnlColorScBar *pnlGreen;
  TpnlColorScBar *pnlBlue;

  TPic picRGB;
  TPic picBrightness;
  TPic picContrast;
  TPic picRed;
  TPic picGreen;
  TPic picBlue;

  TPic picZoom_no;
  TPic picZoom_w;
  TPic picZoom_w_dis;
  TPic picZoom_h;
  TPic picZoom_h_dis;
  TPic picZoom_wh;
  TPic picZoom_wh_dis;
  TPic picZoom_xy_dis;

  TPic picZoom_plus;
  TPic picZoom_plus_dis;
  TPic picZoom_minus;
  TPic picZoom_minus_dis;

  TPixMap *pxm;
  TPixMap *rot_pxm;
  TPixMap *rsz_pxm;
  TPixMap *vio_pxm;
  TPixMap *paint_pxm;
  int pxm_left;
  int pxm_top;

  int LoadZoomMod;
  double zoom_k;
  double zoom_kh;
  double new_zoom_k;
  double new_zoom_kh;

  double no_cbWen_zoom_k;
  double no_cbWen_zoom_kh;


  int cHoff;
  int cVoff;
  int HSB_Count;
  int VSB_Count;
  int old_w;
  int old_h;

  int AlphaClrModus;

  bool conv_run;
  bool rsz_run;
  bool paint_run;
  bool RePaint_pxm;

  bool bnc4; //AZClear;
  bool new_pxm_data;
  bool gray;
  bool pnm_plain;

  bool bmp_AutoMask;
  bool bnc09; //Alpha;
  bool bnc10; //AlphaClr;
  bool bnc11; //AlphaClrBackColor;

  bool bnc12; //AlphaRender;
  bool AlphaClrOk;
  bool QuantOk;
  bool QuantMk;

  bool SwapX;
  bool SwapY;
  bool Rotat90;
  bool Rotat180;

  bool Rotat270;
  bool nc21;
  bool nc22;
  bool nc23;

  int	org_stat;
  int	bpp;
  dword AlphaClrColor;
  int	paint_bpp;
  int	pngCompLev;
  int	jpgQuality;
  TFile_Dlg *FileOpen_Dlg;
  TFile_Dlg *FileSave_Dlg;
  char	*StartFile;
  char	*pxmFile;
  char	*pxmLastSaveAs;
  int	ldTime;
  int	zoomTime;
  int	viocTime;
  int	paintTime;
  TVideo_IOC *ioc_colorRGB;
  int	iocfu;
  TFormAlphaClr *fAlphaClr;
  TFormPalette *fpal;
  TFormCutOut *fcutout;
  int selx, sely, selw, selh;
  int selAkt;
  GC GC_Dot;

  TMemInfo MemInfo;
  dword self_mem;  //kB
  dword pxm0_mem;  //kB
} TMainForm;
#undef TCSelf

void ALDpic_init_icons(TMainForm *fpic);

//void ALDpic_Clr_dup_paint_pxm(TMainForm *fpic);
void ALDpic_Chk_Mask(TMainForm *fpic, TPixMap *pxm);
void ALDpic_Chk_AutoMask(TMainForm *fpic, int fu);
void ALDpic_Chk_dup_paint_pxm(TMainForm *fpic);
void ALDpic_Chk_vioc_pxm(TMainForm *fpic);

void ALDpic_resize_pxm(TMainForm *fpic);
void ALDpic_pxm_free(TMainForm *fpic, int fu);
TPixMap *ALDpic_pxm_get(TMainForm *fpic, int fu);

void ALDpic_mbXXXX_Set_en(TMainForm *fpic, int fu);
void ALDpic_FW_Load_Pic(TFileWin *fw, TDirFileList *dfl, char *fn);
void ALDpic_mFile_PrintIndex(TMenu *self, long KeyState, TMenuItem *smi);

#ifndef _OS_WIN32
dword get_FreeMem(TMainForm *fpic, dword new_mem);
#endif
void clr_vioc_pxm_para(TMainForm *fpic);

/* ----------------- Menu File -------------------- */
void MenuFile_Create(TMainForm *self);
void ALDpic_FileOpen(TMainForm *fpic, char **ppc);

char *GetLinePattern(const char *pattern);
void SetFileDlgSinglePattern(TFile_Dlg *File_Dlg, const char *pattern);

/* ----------------- Menu View _------------------- */
void MenuView_Create(TMainForm *fmain);

/* ----------------- Menu Tools ------------------- */
void MenuTools_Create(TMainForm *fmain);

void TMainForm_Copy(TMainForm *self);
void TMainForm_Paste(TMainForm *self);

void menuTools_clr_rot_swap(TMainForm *fmain);

/* ----------------- Menu Setting ----------------- */
void MenuSetting_Create(TMainForm *self);

void menuSetting_clr(TMainForm *fmain);

/* ----------------- Menu Help -------------------- */
void MenuHelp_Create(TMainForm *fmain);

/* ----------------- MenuButton Play -------------- */
void MenuButtonPlay_Create(TMainForm *self);
void ALDpic_mbPlay_Chk_en(TMainForm *fpic);
void ALDpic_mbPlayrigth_OnClick(TMenuButton *self, long KeyState, bool DblClick);
void ALDpic_mbPlayleft_OnClick(TMenuButton *self, long KeyState, bool DblClick);

/* ----------------- MenuButton Zoom -------------- */
void MenuButtonZoom_Create(TMainForm *self);

/* ----------------- Form Palette ----------------- */
TFormPalette *TFormPalette_Create(TWins *parentForm);
//void AzColors(TMainForm *fpic);
void ColorsQuant(TMainForm *fpic);

void AzRGBA(TMainForm *fpic, int x, int y, TImage *img);
void SetQuant_RGB(TMainForm *fpic, int x, int y, TImage *img);

/* ----------------- Form CutOut ----------------- */
TFormCutOut *TFormCutOut_Create(TMainForm *fmain);

void CutOut_SetEvEn(bool en);
void CutOut_Clr();
bool CutOut_Chk_On();
void AzCutOut_0(TMainForm *fmain);
void AzCutOut(TMainForm *fmain);
TPixMap *CutOut_PixMap(TPixMap *pxm, int new_w, int new_h);

void AzGraf_CutOut_OnMouseMove(TWins *self, XMotionEvent *ev);
void AzGraf_CutOut_OnMouseDown(TWins *self, XButtonEvent *ev);
void AzGraf_CutOut_OnMouseUp(TWins *self, XButtonEvent *ev);

/* ----------------- Form AlphaClr -------------- */
TFormAlphaClr *TFormAlphaClr_Create(TMainForm *fmain);
dword TFormAlphaClr_GetColor(TFormAlphaClr *self);
//bool TFormAlphaClr_IsAkt(TFormAlphaClr *self);
//bool TFormAlphaClr_IsOn(TFormAlphaClr *self);
//bool TFormAlphaClrRender_IsAkt(TFormAlphaClr *self);
//bool TFormAlphaClrBackColor_IsAkt(TFormAlphaClr *self);

#define IS_ALPHA_CLR		1
#define IS_ALPHA_CLR_BACKCOLOR	(1<<1)
#define IS_ALPHA_RENDER		(1<<2)
int TFormAlphaClr_GetModus(TFormAlphaClr *self);
int TFormAlphaClr_GetModus_IsAkt(TFormAlphaClr *self);  //+ chk Visible,...

void AlphaClr(TMainForm *self);

/* ----------------- SwapPic -------------------- */
void SwapPic(TMainForm *self);

#ifdef _OS_WIN32
extern const ThZsrc hZsrc_aldpic16_png;
extern const ThZsrc hZsrc_aldpic32_png;
extern const ThZsrc hZsrc_aldpic_desktop;
#endif
