/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "aldpic.h"

static void miPngCompLev_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TMenuItem *mi = ((TMenu*)fpic->menu_pngCompLev)->MenuItem;
	while (mi) {
	    mi->fu &= ~miChecked;
	    mi = mi->next;
	}
	smi->fu |= miChecked;
	fpic->pngCompLev = smi->tag;
}

static void miJpgQuality_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TMenuItem *mi = ((TMenu*)fpic->menu_jpgQuality)->MenuItem;
	while (mi) {
	    mi->fu &= ~miChecked;
	    mi = mi->next;
	}
	smi->fu |= miChecked;
	fpic->jpgQuality = smi->tag;
}

static void miPnmPlain_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->pnm_plain = (smi->fu & miChecked) != 0;
}

static void miBmpAutoMask_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->bmp_AutoMask = (smi->fu & miChecked) != 0;
	ALDpic_Chk_AutoMask(fpic, 1);
	Refresh((TWins*)fpic->AzGraf);
}

static void miGRAY_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->gray = (smi->fu & miChecked) != 0;
}

static void miGRAY_nature_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->iocfu &= ~VIOCFU_GRAY_NATURE;
	if (smi->fu & miChecked) fpic->iocfu |= VIOCFU_GRAY_NATURE;
}

static void miNegative_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->iocfu &= ~VIOCFU_NEGATIV;
	if (smi->fu & miChecked) fpic->iocfu |= VIOCFU_NEGATIV;
}

/*
static void miAlpha_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
	fpic->Alpha = (smi->fu & miChecked) != 0;
}

static void miAlphaCLR_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fmain = (TMainForm*)self->FormStruct;
	TForm_Show((TForm*)fmain->fAlphaClr);
}
*/

static void mibpp_OnClick(TMenu *self, long KeyState, TMenuItem *smi) {
  TMainForm *fpic = (TMainForm*)self->FormStruct;
  TMenuItem *mi = ((TMenu*)fpic->menuSetting)->MenuItem;
	while (mi) {
	    if (mi->tag & 0x10000) mi->fu &= ~miChecked;
	    mi = mi->next;
	}
	smi->fu |= miChecked;
	fpic->bpp = smi->tag & 0x0ffff;
}

void menuSetting_clr(TMainForm *fmain) {  //low mem
TMenuItem *mi;

	if (!fmain->menuSetting) return;
	mi = fmain->menuSetting->MenuItem;
	while (mi) {
	    if (mi->tag & 0x100000) {
		mi->fu &= ~miChecked;
		if (mi->tag & 0x200000) mi->fu |= miChecked;
	    }
	    mi = mi->next;
	}
	fmain->bpp = 0;
//	fmain->Alpha = 0;
	fmain->gray = 0;
	fmain->iocfu &= ~VIOCFU_NEGATIV;
}

/* ______________________ Create _____________________________________ */
void MenuSetting_Create(TMainForm *self) {
  TMenuItem *mi, *mi2;
	self->mbSetting = TMenuButton_Create(self->PanelTop, self->mbFile);
	SetCaption((TWins*)self->mbSetting, "Settings");
	Set_Parent((TWins*)self->mbSetting, self->PanelTop);
	self->menuSetting = TMenu_Create((TWins*)self);
	self->mbSetting->menu = self->menuSetting;

	if (TImageWR_AllFiletyp & filetyp_PNG) {
	  mi = TMenu_AddItem(self->menuSetting, "PNG", 0, NULL);
	    self->menu_png = (TMenu*)TMenu_Create((TWins*)self);
	    mi->next_menu = self->menu_png;
	    mi2 = TMenu_AddItem(self->menu_png, "Compress level", 0, NULL);
		self->menu_pngCompLev = TMenu_Create((TWins*)self);
		mi2->next_menu = self->menu_pngCompLev;
		TMenu_AddItem(self->menu_pngCompLev, "Speed", 
			miCanCheck, miPngCompLev_OnClick)->tag = 4; //4-1=3
		self->pngCompLev = 0;
		TMenu_AddItem(self->menu_pngCompLev, "Default", 
			miCanCheck | miChecked, miPngCompLev_OnClick); //0-1=-1
		TMenu_AddItem(self->menu_pngCompLev, "Max", 
			miCanCheck, miPngCompLev_OnClick)->tag = 10; //10-1=9
	    self->miPngPallette = TMenu_AddItem(self->menu_png, "use pallette <=256", 
			miChecked|miAutoToggle, NULL);
	}

	if (TImageWR_AllFiletyp & filetyp_JPEG) {
	  mi = TMenu_AddItem(self->menuSetting, "JPG", 0, NULL);
	    self->menu_jpg = TMenu_Create((TWins*)self);
	    mi->next_menu = self->menu_jpg;
	    mi2 = TMenu_AddItem(self->menu_jpg, "Quality", 0, NULL);
		self->menu_jpgQuality = (TMenu*)TMenu_Create((TWins*)self);
		mi2->next_menu = self->menu_jpgQuality;
		TMenu_AddItem(self->menu_jpgQuality, "100", 
			miCanCheck, miJpgQuality_OnClick)->tag = 100;
		TMenu_AddItem(self->menu_jpgQuality, "98", 
			miCanCheck, miJpgQuality_OnClick)->tag = 98;
		TMenu_AddItem(self->menu_jpgQuality, "95", 
			miCanCheck | miChecked, miJpgQuality_OnClick)->tag = 95;
		TMenu_AddItem(self->menu_jpgQuality, "90", 
			miCanCheck, miJpgQuality_OnClick)->tag = 90;
		TMenu_AddItem(self->menu_jpgQuality, "83", 
			miCanCheck, miJpgQuality_OnClick)->tag = 83;
		TMenu_AddItem(self->menu_jpgQuality, "75", 
			miCanCheck, miJpgQuality_OnClick)->tag = 75;
		TMenu_AddItem(self->menu_jpgQuality, "63", 
			miCanCheck, miJpgQuality_OnClick)->tag = 63;
		TMenu_AddItem(self->menu_jpgQuality, "50", 
			miCanCheck, miJpgQuality_OnClick)->tag = 50;
		TMenu_AddItem(self->menu_jpgQuality, "40", 
			miCanCheck, miJpgQuality_OnClick)->tag = 40;
		TMenu_AddItem(self->menu_jpgQuality, "25", 
			miCanCheck, miJpgQuality_OnClick)->tag = 25;
		self->jpgQuality = 95;
	}

	if (TImageWR_AllFiletyp & filetyp_PNM) {
	    TMenu_AddItem(self->menuSetting, "PPM,PNM  plain",
				miCanCheck|miAutoToggle, miPnmPlain_OnClick);
	}

	self->miAutoMask = TMenu_AddItem(self->menuSetting, "Auto Mask",
				miCanCheck|miAutoToggle, miBmpAutoMask_OnClick);


	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
	TMenu_AddItem(self->menuSetting, "GRAY", 
			miCanCheck|miAutoToggle, miGRAY_OnClick)->tag = 0x100000;
	TMenu_AddItem(self->menuSetting, "GRAY nature", 
			miCanCheck|miAutoToggle, miGRAY_nature_OnClick);
	TMenu_AddItem(self->menuSetting, "Negative", 
			miCanCheck|miAutoToggle, miNegative_OnClick)->tag = 0x100000;

	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
//	TMenu_AddItem(self->menuSetting, "Alpha", 
//		miCanCheck|miChecked|miAutoToggle, miAlpha_OnClick)->tag = 0x100000;
//	self->miSettingMaskCLR = TMenu_AddItem(self->menuSetting, "Alpha CLR", 
//		0, miAlphaCLR_OnClick);
//	self->Alpha = True;

	TMenu_AddItem(self->menuSetting, "-", 0, NULL);
	TMenu_AddItem(self->menuSetting, "bpp Default", 
		miCanCheck | miChecked, mibpp_OnClick)->tag = 0x310000;
	TMenu_AddItem(self->menuSetting, "bpp 6", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp6;
	TMenu_AddItem(self->menuSetting, "bpp 7", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp7;
	TMenu_AddItem(self->menuSetting, "bpp 8", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp8;
	TMenu_AddItem(self->menuSetting, "bpp 9", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp9;
	TMenu_AddItem(self->menuSetting, "bpp 10", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp10;
	TMenu_AddItem(self->menuSetting, "bpp 12", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp12;
	TMenu_AddItem(self->menuSetting, "bpp 15", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp15;
	TMenu_AddItem(self->menuSetting, "bpp 16", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp16;
	TMenu_AddItem(self->menuSetting, "bpp 18", 
		miCanCheck, mibpp_OnClick)->tag = 0x110000 | pmxWR_bpp18;
}
