/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"
#include "ElGraf.h"
#include <math.h>

void DrawTP1_Lh(Window WinID, int *x, int y, TPic *pic) {
  int x2 = *x;
	DrawPic(WinID, get_Pic_Lh(), x2, y-5);
	DrawPic(WinID, pic, x2+5, y+5);
	x2 += 20;
	*x = x2;
}

void DrawTP1_Ch(Window WinID, int *x, int y, TPic *pic) {
  int x2 = *x;
	DrawPic(WinID, get_Pic_Ch(), x2, y-5);
	DrawPic(WinID, pic, x2+5, y+7);
	x2 += 20;
	*x = x2;
}

void DrawTP1_Cv(Window WinID, int *x, int xo, int y, TPic *pic) {
  int x2 = *x;
  int y2 = y+30;
	DrawLineRGB(WinID, 0, x2, y, x2+10+xo, y);
	x2 += xo;
	DrawPic(WinID, get_Pic_pt(), x2+3, y-2);
	DrawLineRGB(WinID, 0, x2+5, y+3, x2+5, y+4);
	DrawPic(WinID, get_Pic_Cv(), x2, y+4);
	DrawPic(WinID, pic, x2+7, y+18);
	DrawLineRGB(WinID, 0, x2+5, y+24, x2+5, y+28);
	DrawPic(WinID, get_Pic_pt(), x2+3, y2-2);
	x2 += 10;
	*x = x2;
}

void DrawTP1_Lv(Window WinID, int *x, int xo, int y, TPic *pic) {
  int x2 = *x;
  int y2 = y+30;
	DrawLineRGB(WinID, 0, x2, y, x2+10+xo, y);
	x2 += xo;
	DrawPic(WinID, get_Pic_pt(), x2+3, y-2);
	DrawLineRGB(WinID, 0, x2+5, y+3, x2+5, y+5);
	DrawPic(WinID, get_Pic_Lv(), x2, y+5);
	DrawPic(WinID, pic, x2+10, y+18);
	DrawLineRGB(WinID, 0, x2+5, y+25, x2+5, y+28);
	DrawPic(WinID, get_Pic_pt(), x2+3, y2-2);
	x2 += 10;
	*x = x2;
}

void Draw_xP1_Rg(Window WinID, int *px2, int *pxa, int y, int y2, int fu) {
  int x2 = *px2;
  int xa;

	DrawLineRGB(WinID, 0, x2+10, y, x2+14, y);
	DrawLineRGB(WinID, 0, x2+10, y, x2+10, y+4);
	DrawPic(WinID, get_Pic_Rg(), x2, y+5);
	DrawLineRGB(WinID, 0, x2+10, y2, x2+14, y2);
	DrawLineRGB(WinID, 0, x2+10, y+25, x2+10, y2);

	x2 += 20;

	DrawPic(WinID, get_Pic_pto(), x2-3, y-3);
	DrawPic(WinID, get_Pic_pto(), x2-3, y2-3);
	xa = x2+3;
	x2 += 4;

	if ((fu & 0x10000) == 0) {
	  if (fu & 0x01) {
	    DrawLineRGB(WinID, 0, x2, y, x2+4, y);
	    x2 += 5;
	    DrawPic(WinID, get_Pic_Ch(), x2, y-5);
	    DrawPic(WinID, get_Pic_cCs(), x2, y+5);
	    x2 += 20;
	  } else {
	    DrawLineRGB(WinID, 0, x2, y, x2+5, y);
	    x2 += 6;
	  }

	  if (fu & 0x02) {
	    DrawPic(WinID, get_Pic_Rh(), x2, y-5);
	    DrawPic(WinID, get_Pic_cRs(), x2+5, y+5);
	    x2 += 20;
	  }
	} else {
	  if (fu & 0x04) {
	    DrawLineRGB(WinID, 0, x2, y, x2+4, y);
	    x2 += 5;
	    DrawPic(WinID, get_Pic_Ch(), x2, y-5);
	    DrawPic(WinID, get_Pic_cCx(), x2, y+5);
	    x2 += 20;
	  } else {
	    DrawLineRGB(WinID, 0, x2, y, x2+5, y);
	    x2 += 6;
	  }

	  if (fu & 0x08) {
	    DrawPic(WinID, get_Pic_Rh(), x2, y-5);
	    DrawPic(WinID, get_Pic_cRx(), x2+5, y+5);
	    x2 += 20;
	  }
	}
	*px2 = x2;
	*pxa = xa;
}

void Draw_xP1_R_Out(Window WinID, int x2, int xa, int y, int y2, int fu, TPic *pic) {
/* Cx */
	if ((fu & 0x10000) == 0) {
	  if (fu & 0x04) {
	    DrawPic(WinID, get_Pic_Ch(), x2, y-5);
	    DrawPic(WinID, get_Pic_cCx(), x2+14, y+5);
	    x2 += 15;
	  }

	  if (fu & 0x08) {
	    if (fu & 0x04) x2 += 4;
	    x2 += 1;
	    DrawPic(WinID, get_Pic_Rh(), x2, y-5);
	    DrawPic(WinID, get_Pic_cRx(), x2+14, y+5);
	    x2 += 18;
	  }
	} else {
	  if (fu & 0x01) {
	    DrawPic(WinID, get_Pic_Ch(), x2, y-5);
	    DrawPic(WinID, get_Pic_cCs(), x2+14, y+5);
	    x2 += 15;
	  }

	  if (fu & 0x02) {
	    if (fu & 0x04) x2 += 4;
	    x2 += 1;
	    DrawPic(WinID, get_Pic_Rh(), x2, y-5);
	    DrawPic(WinID, get_Pic_cRs(), x2+14, y+5);
	    x2 += 18;
	  }
	}

	x2 += 7;
	DrawLineRGB(WinID, 0, xa, y2, x2, y2);
	xa = x2-7;
	DrawLineRGB(WinID, 0, xa, y, x2, y);
	DrawPic(WinID, get_Pic_pto(), x2, y-3);
	DrawPic(WinID, get_Pic_pto(), x2, y2-3);

	xa = x2+6;
	x2 += 10;
	DrawLineRGB(WinID, 0, x2, y, x2+5, y);
	DrawLineRGB(WinID, 0, x2+5, y, x2+5, y+5);
	DrawPic(WinID, get_Pic_Rv(), x2, y+5);
	DrawLineRGB(WinID, 0, x2, y2, x2+5, y2);
	DrawLineRGB(WinID, 0, x2+5, y2, x2+5, y2-5);
	DrawPic(WinID, pic, x2+10, y+12);
}

void Draw_xP1_Ra(Window WinID, int x2, int xa, int y, int y2, int fu) {
	Draw_xP1_R_Out(WinID, x2, xa, y, y2, fu, get_Pic_cRa());
}

static void str_toGraf(TWins *Wins, const char *s, int x, int y) {
	vds_SetStr(&Wins->vds, s);
	DrawColorString(x, y, &Wins->vds);
}

static void ELM_TP1_pnlGrafVal_OnPaint(TWins *self) {
  TPage_Filter *pg = self->subClass;
  int x = 2;
  char *s;
	str_toGraf(self, "Freq", x, 3);
	x =  pg->cbmaxMHZ->left + pg->cbmaxMHZ->width + 2;
	s = pcadd(pg->xy_ind->dat->dx->s, " +");
	str_toGraf(self, s, x, 3);
	xfree(s);
	str_toGraf(self, "dB", pg->dv_TP1_Off_dB->left+pg->dv_TP1_Off_dB->width+2, 3);
}

static void SetCursor_sbDetail(TPage_Filter *pg) {
  int nk = 1;
  char buf[64];
  char *pc;
  float freq;

	pg->xy_ind->CursorX = pg->sbDetail->Count * pg->ScaleMHz / 
			      pg->sbDetail->MaxCount;
	if (pg->ScaleMHz < 2000) nk = 2;
	if (pg->ScaleMHz < 200) nk = 3;
	if (pg->ScaleMHz < 20) nk = 4;
	if (pg->ScaleMHz < 2) nk = 5;
	pc = buf;
	freq = TScaleXY_GetCursX_ScaleVal(pg->xy_ind);
	floattoppc(&pc, freq, nk | kSPACE_ADD);
	ppcmove(&pc, "MHz");
	ppcchange(&pg->xy_ind->CursorX_Str, buf);

  TWins *wins = appXDat.Wins;
	while (wins) {
	    if ((wins->wtyp == wtyp_TFormR) || 
		(wins->wtyp == wtyp_TFormL) ||
		(wins->wtyp == wtyp_TFormC)) {
		if (((TFormRLC*)wins)->SetFreq) 
			((TFormRLC*)wins)->SetFreq((TFormRLC*)wins, freq);
	    }
	    wins = wins->next;
	}

	SetCursor_Dat_txt(pg);
}


static void EML_Filter_TP1_Off_dB_OnValChange(TDVal *dv, double val) {
  TPage_Filter *pg = dv->subClass;
	pg->xy_ind->XY_Dat_yOff = val;
	SetCursor_Dat_txt(pg);
	Refresh((TWins*)pg->xy_ind);
}
static TPage *ELM_pageFilter_Create(TPageControl *Parent) {
	return TPage_CreateParamAlg(Parent, sizeof(TPage_Filter));
}

/* ****************** Graf ****************************************************/
static void ELM_TP1_pnlGrafVal_OnResize(TWins *self) {
  TPage_Filter *pg = self->subClass;
  int x;
	vds_SetStr(&self->vds, "Freq");
	x = TextWidthColorString(&self->vds) + 4;
	SetLeft((TWins*)pg->cbmaxMHZ, x);
	vds_SetStr(&self->vds, "MHz");
	x += pg->cbmaxMHZ->width + TextWidthColorString(&self->vds) + 4;

	SetLeft((TWins*)pg->dv_TP1_Off_dB, x);

	vds_SetStr(&self->vds, "dB");
	x += pg->dv_TP1_Off_dB->width + TextWidthColorString(&self->vds) + 10;
	SetLeft((TWins*)pg->cbRgRa, x);

	x = self->width - pg->cbLog->width - 2;
	SetLeft((TWins*)pg->cbLog, x);
}

static void EML_Filter_xy_ind_OnResize(TScaleXY *self) {
  TPage_Filter *pg = self->subClass;
	SetWidth((TWins*)pg->sbDetail, self->width - pg->xy_ind->sx2 + 22);
}


void SetCursor_Dat_txt(TPage_Filter *pg) {
  int nk = 0;
  char buf[128];
  char *pc = buf;
  TScaleXY_Txt *xy_txt = pg->xy_ind->txt;
  TPage_XFilter *XF = NULL;
  float fc = 0;
  float yVal = 0;
  float inZ = 0;
  bool Ok = True;

	while (xy_txt) {
	    xfree(xy_txt->s);
	    xy_txt->s = NULL;
	    xy_txt = xy_txt->next;
	}
	buf[0] = 0;
	nk = 0;
	pc = buf;
	fc = TScaleXY_GetCursX_ScaleVal(pg->xy_ind);
	xy_txt = pg->xy_ind->txt;
	if (!pg->sbDetail->Count) {
	    Ok = False;

	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->TP1) {
	    Ok = ImpTP1_Fx(pg->TP1, fc, &yVal, &inZ);
	    XF = (TPage_XFilter*)pg->TP1;

	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->HP1) {
	    Ok = ImpHP1_Fx(pg->HP1, fc, &yVal, &inZ);
	    XF = (TPage_XFilter*)pg->HP1;

	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->BP1) {
	    Ok = ImpBP1_Fx(pg->BP1, fc, &yVal, &inZ);
	    XF = (TPage_XFilter*)pg->BP1;

	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->BP2) {
	    Ok = ImpBP2_Fx(pg->BP2, fc, &yVal, &inZ);
	    XF = (TPage_XFilter*)pg->BP2;

	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->BP2x) {
	    Ok = ImpBP2x_Fx(pg->BP2x, fc, &yVal, &inZ);
	    XF = (TPage_XFilter*)pg->BP2x;

	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->W1) {
	    Ok = ImpW1_Fx(pg->W1, fc, &yVal, &inZ);
	    XF = (TPage_XFilter*)pg->W1;

	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->SGS1) {
	    Ok = ImpSGS1_Fx(pg->SGS1, fc, &yVal, &inZ);
	    XF = (TPage_XFilter*)pg->SGS1;

	} else Ok = False;


	if (Ok) {
	    if (pg->cbRgRa->Checked) {
		yVal *= (XF->f_Rg->rlc.val + XF->f_Ra->rlc.val) / XF->f_Ra->rlc.val;
	    }
	    ppcmove(&pc, "IN Imp = ");
	    floattoppc(&pc, inZ, nk);
	    ppcchange(&xy_txt->s, buf);

	    pc = buf;
	    xy_txt = xy_txt->next;
	    ppcmove(&pc, "I/O = ");
	    yVal = log10(yVal)*20 + pg->xy_ind->XY_Dat_yOff;
	    floattoppc(&pc, yVal, 1);
	    ppcmove(&pc, " dB");
	    ppcchange(&xy_txt->s, buf);
	}
}

static void EML_Filter_sbDetail_OnCount(TScrollBar* sb, int Count) {
  TPage_Filter *pg = sb->subClass;
	SetCursor_sbDetail(pg);
	TWins_Refresh((TWins*)pg->xy_ind);
}

static void math_Filter_xP(TPage_Filter *pg) {
	if (pg->pgc_Filter->AktPage == (TPage*)pg->TP1) {
	    math_Filter_TP1(pg->TP1);
	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->HP1) {
	    math_Filter_HP1(pg->HP1);
	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->BP1) {
	    math_Filter_BP1(pg->BP1);
	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->BP2) {
	    math_Filter_BP2(pg->BP2);
	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->BP2x) {
	    math_Filter_BP2x(pg->BP2x);
	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->W1) {
	    math_Filter_W1(pg->W1);
	} else if (pg->pgc_Filter->AktPage == (TPage*)pg->SGS1) {
	    math_Filter_SGS1(pg->SGS1);
	}
}


static void EML_Filter_sbScale_OnCount(TScrollBar* sb, int Count) {
  TPage_Filter *pg = sb->subClass;
  float off;
  int m = 0;

	if (pg->ScaleMHz < 10) m = 1;
	if (pg->ScaleMHz < 1) m = 2;
	if (pg->ScaleMHz < 0.1) m = 3;
	off = Count * pg->ScaleMHz / 10;
	pg->ScaleMHzoff = off;
	TScaleXY_Set_Dat(pg->xy_ind->dat->dx, "MHz", off, pg->ScaleMHz+off, 2, pg->fuLogX | m);
	SetCursor_sbDetail(pg);
	math_Filter_xP(pg);
}

static void ELM_F_cbmaxMHZ_OnClick(TMenu *me, long KeyState, TMenuItem *mi) {
  TPage_Filter *pg = me->subClass;
  int m = 0;
  float off;
	if (pg->cbmaxMHZ->popup == me) {
	    off = pg->ScaleMHz;
	    pg->ScaleMHz = pctodouble(mi->s);
	    m = pg->sbScale->Count;
	    if (m > 0) {
		m = m * off / pg->ScaleMHz;
		TScrollBar_SetCount(pg->sbScale, m);
	    }
	}
	m = 0;
	if (pg->ScaleMHz < 10) m = 1;
	if (pg->ScaleMHz < 1) m = 2;
	if (pg->ScaleMHz < 0.1) m = 3;

	off = pg->sbScale->Count * pg->ScaleMHz / 10;
	pg->ScaleMHzoff = off;
	TScaleXY_Set_Dat(pg->xy_ind->dat->dx, "MHz", off, pg->ScaleMHz+off, 2, pg->fuLogX | m);
	SetCursor_sbDetail(pg);
	math_Filter_xP(pg);
}

static void ELM_F_cbLog_OnClick(TMenu *me, long KeyState, TMenuItem *mi) {
  TPage_Filter *pg = me->subClass;
  const char *pc;
	pg->fuLogX = sxysetfu_lin;
	pc = GetCaption_pc((TWins*)pg->cbLog);
	if (!pccasecmpASCII(pc, "log -1")) pg->fuLogX = sxysetfu_log_1; else
	if (!pccasecmpASCII(pc, "log10 -1")) pg->fuLogX = sxysetfu_log10_1;
	if (!pccasecmpASCII(pc, "log20 -1")) pg->fuLogX = sxysetfu_log20_1;
	if (!pccasecmpASCII(pc, "log100-1")) pg->fuLogX = sxysetfu_log100_1;
	TScaleXY_Set_Dat_Log(pg->xy_ind, pg->fuLogX, 0);
}

static void SaveFilterOnOff(TPage_Filter *pg, TpcIni *pcIni) {
  int OnOff = 0;
	if (pg->cbRgRa->Checked) OnOff |= 0x01;
	TpcIni_WR_int(pcIni, "Filter", "OnOff", OnOff);
}

static void EML_cbRgRa_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_Filter *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	SaveFilterOnOff(pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	math_Filter_xP(pg);
	SetCursor_Dat_txt(pg);
	Refresh((TWins*)pg->xy_ind);
}


/* void pgc_Filter_OnActivate_pg(TPageControl *pagc, TPage *pag) {
  TPage_Filter *pg = pagc->subClass;
  bool Visible_TP1 = (pag == (TPage*)pg->TP1);
  bool Visible_HP1 = (pag == (TPage*)pg->HP1);
  bool Visible_BP1 = (pag == (TPage*)pg->BP1);
  bool Visible_BP2 = (pag == (TPage*)pg->BP2);
  bool Visible_BP2x = (pag == (TPage*)pg->BP2x);
  bool Visible_W1 = (pag == (TPage*)pg->W1);
  bool Visible_SGS1 = (pag == (TPage*)pg->SGS1);
	TP1_SetVisible(pg->TP1, Visible_TP1);
	HP1_SetVisible(pg->HP1, Visible_HP1);
	BP1_SetVisible(pg->BP1, Visible_BP1);
	BP2_SetVisible(pg->BP2, Visible_BP2);
	BP2x_SetVisible(pg->BP2x, Visible_BP2x);
	W1_SetVisible(pg->W1, Visible_W1);
	SGS1_SetVisible(pg->SGS1, Visible_SGS1);
 printf("%s(%d): \n", FL);
} */

static void pgc_Filter_OnChangeTab(TPageControl *self, TPage *fromPage, TPage *toPage, int *fu) {
  TPage_Filter *pg = self->subClass;

	TP1_SetVisible(pg->TP1, (TPage*)pg->TP1 == toPage);
	HP1_SetVisible(pg->HP1, (TPage*)pg->HP1 == toPage);
	BP1_SetVisible(pg->BP1, (TPage*)pg->BP1 == toPage);
	BP2_SetVisible(pg->BP2, (TPage*)pg->BP2 == toPage);
	BP2x_SetVisible(pg->BP2x, (TPage*)pg->BP2x == toPage);
	W1_SetVisible(pg->W1, (TPage*)pg->W1 == toPage);
	SGS1_SetVisible(pg->SGS1, (TPage*)pg->SGS1 == toPage);
}

TPage_Filter *ELM_pageFilterAdd(TPageControl *pagc, const char *Caption) {
  TPage_Filter *self;
  TpcIni *pcIni;
  int m;

	pcIni = get_appIni();

	self = (TPage_Filter*) TPageControl_AddNewUserPage(pagc, Caption, ELM_pageFilter_Create);
	self->subClass = self;

	self->pnlFilter = TWins_CreateBA((TWins*)self, 0, 0, 322, 21,
					mBorder | mBorderL, alLeft);

	self->pgc_Filter = TPageControl_Create(self->pnlFilter);
	self->pgc_Filter->Align = alClient;
	self->pgc_Filter->height = 120;
//	self->pgc_Filter->OnPageActivate = pgc_Filter_OnActivate_pg;
	self->pgc_Filter->OnChangeTab = pgc_Filter_OnChangeTab;

	Set_Parent((TWins*)self->pgc_Filter, self->pnlFilter);
	self->TP1 = page_Add_TP1(self->pgc_Filter, self);
	self->HP1 = page_Add_HP1(self->pgc_Filter, self);
	self->BP1 = page_Add_BP1(self->pgc_Filter, self);
	self->BP2 = page_Add_BP2(self->pgc_Filter, self);
	self->BP2x = page_Add_BP2x(self->pgc_Filter, self);
	self->W1 = page_Add_W1(self->pgc_Filter, self);
	self->SGS1 = page_Add_SGS1(self->pgc_Filter, self);

/* ****************** Graf ****************************************************/
	self->pnlGraf = TWins_CreateBA((TWins*)self, 0, 0, 310, 21, 
				mBorder | mBorderL, alClient);
/* Graf Dat */
	self->pnlGrafVal = TWins_CreateBA(self->pnlGraf, 0, 0, 310, 21, 
				mBorder, alTop);
	self->pnlGrafVal->OnPaint = ELM_TP1_pnlGrafVal_OnPaint;
	self->pnlGrafVal->OnResize = ELM_TP1_pnlGrafVal_OnResize;
	self->cbmaxMHZ = TComboBox_CreateS(self->pnlGrafVal, 40, 1, 60, 18, "1000");

  static const char *cbMHZ_Tab[13] = {"0.5", "1", "2", "5", "10", "20", "50", 
		"100", "200", "500", "1000", "2000", "5000"};

	for (int i=0;i<13;i++)
	    TComboBox_AddItem(self->cbmaxMHZ, cbMHZ_Tab[i], 0, ELM_F_cbmaxMHZ_OnClick);

	self->cbLog = TComboBox_CreateS(self->pnlGrafVal, 220, 1, 76, 18, "lin");
	self->cbLog->ReadOnly = True;
  static const char *cbLog_Tab[5] = {"lin", "log -1", "log10 -1", "log20 -1", "log100-1"};
	for (int i=0;i<5;i++)
	    TComboBox_AddItem(self->cbLog, cbLog_Tab[i], 0, ELM_F_cbLog_OnClick);


	self->dv_TP1_Off_dB = TDVal_CreateS(self->pnlGrafVal, 170, 1, 40, 18);
	self->dv_TP1_Off_dB->nk = 1;
	self->dv_TP1_Off_dB->max = 100;
	self->dv_TP1_Off_dB->min = -100;
	self->dv_TP1_Off_dB->dv_fu = tdv_fu_LostFocusEnter;
	self->dv_TP1_Off_dB->OnValChange = EML_Filter_TP1_Off_dB_OnValChange;

	m = TpcIni_RD_int(pcIni, "Filter", "OnOff", 0xffff);

	self->cbRgRa = TChkBox_CreateS(self->pnlGrafVal, 2, 2, 56, 17, "Rg/Ra");
	self->cbRgRa->OnClick = EML_cbRgRa_OnClick;
	self->cbRgRa->Checked = ((m & 0x01) != 0);

/* Graf Az */
	self->xy_ind = TScaleXY_Create(self->pnlGraf);
	self->xy_ind->Align = alClient;
	self->xy_ind->OnResize = EML_Filter_xy_ind_OnResize;
	self->xy_ind->sx1 = 22;
	self->xy_ind->sy1 = 18;
	self->xy_ind->sy2 = 46;
	self->xy_ind->CursFu = 0x01;
	Set_Parent((TWins*)self->xy_ind, self->pnlGraf);

	self->sbDetail = TScrollBarHorz_CreateP((TWins*)self->xy_ind);
	self->sbDetail->OnCount = EML_Filter_sbDetail_OnCount;
//	SetLeft((TWins*)self->sbDetail, 1);
	TScrollBar_SetMaxCount(self->sbDetail, 20000);
	self->sbDetail->LargeChange = 50;

	self->sbScale = TScrollBarHorz_CreateP((TWins*)self->xy_ind);
	self->sbScale->BorderFu = mBorder | mBorderL | 
			mBorderNoLeft | mBorderNoRigth | mBorderNoBottom;
	self->sbScale->Align = alBottom;
	SetHeight((TWins*)self->sbScale, 16);
	TScrollBar_SetMaxCount(self->sbScale, 300);
	self->sbScale->LargeChange = 5;
	self->sbScale->OnCount = EML_Filter_sbScale_OnCount;


	TScaleXY_SetDat_mem(&self->xy_ind->dat, 21, 19, 1001);

  TScale_pxy *pxy = self->xy_ind->dat->pxy;
	pxy->Color = 0x0000c0;
	pxy->PaintDat = self->TP1->cbF1On->Checked;
	pxy->AddOff = True;
	self->TP1->cbF1On->tag = (long)pxy;
	self->HP1->cbF1On->tag = (long)pxy;
	self->BP1->cbF1On->tag = (long)pxy;
	self->BP2->cbF1On->tag = (long)pxy;
	self->BP2x->cbF1On->tag = (long)pxy;
	self->W1->cbF1On->tag = (long)pxy;
	self->SGS1->cbF1On->tag = (long)pxy;

	pxy->next = xcalloc(sizeof(TScale_pxy) + sizeof(TScale_Point)*1001);
	pxy = pxy->next;
	pxy->count = 1001;
	pxy->Color = 0x00c000;
	pxy->PaintDat = self->TP1->cbF2On->Checked;
	pxy->AddOff = True;
	self->TP1->cbF2On->tag = (long)pxy;
	self->HP1->cbF2On->tag = (long)pxy;
	self->BP1->cbF2On->tag = (long)pxy;
	self->BP2->cbF2On->tag = (long)pxy;
	self->BP2x->cbF2On->tag = (long)pxy;
	self->W1->cbF2On->tag = (long)pxy;
	self->SGS1->cbF2On->tag = (long)pxy;

	pxy->next = xcalloc(sizeof(TScale_pxy) + sizeof(TScale_Point)*1001);
	pxy = pxy->next;
	pxy->count = 1001;
	pxy->Color = 0xc00000;
	pxy->PaintDat = self->TP1->cbF3On->Checked;
	pxy->AddOff = True;
	self->TP1->cbF3On->tag = (long)pxy;
	self->HP1->cbF3On->tag = (long)pxy;
	self->BP1->cbF3On->tag = (long)pxy;
	self->BP2->cbF3On->tag = (long)pxy;
//	self->BP2x->cbF3On->tag = (long)pxy;
	self->W1->cbF3On->tag = (long)pxy;
	self->SGS1->cbF3On->tag = (long)pxy;

	pxy->next = xcalloc(sizeof(TScale_pxy) + sizeof(TScale_Point)*1001);
	pxy = pxy->next;
	pxy->count = 1001;
	pxy->Color = 0xc000c0;
	pxy->PaintDat = self->TP1->cbF4On->Checked;
	pxy->AddOff = True;
	self->TP1->cbF4On->tag = (long)pxy;
	self->HP1->cbF4On->tag = (long)pxy;
	self->BP1->cbF4On->tag = (long)pxy;
	self->BP2->cbF4On->tag = (long)pxy;
//	self->BP2x->cbF4On->tag = (long)pxy;
	self->W1->cbF4On->tag = (long)pxy;
	self->SGS1->cbF4On->tag = (long)pxy;

	pxy->next = xcalloc(sizeof(TScale_pxy) + sizeof(TScale_Point)*1001);
	pxy = pxy->next;
	self->yInZ = pxy;
	pxy->count = 1001;
	pxy->Color = 0xc0c000;
//	pxy->PaintDat = True; //self->cbF4On->Checked;
//	self->cbF4On->tag = (long)pxy;

	self->ScaleMHz = TpcIni_RD_float(pcIni, "TP1", "ScaleMHz", 1000);
	self->fuLogX = sxysetfu_lin;
	TScaleXY_Set_Dat(self->xy_ind->dat->dx, "MHz", 0, self->ScaleMHz, 2, self->fuLogX);
	TScaleXY_Set_Dat(self->xy_ind->dat->dy, "dB", -70, 20, 2, sxysetfu_dB20);

//static TFormR *Create_fR(TPage_Filter *self, char *Caption, char *Gruppe, char *s, TDVal *dv) {

  TScaleXY_Txt *xy_txt;
	xy_txt = xcalloc(sizeof(TScaleXY_Txt));
	xy_txt->x = 2;
	xy_txt->y = 20;
	self->xy_ind->txt = xy_txt;
	xy_txt->next = xcalloc(sizeof(TScaleXY_Txt));
	xy_txt = xy_txt->next;
	xy_txt->x = 2;
	xy_txt->y = 36;

	free_appIni(pcIni);

	return self;
}
