/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "ElMath.h"
#include "ElGraf.h"
#include <math.h>

static void str_toGraf(TWins *Wins, const char *s, int x, int y) {
	vds_SetStr(&Wins->vds, s);
	DrawColorString(x, y, &Wins->vds);
}

static void DrawW1(Window WinID, int x, int y, int fu) {
  int xa;
  int x2 = x;
  int x2a;
  int ya = y+45;
  int y2 = y+30;

	if ((fu & 0x0300) == 0x000) {
	    Draw_xP1_Rg(WinID, &x2, &xa, y, y2, fu & 0x01);
	    x2a = x2;
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC1());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL1());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC3());
	    Draw_xP1_Ra(WinID, x2, xa, y, y2, 0);

	    xa -= 3;
	    DrawLineRGB(WinID, 0, xa, y2+3, xa, y2+45);

	    DrawPic(WinID, get_Pic_pt(), x2a-4, y-2);
	    DrawLineRGB(WinID, 0, x2a-2, y, x2a-2, y+45);
	    DrawLineRGB(WinID, 0, x2a-2, y+45, x2a, y+45);

	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL3());
	    DrawTP1_Cv(WinID, &x2a, 0, ya, get_Pic_cC4());
	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL5());
	    Draw_xP1_R_Out(WinID, x2a, xa, ya, ya+30, fu & 0x04, get_Pic_cRb());
	}

	if ((fu & 0x0300) == 0x200) {
	    Draw_xP1_Rg(WinID, &x2, &xa, y, y2, fu & 0x01);
	    x2a = x2;
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC1());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL1());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC2());
	    DrawTP1_Lv(WinID, &x2, 0, y, get_Pic_cL2());
	    DrawTP1_Ch(WinID, &x2, y, get_Pic_cC3());
	    Draw_xP1_Ra(WinID, x2, xa, y, y2, 0);

	    xa -= 3;
	    DrawLineRGB(WinID, 0, xa, y2+3, xa, y2+45);

	    DrawPic(WinID, get_Pic_pt(), x2a-4, y-2);
	    DrawLineRGB(WinID, 0, x2a-2, y, x2a-2, y+45);
	    DrawLineRGB(WinID, 0, x2a-2, y+45, x2a, y+45);

	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL3());
	    DrawTP1_Cv(WinID, &x2a, 0, ya, get_Pic_cC4());
	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL4());
	    DrawTP1_Cv(WinID, &x2a, 0, ya, get_Pic_cC5());
	    DrawTP1_Lh(WinID, &x2a, ya, get_Pic_cL5());
	    Draw_xP1_R_Out(WinID, x2a, xa, ya, ya+30, fu & 0x04, get_Pic_cRb());
	}
}

static void ImpW1_ab_F1(TPage_W1 *pg, float MHz, float *Z, float *ZB, float *yVA, float *yVB) {
  TRLC rlcA, rlcB, rlcT;
  float yA, yB;
  float w = MHz * M_PI * 2;
	if (w < 0.000001) {
	    *Z = pg->f_Rx->R->dval;
	    *yVA = 0;
	    *yVB = 0;
	    return;
	}
	Form_R_math(pg->f_Ra, w);
	Form_R_math(pg->f_Rx, w);
	Form_C_math(pg->f_C1, w);
	Form_C_math(pg->f_C3, w);
	Form_C_math(pg->f_C4, w);
	Form_L_math(pg->f_L1, w);
	Form_L_math(pg->f_L3, w);
	Form_L_math(pg->f_L5, w);

	RLC_Copy(&rlcA, &pg->f_Ra->rlc);
	yA = rlcA.Z;
	RLC_Add_Ser(&rlcA, &pg->f_C3->rlc);
	yA /= rlcA.Z;
	RLC_Add_Par(&rlcA, &pg->f_L1->rlc);
	yA *= rlcA.Z;
	RLC_Add_Ser(&rlcA, &pg->f_C1->rlc);
	yA /= rlcA.Z;
	RLC_Copy(&rlcT, &rlcA);


	RLC_Copy(&rlcB, &pg->f_Rx->rlc);
	yB = rlcB.Z;

	if (pg->cbCxOn->Checked) {
		Form_C_math(pg->f_Cx, w);
		RLC_Add_Ser(&rlcB, &pg->f_Cx->rlc);
	}


	RLC_Add_Ser(&rlcB, &pg->f_L5->rlc);
	yB /= rlcB.Z;
	RLC_Add_Par(&rlcB, &pg->f_C4->rlc);
	yB *= rlcB.Z;
	RLC_Add_Ser(&rlcB, &pg->f_L3->rlc);
	yB /= rlcB.Z;

	RLC_Add_Par(&rlcA, &rlcB);
	yA *= rlcA.Z;
	RLC_Add_Par(&rlcB, &rlcT);
	yB *= rlcB.Z;

	if (pg->cbCsOn->Checked) {
	    Form_C_math(pg->f_Cs, w);
	    RLC_Add_Ser(&rlcA, &pg->f_Cs->rlc);
	    RLC_Add_Ser(&rlcB, &pg->f_Cs->rlc);
	}

	*Z = 0;
	*ZB = 0;
	if (pg->f_Rg->R->dval > 0) {
	    *Z = rlcA.Z;
	    *ZB = rlcB.Z;
	    Form_R_math(pg->f_Rg, w);
	    RLC_Add_Ser(&rlcA, &pg->f_Rg->rlc);
	    RLC_Add_Ser(&rlcB, &pg->f_Rg->rlc);
	}

	yA /= rlcA.Z;
	yB /= rlcB.Z;
	*yVA = yA;
	*yVB = yB;
}

static void ImpW1_ab_F3(TPage_W1 *pg, float MHz, float *Z, float *ZB, float *yVA, float *yVB) {
  TRLC rlcA, rlcB, rlcT;
  float yA, yB;
  float w = MHz * M_PI * 2;
	if (w < 0.000001) {
	    *Z = pg->f_Rx->R->dval;
	    *yVA = 0;
	    *yVB = 0;
	    return;
	}
	Form_R_math(pg->f_Ra, w);
	Form_R_math(pg->f_Rx, w);
	Form_C_math(pg->f_C1, w);
	Form_C_math(pg->f_C2, w);
	Form_C_math(pg->f_C3, w);
	Form_C_math(pg->f_C4, w);
	Form_C_math(pg->f_C5, w);
	Form_L_math(pg->f_L1, w);
	Form_L_math(pg->f_L2, w);
	Form_L_math(pg->f_L3, w);
	Form_L_math(pg->f_L4, w);
	Form_L_math(pg->f_L5, w);

	RLC_Copy(&rlcA, &pg->f_Ra->rlc);
	yA = rlcA.Z;
	RLC_Add_Ser(&rlcA, &pg->f_C3->rlc);
	yA /= rlcA.Z;
	RLC_Add_Par(&rlcA, &pg->f_L2->rlc);
	yA *= rlcA.Z;
	RLC_Add_Ser(&rlcA, &pg->f_C2->rlc);
	yA /= rlcA.Z;
	RLC_Add_Par(&rlcA, &pg->f_L1->rlc);
	yA *= rlcA.Z;
	RLC_Add_Ser(&rlcA, &pg->f_C1->rlc);
	yA /= rlcA.Z;
	RLC_Copy(&rlcT, &rlcA);


	RLC_Copy(&rlcB, &pg->f_Rx->rlc);
	yB = rlcB.Z;
	if (pg->cbCxOn->Checked) {
		Form_C_math(pg->f_Cx, w);
		RLC_Add_Ser(&rlcB, &pg->f_Cx->rlc);
	}
	RLC_Add_Ser(&rlcB, &pg->f_L5->rlc);
	yB /= rlcB.Z;
	RLC_Add_Par(&rlcB, &pg->f_C5->rlc);
	yB *= rlcB.Z;
	RLC_Add_Ser(&rlcB, &pg->f_L4->rlc);
	yB /= rlcB.Z;
	RLC_Add_Par(&rlcB, &pg->f_C4->rlc);
	yB *= rlcB.Z;
	RLC_Add_Ser(&rlcB, &pg->f_L3->rlc);
	yB /= rlcB.Z;

	RLC_Add_Par(&rlcA, &rlcB);
	yA *= rlcA.Z;
	RLC_Add_Par(&rlcB, &rlcT);
	yB *= rlcB.Z;

	if (pg->cbCsOn->Checked) {
	    Form_C_math(pg->f_Cs, w);
	    RLC_Add_Ser(&rlcA, &pg->f_Cs->rlc);
	    RLC_Add_Ser(&rlcB, &pg->f_Cs->rlc);
	}

	*Z = 0;
	*ZB = 0;
	if (pg->f_Rg->R->dval > 0) {
	    *Z = rlcA.Z;
	    *ZB = rlcB.Z;
	    Form_R_math(pg->f_Rg, w);
	    RLC_Add_Ser(&rlcA, &pg->f_Rg->rlc);
	    RLC_Add_Ser(&rlcB, &pg->f_Rg->rlc);
	}

	yA /= rlcA.Z;
	yB /= rlcB.Z;
	*yVA = yA;
	*yVB = yB;
}


static float ImpW1_F1(TPage_W1 *pg, float MHz, float *Z) {
  float ZA, ZB;
  float yVA, yVB;
	ImpW1_ab_F1(pg, MHz, &ZA, &ZB, &yVA, &yVB);
	*Z = ZA;
	return yVA;
} 
static float ImpW1_F2(TPage_W1 *pg, float MHz, float *Z) {
  float ZA, ZB;
  float yVA, yVB;
	ImpW1_ab_F1(pg, MHz, &ZA, &ZB, &yVA, &yVB);
	*Z = ZB;
	return yVB;
}


static float ImpW1_F3(TPage_W1 *pg, float MHz, float *Z) {
  float ZA, ZB;
  float yVA, yVB;
	ImpW1_ab_F3(pg, MHz, &ZA, &ZB, &yVA, &yVB);
	*Z = ZA;
	return yVA;
}

static float ImpW1_F4(TPage_W1 *pg, float MHz, float *Z) {
  float ZA, ZB;
  float yVA, yVB;
	ImpW1_ab_F3(pg, MHz, &ZA, &ZB, &yVA, &yVB);
	*Z = ZB;
	return yVB;
}

void math_Filter_W1(TPage_W1 *pg) {
  TPage_Filter *pgf = pg->pgfilt;
  float fcStep, fOff, fStep;
  TScale_pxy *pxy = pgf->xy_ind->dat->pxy;
  TScale_pxy *pxy2;
  TScale_pxy *pxy3 = NULL;
  float fc, Z, K;
  TScale_Point *sSP, *dSP;

	K = 1;
	if (pgf->cbRgRa->Checked)
	    K = (pg->f_Rg->rlc.val + pg->f_Ra->rlc.val) / pg->f_Ra->rlc.val;

	fOff = pgf->ScaleMHzoff;
	fStep = pgf->ScaleMHz;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpW1_F1(pg, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (pg->cbF1ImpOn->Checked) pxy3 = pxy;

	pxy = pxy->next;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpW1_F2(pg, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (pg->cbF2ImpOn->Checked) pxy3 = pxy;

	pxy = pxy->next;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpW1_F3(pg, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (pg->cbF3ImpOn->Checked) pxy3 = pxy;


	pxy = pxy->next;
	fcStep = fStep / (pxy->count-1);
	for (int i=0;i<pxy->count;i++) {
	    fc = i * fcStep + fOff;
	    pxy->xy[i].x = fc;
	    pxy->xy[i].y = K * ImpW1_F4(pg, fc, &Z);
	    pxy->xy[i].y2 = Z;
	}
	if (pg->cbF4ImpOn->Checked) pxy3 = pxy;

	Z = pg->dv_Rg->dval;
	if (pxy3 && (Z > 0)) {
	    pxy2 = pgf->yInZ;
	    pxy2->PaintDat = True;
	    sSP = &pxy3->xy[0];
	    dSP = &pxy2->xy[0];
	    for (int i=0;i<pxy2->count;i++) {
		dSP->x = sSP->x;
		dSP->y = sSP->y2 / Z;
		dSP++; sSP++;
	    }
	} else {
	    pgf->yInZ->PaintDat = False;
	}

	SetCursor_Dat_txt(pgf);
	Refresh((TWins*)pgf->xy_ind);

}

static void SaveW1OnOff(TPage_W1 *pg, TpcIni *pcIni) {
  int OnOff = 0;

	if (pg->cbCsOn->Checked) OnOff |= 0x01;
//	if (pg->cbRsOn->Checked) OnOff |= 0x02;
	if (pg->cbCxOn->Checked) OnOff |= 0x04;
//	if (pg->cbRxOn->Checked) OnOff |= 0x08;

	if (pg->cbF1On->Checked) OnOff |= 0x010;
	if (pg->cbF2On->Checked) OnOff |= 0x020;
	if (pg->cbF3On->Checked) OnOff |= 0x040;
	if (pg->cbF4On->Checked) OnOff |= 0x080;

	if (pg->cbF1ImpOn->Checked) OnOff |= 0x100;
	if (pg->cbF2ImpOn->Checked) OnOff |= 0x200;
	if (pg->cbF3ImpOn->Checked) OnOff |= 0x300;
	if (pg->cbF4ImpOn->Checked) OnOff |= 0x400;

	TpcIni_WR_int(pcIni, "W1", "OnOff", OnOff);
}

void W1_SetVisible(TPage_W1 *pg, bool On) {
	SetVisible((TWins*)pg->f_Rg, pg->f_Rg->tag && On);
//	SetVisible((TWins*)pg->f_Rs, pg->f_Rs->tag && On);
	SetVisible((TWins*)pg->f_Rx, pg->f_Rx->tag && On);
	SetVisible((TWins*)pg->f_Ra, pg->f_Ra->tag && On);
	SetVisible((TWins*)pg->f_Cs, pg->f_Cs->tag && On);
	SetVisible((TWins*)pg->f_Cx, pg->f_Cx->tag && On);
	SetVisible((TWins*)pg->f_C1, pg->f_C1->tag && On);
	SetVisible((TWins*)pg->f_C2, pg->f_C2->tag && On);
	SetVisible((TWins*)pg->f_C3, pg->f_C3->tag && On);
	SetVisible((TWins*)pg->f_C4, pg->f_C4->tag && On);
	SetVisible((TWins*)pg->f_C5, pg->f_C5->tag && On);
	SetVisible((TWins*)pg->f_L1, pg->f_L1->tag && On);
	SetVisible((TWins*)pg->f_L2, pg->f_L2->tag && On);
	SetVisible((TWins*)pg->f_L3, pg->f_L3->tag && On);
	SetVisible((TWins*)pg->f_L4, pg->f_L4->tag && On);
	SetVisible((TWins*)pg->f_L5, pg->f_L5->tag && On);
  TScale_pxy *pxy;
	if (On) {
	    pxy = pg->pgfilt->xy_ind->dat->pxy;
	    while (pxy) {
		pxy->PaintDat = False;
		pxy = pxy->next;
	    }
	    math_Filter_W1(pg);
	    ((TScale_pxy*)pg->cbF1On->tag)->PaintDat = pg->cbF1On->Checked;
	    ((TScale_pxy*)pg->cbF2On->tag)->PaintDat = pg->cbF2On->Checked;
	    ((TScale_pxy*)pg->cbF3On->tag)->PaintDat = pg->cbF3On->Checked;
	    ((TScale_pxy*)pg->cbF4On->tag)->PaintDat = pg->cbF4On->Checked;
	}
}

/* ************** W1 Ext Ev ****************** */
bool ImpW1_Fx(TPage_W1 *pg, float MHz, float *yVal, float *Z) {
	if (pg->cbF1ImpOn->Checked) {
		*yVal = ImpW1_F1(pg, MHz, Z);
	} else if (pg->cbF2ImpOn->Checked) {
		*yVal = ImpW1_F2(pg, MHz, Z);
	} else if (pg->cbF3ImpOn->Checked) {
		*yVal = ImpW1_F3(pg, MHz, Z);
	} else if (pg->cbF4ImpOn->Checked) {
		*yVal = ImpW1_F4(pg, MHz, Z);
	} else return False;
	return True;
}

/* ************** W1 Ev ****************** */
static void cbW1XxOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_W1 *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	SaveW1OnOff(pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	RePaint((TWins*)pg->pnl);
	math_Filter_W1(pg);
}

static void cbW1FxOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_W1 *pg = self->subClass;
//  TPage_Filter *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	SaveW1OnOff(pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	((TScale_pxy*)self->tag)->PaintDat = ((TChkBox*)self)->Checked;
	Refresh((TWins*)pg->pgfilt->xy_ind);
}

static void cbW1FxImpOn_OnClick(TChkBox *self, long KeyState, bool DblClick) {
  TPage_W1 *pg = self->subClass;
  TpcIni *pcIni = TpcIni_Create(appDat.inifile_app);
	if (pg->cbF1ImpOn != self) TChkBox_SetChecked(pg->cbF1ImpOn, False);
	if (pg->cbF2ImpOn != self) TChkBox_SetChecked(pg->cbF2ImpOn, False);
	if (pg->cbF3ImpOn != self) TChkBox_SetChecked(pg->cbF3ImpOn, False);
	if (pg->cbF4ImpOn != self) TChkBox_SetChecked(pg->cbF4ImpOn, False);
	SaveW1OnOff(pg, pcIni);
	TpcIni_SaveAndFree(pcIni);
	math_Filter_W1(pg);
	Refresh((TWins*)pg->pgfilt->xy_ind);
}

static void pnl_W1_OnPaint(TWins *self) {
  TPage_W1 *pg = self->subClass;
  int fu = 0;
  int x = pg->cbF1On->left + pg->cbF1On->width + 2;

	if (pg->cbCsOn->Checked) fu |= 0x01;
//	if (pg->cbRsOn->Checked) fu |= 0x02;
	if (pg->cbCxOn->Checked) fu |= 0x04;
//	if (pg->cbRxOn->Checked) fu |= 0x08;

	DrawW1(self->WinID, x, pg->cbF1On->top, fu);
	fu += 0x100;
	DrawW1(self->WinID, x, pg->cbF2On->top, fu);
	fu += 0x100;
	DrawW1(self->WinID, x, pg->cbF3On->top, fu);
	fu += 0x100;
	DrawW1(self->WinID, x, pg->cbF4On->top, fu);

	DrawPic(self->WinID, get_Pic_cOhm(), 
			pg->dv_Rx->left + pg->dv_Rx->width + 2,
			pg->dv_Rx->top + 5);

	str_toGraf(self, "pF", pg->dv_Cx->left + pg->dv_Cx->width + 1,
			       pg->dv_Cx->top + 3);

	str_toGraf(self, "pF", pg->dv_C3->left + pg->dv_C3->width + 1,
			       pg->dv_C3->top + 3);
	str_toGraf(self, "pF", pg->dv_C5->left + pg->dv_C5->width + 1,
			       pg->dv_C5->top + 3);

	str_toGraf(self, "uH", pg->dv_L2->left + pg->dv_L2->width + 1,
			       pg->dv_L2->top + 3);
	str_toGraf(self, "uH", pg->dv_L5->left + pg->dv_L5->width + 1,
			       pg->dv_L5->top + 3);
}

static void W1_DVal_OnValChange(TDVal *dv, double val) {
	if (dv->owner) TDVal_DoValChange((TDVal*)dv->owner, val, tdvfu_ChangeEv);
}

static void W1_fXxx_OnChange(TFormRLC* fRLC) {
	math_Filter_W1((TPage_W1*)fRLC->subClass);
}
static void W1_OnRSync(TFormRLC* fRLC, int val) {
  TPage_W1 *pg = fRLC->subClass;
	Form_R_sync(fRLC, pg->f_Rg, val);
//	Form_R_sync(fRLC, pg->f_Rs, val);
	Form_R_sync(fRLC, pg->f_Rx, val);
	Form_R_sync(fRLC, pg->f_Ra, val);
}
static void W1_OnLSync(TFormRLC* fRLC, int val) {
  TPage_W1 *pg = fRLC->subClass;
	Form_L_sync(fRLC, pg->f_L1, val);
	Form_L_sync(fRLC, pg->f_L2, val);
	Form_L_sync(fRLC, pg->f_L3, val);
	Form_L_sync(fRLC, pg->f_L4, val);
	Form_L_sync(fRLC, pg->f_L5, val);
}
static void W1_OnCSync(TFormRLC* fRLC, int val) {
  TPage_W1 *pg = fRLC->subClass;
	Form_C_sync(fRLC, pg->f_Cs, val);
	Form_C_sync(fRLC, pg->f_Cx, val);
	Form_C_sync(fRLC, pg->f_C1, val);
	Form_C_sync(fRLC, pg->f_C2, val);
	Form_C_sync(fRLC, pg->f_C3, val);
	Form_C_sync(fRLC, pg->f_C4, val);
	Form_C_sync(fRLC, pg->f_C5, val);
}

/* ************** W1 Create ****************** */
static void DVal_Create_Xxx(TWins *Parent, TDVal **dv, TFormRLConoff **onoff, int *x, int y, int w, int nk, TPic *pic) {
  int tx = *x;
  TDVal *tdv = TDVal_CreateS(Parent, tx+19, y, w, 19);
	tdv->nk = nk;
	tdv->dv_fu = tdv_fu_LostFocusEnter;
	tdv->OnValChange = W1_DVal_OnValChange;
	*dv = tdv;
	*onoff = TFormRLConoff_CreateU(Parent, tx, y+1, 18, 16, pic);
	*x = tx + w + 21;
}

static TFormR *Create_f_W1_R(TPage_W1 *pg, const char *Caption, const char *Gruppe, 
			const char *s, TDVal *dv, float val) {
  TFormR *fR = Create_Form_R(appDat.obj, Caption, Gruppe, s, dv, val);
	fR->subClass = pg;
	TDVal_Set_Value(dv, fR->R->dval);
	fR->OnChange = W1_fXxx_OnChange;
	fR->OnSync = W1_OnRSync;
	return fR;
}
static TFormL *Create_f_W1_L(TPage_W1 *pg, const char *Caption, const char *Gruppe, 
			const char *s, TDVal *dv, float val) {
  TFormL *fL = Create_Form_L(appDat.obj, Caption, Gruppe, s, dv, val);
	fL->subClass = pg;
	TDVal_Set_Value(dv, fL->L->dval);
	fL->OnChange = W1_fXxx_OnChange;
	fL->OnSync = W1_OnLSync;
	return fL;
}
static TFormC *Create_f_W1_C(TPage_W1 *pg, const char *Caption, const char *Gruppe, 
			const char *s, TDVal *dv, float val) {
  TFormC *fC = Create_Form_C(appDat.obj, Caption, Gruppe, s, dv, val);
	fC->subClass = pg;
	TDVal_Set_Value(dv, fC->C->dval);
	fC->OnChange = W1_fXxx_OnChange;
	fC->OnSync = W1_OnCSync;
	return fC;
}

static TPage *page_Add_W1_Create(TPageControl *Parent) {
	return TPage_CreateParamAlg(Parent, sizeof(TPage_W1));
}

TPage_W1 *page_Add_W1(TPageControl *pagc, TPage_Filter *pgfilt) {
  TPage_W1 *hp1;
  TWins *pnl;
  TpcIni *pcIni;
  int x, y, m;

	pcIni = get_appIni();

	hp1 = (TPage_W1*) TPageControl_AddNewUserPage(pagc, "W1", page_Add_W1_Create);
	hp1->subClass = hp1;
	hp1->pgfilt = pgfilt;

	pnl = TWins_CreateBA((TWins*)hp1, 0, 0, 318, 21, 0, alLeft);
	hp1->pnl = pnl;
	hp1->pnl->OnPaint = pnl_W1_OnPaint;

/* Rg Rs Rx Ra */
	x = 0;
	y = 2;
	DVal_Create_Xxx(pnl, &hp1->dv_Rg, &hp1->OnOff_Rg, &x, y, 54, 1, get_Pic_cRg());
//	DVal_Create_Xxx(pnl, &hp1->dv_Rs, &hp1->OnOff_Rs, &x, y, 54, 1, get_Pic_cRs());
	x += 75;
	DVal_Create_Xxx(pnl, &hp1->dv_Ra, &hp1->OnOff_Ra, &x, y, 54, 1, get_Pic_cRa());
	DVal_Create_Xxx(pnl, &hp1->dv_Rx, &hp1->OnOff_Rx, &x, y, 54, 1, get_Pic_cRb());
/* Cs Ca */
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &hp1->dv_Cs, &hp1->OnOff_Cs, &x, y, 54, 1, get_Pic_cCs());
	DVal_Create_Xxx(pnl, &hp1->dv_Cx, &hp1->OnOff_Cx, &x, y, 54, 1, get_Pic_cCx());
/* C1 C2 C3 */
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &hp1->dv_C1, &hp1->OnOff_C1, &x, y, 54, 1, get_Pic_cC1());
	DVal_Create_Xxx(pnl, &hp1->dv_C2, &hp1->OnOff_C2, &x, y, 54, 1, get_Pic_cC2());
	DVal_Create_Xxx(pnl, &hp1->dv_C3, &hp1->OnOff_C3, &x, y, 54, 1, get_Pic_cC3());
/* L1 L2 */
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &hp1->dv_L1, &hp1->OnOff_L1, &x, y, 54, 3, get_Pic_cL1());
	DVal_Create_Xxx(pnl, &hp1->dv_L2, &hp1->OnOff_L2, &x, y, 54, 3, get_Pic_cL2());
/* C4 C5 */
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &hp1->dv_C4, &hp1->OnOff_C4, &x, y, 54, 1, get_Pic_cC4());
	DVal_Create_Xxx(pnl, &hp1->dv_C5, &hp1->OnOff_C5, &x, y, 54, 1, get_Pic_cC5());
/* L3 L4 L5*/
	x = 0;
	y += 20;
	DVal_Create_Xxx(pnl, &hp1->dv_L3, &hp1->OnOff_L3, &x, y, 54, 3, get_Pic_cL3());
	DVal_Create_Xxx(pnl, &hp1->dv_L4, &hp1->OnOff_L4, &x, y, 54, 3, get_Pic_cL4());
	DVal_Create_Xxx(pnl, &hp1->dv_L5, &hp1->OnOff_L5, &x, y, 54, 3, get_Pic_cL5());

	m = TpcIni_RD_int(pcIni, "W1", "OnOff", 0xffe0);

	y += 20;
	hp1->cbCsOn = TChkBox_CreateS(pnl, 2, y, 60, 16, "Cs on");
//	hp1->cbRsOn = TChkBox_CreateS(pnl, 72, y, 60, 16, "Rs on");
	hp1->cbCxOn = TChkBox_CreateS(pnl, 142, y, 60, 16, "Cx on");
//	hp1->cbRxOn = TChkBox_CreateS(pnl, 212, y, 60, 16, "Rx on");
	hp1->cbCsOn->OnClick = cbW1XxOn_OnClick;
//	hp1->cbRsOn->OnClick = cbW1XxOn_OnClick;
	hp1->cbCxOn->OnClick = cbW1XxOn_OnClick;
//	hp1->cbRxOn->OnClick = cbW1XxOn_OnClick;
	hp1->cbCsOn->Checked = ((m & 0x01) != 0);
//	hp1->cbRsOn->Checked = ((m & 0x02) != 0);
	hp1->cbCxOn->Checked = ((m & 0x04) != 0);
//	hp1->cbRxOn->Checked = ((m & 0x08) != 0);

/* Filter On/Off */
//	y = 105;
	y += 20;
	hp1->cbF1On = TChkBox_CreateS(pnl, 2, y, 38, 17, "F1");
	hp1->cbF1ImpOn = TChkBox_CreateS(pnl, 2, y+17, 38, 17, "Imp");
	SetColor((TWins*)hp1->cbF1On, 0xa0a0ff);
	SetColor((TWins*)hp1->cbF1ImpOn, 0xe0e080);
	y += 45;
	hp1->cbF2On = TChkBox_CreateS(pnl, 2, y, 38, 17, "F2");
	hp1->cbF2ImpOn = TChkBox_CreateS(pnl, 2, y+17, 38, 17, "Imp");
	SetColor((TWins*)hp1->cbF2On, 0xa0ffa0);
	SetColor((TWins*)hp1->cbF2ImpOn, 0xe0e080);
	y += 45;
	hp1->cbF3On = TChkBox_CreateS(pnl, 2, y, 38, 17, "F3");
	hp1->cbF3ImpOn = TChkBox_CreateS(pnl, 2, y+17, 38, 17, "Imp");
	SetColor((TWins*)hp1->cbF3On, 0xff8080);
	SetColor((TWins*)hp1->cbF3ImpOn, 0xe0e080);
	y += 45;
	hp1->cbF4On = TChkBox_CreateS(pnl, 2, y, 38, 17, "F4");
	hp1->cbF4ImpOn = TChkBox_CreateS(pnl, 2, y+17, 38, 17, "Imp");
	SetColor((TWins*)hp1->cbF4On, 0xff80ff);
	SetColor((TWins*)hp1->cbF4ImpOn, 0xe0e080);

	hp1->cbF1On->OnClick = cbW1FxOn_OnClick;
	hp1->cbF2On->OnClick = cbW1FxOn_OnClick;
	hp1->cbF3On->OnClick = cbW1FxOn_OnClick;
	hp1->cbF4On->OnClick = cbW1FxOn_OnClick;
	hp1->cbF1On->Checked = ((m & 0x010) != 0);
	hp1->cbF2On->Checked = ((m & 0x020) != 0);
	hp1->cbF3On->Checked = ((m & 0x040) != 0);
	hp1->cbF4On->Checked = ((m & 0x080) != 0);

	hp1->cbF1ImpOn->OnClick = cbW1FxImpOn_OnClick;
	hp1->cbF2ImpOn->OnClick = cbW1FxImpOn_OnClick;
	hp1->cbF3ImpOn->OnClick = cbW1FxImpOn_OnClick;
	hp1->cbF4ImpOn->OnClick = cbW1FxImpOn_OnClick;
	hp1->cbF1ImpOn->Checked = ((m & 0x700) == 0x100);
	hp1->cbF2ImpOn->Checked = ((m & 0x700) == 0x200);
	hp1->cbF3ImpOn->Checked = ((m & 0x700) == 0x300);
	hp1->cbF4ImpOn->Checked = ((m & 0x700) == 0x400);

	hp1->f_Rg = Create_f_W1_R(hp1, "W1 Rg", "W1", "Rg", hp1->dv_Rg, 60);
//	hp1->f_Rs = Create_f_W1_R(hp1, "W1 Rs", "W1", "Rs", hp1->dv_Rs, 50);
	hp1->f_Rx = Create_f_W1_R(hp1, "W1 Rb", "W1", "Rb", hp1->dv_Rx, 60);
	hp1->f_Ra = Create_f_W1_R(hp1, "W1 Ra", "W1", "Ra", hp1->dv_Ra, 60);

	hp1->f_Cs = Create_f_W1_C(hp1, "W1 Cs", "W1", "Cs", hp1->dv_Cs, 100);
	hp1->f_Cx = Create_f_W1_C(hp1, "W1 Cx", "W1", "Cx", hp1->dv_Cx, 100);
	hp1->f_C1 = Create_f_W1_C(hp1, "W1 C1", "W1", "C1", hp1->dv_C1, 3.3);
	hp1->f_C2 = Create_f_W1_C(hp1, "W1 C2", "W1", "C2", hp1->dv_C2, 2.7);
	hp1->f_C3 = Create_f_W1_C(hp1, "W1 C3", "W1", "C3", hp1->dv_C3, 4.7);
	hp1->f_C4 = Create_f_W1_C(hp1, "W1 C4", "W1", "C4", hp1->dv_C4, 12);
	hp1->f_C5 = Create_f_W1_C(hp1, "W1 C5", "W1", "C5", hp1->dv_C5, 12);

	hp1->f_L1 = Create_f_W1_L(hp1, "W1 L1", "W1", "L1", hp1->dv_L1, 0.016);
	hp1->f_L2 = Create_f_W1_L(hp1, "W1 L2", "W1", "L2", hp1->dv_L2, 0.016);
	hp1->f_L3 = Create_f_W1_L(hp1, "W1 L3", "W1", "L3", hp1->dv_L3, 0.068);
	hp1->f_L4 = Create_f_W1_L(hp1, "W1 L4", "W1", "L4", hp1->dv_L4, 0.100);
	hp1->f_L5 = Create_f_W1_L(hp1, "W1 L5", "W1", "L5", hp1->dv_L5, 0.056);

	TFormRLConoff_SetForm(hp1->OnOff_Rg, (TForm*)hp1->f_Rg);
//	TFormRLConoff_SetForm(hp1->OnOff_Rs, (TForm*)hp1->f_Rs);
	TFormRLConoff_SetForm(hp1->OnOff_Rx, (TForm*)hp1->f_Rx);
	TFormRLConoff_SetForm(hp1->OnOff_Ra, (TForm*)hp1->f_Ra);
	TFormRLConoff_SetForm(hp1->OnOff_Cs, (TForm*)hp1->f_Cs);
	TFormRLConoff_SetForm(hp1->OnOff_Cx, (TForm*)hp1->f_Cx);
	TFormRLConoff_SetForm(hp1->OnOff_C1, (TForm*)hp1->f_C1);
	TFormRLConoff_SetForm(hp1->OnOff_C2, (TForm*)hp1->f_C2);
	TFormRLConoff_SetForm(hp1->OnOff_C3, (TForm*)hp1->f_C3);
	TFormRLConoff_SetForm(hp1->OnOff_C4, (TForm*)hp1->f_C4);
	TFormRLConoff_SetForm(hp1->OnOff_C5, (TForm*)hp1->f_C5);
	TFormRLConoff_SetForm(hp1->OnOff_L1, (TForm*)hp1->f_L1);
	TFormRLConoff_SetForm(hp1->OnOff_L2, (TForm*)hp1->f_L2);
	TFormRLConoff_SetForm(hp1->OnOff_L3, (TForm*)hp1->f_L3);
	TFormRLConoff_SetForm(hp1->OnOff_L4, (TForm*)hp1->f_L4);
	TFormRLConoff_SetForm(hp1->OnOff_L5, (TForm*)hp1->f_L5);

	free_appIni(pcIni);

	return hp1;
}
