/*
 Copyright (C) 2010-2012 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/


#include "TeCache.h"
#include "tpixmap.h"

#ifdef use_FEATURE

static void ImageZoom(TFormTeCache *fcs, int size) {
  int i;
  int *pi1, *pi2, *pi3;
  int *pis1, *pis2, *pid;
  int z, z0, res;
  double dz;

	pi1 = malloc(size * 4);
	pi2 = malloc(size * 4);
	pi3 = malloc(size * 4);

	pis1 = pi1;
	pis2 = pi2;
	pid = pi3;
	z = GetTime_us();
	for (i=size-1;i;i--) {
	    *pid = *pis1; // + *pis2;
	    pid++; pis1++; // pis2++;
	}
	z0 = GetTime_us();
	dz = (10000 * (double)(z0-z)) / size;
	res = dz;
 printf("%s(%d): %d %d\n", FL, z0-z, res);

	xfree(pi3);
	xfree(pi2);
	xfree(pi1);
}

void TTeCache_ImageZoom_Start(TFormTeCache *self) {
	ImageZoom(self, 0x1000);
	ImageZoom(self, 0x2000);
	ImageZoom(self, 0x4000);
	ImageZoom(self, 0x8000);
	ImageZoom(self, 0x10000);
	ImageZoom(self, 0x20000);
	ImageZoom(self, 0x40000);
	ImageZoom(self, 0x80000);
	ImageZoom(self, 0x100000);
	ImageZoom(self, 0x200000);
	ImageZoom(self, 0x400000);
	ImageZoom(self, 0x800000);

}
#endif
