/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "TeCache.h"

#ifdef use_SAVE_UserDat

static void wr_int(char **ppc, int val) {
	ppcmove_v32(ppc, val, 0x120000);
}

static void wr_head(TFormTeCache *fcs, TpcIni *pcIni, const char *Gpd) {
  TFormTeCache_Dat *cd;
  char *pc;
  char Funkt[16];
  char buf[4096];

	for (int idx=0; idx<max_cbXM; idx++) {
	  cd = &cd_Buf[idx];
	  if (cd->sampz) {
	    pc = Funkt;
	    ppcmove(&pc, "head"); ppcmove(&pc, sMemSize[idx]);

	    pc = buf;
	    wr_int(&pc, cd->MHz);
	    wr_int(&pc, cd->sampz);
	    wr_int(&pc, cd->maxmem_ps);
	    wr_int(&pc, cd->min_ps);
	    wr_int(&pc, cd->max_ps);
	    wr_int(&pc, cd->ges_time);
	    TpcIni_WR(pcIni, Gpd, Funkt, buf);

	    pc = Funkt;
	    ppcmove(&pc, "t"); ppcmove(&pc, sMemSize[idx]);
	    pc = buf;
	    for (int i=0; i<cd->sampz; i++) {
		hextoppc(&pc, cd->sampt[i], kSPACE_ADD);
	    }
	    TpcIni_WR(pcIni, Gpd, Funkt, buf);

	    pc = Funkt;
	    ppcmove(&pc, "m"); ppcmove(&pc, sMemSize[idx]);
	    pc = buf;
	    for (int i=0; i<cd->sampz; i++) {
		hextoppc(&pc, cd->sampmem[i] >> 8, kSPACE_ADD);
	    }
	    TpcIni_WR(pcIni, Gpd, Funkt, buf);
	  }
	}
}

static void wr_move_head(TFormTeCache *fcs, TpcIni *pcIni, const char *Gpd) {
  TScaleXnsRaster *xr;
  char *pc, *pcn;
  TFormTeCache_Dat *cd;
  TXnsPoint *PV;
  char Funkt[16];
  char buf[4096];

	if (!fcs->xns_mov->xr || !fcs->xns_mov->xr->PVs) return;

	for (int idx=0; idx<max_cbXM; idx++) {
	  cd = &cdm_Buf[idx];
	  xr = &dat_xr[idx];
	  if (xr->PVs && xr->PVs[0].PV) {

	    pc = Funkt;
	    ppcmove(&pc, "hmov"); ppcmove(&pc, sMemSize[idx]);

	    pc = buf;
	    wr_int(&pc, cd->MHz);
	    wr_int(&pc, cd->min_ps);
	    wr_int(&pc, cd->max_ps);
	    wr_int(&pc, cd->ges_time);
	    wr_int(&pc, xr->PX_Count);
	    TpcIni_WR(pcIni, Gpd, Funkt, buf);

	    pc = Funkt;
	    ppcmove(&pc, "xmov"); ppcmove(&pc, sMemSize[idx]);
	    pc = buf;
	    for (int x=0;x<xr->PX_Count;x++) {
	      hextoppc(&pc, xr->PX[x].fx * 1000, kSPACE_ADD | 3);
	    }
	    TpcIni_WR(pcIni, Gpd, Funkt, buf);

	    pc = Funkt;
	    ppcmove(&pc, "mov"); ppcmove(&pc, sMemSize[idx]);
	    *pc = '.'; pc++; *pc = 0; 
	    pcn = pc;
	    for (int n=0;n<xr->PVs_count;n++) {
	      PV = xr->PVs[n].PV;
	      if (PV && (xr->PVs[n].PV_Count == xr->PX_Count)) {
		pc = pcn;
		inttoppc(&pc, n);
		pc = buf;
		for (int x=0;x<xr->PX_Count;x++) {
		  hextoppc(&pc, PV[x].fy * 1000, kSPACE_ADD | 3);
		}
		TpcIni_WR(pcIni, Gpd, Funkt, buf);
	      }
	    }
	  }
	}
}

void TTeCache_mFile_SaveU1(TMenu *self, long KeyState, TMenuItem *smi) {
  TFormTeCache *fcs = (TFormTeCache*)self->FormStruct;
  const char *Gpd;
  TpcIni *pcIni;

	switch(smi->tag) {
	case 1: Gpd = "USER1_Dat"; break;
	case 2: Gpd = "USER2_Dat"; break;
	case 3: Gpd = "USER3_Dat"; break;
	default: return;
	}

	pcIni = TpcIni_Create(appDat.inifile_app);

	wr_head(fcs, pcIni, Gpd);

#ifdef use_PAGES
	wr_move_head(fcs, pcIni, Gpd);
#endif

	TpcIni_SaveAndFree(pcIni);
}

#endif /* use_SAVE_UserDat */

