/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "TeCache.h"

#ifdef use_PAGES

#if defined (__i386__)

void MemMoveK0_ASM(TMemMoveK *mmk) {
 __asm__ volatile(
		"mov	%3, %%eax \n"
	      "0:\n"
		"mov	%0, %%edi \n"
		"mov	%1, %%esi \n"
		"mov	%2, %%ecx \n"
		"nop \n"
		"mov	%0, %%esi \n"
		"mov	%1, %%edi \n"
		"mov	%2, %%ecx \n"
		"nop \n"
		"dec	%%eax \n"
	      "jne	0b \n"
		: :"m"(mmk->pi1),"m"(mmk->pi2),"m"(mmk->size),"m"(mmk->k)
		: "eax","ecx","esi","edi"
		);
}

void MemMoveK_ASM(TMemMoveK *mmk) {
 __asm__ volatile(
		"mov	%3, %%eax \n"
	      "0:\n"
		"mov	%0, %%edi \n"
		"mov	%1, %%esi \n"
		"mov	%2, %%ecx \n"
		"rep	movsd \n"
		"mov	%0, %%esi \n"
		"mov	%1, %%edi \n"
		"mov	%2, %%ecx \n"
		"rep	movsd \n"
		"dec	%%eax \n"
	      "jne	0b \n"
		: :"m"(mmk->pi1),"m"(mmk->pi2),"m"(mmk->size),"m"(mmk->k)
		: "eax","ecx","esi","edi"
		);
}

#else
void MemMoveK0_ASM(TMemMoveK *mmk) {
 __asm__ volatile(
		"mov	%3, %%eax \n"
	      "0:\n"
		"mov	%0, %%rdi \n"
		"mov	%1, %%rsi \n"
		"mov	%2, %%rcx \n"
		"nop \n"
		"mov	%0, %%rsi \n"
		"mov	%1, %%rdi \n"
		"mov	%2, %%rcx \n"
		"nop \n"
		"dec	%%eax \n"
	      "jne	0b \n"
		: :"m"(mmk->pi1),"m"(mmk->pi2),"m"(mmk->size),"m"(mmk->k)
		: "eax","rcx","rsi","rdi"
		);
}

void MemMoveK_ASM(TMemMoveK *mmk) {
 __asm__ volatile(
		"mov	%3, %%eax \n"
	      "0:\n"
		"mov	%0, %%rdi \n"
		"mov	%1, %%rsi \n"
		"mov	%2, %%rcx \n"
		"rep	movsd \n"
		"mov	%0, %%rsi \n"
		"mov	%1, %%rdi \n"
		"mov	%2, %%rcx \n"
		"rep	movsd \n"
		"dec	%%eax \n"
	      "jne	0b \n"
		: :"m"(mmk->pi1),"m"(mmk->pi2),"m"(mmk->size),"m"(mmk->k)
		: "eax","rcx","rsi","rdi"
		);
}
#endif

#endif
