/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"

#define TCSelf TFormMain
typedef struct TFormMain {
  AlgTForm
  TEdit *ed1;
  TEdit *ed2;
  TDVal *dv1;
} TFormMain;
#undef TCSelf



static const char *Help_Msg = {
  "\n"
  "Usage: edit\n"
  "\n"
  "  -h, --help           Prints out this screen\n\n"
  "  ALDccp: edit version "VERSION"  (build %d  %s)\n"
};

int build_v = ALD_BUILD_V;
static const char *build_date = __DATE__;

int main (int argc, char **argv) {
  int i;
  char *val;
//  char *InFile;
  TFormMain *self;
  bool help = False;
  bool err = False;


//	InFile = NULL;
	i = 1;
	while (!err && (i<argc)) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'h':
		    help = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
		    } else err = True;
		    break;
		default: 
		    err = True;
		}
	    } else {
//		InFile = val;
		err = True;
	    }
	    i++;
	}

//	err = err || !InFile;
	if (help || err) {
	    printf(Help_Msg, build_v, build_date);
	    exit(err);
	}

	initXapp(0, argc, argv);
	self = TForm_CreatParamAlg(NULL, sizeof(TFormMain));
	appDat.obj = self;

	self->ed1 = TEdit_CreateS((TWins*)self, 1, 1, 200, 18, 
						"Test Value");
	self->ed2 = TEdit_CreateS((TWins*)self, 1, 21, 200, 18, 
						NULL);
	self->ed2->Passwd = ed_passwd_akt;

	self->dv1 = TDVal_CreateSV4((TWins*)self, 1, 41, 200, 18,
					123.4, -9999, 9999, 1);
	self->dv1->dv_fu |= tdv_fu_MouseMove_add;
	self->dv1->MouseMove_add_dval = 0.1;

	AppRun();
	return 0;
}
