/*
 Copyright (C) 2010-2013 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"

#define TCSelf TFormMain
typedef struct TFormMain {
  AlgTForm
  TProgressBar *pb1;
  TProgressBar *pb2;
  TScrollBar *sb;
} TFormMain;
#undef TCSelf

static void sb_OnCount(TScrollBar* sb, int Count) {
  TFormMain *mf = appDat.obj;
	TProgressBar_SetProz(mf->pb1, Count);
	TProgressBar_SetProz(mf->pb2, Count);
}

static const char *Help_Msg = {
  "\n"
  "Usage: edit\n"
  "\n"
  "  -h, --help           Prints out this screen\n\n"
  "  ALDccp: edit version "VERSION"  (build %d  %s)\n"
};

int build_v = ALD_BUILD_V;
static const char *build_date = __DATE__;

int main (int argc, char **argv) {
  int i;
  char *val;
  TFormMain *self;
  bool help = False;
  bool err = False;


	i = 1;
	while (!err && (i<argc)) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'h':
		    help = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
		    } else err = True;
		    break;
		default: 
		    err = True;
		}
	    } else {
		err = True;
	    }
	    i++;
	}

	if (help || err) {
	    printf(Help_Msg, build_v, build_date);
	    exit(err);
	}

	initXapp(0, argc, argv);
	self = TForm_CreatParamAlg(NULL, sizeof(TFormMain));
	appDat.obj = self;

	self->pb1 = TProgressBar_CreateU((TWins*)self, 1, 1, 100, 17);
	self->pb1->Align = alTop;
	self->pb1->nk = 0;
	self->pb2 = TProgressBar_CreateU((TWins*)self, 1, 1, 100, 17);
	self->pb2->Align = alTop;

	self->sb = TScrollBarHorz_CreateP((TWins*)self);
	self->sb->Align = alTop;
	self->sb->OnCount = sb_OnCount;
	TScrollBar_SetMaxCount(self->sb, 1000);

	AppRun();
	return 0;
}

