/*
 Copyright (C) 2010-2014 by Hoefer Alfred

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version. 

 This program is distributed in the hope that it will be useful, 
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details. 

 You should have received a copy of the GNU General Public
 License along with this program; if not, write to the Free
 Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
 MA 02110, USA

 ----------------------------------------------------------------
 Licensed under GPL v2, see file COPYING in this tarball
*/

#include "appXbase.h"
#include "tlineedit.h"
#include "tpixmap.h"
#include "dlg.h"
#include "cicons.h"

#define APPNAME "XpmToZimg"

static int build_v = ALD_BUILD_V;
static const char *build_date = __DATE__;

//char *AppName = "XpmToZimg";
int app_argc;
char **app_argv;

TWins *FormMain;

TWins *PanelTop;

TMenuButton *mbFile;
TMenu *menuFile;
TMenu *menuLE;
TMenu *menuReopen;
TMenuItem *miSave;
TMenuItem *miLESave;

TMenuButton *mbEdit;
TMenu *menuEdit;

TMenuButton *mbTools;

TMenuButton *mbSetting;
TMenu *menuSetting;
TMenu *menuHighlight;
TMenu *menuEOL;
TMenuItem *miMixed;
TMenu *menuClipbord;
TMenu *menuFont;

TMenuButton *mbHelp;
TMenu *menuHelp;
TMenuButton *mbSave;
TMenuButton *mbRedo;
TMenuButton *mbUndo;

TMenuButton *mbConv;

TLineEdit *LineEdit;
TWins *PanelRight;
TWins *PanelRightTop;
TWins *PanelRightTopSel;
TChkBox *cb_C16;
TChkBox *cb_C15;
TChkBox *cb_C12;
TChkBox *cb_C9;
TChkBox *cb_C8;
TChkBox *cb_C6;
TChkBox *cb_Cxp;
TScrollBar *sb_Cxx;
TWins *lbl_sbCxxAZ;

TLineEdit *AHimgEdit;


TWins *PanelBottom;
TWins *CursPosBox;
TWins *SBVPosBox;
TWins *CharAzBox;


TFile_Dlg *File_Dlg = NULL;
TFile_Dlg *FileSave_Dlg = NULL;
TFind_Dlg *Find_Dlg;
TReplace_Dlg *Replace_Dlg;

TpcIni *globIniLoad = NULL;

int argv_fileIdx = 0;
int LCount;
int us_mk;
long long mkDataNowSize;

bool IO_Run = False;
bool MsgBox_Reload_Run = False;

// *************************

#define TranspArray	1
#define Color0isMask	(1<<1)
#define CountArray	(1<<2)

typedef struct TxpmCol {
  int col;
  byte c[4];
  int z;
  int colno;
  int idx;
} TxpmCol;

typedef struct TAHicoHead {
  byte fu;
  byte cols;
  short width;
  short height;
  int DataSize;
    //..... Data
} TAHicoHead;
#define icoHeadSize 10

TPic *AZpic = NULL;

static int Col2bit_Korr(int c) {
	c += sb_Cxx->Count-31;
	if (((TChkBox*)cb_Cxp)->Checked) {
	    if (c > 0xe0) c = 0xff; else
	    if (c > 0xa0) c = 0xc0; else
	    if (c > 0x60) c = 0x80; else
	    if (c > 0x20) c = 0x40; else c = 0;
	} else {
	    if (c > 0xd0) c = 0xff; else
	    if (c > 0x80) c = 0xb0; else
	    if (c > 0x40) c = 0x58; else c = 0;
	}
	return c;
}

static int Col25bit_Korr(int c) {
	c += sb_Cxx->Count-31;
	if (((TChkBox*)cb_Cxp)->Checked) {
	    if (c > 0xe8) c = 0xff; else
	    if (c > 0xd0) c = 0xe0; else
	    if (c > 0xa0) c = 0xc0; else
	    if (c > 0x70) c = 0x80; else
	    if (c > 0x50) c = 0x60; else
	    if (c > 0x20) c = 0x30; else c = 0;
	} else {
	    if (c > 0xe8) c = 0xff; else
	    if (c > 0xd0) c = 0xe0; else
	    if (c > 0xa0) c = 0xc0; else
	    if (c > 0x60) c = 0x80; else
	    if (c > 0x20) c = 0x40; else c = 0;
	}
	return c;
}

static int Col3bit_Korr(int c) {
	c += sb_Cxx->Count-31;
	if (((TChkBox*)cb_Cxp)->Checked) {
	    if (c > 0xf0) c = 0xff; else
	    if (c > 0xd0) c = 0xe0; else
	    if (c > 0xb0) c = 0xc0; else
	    if (c > 0x90) c = 0xa0; else
	    if (c > 0x70) c = 0x80; else
	    if (c > 0x50) c = 0x60; else
	    if (c > 0x30) c = 0x40; else
	    if (c > 0x10) c = 0x20; else c = 0;
	} else {
	    if (c > 0xea) c = 0xff; else
	    if (c > 0xc6) c = 0xd8; else
	    if (c > 0xa2) c = 0xb4; else
	    if (c > 0x7e) c = 0x90; else
	    if (c > 0x5a) c = 0x6c; else
	    if (c > 0x36) c = 0x48; else
	    if (c > 0x12) c = 0x24; else c = 0;
	}
	return c;
}

static bool read_xpm_colTab(TLines *tls, int chr_per_pixel, int *y, TxpmCol *xpmCol) {
  int i, r, g, b, k;
  int idx = *y;
  char *s;

loop:
	if (tls->Count <= idx) return False;
	s = tls->lines->cs[idx]->s;
	idx++;
	if (!s) return False;
	if (*s != '"') goto loop;
	s++;

	for (i=0; i<chr_per_pixel; i++) {
	    if (!*s) return False;
	    xpmCol->c[i] = *s;
	    s++;
	}
	while (*s && ((*s == ' ') || (*s == 0x09))) s++;

	if ((*s == 'm') || (*s == 's')) {
	    s++;
	    while (*s && ((*s == ' ') || (*s == 0x09))) s++;
	    while (*s && ((*s != ' ') && (*s != 0x09))) s++;
	    while (*s && ((*s == ' ') || (*s == 0x09))) s++;
	}
	if ((*s == 'm') || (*s == 's')) {
	    s++;
	    while (*s && ((*s == ' ') || (*s == 0x09))) s++;
	    while (*s && ((*s != ' ') && (*s != 0x09))) s++;
	    while (*s && ((*s == ' ') || (*s == 0x09))) s++;
	}
	if (*s != 'c') return False;
	s++;

	while (*s && ((*s == ' ') || (*s == 0x09))) s++;
	if (!*s) return False;
	    /* Chk Color name */
	if (!pcncasecmpASCII(s, "none", 4)) {
	    xpmCol->col = -1;
	} else {

	    i = GetColorByName(s);

	    r = (i >> 16) & 0xff;
	    g = (i >> 8) & 0xff;
	    b = i & 0xff;
	    k = sb_Cxx->Count-31;
	    if (cb_C16->Checked) {
		r += k+3; g += k+1; b += k+3;
	    } else if (cb_C15->Checked) {
		r += k+3; g += k+3; b += k+3;
	    } else if (cb_C12->Checked) {
		r += k+7; g += k+7; b += k+7;
	    }

	    if (r > 0xff) r = 0xff;
	    if (g > 0xff) g = 0xff;
	    if (b > 0xff) b = 0xff;
	    if (r < 0) r = 0;
	    if (g < 0) g = 0;
	    if (b < 0) b = 0;

	    if (cb_C16->Checked) {
		xpmCol->col = ((r & 0xf8) << 16) | ((g & 0xfc) << 8) | (b & 0xf8);
	    } else if (cb_C15->Checked) {
		xpmCol->col = ((r & 0xf8) << 16) | ((g & 0xf8) << 8) | (b & 0xf8);
	    } else if (cb_C12->Checked) {
		xpmCol->col = (((r & 0xf0) | 0x07) << 16) | (((g & 0xf0) | 0x07) << 8) | ((b & 0xf0) | 0x07);
	    } else if (cb_C9->Checked) {
		xpmCol->col = (Col3bit_Korr(r) << 16) | (Col3bit_Korr(g) << 8) | Col3bit_Korr(b);
	    } else if (cb_C8->Checked) {
		xpmCol->col = (Col25bit_Korr(r) << 16) | (Col25bit_Korr(g) << 8) | Col25bit_Korr(b);
	    } else {
		xpmCol->col = (Col2bit_Korr(r) << 16) | (Col2bit_Korr(g) << 8) | Col2bit_Korr(b);
	    }
	}
	*y = idx;
	return True;
}

static int get_eq_stk(byte *s, int lg) {
  int res;
  byte a;
	res = 0;
	a = *s;
	s++; lg--;
	while ((lg>0) && (a == *s)) {s++; res++; lg--;}
	return res;
}

static int chk3_eq(byte *s, int lg) {
	return (get_eq_stk(s, lg) > 1);
}

static int get_ne_stk(byte *s, int lg) {
  int res;
  byte a;
	res = 0;
	a = *s;
	s++; lg--;
	while ((lg>0) && !chk3_eq(s, lg)) {
	    a = *s; s++; res++; lg--;
	}
	return res;
}

static int calc_stk(byte *s, int lg, int k) {
  int res = 0;
  int m, z = 0;

	while (lg>0) {
	    if (chk3_eq(s, lg)) {
		z = get_eq_stk(s, lg);
		res += k + 4;
		m = (z - 2) >> 2;
		while (m) {res += 2; m >>= 1;}
	    } else {
		z = get_ne_stk(s, lg);
		res += k + 4;
		m = z >> 2;
		while (m) {res += 2; m >>= 1;}
		m = z;
		while (m) {res += k; m--;}
	    }
	    z++;
	    lg -= z;
	    s += z;
	}
	return (res+7)>>3;
}

static void wr_CA_Dat(TBitsIO *cbits, byte *s, int lg, int k) {
  int m, z = 0, g = 0;
  byte *sb;

	while (lg>0) {
	    if (chk3_eq(s, lg)) {
		z = get_eq_stk(s, lg);
		g += z+1;
		m = z - 2;
		SetBits8(cbits, m, 2);
		m >>= 2;
		while (m) {
		    SetBits8(cbits, 1, 1); //next bit
		    SetBits8(cbits, m, 1);
		    m >>= 1;
		}
		SetBits8(cbits, 0, 1);	//Stop bit
		SetBits8(cbits, 1, 1);	//n loop data
		SetBits8(cbits, *s, k);
	    } else {
		z = get_ne_stk(s, lg);
		g += z+1;
		m = z;
		SetBits8(cbits, m, 2);
		m >>= 2;
		while (m) {
		    SetBits8(cbits, 1, 1);
		    SetBits8(cbits, m, 1);
		    m >>= 1;
		}
		SetBits8(cbits, 0, 1);
		SetBits8(cbits, 0, 1);	//n data
		sb = s;
		m = z + 1;
		while (m) {
		    SetBits8(cbits, *sb, k);
		    sb++; m--;
		}
	    }
	    z++;
	    lg -= z;
	    s += z;
	}
}

static int GetCol_k(int cols) {
  int k = 0;
	while (cols > 0) {k++; cols >>= 1;}
	return k;
}

static void ChColTab(TxpmCol *xpmCol, int a, int b) {
  int col, idx;
  int c;
	col = xpmCol[a].col;
	idx = xpmCol[a].idx;
	c = *(int*)xpmCol[a].c;
	xpmCol[a].col = xpmCol[b].col;
	xpmCol[a].idx = xpmCol[b].idx;
	*(int*)xpmCol[a].c = *(int*)xpmCol[b].c;
	xpmCol[b].col = col;
	xpmCol[b].idx = idx;
	*(int*)xpmCol[b].c = c;
}

static void XpmConv() {
  int idx, lg, x, y, chr_per_pixel, cz, i, m, xi, fu, k, xpmDatLg;
  int cols, colsg;
  int MaskDatLg = 0;
  int ColDatLg = 0;
  int NoneIdx = -1;
  int omz;
  char line[256];
  TLines *tls;
  TBitsIO mbits;
  TBitsIO cbits;
  char *ps, *pc, *pcd, *pcom, *icoHead;
  const char *cpc;
  byte *pb;
  TxpmCol *xpmCol = NULL;
  byte *xpmDat = NULL;
  byte *xpmDat_oM = NULL;
  word *pCol16;
  byte *pColNr;
  bool mkTreansp = False;

	cbits.io.rd_byte = NULL;
	mbits.io.rd_byte = NULL;
	tls = LineEdit->tls;
	lg = tls->Count;
	if (!lg) return;
	TLineEdit_Clr(AHimgEdit);


	idx = x = y = cols = chr_per_pixel = 0;
	while (idx < lg) {
	    pc = tls->lines->cs[idx]->s;
	    if (*pc == '"') {
		pc++;
		x = ppctoint((const char**)&pc);
		y = ppctoint((const char**)&pc);
		cols = ppctoint((const char**)&pc);
		chr_per_pixel = ppctoint((const char**)&pc);
		idx++;
		break;
	    }
	    idx++;
	} 
// printf("%s(%d): %d %d %d %d\n", FL, x, y, cols, chr_per_pixel);

	if ((cols == 0) || (cols > 2048) || (chr_per_pixel == 0) || (chr_per_pixel > 2)) return;
	xpmCol = xcalloc(sizeof(TxpmCol) * (cols+1));
	xpmDatLg = x * y;
	xpmDat = xcalloc(sizeof(xpmDat) * xpmDatLg);
	xpmDat_oM = xcalloc(sizeof(xpmDat) * xpmDatLg);

/* set color tab */
	cz = 0;
	while ((idx < lg) && (cz < cols)) {
	    if (!read_xpm_colTab(tls, chr_per_pixel, &idx, &xpmCol[cz])) goto ende;
	    if ((xpmCol[cz].col == -1) && !mkTreansp) {
		if (cz) ChColTab(xpmCol, 0, cz);
		mkTreansp = True;
		NoneIdx = 0;
	    } 
	    xpmCol[cz].z = 0;
	    cz++;
	}

/* set color tab idx */
	colsg = 0;
	for (i=0;i<cols;i++) {
	    colsg++;
	    xpmCol[i].idx = i;
	    for (m=0;m<i;m++) {
		if (xpmCol[i].col == xpmCol[m].col) {
		    xpmCol[i].idx = m;
		    colsg--;
		    break;
		}
	    }
	}

/* sort color tab */
	for (i=0;i<cols;i++) {
	    if (xpmCol[i].idx != i) {
		for (xi=i+1;xi<cols;xi++) {
		    if (xpmCol[xi].idx == xi) {
			ChColTab(xpmCol, i, xi);
			xpmCol[i].idx = i;
			break;
		    }
		}
	    }
	}

/* set color tab idx */
	for (i=0;i<cols;i++) {
	    xpmCol[i].idx = i;
	    for (m=0;m<i;m++) {
		if (xpmCol[i].col == xpmCol[m].col) {
		    xpmCol[i].idx = m;
		    break;
		}
	    }
	}

// printf("%s(%d): colsg=%d\n", FL, colsg);

	if (colsg > 255) return;


	if (mkTreansp) MaskDatLg = (xpmDatLg+7) >> 3;
	cz = 0;
	omz = 0;
	pcd = (char*)xpmDat;
	pcom = (char*)xpmDat_oM;
	while ((idx < lg) && (cz < y)) {
	    pb = (byte*)tls->lines->cs[idx]->s;
	    if (*pb == '"') {
		pb++;
		for (xi=0;xi<x;xi++) {
		  for (i=0;i<cols;i++) {
		    if (chr_per_pixel == 1) {
		      if (xpmCol[i].c[0] == *pb) break;
		    } else {
		      if ((xpmCol[i].c[0] == *pb) && (xpmCol[i].c[1] == pb[1])) break;
		    } 
		  } 
// if (i>=cols) {
//  printf("%s(%d): Err: %d\n", FL, i);
//  i = cols-1;
// }
		  m = xpmCol[i].idx;
		  xpmCol[i].z++;
		  *pcd = m;
		  pcd++;
		  if (i != NoneIdx) {
		    *pcom = m;
		    pcom++; omz++;
		  }
		  pb += chr_per_pixel;
		}
		cz++;
	    } 
	    idx++;
	}

// printf("%s(%d): %d %d %d lg=%d lg2=%d\n", FL, NoneIdx, cols, colsg, xpmDatLg, omz);

	cols = colsg;
	fu = 0;
	if (mkTreansp) {
	    fu = TranspArray;
	    cols--;
	    snprintf(line, sizeof(line), "Treansp=%d", xpmCol[NoneIdx].z);
	    TLineEdit_AddLine(AHimgEdit, line);
	} 

// printf("colsg=%d\n", colsg);

 int qk1 = calc_stk(xpmDat, xpmDatLg, GetCol_k(colsg-1));

 int qk2 = calc_stk(xpmDat_oM, omz, GetCol_k(cols-1));

	m = cols*2 + 10;
 int Std;
// printf("%s(%d): %d %d %d lg=%d lg2=%d\n", FL, m, cols, colsg, xpmDatLg, omz);

	if (mkTreansp) {
	  Std = m + (((xpmDatLg - xpmCol[NoneIdx].z) * GetCol_k(cols-1) + 7) >> 3) + MaskDatLg;
	} else {
	  Std = m + ((xpmDatLg * GetCol_k(colsg-1) + 7) >> 3);
	}
	snprintf(line, sizeof(line), "std=%d qk1=%d qk2=%d", 
		Std, qk1 + m, qk2 + m + MaskDatLg);
	TLineEdit_AddLine(AHimgEdit, line);

	if (Std > (qk1+m+1)) {
	    fu = CountArray;
	    if (mkTreansp) fu = Color0isMask | CountArray;
	}

	k = 0;
	if (fu & CountArray) {
	    if (fu & TranspArray) {
	    } else {
		k = GetCol_k(colsg-1);
		ColDatLg = qk1;
		MaskDatLg = 0;
	    }
	    if (!k) return;
	} else {
	    if (mkTreansp) {
		k = GetCol_k(cols-1);
		ColDatLg = ((xpmDatLg - xpmCol[NoneIdx].z) * k + 7) >> 3; //div8
	    } else {
		k = GetCol_k(colsg-1);
		ColDatLg = (xpmDatLg * k + 7) >> 3; //div8
	    }
	}
//	if (!k) return;
// printf("%s(%d): %d\n", FL, k);

	lg = icoHeadSize + cols*2 + MaskDatLg + ColDatLg;

// printf("gesMemLg=%d HeadLg=%d ColLg=%d MaskLg=%d DatLg=%d\n", 
//		lg, icoHeadSize, colsg*2, MaskDatLg, ColDatLg);

	icoHead = xcalloc(lg);
	((TAHicoHead*)icoHead)->cols = cols;
//	((TAHicoHead*)icoHead)->cols = colsg;
	((TAHicoHead*)icoHead)->width = x;
	((TAHicoHead*)icoHead)->height = y;
	((TAHicoHead*)icoHead)->fu = fu;
	((TAHicoHead*)icoHead)->DataSize = lg;
	pCol16 = (word*)(icoHead + icoHeadSize);
// printf("%d HeadSize=%d\n", (int)pCol16 - (int)icoHead, icoHeadSize);
	for (i=0;i<colsg;i++) {
	    if (i != NoneIdx) {
		*pCol16 = RGB24To16(xpmCol[i].col);
		pCol16++;
	    }
	}
// printf("MaskIdx=%d\n", (int)pCol16 - (int)icoHead);
// printf("NoneIdx=%d k=%d\n", NoneIdx, k);

//*************** Mask *****************
	pColNr = (byte*)pCol16;
	if (fu & TranspArray) {
	    mbits.dat = pColNr;
	    mbits.buf = mbits.k = 0;
	    pb = xpmDat;
	    for (i=0;i<xpmDatLg;i++) {
		SetBits8(&mbits, (*pb != NoneIdx), 1);
		pb++;
	    } 
	    SetBits8End(&mbits);
	    pColNr += MaskDatLg;
	} 
// printf("ColorIdx=%d\n", (int)pCol16 - (int)icoHead);

//*************** Daten *****************
	cbits.dat = pColNr;
	cbits.buf = cbits.k = 0;
	pb = xpmDat;
	if (fu & CountArray) {
	  wr_CA_Dat(&cbits, xpmDat, xpmDatLg, k);
	} else {
	  for (i=0;i<xpmDatLg;i++) {
	    if (*pb != NoneIdx) {
		cz = *pb;
		if (mkTreansp && (cz > NoneIdx)) cz--;
		SetBits8(&cbits, cz, k);
	    }
	    pb++;
	  }
	}
// printf("lg=%d EndeIdx=%d %d\n", lg, (int)cbits.dat - (int)icoHead, cbits.k);
	SetBits8End(&cbits);
// printf("lg=%d EndeIdx=%d\n", lg, (int)cbits.dat - (int)icoHead);


	snprintf(line, sizeof(line), "cols=%d colsg=%d mh=%d mc=%d mm=%d md=%d mges=%d", 
		cols, colsg, icoHeadSize, colsg*2, MaskDatLg, ColDatLg, lg);
	TLineEdit_AddLine(AHimgEdit, line);
// printf("qk1=%d qk2=%d %d\n", colsg*2 + qk1 + 10, colsg*2 + qk2 + MaskDatLg + 10, (int)cbits.dat - (int)icoHead);

	if (!AZpic) {
	    AZpic = xcalloc(sizeof(TPic));
	} else {
	    XFreePixmap(appXDat.dpy, AZpic->pic);
	    if (AZpic->mask) XFreePixmap(appXDat.dpy, AZpic->mask);
	    AZpic->pic = 0;
	    AZpic->mask = 0;
	}
	CreateAHicoPic(icoHead, AZpic);
	RePaint(PanelRightTop);

	cpc = GetFileName_pc(LineEdit->tls->FileName);
	pc = ChangeFileExt(cpc, NULL);
	snprintf(line, sizeof(line), "static char zico%d%s[] = {", x, pc);
	xfree(pc);
	TLineEdit_AddLine(AHimgEdit, NULL); //"\n");
	TLineEdit_AddLine(AHimgEdit, line);

	
	ps = icoHead;
	for (i=0;i<lg;i++) {
	    if ((i & 0x0f) == 0) {pc = line; *pc = ' '; pc++;}
	    hexto0xppc(&pc, (byte)*ps, 2); ps++;
	    if (i != lg-1) {
		*pc = ','; pc++;
		if ((i & 0x0f) == 0x0f) {
		    *pc = 0;
		    TLineEdit_AddLine(AHimgEdit, line);
		}
	    }
	}
	*pc = '}'; pc++;
	*pc = ';'; pc++;
	*pc = 0;
	TLineEdit_AddLine(AHimgEdit, line);

ende:
	xfree(xpmDat);
	xfree(xpmCol);

	TLineEdit_SetCaretXY(AHimgEdit, 0, 0);
	TLineEdit_AllAtrNew(AHimgEdit);
}

static void cbCxx_OnClick(TChkBox *self, long KeyState, bool DblClick) {
	TChkBox_SetChecked(cb_C16, self == cb_C16);
	TChkBox_SetChecked(cb_C15, self == cb_C15);
	TChkBox_SetChecked(cb_C12, self == cb_C12);
	TChkBox_SetChecked(cb_C9,  self == cb_C9);
	TChkBox_SetChecked(cb_C8,  self == cb_C8);
	TChkBox_SetChecked(cb_C6,  self == cb_C6);
	XpmConv();
}

static void mbConv_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
	XpmConv();
}

static void cbCxp_OnClick(TChkBox *self, long KeyState, bool DblClick) {
	XpmConv();
}

static void sbCxx_OnCount(TScrollBar* sb, int Count) {
  char c[16];
	XpmConv();
	inttopc(c, Count-31);
	SetCaption(lbl_sbCxxAZ, c);
}


static void lbl_sbCxxAZ_OnClick(TWins *self, long KeyState, bool DblClick) {
	TScrollBar_SetCount_ev(sb_Cxx, 31);
}


static void AZpic_Paint(TWins *self) {
	if (!AZpic) return;
	DrawPic(PanelRightTop->WinID, AZpic, 1, 1);
}


static int ChkFileIsSaved(TLineEdit *le);



static int GetAkt_EOL() {
  TMenuItem *mi  = ((TMenu*)menuEOL)->MenuItem;
  int res = 0;
	while (mi) {
		if (mi->tag == fio_EOLunix) {
		    if (mi->fu & miChecked) res |= fio_EOLunix;
		} else if (mi->tag == fio_EOLwindos) {
		    if (mi->fu & miChecked) res |= fio_EOLwindos;
		} else if (mi->tag == fio_EOL_mix) {
		    if ((mi->fu & (miChecked | miNotEnabled)) == miChecked)
			res |= fio_EOL_mix;
		}
		mi = mi->next;
	}
	return res;
}

static bool Chk_Akt_EOL() {
	return (GetAkt_EOL() != LineEdit->tls->DefaultEOL);
}


static void LoadFile(char *pfn, int fu) {
  TLineEdit *le;
  TpcIni *pcIni;
  TMenuItem *mi;
  int i, m, dupi = -1;
  char *s, *fn;
  char *itm[10];
  char line[32];

	if (!pfn || !*pfn) return;
	fn = path_rel2abs(pfn, NULL);
	le = LineEdit;
	if (fu & 0x02) ChkFileIsSaved(le);

	IO_Run = True;
	TUnRedo_Clr(le->UnRedo);
	SetEnabled((TWins*)mbUndo, False);
	SetEnabled((TWins*)mbRedo, False);
	SetEnabled((TWins*)mbSave, False);
	miSave->fu |= miNotEnabled;
	miLESave->fu |= miNotEnabled;

	Tfree(le->highlight);
	le->highlight = NULL;

	SetCaption(FormMain, fn);
	TLineEdit_LoadFromFile(LineEdit, fn);

	for (i=0; i<10; i++) itm[i] = NULL;

	pcIni = globIniLoad;
	if (!pcIni) pcIni = TpcIni_Create(appDat.inifile_app);

	for (i=0; i<10; i++) {
		snprintf(&line[0], 32, "LastFile%d", i);
		s = TpcIni_RDstrdup(pcIni, APPNAME, &line[0], NULL);
		if (!s) break;
		itm[i] = s;
		if (pccmp(fn, s)) dupi = i;
	}

	if (dupi < 0) {
		xfree(itm[9]);
		for (i=8; i>=0; i--) itm[i+1] = itm[i];
		itm[0] = NULL;
		ppcchange(&itm[0], fn);
	} else if (dupi) {
		s = itm[dupi];
		for (i=dupi; i>0; i--) itm[i] = itm[i-1];
		itm[0] = s;
	}

	if (dupi) {
		for (i=0; i<10; i++) {
			if (!itm[i]) break;
			snprintf(&line[0], 32, "LastFile%d", i);
			TpcIni_WR(pcIni, APPNAME, &line[0], itm[i]);
		}
		if (!globIniLoad) TpcIni_Save(pcIni);
	}

	for (i=0; i<10; i++) xfree(itm[i]);
	if (!globIniLoad) Tfree(pcIni);

	IO_Run = False;

	m = LineEdit->tls->DefaultEOL;
	mi = menuEOL->MenuItem;
	while (mi) {
		mi->fu &= ~miChecked;
		if (mi->tag == fio_EOLunix) {
		    if (((m & fio_EOL_Mask) == fio_EOLunix) ||
		        ((m & fio_EOL_Mask) == 0)) mi->fu |= miChecked;
		} else if (mi->tag == fio_EOLwindos) {
		    if ((m & fio_EOL_Mask) == fio_EOLwindos) mi->fu |= miChecked;
		} else if (mi->tag == fio_EOL_mix) {
		    if ((m & fio_EOL_mix) == fio_EOL_mix) {
			 mi->fu |= miChecked;
			 mi->fu &= ~miNotEnabled;
		    } else {
			 mi->fu &= ~miChecked;
			 mi->fu |= miNotEnabled;
		    }
		}
		mi = mi->next;
	}

	xfree(fn);
}

// ******* Menu File *******
static void menuFile_OnMenuOpen(TMenu *me) {
}

static void mFile_New(TMenu *self, long KeyState, TMenuItem *smi) {
	TLineEdit_Clr(LineEdit);
}

static void File_Open(int fu) {
  char *s=NULL;

	if (!File_Dlg) {
	    File_Dlg = Create_File_Dlg(FormMain);
	    file_dlg_InitAzPic(File_Dlg);
	}
	if (LineEdit) {
	    s = GetFilePath(LineEdit->tls->FileName);
	    if (s) File_Dlg_SetPath(File_Dlg, s);
	    ppcfree(&s);
	}
	
	if (File_Dlg_Execute(File_Dlg)) {
		File_Dlg_GetEdFileName(File_Dlg, &s);
		LoadFile(s, fu);
		xfree(s);
	}
}

static void SaveFile(TLineEdit *le, char *fn) {
  TLines *tls = le->tls;

	tls->DefaultEOL = GetAkt_EOL();
	if (TLineEdit_SaveToFile(le, fn)) {
	    SetEnabled((TWins*)mbSave, False);
	    miSave->fu |= miNotEnabled;
	    miLESave->fu |= miNotEnabled;
	}
}

static void FileSaveAs(TLineEdit *le) {
  char *s=NULL;

	IO_Run = True;
	if (!FileSave_Dlg) {
		FileSave_Dlg = Create_FileSave_Dlg(FormMain);
		s = le->tls->FileName;
		if (s) File_Dlg_SetNamePath(FileSave_Dlg, s);
		s = NULL;
	}
	if (File_Dlg_Execute(FileSave_Dlg)) {
		File_Dlg_GetEdFileName(FileSave_Dlg, &s);
		SaveFile(le, s);
		SetCaption(FormMain, s);
		xfree(s);
	}
	IO_Run = False; 
}

static void mFile_Open(TMenu *self, long KeyState, TMenuItem *smi) {
	File_Open(0x02);
}

static void mFile_SaveAs(TMenu *self, long KeyState, TMenuItem *smi) {
	FileSaveAs(LineEdit);
}

static void SaveFileChk(TLineEdit *le) {
	if (le->tls->FileName) {
		SaveFile(le, NULL);
	} else {
		FileSaveAs(le);
	}
}

static void mFile_Save(TMenu *self, long KeyState, TMenuItem *smi) {
	SaveFileChk(LineEdit);
}

static void mFile_Exit(TMenu *self, long KeyState, TMenuItem *smi) {
  Close();
}

static void menuReopen_OnMenuOpen(TMenu *me) {
  TpcIni *pcIni;
  int i, fileart;
  const char *s;
  char line[32];
  TMenuItem *mi;

	TMenu_Cls(menuReopen);
	pcIni = TpcIni_Create(appDat.inifile_app);
	for (i=0; i<10; i++) {
		snprintf(&line[0], 32, "LastFile%d", i);
		s = TpcIni_RD(pcIni, APPNAME, &line[0]);
		if (!s) break;
//		fileart = getfileart(s);
		fileart = stft_ErrNoFile;
		Tstat64 *st = file_stat_fn(s, fsFollowLink|fsNoFileName|fsNoLinkName|fsGetFileType|fsGetFileTypeHead);
		if (st) fileart = st->FileType;
		xfree(st);
		if (fileart != stft_ErrNoFile) {
			mi = TMenu_AddItem(menuReopen, s, 0, NULL);
			mi->pic = get_fileIcon(fileart);
		}
	}
	Tfree(pcIni);
}

static void menuFile_Reopen(TMenu *self, long KeyState, bool DblClick) {
	if (menuReopen->SelItem) {
		LoadFile(menuReopen->SelItem->s, 0x03);
	}
}

// ******* Menu Edit *******
static void menuEdit_ChkTag1(TMenuItem *mi) {
  bool mk = False;

	if (LineEdit) mk = TLineEdit_ChkIsSel(LineEdit);
	while (mi) {
	    if (mi->tag == 1) {
		if (mk) mi->fu &= ~miNotEnabled; else mi->fu |= miNotEnabled;
	    }
	    mi = mi->next;
	}
}

static void menuEdit_OnMenuOpen(TMenu *me) {
	menuEdit_ChkTag1(menuEdit->MenuItem);
}

static void menuLE_OnMenuOpen(TMenu *me) {
	menuEdit_ChkTag1(menuLE->MenuItem);
}

static void mEdit_Cut(TMenu *self, long KeyState, TMenuItem *smi) {
	TLineEdit_Strg_X(LineEdit);
}

static void mEdit_Copy(TMenu *self, long KeyState, TMenuItem *smi) {
//	TLineEdit_Strg_C(LineEdit);
	TLineEditBase_Strg_C((TLineEditBase*)self);
}

static void mEdit_Paste(TMenu *self, long KeyState, TMenuItem *smi) {
	TLineEdit_Strg_V(LineEdit);
}

static void mEdit_SelectAll(TMenu *self, long KeyState, TMenuItem *smi) {
	TLineEdit_SetSel((TLineEdit*)LineEdit, 0, 0, 
		0, LineEdit->tls->Count);
}

static const char *No_Find_Msg = {
  "\"%s\"\n"
  "End of document\n"
  "Continue from the beginning ?"
};

static bool EditFind_run = False;
static bool mEdit_Find_run = False;
static bool EditReplace_run = False;
static bool mEdit_Replace_run = False;

static void EditFind() {
  TLines *tls = LineEdit->tls;
  int m;
  char line[1024];

	if (EditFind_run) return;
	EditFind_run = True;
	if (!Find_Dlg->edFind->vds.s) Find_Dlg_Execute(Find_Dlg, NULL);
	if (Find_Dlg->edFind->vds.s) {
		tls->FindXa = LineEdit->CaretCharIdx;
		tls->FindYa = LineEdit->CaretCharIdy;
loopAnf:
		tls->FindNoCase = ((TChkBox*)Find_Dlg->cbCase)->Checked;
		if (TLines_FindS(tls, Find_Dlg->edFind->vds.s)) {
			TLineEdit_SetSel(LineEdit, 
				tls->FindXa, tls->FindYa, tls->FindXe, tls->FindYe);
			TLineEdit_ChkCaret(LineEdit, 0);
		} else {
			snprintf(&line[0], 1024, No_Find_Msg, Find_Dlg->edFind->vds.s);
			m = MsgBox_Show(FormMain, "Find - AHedit", &line[0], msgYES | msgNO, msgYES);
			if (m == msgYES) {
				tls->FindXa = 0;
				tls->FindYa = 0;
				goto loopAnf;
			}
		}
	}
	EditFind_run = False;
}


static void mEdit_Find(TMenu *self, long KeyState, TMenuItem *smi) {
  Tlgs lgs;

	if (mEdit_Find_run) return;
	mEdit_Find_run = True;
	TLineEditBase_GetSel_lgs((TLineEditBase*)LineEdit, &lgs, 0);
	if (Find_Dlg_Execute(Find_Dlg, lgs.s)) EditFind();
	Tlgs_Clr(&lgs);
	mEdit_Find_run = False;
}


static void EditReplace() {
  TLineEdit *le = LineEdit;
  TLines *tls = le->tls;
  int m = 0;
  char line[1024];
  char *s, *srp;
  int x, y;
  TMsgBoxParam mbp;
  Tlgs Tmp_lgs;
  bool AutoLoop, msg_next;

	if (EditReplace_run) return;
	mbp.akt = mbpakt_FocusButton | mbpakt_Caption;
	EditReplace_run = True;
	AutoLoop = False;
	if (TLineEdit_ChkIsSel(LineEdit)) {
		x = le->SelAx;
		y = le->SelAy;
		if (y == le->CaretCharIdy) {
			if (le->SelAx > le->CaretCharIdx) x = le->CaretCharIdx;
		} else if (y > le->CaretCharIdy) {
			x = le->CaretCharIdx;
			y = le->CaretCharIdy;
		}
		TLineEdit_SetSel(le, x, y, x, y);
	}

	if (!Replace_Dlg->edFind->vds.s) Replace_Dlg_Execute(Replace_Dlg, NULL);
	s = Replace_Dlg->edFind->vds.s;
	if (s) {
	    srp = Replace_Dlg->edRepl->vds.s;
	    tls->FindNoCase = ((TChkBox*)Replace_Dlg->cbCase)->Checked;
	    Tmp_lgs.s = srp;
	    Tmp_lgs.lg = pclen(srp);
	    msg_next = False;

loopNext:
	    tls->FindXa = le->CaretCharIdx;
	    tls->FindYa = le->CaretCharIdy;
loopAnf:
	    if (TLines_FindS(tls, s)) {
		TLineEdit_SetSel(le, tls->FindXa, tls->FindYa, tls->FindXe, tls->FindYe);
		TLineEdit_ChkCaret(le, 0);
		if (!AutoLoop) {
		    snprintf(&line[0], 1024, "Replace\n\"%s\"\n\nWith\n\"%s\"", 
			s, srp);
		    mbp.Caption = "Replace - ALDedit";
		    mbp.FocusButton = msgYES;
		    m = MsgBox_Show_mbp(FormMain, line,
			msgYES | msgYESALL | msgNO | msgCANCEL, &mbp);
		    mbp.akt |= mbpakt_x_y;
		}
		if ((m == msgYES) || (m == msgYESALL)) {
			if (m == msgYESALL) AutoLoop = True;
			TLineEdit_DoChange(le, ur_DelSel, NULL, NULL);
			if (srp) TLineEdit_DoChange(le, ur_InsStr | ur_DupTlgs, NULL, &Tmp_lgs);
			goto loopNext;
		} else if (m == msgNO) {
			goto loopNext;
		}
	    } else {
		snprintf(&line[0], 1024, No_Find_Msg, s);
		m = MsgBox_Show(FormMain, "Replace - AHedit", &line[0], msgYES | msgNO, msgYES);
		if (m == msgYES) {
			tls->FindXa = 0;
			tls->FindYa = 0;
			goto loopAnf;
		}
	    }
	}
	EditReplace_run = False;
}

static void mEdit_Replace(TMenu *self, long KeyState, TMenuItem *smi) {
  Tlgs lgs;

	if (mEdit_Replace_run) return;
	mEdit_Replace_run = True;
	TLineEditBase_GetSel_lgs((TLineEditBase*)LineEdit, &lgs, 0);
	if (Replace_Dlg_Execute(Replace_Dlg, lgs.s)) EditReplace();
	Tlgs_Clr(&lgs);
	mEdit_Replace_run = False;
}

/* ****** Menu Tools ****** */

/* ****** Menu Setting ****** */

static void mSetting_EOL(TMenu *self, long KeyState, TMenuItem *smi) {
  TMenuItem *mi;
	mi = ((TMenu*)menuEOL)->MenuItem;
	while (mi) {
		if ((mi->tag & fio_EOL_mix) == 0) mi->fu &= ~miChecked; 
		mi = mi->next;
	}
	smi->fu |= miChecked;
	if (Chk_Akt_EOL()) {
		SetEnabled((TWins*)mbSave, True);
		miSave->fu &= ~miNotEnabled;
		miLESave->fu &= ~miNotEnabled;
	}
}

static void mSetting_MixedEOL(TMenu *self, long KeyState, TMenuItem *smi) {
	smi->fu ^= miChecked;
	if (Chk_Akt_EOL()) {
		SetEnabled((TWins*)mbSave, True);
		miSave->fu &= ~miNotEnabled;
		miLESave->fu &= ~miNotEnabled;
	}
}

static void mSetting_Clipbord(TMenu *self, long KeyState, TMenuItem *smi) {
  TMenuItem *mi;
	mi = menuClipbord->MenuItem;
	while (mi) {mi->fu &= ~miChecked; mi = mi->next;}
	smi->fu |= miChecked;
	if (smi->tag == 1) {
		appXDat.CLIPBOARD_ATOM = XA_PRIMARY;
	} else if (smi->tag == 2) {
		appXDat.CLIPBOARD_ATOM = appXDat.XA_CLIPBOARD;
	}
}

/* ****** Menu Help ****** */
static void mHelp_Info(TMenu *self, long KeyState, TMenuItem *smi) {
  char buf[80];
	snprintf(buf, sizeof(buf), "XpmToZimg %s   (build-%d  %s)", 
			VERSION, build_v, build_date);
	Copyright_MsgBox_Show(FormMain, buf);
}

static void mbSave_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
	mFile_Save((TMenu*)self, KeyState, NULL);
}

static void Chk_UnRedo() {
  bool mkundo, mkredo;
	TUnRedo_GetStat(LineEdit->UnRedo, &mkundo, &mkredo);
	SetEnabled((TWins*)mbUndo, mkundo);
	SetEnabled((TWins*)mbRedo, mkredo);
}

static void LineEdit_OnChange(TLineEdit *le, int fu, TKeyS *KeyS, Tlgs *lgs, int xa, int ya, int xe, int ye) {
	TUnRedo_AddLine(le->UnRedo, fu, KeyS, lgs, xa, ya, xe, ye);
	SetEnabled((TWins*)mbSave, True);
	miSave->fu &= ~miNotEnabled;
	miLESave->fu &= ~miNotEnabled;
	Chk_UnRedo();
}

static void mbUndo_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TUnRedoLine *url = TUnRedo_GetUndo(LineEdit->UnRedo);
	if (url) {
	    if (!TLineEdit_Undo(LineEdit, url)) {
		TUnRedo_Undo_Old(LineEdit->UnRedo);
	    }
	}
	Chk_UnRedo();
}

static void mbRedo_OnClick(TMenuButton *self, long KeyState, bool DblClick) {
  TUnRedoLine *url = TUnRedo_GetRedo(LineEdit->UnRedo);
	if (url) {
	    if (!TLineEdit_Redo(LineEdit, url)) {
		TUnRedo_Redo_Old(LineEdit->UnRedo);
	    }
	}
	Chk_UnRedo();
}

static void LineEdit_VSB_AzCount() {
  char tmps[32];
  int m;

	m = LineEdit->tls->Count;
	snprintf(&tmps[0], 32, "%d:%5d", m, LCount);
	SetCaption(SBVPosBox, &tmps[0]);
}

static void LineEdit_OnSetCaret(TLineEdit *le, TColS *cs) {
  const char *s;
  char tmps[32];
  int x = le->CaretCharIdx;
  int y = le->CaretCharIdy;
  int c, m;
	if (cs) {
	    if ((cs->s) && (cs->lg > x) && (cs->s[x])) {
		c = (unsigned char)cs->s[x];
		snprintf(&tmps[0], 32, "%d / 0x%02x", c, c);
		s = &tmps[0];
	    } else {
		m = cs->fu & fio_EOL_Mask;
		if (m == fio_EOLunix) {
			s = "EOL LF";
		} else if (m == fio_EOLwindos) {
			s = "EOL CRLF";
		} else if (m == fio_EOL_0) {
			s = "EOL 0";
		} else s = "EOL";
	    }
	} else s = "EOF";
	SetCaption(CharAzBox, s);

	snprintf(&tmps[0], 32, "%5d:%5d", x, y+1);
	SetCaption(CursPosBox, &tmps[0]);
	LineEdit_VSB_AzCount();
}

static void LineEdit_VSB_DoCount(TWins *self, int Count) {
	LCount = Count;
	LineEdit_VSB_AzCount();
}

static void LineEdit_OnKeyDown(TLineEdit *self, TKeyEvent *KeyEv) {
	if (KeyEv->keysym == XK_F3) {
		EditFind();
		KeyEv->keysym = 0;
	} else if ((KeyEv->keycode == 41) && ((KeyEv->state & 0x4) != 0)) { //Strg_F
		mEdit_Find(NULL, 0, NULL);
		KeyEv->keysym = 0;
	}
}

static void OnAppStart() {
	if ((argv_fileIdx) && (app_argc > argv_fileIdx)) LoadFile(app_argv[argv_fileIdx], 0x01);
	IO_Run = True;
	Set_Focus((TWins*)LineEdit);
	IO_Run = False;
}

static int ChkFileIsSaved(TLineEdit *le) {
  int res = -1;
  char line[2048];
  const char *s;

	if ((le) && (le->tls->Changed)) {
	    if (le->tls->FileName) {
		snprintf(&line[0], sizeof(line), 
			"The current Document has been modified.\n\"%s\"\n\nWould you like to save it ?", 
			le->tls->FileName);
		s = &line[0];
	    } else {
		s = "The current Document has been modified\nWould you like to save it ?";
	    }
	    res = MsgBox_Show(FormMain, "Warning - AHedit", s,
			msgYES | msgNO | msgCANCEL, msgYES);
	    if (res == msgYES) {
		mFile_Save(NULL, 0, NULL);
	    }
	}
	return res;
}

static void OnCanClose(TForm *self, int *CanClose) {
  int m;

	if (mbSave->Enabled) {
	    if (MsgBox_Reload_Run) {
		*CanClose = False;
	    } else {
		m = ChkFileIsSaved(LineEdit);
		if (m == msgCANCEL) {
			Set_Focus((TWins*)LineEdit);
			*CanClose = False; 
		}
	    }
	}
}

static TLineEdit *Add_LineEdit(TWins *Parent) {
  TLineEdit *le;
  TpcIni *pcIni;
  const char *s;

	pcIni = TpcIni_Create(appDat.inifile_app);

	le = TLineEdit_CreateA(Parent, 0, 0, 290, 200, alLeft);
	s = TpcIni_RD_pc(pcIni, APPNAME, "Font", "-adobe-courier-medium-r-normal--12-120-75-75-*-*-iso8859-1");
	SetFont((TWins*)le, s);

//	le->MouseZ_Wheel = TpcIni_RD_int(pcIni, APPNAME, "MouseZ_Wheel", 3);
	TLineEdit_SetMouseZ_Wheel(le, TpcIni_RD_int(pcIni, APPNAME, "MouseZ_Wheel", 3));
	le->OnKeyDown = LineEdit_OnKeyDown;
	le->OnChange = LineEdit_OnChange;
	le->OnSetCaret = LineEdit_OnSetCaret;
	le->VSB_DoCount = LineEdit_VSB_DoCount;
	le->UnRedo = TUnRedo_Create(200);
	le->PopupMenu = menuLE;

	Tfree(pcIni);
	return le;
}

static const char *Help_Msg = {
  "\n"
  "Usage: "APPNAME" [options] file\n"
  "\n"
  "  -h, --help           Prints out this screen\n"
  "  ALDccp: "APPNAME" version "VERSION"  (build %d  %s)\n"
};

int main (int argc, char **argv) {
  app_name = *argv;
  TpcIni *pcIni;
  int m;

#if 1
  int i;
  char *val;
  bool help = False;
  bool err = False;

	app_argc = argc;
	app_argv = argv;
	i = 1;
	while (!err && !help && (i<argc)) {
	    val = argv[i];
	    if (*val == '-') {
		val++;
		switch (*val) {
		case 'h':
			help = True;
		    break;
		case '-':
		    val++;
		    if (pcncmp(val, "help", 4)) {
			help = True;
#ifdef Test_Root_WinId
		    } else if (pcncmp(val, "TestRootWinID", 13)) {
			i++;
			val = argv[i];
			if (val && *val != '-') {
				TestRootWinId = pctoint(val);
			} else err = True;
#endif
		    } else err = True;
		    break;
		default: 
			err = True;
		}
	    } else {
		argv_fileIdx = i;
		break;
	    }
	    i++;
	}
#endif

	if (help || err) {
	    printf(Help_Msg, build_v, build_date);
	    exit(err);
	}

	initXapp(0, argc, argv);
	appDat.inifile_app = pcadd(appDat.ALDini_dir, "/edit.ini");

	hGetFileHeadInfo = &hGetFileHeadInfo_buildin;
	ThImageRD_Reg(1, &hImageRD_xpm);

	pcIni = TpcIni_Create(appDat.inifile_app);

	FormMain =  (TWins*)TForm_Create(NULL);
	((TForm*)FormMain)->OnCanClose = OnCanClose;
	SetCaption(FormMain, "FormMain");
	((TForm*)FormMain)->IconName = APPNAME;
	FormMain->height = TpcIni_RD_int(pcIni, APPNAME, "Height", 500);
	FormMain->width = TpcIni_RD_int(pcIni, APPNAME, "Width", 900);

	PanelTop = TWins_CreateBA(FormMain, 0, 0, 200, 21, mBorder | mBorderL, alTop);


// ******* Menu File *******
	mbFile = TMenuButton_Create(PanelTop, (void*)FormMain);
	mbFile->top = 2;
	mbFile->left = 1;
	SetCaption((TWins*)mbFile, "File");
	Set_Parent((TWins*)mbFile, PanelTop);

  TMenuItem *mi;
	menuFile = TMenu_Create(FormMain);
	menuFile->OnMenuOpen = menuFile_OnMenuOpen;
	mbFile->menu = menuFile;
	TMenu_AddItem(menuFile, "New", 0, mFile_New);
	TMenu_AddItem(menuFile, "-", 0, NULL);
	mi = TMenu_AddItem(menuFile, "Open...", 0, mFile_Open);
	mi->pic = get_pic16_fileopen(False);
	mi = TMenu_AddItem(menuFile, "Reopen", 0, NULL);
		menuReopen = TMenu_Create(FormMain);
		menuReopen->OnClick = menuFile_Reopen;
		menuReopen->OnMenuOpen = menuReopen_OnMenuOpen;
		mi->next_menu = menuReopen;
	TMenu_AddItem(menuFile, "-", 0, NULL);
	miSave = TMenu_AddItem(menuFile, "Save", miNotEnabled, mFile_Save);
	miSave->pic = get_pic16_filesave(False);
	mi = TMenu_AddItem(menuFile, "Save As...", 0, mFile_SaveAs);
	mi->pic = get_pic16_filesave(False);
	TMenu_AddItem(menuFile, "-", 0, NULL);
	TMenu_AddItem(menuFile, "Exit", 0, mFile_Exit);


// ******* Menu Edit *******
	mbEdit = TMenuButton_Create(PanelTop, mbFile);
	SetCaption((TWins*)mbEdit, "Edit");
	Set_Parent((TWins*)mbEdit, PanelTop);

	menuEdit = TMenu_Create(FormMain);
	menuEdit->OnMenuOpen = menuEdit_OnMenuOpen;
	mbEdit->menu = menuEdit;
	mi = TMenu_AddItem(menuEdit, "Cut", miNotEnabled, mEdit_Cut);
	mi->tag = 1;
	mi = TMenu_AddItem(menuEdit, "Copy", miNotEnabled, mEdit_Copy);
	mi->tag = 1;
	TMenu_AddItem(menuEdit, "Paste", 0, mEdit_Paste);
	TMenu_AddItem(menuEdit, "Select All", 0, mEdit_SelectAll);
	TMenu_AddItem(menuEdit, "-", 0, NULL);
	TMenu_AddItem(menuEdit, "Find", 0, mEdit_Find);
	TMenu_AddItem(menuEdit, "Replace", 0, mEdit_Replace);

// ******* Menu Tools *******
	mbTools = TMenuButton_Create(PanelTop, mbFile);
	mbTools->Enabled = False;
	SetCaption((TWins*)mbTools, "Tools");
	Set_Parent((TWins*)mbTools, PanelTop);

// ******* Menu Setting *******
	mbSetting = TMenuButton_Create(PanelTop, mbFile);
	SetCaption((TWins*)mbSetting, "Settings");
	Set_Parent((TWins*)mbSetting, PanelTop);

	menuSetting = TMenu_Create(FormMain);
	mbSetting->menu = menuSetting;
	mi = TMenu_AddItem(menuSetting, "End of Line", 0, NULL);
		menuEOL = (TMenu*)TMenu_Create(FormMain);
		mi->next_menu = menuEOL;
		TMenu_AddItem(menuEOL, "Unix", miCanCheck | miChecked, mSetting_EOL)->tag = fio_EOLunix;
		TMenu_AddItem(menuEOL, "Windows", miCanCheck, mSetting_EOL)->tag = fio_EOLwindos;
		miMixed = TMenu_AddItem(menuEOL, "Mixed", miCanCheck | miNotEnabled, mSetting_MixedEOL);
		miMixed->tag = fio_EOL_mix;
	mi = TMenu_AddItem(menuSetting, "Clipbord Mode", 0, NULL);
		menuClipbord = (TMenu*)TMenu_Create(FormMain);
		mi->next_menu = menuClipbord;
		m = miCanCheck;
		if (appXDat.CLIPBOARD_ATOM != appXDat.XA_CLIPBOARD) m |= miChecked;
		TMenu_AddItem(menuClipbord, "X11 (XA_PRIMARY)", m, mSetting_Clipbord)->tag = 1;
		m = miCanCheck;
		if (appXDat.CLIPBOARD_ATOM == appXDat.XA_CLIPBOARD) m |= miChecked;
		TMenu_AddItem(menuClipbord, "QT3 (XA_CLIPBOARD)", m, mSetting_Clipbord)->tag = 2;
	TMenu_AddItem(menuSetting, "-", 0, NULL);
	mi = TMenu_AddItem(menuSetting, "Font", 0, NULL);
	mi->pic = get_fileIcon(stft_Font_A);
		menuFont = TMenu_Create(FormMain);
		mi->next_menu = menuFont;
		TMenu_AddItem(menuFont, "Set Font", 0, NULL)->pic = get_fileIcon(stft_Font_A);
		TMenu_AddItem(menuFont, "Save Font as Default", 0, NULL)->pic = get_pic16_filesave(False);
	TMenu_AddItem(menuSetting, "Font CharSet", 0, NULL);
	TMenu_AddItem(menuSetting, "UTF-8 On", miCanCheck | miNotEnabled, NULL);

// ******* Menu Help *******
	mbHelp = TMenuButton_Create(PanelTop, mbFile);
	SetCaption((TWins*)mbHelp, "Help");
	Set_Parent((TWins*)mbHelp, PanelTop);

	menuHelp = TMenu_Create(FormMain);
	mbHelp->menu = menuHelp;
	  mi = TMenu_AddItem(menuHelp, "Info", 0, mHelp_Info);
	  mi->pic = get_pic16_info(False);

// ******* Menu Save *******
	mbSave = TMenuButton_Create(PanelTop, mbFile);
	mbSave->Enabled = False;
	mbSave->pic = get_pic16_filesave(False);
	mbSave->dis_pic = get_pic16_filesave(True);
	mbSave->OnClick = mbSave_OnClick;
	Set_Parent((TWins*)mbSave, PanelTop);

// ******* Menu Undo *******
	mbUndo = TMenuButton_Create(PanelTop, mbFile);
	mbUndo->Enabled = False;
	mbUndo->pic = get_pic16_undo(False);
	mbUndo->dis_pic = get_pic16_undo(True);
	mbUndo->OnClick = mbUndo_OnClick;
	Set_Parent((TWins*)mbUndo, PanelTop);

// ******* Menu Redo *******
	mbRedo = TMenuButton_Create(PanelTop, mbFile);
	mbRedo->Enabled = False;
	mbRedo->pic = get_pic16_redo(False);
	mbRedo->dis_pic = get_pic16_redo(True);
	mbRedo->OnClick = mbRedo_OnClick;
	Set_Parent((TWins*)mbRedo, PanelTop);

	TMenuButton_SetPosition(mbFile);


// ******* Menu Conv *******
	mbConv = TMenuButton_Create(PanelTop, mbFile);
	mbConv->OnClick = mbConv_OnClick;
	SetCaption((TWins*)mbConv, "Conv");
	Set_Parent((TWins*)mbConv, PanelTop);


// ******* Menu LineEdit *******
	menuLE = (TMenu*)TMenu_Create(FormMain);
	menuLE->OnMenuOpen = menuLE_OnMenuOpen;
	mi = TMenu_AddItem(menuLE, "Open...", 0, mFile_Open);
	mi->pic = get_pic16_fileopen(False);
	mi = TMenu_AddItem(menuLE, "Reopen", 0, NULL);
		mi->next_menu = menuReopen;
	TMenu_AddItem(menuLE, "-", 0, NULL);
	miLESave = TMenu_AddItem(menuLE, "Save", miNotEnabled, mFile_Save);
	miLESave->pic = get_pic16_filesave(False);
	mi = TMenu_AddItem(menuLE, "Save As...", 0, mFile_SaveAs);
	mi->pic = get_pic16_filesave(False);
	TMenu_AddItem(menuLE, "-", 0, NULL);
	mi = TMenu_AddItem(menuLE, "Cut", miNotEnabled, mEdit_Cut);
	mi->tag = 1;
	mi = TMenu_AddItem(menuLE, "Copy", miNotEnabled, mEdit_Copy);
	mi->tag = 1;
	TMenu_AddItem(menuLE, "Paste", 0, mEdit_Paste);
	TMenu_AddItem(menuLE, "Select All", 0, mEdit_SelectAll);
	TMenu_AddItem(menuLE, "-", 0, NULL);
	TMenu_AddItem(menuLE, "Find", 0, mEdit_Find);
	TMenu_AddItem(menuLE, "Replace", 0, mEdit_Replace);

// ******* LineEdit *******
	TLineEdit_AddKeyDownPlugIn(NULL, TLineEdit_keyplugin_edit_Create());
	TLineEdit_AddKeyDownPlugIn(NULL, TLineEdit_keyplugin_strg_u_i_Create());
	TLineEdit_AddKeyDownPlugIn(NULL, TLineEdit_keyplugin_cursor_Create());

	LineEdit = Add_LineEdit(FormMain);

	PanelRight = TWins_CreateBA(FormMain, 0, 0, 200, 180, 0, alClient);
	PanelRightTop = TWins_CreateBA(PanelRight, 0, 0, 200, 81, mBorder | mBorderL, alTop);
	PanelRightTop->OnPaint = AZpic_Paint;

	PanelRightTopSel = TWins_CreateLabelA(PanelRightTop, 0, 0, 116, 66, "Color Bits", 0, mBorder, alRight);
	PanelRightTopSel->CaptionFu = mCaptionPaint | mCaptionTop | mCaptionLeft;
	cb_C16 = TChkBox_CreateS(PanelRightTopSel, 2, 16, 46, 15, "16");
	cb_C15 = TChkBox_CreateS(PanelRightTopSel, 50, 16, 46, 15, "15");
	cb_C12 = TChkBox_CreateS(PanelRightTopSel, 2, 31, 46, 15, "12");
	cb_C9  = TChkBox_CreateS(PanelRightTopSel, 50, 31, 46, 15, " 9");
	cb_C8  = TChkBox_CreateS(PanelRightTopSel, 2, 46, 46, 15, " 7,5");
	cb_C6  = TChkBox_CreateS(PanelRightTopSel, 50, 46, 46, 15, " 6");
	cb_Cxp = TChkBox_CreateS(PanelRightTopSel, 2, 61, 46, 15, " +c");
	TChkBox_SetChecked(cb_C15, True);
	cb_C16->OnClick = cbCxx_OnClick;
	cb_C15->OnClick = cbCxx_OnClick;
	cb_C12->OnClick = cbCxx_OnClick;
	cb_C9->OnClick = cbCxx_OnClick;
	cb_C8->OnClick = cbCxx_OnClick;
	cb_C6->OnClick = cbCxx_OnClick;
	cb_Cxp->OnClick = cbCxp_OnClick;

	sb_Cxx = (TScrollBar*)TScrollBarVert_CreateP(PanelRightTopSel);
	SetRC((TWins*)sb_Cxx, 100, 1, 15, 77);
	TScrollBar_SetMaxCount(sb_Cxx, 62);
	TScrollBar_SetCount_ev(sb_Cxx, 31);
	sb_Cxx->OnCount = sbCxx_OnCount;

	lbl_sbCxxAZ = TWins_CreateLabel(PanelRightTopSel, 78, 2, 22, 14, "0", mCaptionRigth, mBorder | mBorderL);
	lbl_sbCxxAZ->OnClick = lbl_sbCxxAZ_OnClick;

	AHimgEdit = TLineEdit_CreateA(PanelRight, 0, 0, 260, 200, alClient);
	SetFont((TWins*)AHimgEdit, "-adobe-courier-medium-r-normal--12-120-75-75-*-*-iso8859-1");
	AHimgEdit->highlight = Thighlight_C_Create((TWins*)AHimgEdit, AHimgEdit->tls);

// ******* PanelBottom *******
	PanelBottom = TWins_CreateBA(FormMain, 0, 0, 200, 18, 0, alBottom);

	CursPosBox = TWins_CreateLabel(PanelBottom, 0, 1, 90, 17, "0:  0", 0, mBorder | mBorderL);

	SBVPosBox = TWins_CreateLabel(PanelBottom, 91, 1, 90, 17, "0", mCaptionRigth, mBorder | mBorderL);
	SBVPosBox->CaptionOffX = -1;

	CharAzBox = TWins_CreateLabel(PanelBottom, 182, 1, 70, 17, "255/FF", mCaptionRigth, mBorder | mBorderL);
	CharAzBox->CaptionOffX = -1;

	Find_Dlg = Create_Find_Dlg(FormMain);
	Replace_Dlg = Create_Replace_Dlg(FormMain);

	appXDat.OnAppStart = OnAppStart;
	Tfree(pcIni);

	AppRun();

	return 0;
}
